function param1()
  return "ブラシ間隔", 10, 100, 50
end

function param2()
	return "回転", 0, 1, 1
end

function param3()
	return "大きさのジッタ", 0, 100, 25
end

function param4()
	return "位置のジッタ", 0, 100, 25
end

function param5()
	return "色のジッタ", 0, 100, 0
end

function param6()
	return "グリッドスナップ", 0, 1, 1
end

function param7()
	return "グリッド45度", 0, 1, 1
end

function param8()
	return "グリッド間隔", 1, 100, 60
end

function param9()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.5
end

bs_setmode( 1 )

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.05
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param9() )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local SpinCheck = bs_param2()	
	local GridLock = bs_param6()
	local GridSpin = bs_param7()
	local GridReso = 16 * bs_param8() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end

	if ( GridLock==1 ) then	math.randomseed( gridX * gridX * gridY * gridY ) end

	local rdmSpin = math.random() * 3.14
	local rdmSize = math.random() * bs_param3()/500

	if ( SpinCheck == 0 ) then dx,dy = 0,0 rdmSpin = 0 end

	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms()) 
			rdmSize = rdm0 * math.random() * bs_param3()/1000
			if ( SpinCheck == 1 ) then rdmSpin = math.random() * 3.14 end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w, (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ


shape = { 1, 7.12, -47.55, 4, 0.00, -35.59, 4, -7.12, -47.55, 3, -11.45, -43.84, -14.36, -36.85, -14.36, -28.84, 
	3, -14.36, -16.95, -5.38, -3.72, 0.00, -3.72, 3, 5.39, -3.72, 14.36, -16.95, 14.36, -28.84, 3, 14.36, 
	-36.85, 11.45, -43.84, 7.12, -47.55, 0, 1, -45.60, -19.60, 4, -36.42, -9.13, 4, -50.00, -6.05, 3, -47.81, 
	-0.79, -42.06, 4.14, -34.44, 6.61, 3, -23.13, 10.29, -7.77, 5.84, -6.11, 0.72, 3, -4.44, -4.40, -14.26, 
	-17.02, -25.57, -20.70, 3, -33.19, -23.18, -40.73, -22.56, -45.60, -19.60, 0, 1, -35.30, 39.18, 4, -22.51, 
	33.69, 4, -23.78, 47.55, 3, -18.10, 47.09, -11.63, 43.15, -6.93, 36.67, 3, 0.06, 27.05, 0.58, 11.07, 
	-3.77, 7.90, 3, -8.13, 4.74, -23.17, 10.17, -30.16, 19.79, 3, -34.87, 26.27, -36.62, 33.64, -35.30, 
	39.18, 0, 1, 23.78, 47.55, 4, 22.51, 33.69, 4, 35.30, 39.18, 3, 36.62, 33.64, 34.87, 26.27, 30.16, 19.79, 
	3, 23.17, 10.17, 8.13, 4.74, 3.77, 7.90, 3, -0.58, 11.07, -0.06, 27.05, 6.93, 36.67, 3, 11.64, 43.15, 
	18.10, 47.09, 23.78, 47.55, 0, 1, 50.00, -6.05, 4, 36.42, -9.13, 4, 45.60, -19.60, 3, 40.73, -22.56, 
	33.19, -23.18, 25.57, -20.70, 3, 14.26, -17.02, 4.44, -4.40, 6.11, 0.72, 3, 7.77, 5.84, 23.13, 10.29, 
	34.44, 6.61, 3, 42.06, 4.14, 47.81, -0.79, 50.00, -6.05, 0 }
