function param1()
  return "粒子数", 0, 100, 50
end

function param2()
	return "粒子密度", 0, 100, 50
end

function param3()
	return "大きさのジッタ", 0, 100, 50
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "延伸", 0, 100, 40
end

function param6()
	return "延伸増幅", 0, 1, 0
end

function param7()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.5
end

function main( x, y, p )

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param7() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )

	local mul = 0.006
	local rdmSize = math.random()/2500 * bs_param3()
	local rdmShape = math.random(5)
	local xrdm = bs_grand( 0, w * (100 - bs_param2())/2.5 )
	local yrdm = bs_grand( 0, w * (100 - bs_param2())/2.5 )
	
	local distance = bs_distance( lastDrawX - x, lastDrawY - y )
	
	if ( not firstDraw ) then
			if ( distance < w * (110 - bs_param1()) * 0.25 ) then
				return 0
			end
	end

	if ( bs_param2()==100 ) then drawCount = 500 end

	if ( drawCount < 500 ) then
			drawCount = drawCount + 1
			return 0
	end

	local chkAddStretch = bs_param6()
	if ( chkAddStretch==1 ) then  distance = distance * 3 end
	

	local id = 1
	local code = ''

	local stroke = shape[ rdmShape ]

	repeat

		local stretch = 0
		local baseStretch = 1 + bs_param5()/100 * chkAddStretch

		code = cmdcon[stroke[id]]

		if (code=='z') then

				currentTime = bs_ms()

				stretch = bs_param5()/100 * distance / ( 20 + currentTime - previousTime)

				bs_bezier_rotate( bs_grand( 0, 3.14 ) )
				bs_bezier_mul( ( baseStretch + stretch ) * (mul + rdmSize) * w, (mul + rdmSize) * w ) 
				bs_bezier_rotate( bs_atan( dx, dy ) )
				bs_bezier_move( x + xrdm, y + yrdm )

				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( stroke, id+1 )
		end

	until id > #stroke

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	previousTime = currentTime

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

currentTime, previousTime = 0, 0
drawCount = 0

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}


-- ブラシ形状データ

shape = {}

shape[1] = { 1, -12.92, -50.00, 3, -12.64, -50.00, -12.36, -50.00, -12.09, -50.00, 3, -12.53, -45.02, -7.83, -45.95, 
	-6.25, -45.00, 3, -5.65, -42.45, -7.69, -42.55, -7.09, -40.00, 3, -3.48, -40.01, -3.79, -43.93, -1.25, 
	-45.00, 3, 0.82, -40.68, 6.17, -39.64, 6.25, -33.33, 3, 4.54, -35.02, 4.58, -32.99, 3.75, -31.67, 3, 
	10.12, -24.31, 19.60, -27.74, 23.75, -31.67, 3, 24.80, -29.13, 20.90, -27.42, 22.92, -26.67, 3, 26.39, 
	-30.93, 30.00, -23.51, 33.75, -27.50, 3, 33.75, -25.55, 33.75, -23.61, 33.75, -21.67, 3, 38.50, -21.87, 
	41.89, -10.88, 35.42, -8.33, 3, 35.74, -5.60, 37.85, -4.66, 38.75, -2.50, 3, 36.55, -1.64, 33.89, -1.25, 
	32.92, 0.83, 3, 35.53, 1.76, 35.12, 1.22, 37.08, -0.00, 3, 37.49, 4.55, 41.21, 1.80, 43.75, 5.00, 3, 
	43.75, 5.28, 43.75, 5.56, 43.75, 5.83, 3, 43.47, 5.83, 43.19, 5.83, 42.92, 5.83, 3, 40.44, 10.03, 40.77, 
	17.02, 35.42, 18.33, 3, 34.96, 16.85, 34.99, 14.87, 33.75, 14.17, 3, 29.52, 17.48, 23.17, 20.11, 26.25, 
	28.33, 3, 19.88, 27.80, 19.37, 33.12, 12.08, 31.67, 3, 12.45, 35.92, 9.05, 36.41, 8.75, 40.00, 3, 7.92, 
	38.89, 6.50, 38.36, 6.25, 36.67, 3, 2.07, 38.59, -2.27, 40.36, -4.58, 44.17, 3, -8.10, 45.46, -4.40, 
	39.54, -7.91, 40.83, 3, -6.29, 44.64, -5.54, 48.43, -9.58, 50.00, 3, -11.25, 50.00, -12.92, 50.00, -14.58, 
	50.00, 3, -15.69, 45.09, -13.42, 42.02, -12.08, 37.50, 3, -16.15, 37.67, -16.44, 34.08, -20.42, 34.17, 
	3, -20.08, 37.28, -21.08, 39.06, -23.75, 39.17, 3, -25.18, 34.93, -27.76, 41.01, -28.75, 39.17, 3, -27.43, 
	33.57, -32.81, 38.39, -33.75, 34.17, 3, -32.28, 31.88, -35.08, 29.29, -32.08, 27.50, 3, -33.80, 20.32, 
	-38.58, 16.21, -42.92, 11.67, 3, -39.74, 9.04, -40.55, 5.68, -43.75, 4.17, 3, -43.75, 3.33, -43.75, 
	2.50, -43.75, 1.67, 3, -42.15, -1.73, -40.76, -5.34, -37.92, -7.50, 3, -36.80, -6.67, -36.28, -5.25, 
	-34.58, -5.00, 3, -33.14, -12.77, -33.00, -15.84, -35.42, -21.67, 3, -35.52, -24.55, -31.75, -23.56, 
	-31.25, -25.83, 3, -35.01, -25.76, -30.89, -28.35, -32.08, -30.83, 3, -28.73, -29.98, -28.38, -32.13, 
	-27.08, -33.33, 3, -24.68, -29.52, -21.20, -23.65, -15.42, -25.84, 3, -17.42, -31.46, -14.85, -33.22, 
	-14.58, -37.50, 3, -21.42, -40.18, -14.18, -46.01, -12.92, -50.00, 0 }
	
shape[2] = { 1, -39.86, -16.10, 3, -38.85, -15.54, -38.19, -14.70, -37.90, -13.58, 3, -41.21, -12.52, -41.73, -13.41, 
	-39.86, -16.10, 0, 1, 2.41, -49.69, 3, 2.88, -49.69, 3.35, -49.69, 3.81, -49.69, 3, 3.59, -49.10, 3.32, 
	-48.54, 2.97, -48.01, 3, 3.97, -48.35, 4.99, -48.54, 6.05, -48.57, 3, 5.81, -47.87, 5.35, -47.41, 4.65, 
	-47.17, 3, 4.88, -47.11, 5.64, -43.42, 5.21, -42.69, 3, 6.59, -43.96, 8.34, -45.05, 10.18, -45.46, 3, 
	11.26, -45.72, 12.31, -45.64, 13.33, -45.21, 3, 14.36, -45.31, 13.52, -46.96, 14.45, -47.17, 3, 15.13, 
	-46.96, 15.50, -46.49, 15.57, -45.77, 3, 16.47, -46.37, 17.32, -46.30, 18.14, -45.55, 3, 20.45, -43.94, 
	19.48, -45.74, 21.17, -46.89, 3, 21.90, -44.49, 25.28, -46.36, 26.76, -46.61, 3, 27.68, -43.27, 26.20, 
	-38.24, 29.56, -35.97, 3, 25.68, -36.18, 29.04, -31.17, 31.22, -31.09, 3, 35.96, -30.93, 32.26, -27.47, 
	33.48, -25.90, 3, 35.41, -28.20, 34.20, -27.85, 36.56, -28.41, 3, 36.03, -26.95, 34.44, -23.35, 37.68, 
	-23.10, 3, 35.76, -21.52, 36.51, -19.80, 35.16, -18.06, 3, 35.51, -16.86, 39.19, -12.48, 39.44, -12.66, 
	3, 38.38, -11.93, 41.00, -10.04, 41.18, -9.52, 3, 41.80, -7.71, 36.28, -4.85, 36.28, -7.98, 3, 34.57, 
	-7.55, 35.77, -5.37, 34.04, -4.90, 3, 35.01, -3.31, 36.08, -4.49, 37.40, -4.21, 3, 39.91, -3.68, 39.52, 
	-0.60, 40.33, 1.61, 3, 42.02, 6.26, 46.34, 5.76, 50.00, 6.86, 3, 51.18, 12.56, 45.54, 9.79, 43.05, 13.57, 
	3, 41.88, 15.35, 40.55, 15.48, 39.63, 16.76, 3, 38.33, 18.55, 37.36, 15.59, 37.96, 14.70, 3, 37.64, 
	14.70, 34.90, 17.55, 35.16, 15.26, 3, 34.89, 15.73, 34.61, 16.19, 34.32, 16.66, 3, 33.53, 16.08, 32.50, 
	15.97, 32.05, 16.99, 3, 31.45, 18.35, 33.38, 19.69, 33.46, 19.55, 3, 33.16, 19.87, 32.80, 20.02, 32.36, 
	20.02, 3, 33.09, 20.92, 32.95, 22.24, 33.36, 23.26, 3, 33.68, 24.07, 34.28, 24.48, 35.16, 24.50, 3, 
	35.05, 25.48, 35.33, 26.32, 36.00, 27.01, 3, 36.74, 27.13, 35.83, 25.50, 36.56, 25.62, 3, 37.95, 26.95, 
	37.92, 32.26, 37.22, 33.41, 3, 36.19, 35.10, 34.47, 36.03, 36.28, 37.65, 3, 32.72, 39.03, 35.66, 40.39, 
	35.44, 42.13, 3, 33.42, 42.64, 32.82, 44.48, 33.48, 46.33, 3, 31.91, 46.66, 30.33, 46.86, 28.72, 46.89, 
	3, 28.29, 47.44, 28.52, 49.69, 27.60, 49.69, 3, 27.51, 49.13, 27.42, 48.57, 27.32, 48.01, 3, 25.50, 
	48.79, 21.74, 46.64, 21.24, 46.96, 3, 21.05, 47.08, 19.96, 47.98, 19.76, 48.01, 3, 18.06, 46.59, 19.03, 
	41.12, 15.28, 43.25, 3, 14.33, 42.06, 15.26, 41.39, 15.01, 40.45, 3, 14.55, 38.36, 11.27, 39.50, 11.09, 
	36.25, 3, 8.35, 39.01, 4.11, 40.36, 2.20, 43.90, 3, -0.43, 48.78, -0.58, 41.05, -1.51, 39.61, 3, -2.72, 
	39.38, -2.96, 40.36, -4.03, 40.45, 3, -5.64, 38.35, -5.82, 36.39, -8.41, 37.05, 3, -11.66, 37.90, -10.04, 
	35.20, -12.61, 35.97, 3, -14.48, 36.53, -12.46, 38.73, -14.11, 38.77, 3, -13.78, 37.14, -14.09, 35.60, 
	-15.83, 37.02, 3, -17.13, 38.08, -18.44, 34.85, -18.87, 33.73, 3, -19.57, 35.50, -21.29, 36.33, -22.51, 
	37.65, 3, -26.99, 34.12, -19.44, 28.04, -19.15, 33.45, 3, -17.78, 32.55, -19.15, 28.92, -15.79, 27.86, 
	3, -15.16, 28.85, -14.83, 30.25, -13.55, 30.66, 3, -12.28, 30.26, -12.66, 28.98, -11.59, 28.70, 3, -12.84, 
	28.54, -12.85, 27.40, -12.99, 26.46, 3, -15.08, 27.52, -17.14, 27.34, -19.15, 26.18, 3, -20.00, 26.70, 
	-18.73, 27.50, -18.87, 28.14, 3, -20.31, 28.65, -22.06, 28.75, -23.07, 30.10, 3, -23.52, 29.43, -23.99, 
	28.78, -24.47, 28.14, 3, -25.05, 28.75, -25.61, 28.75, -26.14, 28.14, 3, -26.20, 28.65, -26.38, 29.12, 
	-26.70, 29.53, 3, -28.29, 28.74, -29.50, 29.13, -31.18, 29.26, 3, -30.37, 24.87, -28.24, 23.40, -28.66, 
	18.90, 3, -27.26, 18.38, -23.10, 13.01, -26.98, 14.14, 3, -26.34, 9.25, -25.20, 5.50, -32.02, 7.98, 
	3, -32.30, 7.52, -32.30, 7.05, -32.02, 6.58, 3, -33.33, 6.73, -34.16, 6.12, -34.54, 4.90, 3, -34.00, 
	4.70, -33.44, 4.60, -32.86, 4.62, 3, -33.35, 3.81, -34.42, 4.86, -35.10, 4.62, 3, -35.46, 3.47, -35.21, 
	2.10, -36.00, 1.08, 3, -36.78, 0.07, -40.42, -7.67, -41.26, -4.06, 3, -43.15, -4.64, -43.79, -6.60, 
	-44.34, -8.26, 3, -45.47, -7.57, -47.94, -8.24, -47.70, -9.94, 3, -50.58, -8.42, -50.18, -13.44, -50.00, 
	-14.47, 3, -49.37, -18.11, -45.00, -15.83, -43.76, -13.45, 3, -42.64, -11.30, -43.58, -11.02, -41.59, 
	-9.87, 3, -40.24, -9.09, -39.54, -7.40, -39.02, -6.02, 3, -38.18, -6.98, -37.34, -6.98, -36.50, -6.02, 
	3, -33.51, -10.01, -37.69, -14.26, -37.90, -18.62, 3, -39.10, -18.15, -39.75, -19.33, -39.11, -20.38, 
	3, -38.28, -21.72, -38.36, -20.50, -37.06, -20.57, 3, -37.98, -23.18, -35.04, -23.66, -33.98, -24.49, 
	3, -34.34, -20.96, -29.62, -25.16, -28.67, -23.37, 3, -28.30, -24.27, -28.12, -25.21, -28.11, -26.17, 
	3, -28.20, -25.01, -30.49, -25.04, -30.91, -25.89, 3, -29.68, -25.69, -29.23, -26.41, -29.39, -27.60, 
	3, -29.80, -30.60, -30.82, -29.05, -33.15, -29.81, 3, -32.79, -30.63, -32.51, -31.47, -32.31, -32.33, 
	3, -30.34, -30.80, -27.04, -31.48, -24.75, -31.21, 3, -25.28, -32.76, -24.41, -34.14, -23.93, -35.54, 
	3, -23.12, -37.95, -25.51, -37.06, -24.47, -39.33, 3, -25.45, -40.56, -27.76, -41.87, -26.38, -43.30, 
	3, -24.65, -45.11, -24.69, -42.12, -24.75, -41.01, 3, -21.84, -42.01, -23.94, -45.93, -20.55, -45.77, 
	3, -19.09, -44.12, -20.69, -42.93, -18.11, -42.59, 3, -15.88, -42.30, -16.05, -43.74, -15.23, -45.49, 
	3, -14.86, -44.59, -10.97, -44.40, -10.19, -44.37, 3, -10.22, -44.75, -10.41, -45.03, -10.75, -45.21, 
	3, -9.79, -45.75, -8.77, -46.03, -7.67, -46.05, 3, -7.98, -47.07, -8.26, -48.09, -8.51, -49.13, 3, -6.95, 
	-48.29, -5.23, -47.91, -3.75, -46.89, 3, -3.03, -50.23, 1.00, -47.42, 2.41, -49.69, 0 }

shape[3] =  { 1, -50.00, 13.68, 3, -49.30, 13.68, -48.60, 13.68, -47.89, 13.68, 3, -44.92, 2.85, -49.20, -3.64, -45.79, 
	-11.58, 3, -38.97, -10.10, -41.39, -19.32, -37.89, -23.16, 3, -36.79, -22.93, -36.50, -23.52, -35.79, 
	-23.68, 3, -33.61, -22.78, -33.53, -21.81, -30.53, -22.63, 3, -28.34, -25.39, -25.59, -27.83, -27.37, 
	-33.16, 3, -24.62, -35.47, -20.59, -35.00, -17.89, -36.32, 3, -15.12, -35.23, -14.59, -31.90, -10.00, 
	-32.63, 3, -9.77, -28.58, -8.83, -28.78, -10.53, -25.79, 3, -10.36, -25.08, -9.21, -25.35, -8.42, -25.26, 
	3, -7.50, -23.40, -8.77, -23.97, -8.95, -22.11, 3, -8.30, -21.35, -6.94, -21.31, -6.32, -20.53, 3, -6.77, 
	-20.95, -6.63, -21.97, -7.37, -22.11, 3, -4.54, -21.45, 1.04, -22.33, 2.10, -26.32, 3, 6.67, -25.41, 
	5.73, -32.41, 10.53, -33.69, 3, 10.44, -34.30, 9.57, -34.13, 8.95, -34.21, 3, 9.43, -36.46, 12.54, -35.95, 
	13.16, -34.21, 3, 14.70, -35.30, 17.24, -35.40, 18.42, -36.84, 3, 18.59, -36.84, 18.77, -36.84, 18.95, 
	-36.84, 3, 21.73, -35.92, 25.74, -35.29, 27.89, -35.26, 3, 28.15, -33.61, 26.28, -34.07, 26.84, -32.11, 
	3, 28.49, -32.00, 28.62, -30.37, 30.53, -30.53, 3, 28.98, -27.44, 32.02, -26.56, 31.05, -24.74, 3, 33.00, 
	-22.99, 35.07, -26.48, 35.79, -24.21, 3, 36.12, -22.12, 33.79, -22.70, 34.21, -20.53, 3, 36.61, -18.74, 
	40.81, -20.48, 42.63, -17.37, 3, 42.77, -15.83, 41.44, -15.75, 41.58, -14.21, 3, 45.64, -14.76, 46.74, 
	-12.36, 50.00, -12.11, 3, 50.00, -11.41, 50.00, -10.70, 50.00, -10.00, 3, 48.69, -10.08, 48.37, -9.17, 
	47.37, -8.95, 3, 46.63, -6.77, 49.92, -5.93, 48.42, -4.74, 3, 46.19, -5.01, 45.14, -7.29, 43.16, -6.32, 
	3, 43.05, -4.28, 43.14, -2.44, 43.68, -1.05, 3, 42.34, -0.99, 40.98, -0.95, 41.05, 0.52, 3, 44.16, -0.70, 
	42.12, 2.44, 45.79, 2.63, 3, 46.76, 4.44, 45.48, 4.92, 43.68, 5.26, 3, 45.59, 9.22, 42.30, 9.17, 44.74, 
	12.10, 3, 41.37, 13.72, 43.44, 17.51, 40.53, 19.47, 3, 37.06, 19.64, 33.19, 20.68, 29.47, 21.58, 3, 
	29.19, 23.97, 29.74, 25.52, 31.05, 26.31, 3, 30.43, 29.28, 29.37, 31.98, 26.32, 33.68, 3, 25.19, 32.00, 
	25.55, 32.12, 26.32, 30.53, 3, 24.40, 29.71, 23.14, 32.09, 20.53, 32.10, 3, 20.22, 33.95, 23.01, 33.83, 
	21.58, 35.26, 3, 20.01, 35.45, 18.37, 35.57, 17.89, 36.84, 3, 17.54, 36.84, 17.19, 36.84, 16.84, 36.84, 
	3, 16.84, 36.67, 16.84, 36.49, 16.84, 36.32, 3, 14.83, 35.38, 12.83, 34.83, 11.58, 36.84, 3, 11.41, 
	36.84, 11.23, 36.84, 11.05, 36.84, 3, 11.52, 34.31, 8.06, 31.51, 7.37, 28.42, 3, 0.37, 32.56, -8.40, 
	29.24, -12.10, 24.21, 3, -11.81, 22.93, -9.43, 23.73, -10.00, 21.58, 3, -13.07, 20.96, -12.92, 23.57, 
	-15.26, 23.68, 3, -15.38, 22.75, -14.73, 21.05, -16.31, 21.58, 3, -19.32, 23.66, -23.97, 24.10, -24.21, 
	28.95, 3, -26.79, 28.70, -27.64, 30.88, -31.05, 31.05, 3, -32.69, 29.94, -31.16, 28.71, -32.10, 27.37, 
	3, -39.97, 30.40, -44.52, 26.44, -48.42, 19.48, 3, -46.43, 19.83, -48.68, 17.03, -47.89, 15.27, 3, -48.84, 
	15.33, -49.00, 14.62, -50.00, 14.74, 3, -50.00, 14.39, -50.00, 14.03, -50.00, 13.68, 0 }

shape[4] =  { 1, -9.26, -45.50, 3, -8.73, -45.50, -8.20, -45.50, -7.67, -45.50, 3, -1.77, -44.96, -0.97, -42.08, 3.44, 
	-39.68, 3, 4.55, -43.63, 8.95, -42.22, 12.44, -44.44, 3, 12.74, -43.51, 11.80, -41.33, 12.96, -41.27, 
	3, 14.07, -42.57, 15.49, -39.74, 17.20, -41.27, 3, 17.24, -40.35, 17.08, -39.62, 16.67, -39.15, 3, 20.97, 
	-36.84, 31.87, -36.84, 31.48, -30.16, 3, 33.61, -30.34, 35.35, -30.15, 35.71, -28.57, 3, 35.80, -27.17, 
	36.72, -24.00, 35.71, -21.69, 3, 34.37, -21.12, 33.66, -24.17, 33.60, -21.69, 3, 32.49, -19.86, 36.18, 
	-18.29, 37.83, -17.46, 3, 37.92, -18.25, 37.64, -19.41, 38.36, -19.58, 3, 40.82, -17.62, 41.84, -14.24, 
	42.59, -10.58, 3, 45.13, -9.76, 46.55, -7.83, 47.35, -5.29, 3, 46.41, -3.42, 42.66, -4.34, 42.59, -1.59, 
	3, 45.14, -0.43, 46.66, 1.75, 47.35, 4.76, 3, 47.03, 5.50, 45.32, 4.84, 45.24, 5.82, 3, 46.37, 6.98, 
	48.66, 6.98, 48.94, 8.99, 3, 48.94, 9.69, 48.02, 9.48, 47.88, 10.05, 3, 49.33, 10.10, 48.95, 9.17, 50.00, 
	10.05, 3, 50.00, 10.40, 50.00, 10.76, 50.00, 11.11, 3, 48.98, 11.33, 49.58, 13.16, 47.88, 12.70, 3, 
	48.35, 14.64, 50.12, 15.87, 48.94, 17.99, 3, 49.46, 18.93, 44.44, 17.12, 45.24, 16.93, 3, 43.47, 17.35, 
	42.57, 20.10, 40.48, 21.16, 3, 37.30, 22.76, 33.73, 21.37, 32.01, 24.34, 3, 30.39, 24.30, 29.26, 22.39, 
	27.78, 23.81, 3, 31.40, 25.85, 36.53, 25.61, 38.89, 29.10, 3, 38.32, 32.82, 31.51, 33.34, 29.36, 32.27, 
	3, 28.60, 35.17, 23.12, 36.70, 20.37, 34.39, 3, 19.21, 34.47, 19.23, 35.72, 19.31, 37.03, 3, 17.13, 
	35.80, 9.75, 34.95, 11.38, 30.16, 3, 10.37, 28.68, 7.99, 30.25, 7.14, 30.68, 3, 7.13, 31.93, 8.05, 32.24, 
	7.67, 33.86, 3, 5.57, 37.00, 0.63, 35.92, 0.26, 38.62, 3, -1.26, 38.06, -1.49, 37.02, -0.79, 35.45, 
	3, -2.78, 36.57, -3.58, 36.82, -5.56, 37.03, 3, -5.31, 41.30, -6.68, 41.45, -8.20, 44.44, 3, -11.18, 
	44.98, -14.12, 42.64, -15.08, 45.50, 3, -15.61, 45.50, -16.14, 45.50, -16.67, 45.50, 3, -17.12, 43.81, 
	-15.84, 43.86, -15.61, 42.85, 3, -17.32, 41.33, -18.74, 44.16, -19.84, 42.85, 3, -21.61, 40.92, -17.48, 
	39.03, -19.31, 37.03, 3, -21.14, 36.21, -21.79, 36.68, -23.55, 37.56, 3, -25.06, 36.25, -26.45, 34.83, 
	-27.25, 32.80, 3, -34.02, 32.87, -35.89, 28.04, -39.42, 24.87, 3, -39.42, 23.45, -39.42, 22.04, -39.42, 
	20.63, 3, -45.76, 22.28, -48.32, 11.49, -45.77, 6.35, 3, -45.93, 4.22, -48.45, 4.44, -48.41, 2.11, 3, 
	-47.66, 2.16, -46.92, 2.20, -46.83, 1.58, 3, -47.91, 1.08, -48.92, 0.50, -50.00, -0.00, 3, -50.00, -0.18, 
	-50.00, -0.36, -50.00, -0.53, 3, -46.38, -0.66, -49.40, -4.37, -48.94, -7.41, 3, -48.50, -8.55, -45.57, 
	-7.21, -45.24, -8.47, 3, -46.62, -9.17, -46.25, -10.82, -45.77, -12.17, 3, -44.46, -12.10, -43.22, -12.09, 
	-42.59, -12.70, 3, -42.52, -17.19, -44.55, -19.57, -45.24, -23.28, 3, -43.08, -22.71, -42.63, -23.85, 
	-42.06, -24.87, 3, -40.49, -24.86, -40.27, -23.50, -38.89, -23.28, 3, -38.43, -24.85, -41.15, -25.89, 
	-39.95, -26.46, 3, -36.99, -25.62, -37.99, -28.73, -36.25, -29.10, 3, -34.29, -27.75, -37.82, -26.21, 
	-36.25, -25.40, 3, -34.73, -26.53, -35.32, -29.77, -33.07, -30.16, 3, -33.44, -26.79, -31.62, -25.62, 
	-29.90, -24.34, 3, -34.33, -32.71, -30.26, -37.94, -20.37, -37.04, 3, -20.96, -36.39, -20.83, -35.95, 
	-19.84, -35.98, 3, -18.35, -35.54, -18.47, -36.73, -17.20, -36.51, 3, -17.28, -38.92, -17.64, -38.59, 
	-17.20, -40.74, 3, -14.70, -41.89, -13.06, -45.73, -9.26, -43.92, 3, -9.26, -44.44, -9.26, -44.97, -9.26, 
	-45.50, 2, 42.59, 16.40, 3, 39.69, 15.70, 38.23, 16.15, 36.24, 17.46, 3, 35.52, 18.67, 37.61, 19.45, 
	36.24, 19.58, 3, 34.61, 19.38, 34.19, 17.77, 33.07, 19.58, 3, 37.47, 23.62, 40.03, 16.78, 42.59, 16.40, 
	0 }

shape[5] = { 1, 5.97, -50.00, 3, 6.70, -50.00, 7.42, -50.00, 8.15, -50.00, 3, 8.80, -47.76, 9.83, -45.88, 13.58, 
	-46.74, 3, 12.08, -44.99, 12.66, -41.14, 10.32, -40.22, 3, 12.39, -37.31, 19.57, -36.43, 14.67, -32.61, 
	3, 18.14, -34.21, 22.67, -34.75, 22.28, -40.22, 3, 25.80, -39.39, 26.72, -35.96, 26.63, -31.52, 3, 28.72, 
	-28.17, 32.04, -26.06, 32.06, -20.65, 3, 35.92, -16.81, 45.31, -12.22, 39.67, -5.44, 3, 39.49, -2.71, 
	41.34, -2.03, 42.93, -1.09, 3, 41.83, 7.04, 36.73, 17.30, 48.37, 18.48, 3, 48.37, 19.57, 48.37, 20.65, 
	48.37, 21.74, 3, 46.62, 22.15, 46.49, 20.57, 45.11, 20.65, 3, 43.59, 20.74, 44.87, 22.36, 44.02, 22.83, 
	3, 43.60, 23.06, 41.95, 21.17, 40.76, 21.74, 3, 39.12, 22.53, 40.71, 23.73, 39.67, 25.00, 3, 38.30, 
	26.69, 35.32, 25.43, 34.24, 27.17, 3, 38.98, 37.55, 21.38, 34.45, 24.46, 46.74, 3, 22.24, 46.42, 22.32, 
	43.80, 20.11, 43.48, 3, 20.25, 46.16, 20.27, 48.72, 19.02, 50.00, 3, 17.57, 50.00, 16.12, 50.00, 14.67, 
	50.00, 3, 12.19, 42.92, 1.88, 37.31, 0.54, 48.91, 3, -2.71, 47.82, -1.60, 42.36, -2.72, 39.13, 3, -2.89, 
	42.95, -10.87, 38.95, -9.24, 44.57, 3, -11.17, 43.97, -13.75, 44.01, -14.67, 42.39, 3, -18.15, 43.13, 
	-16.73, 46.00, -17.93, 46.74, 3, -18.78, 46.98, -20.08, 46.77, -20.11, 47.83, 3, -21.23, 44.15, -25.24, 
	46.93, -27.72, 45.65, 3, -30.49, 44.22, -30.17, 40.59, -33.15, 40.22, 3, -30.43, 38.29, -31.98, 38.83, 
	-32.06, 34.78, 3, -35.49, 31.86, -39.05, 28.98, -36.41, 22.83, 3, -37.97, 25.26, -38.66, 28.55, -41.85, 
	29.35, 3, -42.85, 22.94, -40.47, 12.79, -48.37, 10.87, 3, -48.37, 10.51, -48.37, 10.15, -48.37, 9.79, 
	3, -46.34, 7.66, -44.39, 9.45, -41.85, 9.79, 3, -41.68, 7.08, -43.56, 6.42, -44.02, 4.35, 3, -45.63, 
	1.80, -41.27, 1.74, -40.76, 0.00, 3, -40.64, -0.40, -42.17, -3.25, -41.85, -5.43, 3, -41.65, -6.73, 
	-39.67, -8.75, -39.67, -8.69, 3, -39.88, -13.33, -44.69, -16.17, -42.93, -19.56, 3, -48.86, -18.42, 
	-42.62, -23.24, -48.37, -22.83, 3, -48.37, -23.19, -48.37, -23.55, -48.37, -23.91, 3, -45.31, -23.75, 
	-45.23, -26.57, -45.11, -29.35, 3, -41.92, -30.59, -41.07, -29.99, -39.67, -27.17, 3, -37.37, -30.02, 
	-35.86, -26.76, -33.15, -27.17, 3, -31.65, -27.41, -31.92, -28.95, -30.98, -29.35, 3, -29.76, -29.86, 
	-27.83, -28.79, -26.63, -29.35, 3, -24.53, -30.32, -24.63, -32.96, -23.37, -29.35, 3, -21.60, -29.37, 
	-25.11, -35.49, -22.28, -36.96, 3, -23.38, -40.57, -28.30, -40.36, -27.72, -45.65, 3, -24.40, -45.71, 
	-22.18, -44.66, -21.20, -42.39, 3, -19.45, -43.91, -20.04, -47.76, -17.94, -48.91, 3, -12.62, -47.95, 
	-9.63, -47.44, -8.15, -44.57, 3, -7.57, -43.43, -10.25, -42.86, -10.33, -42.39, 3, -10.59, -40.93, -8.15, 
	-40.49, -8.15, -39.13, 3, -6.02, -43.34, -3.05, -46.82, 2.71, -44.57, 3, 4.62, -45.55, 4.70, -48.37, 
	5.97, -50.00, 0 }

