function param1()
  return "粒子数", 0, 100, 75
end

function param2()
	return "粒子密度", 0, 100, 20
end

function param3()
	return "大きさのジッタ", 0, 100, 5
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "ソフトエッジ", 0, 1, 1
end

function param6()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.5
end

function main( x, y, p )

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param6() )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local mul = 0.004
	local itv = 1 + (100 - bs_param2())/2
	local rdmSpin = bs_grand( 0, 3.14 )
	local rdmSize = math.random()/5000 * bs_param3()
	local xrdm = math.random( -w * itv, w * itv )
	local yrdm = math.random( -w * itv, w * itv )

	if ( bs_param5()==1 ) then
		xrdm = bs_grand( 0, w * itv * 0.8 )
		yrdm = bs_grand( 0, w * itv * 0.8 )
		
		if ( math.abs(xrdm) > 1.75*w*itv or math.abs(yrdm) > 1.75*w*itv ) then return 0 end
		
	end



	if ( not firstDraw ) then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if ( distance < 0.8 * w * (100-bs_param1())/100 ) then
				return 0
			end
	end

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then

				bs_bezier_mul( (mul + rdmSize) * w, (mul + rdmSize) * w ) 
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( x + xrdm, y + yrdm )

				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, 41.04, 47.64, 3, 12.80, 92.72, -30.26, 60.17, -41.04, 50.00, 3, -66.66, 25.83, -98.16, -35.92, -29.97, 
	-50.00, 3, 38.21, -64.08, 69.28, 2.55, 41.04, 47.64, 0 }
