function param1()
  return "線数", 10, 100, 35
end

function param2()
  return "線間隔", 0, 100, 60
end

function param3()
  return "線間隔ジッタ", 0, 100, 15
end

function param4()
  return "にじみ量", 0, 100, 60
end

function param5()
  return "筆圧にじみ", 0, 100, 30
end

function param6()
  return "白フチ", 0, 1, 0
end

function param7()
  return "白フチ幅", 0, 100, 80
end

function param8()
  return "破線", 0, 1, 0
end

function param9()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 1.00
end


function main( x, y, p )

	local mul = 0.025
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param9() )

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )
	local FillCheck = r + g + b
	local UseMat = bs_param6()
	local AddWidth = 1 + math.floor( FillCheck/765 ) * 0.2
	local WhiteWidth = 1 + bs_param7() * 2 * UseMat
	local prssWidth = 1.5 + 10 * p * bs_param5()/100
	local dottedLine = 1 - 0.8 * bs_param8()


	if ( not firstDraw ) then
			if distance < w then
				return 0
			end
	end

	if ( drawCount < 250 ) then
			drawCount = drawCount + 1
			return 0
	end

	local code = ''
	currentTime = bs_ms()

-- double stroke

	if ( WhiteWidth > 1 ) then

-- 1st fill	white ink

		if ( FillCheck < 765 ) then

			for stk=0, num do

			local id = 1
			local rdm1 = bs_grand( 0, 3.14 )
			local stretch = 0

			bs_polygon( -50, -50 )
			bs_polygon( 50, -50 )  
			bs_polygon( 50, 50 ) 
			bs_polygon( -50, 50 )

				if ( previousTime==currentTime ) then	stretch = 0
						else
								stretch = distance / (currentTime - previousTime)
				end

			bs_polygon_mul( mul * w * ( 1 + stretch/8 ) * 0.35 *1.5, mul * w * prssWidth * bs_param4()/5000 * rdmWidth[stk] * WhiteWidth * 0.3 ) 
			bs_polygon_move( 0, ( stk - num/2 ) * w * bs_param2()/20 * rdmOffset[stk] + offset[stk] )
			bs_polygon_rotate( bs_atan( dx, dy ) )
			bs_polygon_move( x, y )
			bs_fill( 255,255,255,255 )

		end

	end

-- 2nd fill black ink

		for stk=0, num do

		local id = 1

			repeat

				local stretch = 0

				code = cmdcon[ shape[id] ]

				if (code=='z') then

						if ( previousTime==currentTime ) then
							stretch = 0
						else
							stretch = distance / (currentTime - previousTime)
						end

						local rdm0 = 1 -2 * ( math.random(2) % 2 )

						bs_bezier_rotate( rdm1 )
						bs_bezier_mul( mul * w * ( 1 + stretch/8 ) * dottedLine,
													 mul * w * prssWidth * bs_param4()/500 * rdm0 * rdmWidth[stk] * AddWidth )
						bs_bezier_move( 0, ( stk - num/2 ) * w * bs_param2()/20 * rdmOffset[stk] + offset[stk] )
						bs_bezier_rotate( bs_atan( dx, dy ) )
						bs_bezier_move( x, y )
						bs_fill( r,g,b,a )

						id = id + 1

				else
					id = ( cmd[code] or cmd.default )( shape, id+1 )
				end

			until id > #shape

		end

-- single ink

else

		for stk=0, num do

		local id = 1

			repeat

				local stretch = 0

				code = cmdcon[ shape[id] ]

				if (code=='z') then

						if ( previousTime==currentTime ) then
							stretch = 0
						else
							stretch = distance / (currentTime - previousTime)
						end

						local rdm0 = 1 -2 * ( math.random(2) % 2 )

						bs_bezier_rotate( rdm1 )
						bs_bezier_mul( mul * w * ( 1 + stretch/8 ) * dottedLine,
													 mul * w * prssWidth * bs_param4()/500 * rdm0 * rdmWidth[stk] * AddWidth )
						bs_bezier_move( 0, ( stk - num/2 ) * w * bs_param2()/20 * rdmOffset[stk] + offset[stk] )
						bs_bezier_rotate( bs_atan( dx, dy ) )
						bs_bezier_move( x, y )
						bs_fill( r,g,b,a )

						id = id + 1

				else
					id = ( cmd[code] or cmd.default )( shape, id+1 )
				end

			until id > #shape

		end
end

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	previousTime = currentTime

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

currentTime, previousTime = 0, 0
drawCount = 0

num = 2 * math.floor( bs_param1()/10 )
offset = {}
rdmWidth = {}
rdmOffset = {}
offsetrdm1 = 100 - bs_param3()/4
offsetrdm2 = 100 + bs_param3()/4

for i=0, num do
	offset[i] = bs_grand( 0, bs_width_max()/num ) * 4.5
	rdmWidth[i] = math.random(70,130)/100
	rdmOffset[i] = math.random(offsetrdm1,offsetrdm2)/100
end

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, 4.27, 24.00, 3, -5.32, 23.45, -14.20, 20.22, -21.03, 17.57, 3, -26.80, 4.76, -29.74, 2.76, -31.88, 
	-0.11, 3, -33.94, -2.86, -36.56, -10.29, -35.73, -12.31, 3, -26.59, -12.69, -19.53, -14.37, -11.16, 
	-14.91, 3, 0.41, -15.70, -1.24, -15.65, 6.32, -16.29, 3, 10.49, -16.65, 17.05, -15.89, 23.22, -14.94, 
	3, 28.21, -14.18, 26.32, -13.31, 36.08, -13.40, 3, 34.79, -7.86, 32.61, 5.89, 26.58, 11.39, 3, 21.61, 
	12.69, 15.13, 18.89, 4.27, 24.00, 0 }

