function param1()
  return "インク量", 0, 100, 50
end

function param2()
  return "かすれ強調", 0, 100, 40
end

function param3()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0
end



function main( x, y, p )

	local mul = 0.01

	local rdmSize = bs_grand( 0, 0.1 ) % 0.1 * 0.05

	local press = p
	local pressMax = 1.0001 - bs_param1() / 100
				if ( p > pressMax ) then press = pressMax end 

	local scratchy = 1 + bs_grand( 3.6, 1.8 ) * bs_param2() / 100

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param3() )

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )

	if ( not firstDraw ) then
			if ( distance <  scratchy * 2 * w + ( 0.2 - 2*scratchy ) * w * press / pressMax ) then
				return 0
			end
	end


	local id = 1
	local code = ''

	repeat

		local stretch = 0
		code = cmdcon[shape[id]]

		if (code=='z') then

				currentTime = bs_ms()

				if ( previousTime==currentTime ) then
					stretch = 0
				else
					stretch = distance / (currentTime - previousTime)
				end

				bs_bezier_rotate( bs_grand( 0, 3.14 ) )
				bs_bezier_mul( (1.1+stretch/3) * ( mul + rdmSize ) * w, ( mul + rdmSize/2) * w ) 
				bs_bezier_rotate( bs_atan( dx, dy ) )
				bs_bezier_move( x, y )
				bs_fill( r,g,b,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	previousTime = currentTime

	return 1
end

bs_setmode( 1 )
lastDrawX = 0
lastDrawY = 0
firstDraw = true

intersection = 0

currentTime, previousTime = 0, 0

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, 13.29, -48.39, 3, 8.33, -54.94, -4.45, -54.74, -11.56, -50.00, 3, -17.91, -45.11, -20.60, -38.89, 
	-26.67, -32.96, 3, -31.85, -27.91, -32.00, -17.41, -33.78, -11.19, 3, -35.45, -5.35, -33.58, 11.62, 
	-32.15, 14.89, 3, -29.63, 20.67, -24.88, 33.42, -22.66, 37.27, 3, -20.44, 41.12, -8.36, 47.95, -3.25, 
	50.00, 3, 1.78, 52.02, 14.30, 48.29, 17.49, 45.11, 3, 21.27, 41.34, 23.26, 38.74, 26.37, 30.15, 3, 29.38, 
	21.83, 33.49, 15.79, 33.78, 0.08, 3, 33.89, -5.88, 31.56, -14.00, 29.94, -23.63, 3, 25.95, -37.19, 20.71, 
	-44.11, 13.29, -48.39, 0 }
