function param1()
  return "ブラシ間隔", 10, 100, 20
end

function param2()
	return "大きさのジッタ", 0, 100, 30
end

function param3()
	return "位置のジッタ", 0, 100, 10
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "グリッドスナップ", 0, 1, 0
end

function param6()
	return "グリッド間隔", 1, 100, 30
end

function param7()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.5
end

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.08
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param7() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local SpinCheck = 1	
	local GridLock = bs_param5()

	local canvasW = bs_canvas_width()
	local canvasH = bs_canvas_height() 
	local dpi = bs_canvas_dpi() 
	local GridReso = 16 * bs_param6() / 5

	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso
	local GridSpin = 1

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end

	if ( GridLock==1 ) then
				math.randomseed( gridX * gridX * gridY * gridY )
	end

	local rdmSpin = math.random() * 3.14
	local rdmSize = math.random() * bs_param2()/500
	local rdmShape = math.random(4)

	if ( SpinCheck == 0 ) then dx,dy = 0,0 rdmSpin = 0 end

	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 200
			math.randomseed(bs_ms()*x+y)
			rdmSize = (1 -2 * ( math.random(2) % 2 )) * math.random() * bs_param2()/100 * 0.5
			rdmSpin = math.random() * 3.14
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100 * ( 10 - GridLock * 9 ) * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100 * ( 10 - GridLock * 9 ) * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	shape = {}
	shape = stroke[rdmShape]
	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * (1 -2 * ( math.random(2) % 2 )), (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end

setmode = bs_param4()
if ( setmode == 0 ) then bs_setmode(1) else bs_setmode(0) end

lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

stroke ={}

stroke[1] = { 1, -4.24, -32.61, 3, -1.54, -31.60, -4.24, -32.61, -3.84, -34.43, 3, -3.13, -36.53, -0.30, -37.29, 1.93, 
	-36.79, 3, 7.96, -33.21, -1.13, -28.29, 0.15, -23.47, 3, 5.36, -22.91, 8.93, -14.21, 10.36, -14.01, 
	3, 10.73, -11.81, 8.38, -8.74, 6.65, -8.07, 3, 10.65, -8.04, 7.12, -3.98, 9.25, -2.13, 3, 9.16, -0.36, 
	10.16, 2.91, 5.72, 3.06, 3, 4.25, 2.33, 2.93, -4.64, 2.20, -6.59, 3, 0.88, -6.51, -0.31, -6.79, -2.63, 
	-9.18, 3, -3.66, -5.57, 4.46, -1.99, -0.03, 1.02, 3, 0.96, 4.93, -5.51, 7.95, -8.33, 8.71, 3, -12.64, 
	9.88, -13.84, 6.93, -12.76, 3.60, 3, -11.70, 0.39, -13.22, 1.70, -13.88, -1.19, 3, -14.49, -3.81, -12.47, 
	-4.49, -11.16, -4.36, 3, -7.49, -6.24, -14.98, -6.94, -16.77, -8.38, 3, -20.53, -11.42, -22.84, -5.65, 
	-25.63, -20.50, 3, -23.83, -21.18, -22.96, -22.48, -23.04, -24.40, 3, -28.42, -23.02, -29.34, -14.37, 
	-36.11, -13.54, 3, -40.94, -14.28, -39.72, -19.86, -39.08, -22.07, 3, -35.46, -23.02, -36.84, -24.96, 
	-36.79, -27.58, 3, -37.58, -27.04, -47.21, -19.67, -46.91, -25.21, 3, -46.68, -29.39, -40.33, -30.83, 
	-40.29, -35.34, 3, -36.80, -34.91, -37.53, -31.15, -36.21, -28.85, 3, -36.69, -28.78, -32.99, -30.31, 
	-33.24, -30.15, 3, -33.62, -27.52, -31.15, -29.57, -31.39, -26.99, 3, -31.16, -27.16, -28.21, -31.43, 
	-29.72, -31.63, 3, -32.59, -31.41, -35.62, -32.43, -33.24, -37.20, 3, -32.72, -37.02, -28.33, -47.77, 
	-27.56, -48.96, 3, -25.57, -52.06, -26.01, -49.99, -25.36, -48.44, 3, -24.17, -45.62, -22.28, -47.95, 
	-22.67, -49.26, 3, -20.92, -50.56, -16.64, -50.20, -15.43, -50.00, 3, -14.40, -51.02, -12.73, -49.35, 
	-11.90, -47.77, 3, -17.00, -38.96, -7.58, -42.18, -6.50, -42.07, 3, -2.82, -41.70, -8.35, -26.86, -4.24, 
	-32.61, 0, 1, 22.05, 2.50, 3, 23.01, 2.11, 7.71, 1.97, 14.73, -3.83, 3, 14.97, -4.34, 15.08, -5.46, 
	14.81, -6.03, 3, 14.61, -7.23, 15.51, -7.11, 15.92, -7.51, 3, 17.80, -6.83, 23.71, -11.61, 24.64, -7.33, 
	3, 26.88, -9.14, 28.90, -10.05, 31.88, -9.00, 3, 28.87, -10.33, 31.37, -12.46, 32.25, -14.38, 3, 32.71, 
	-13.85, 33.33, -13.48, 33.36, -12.52, 3, 34.70, -12.82, 34.74, -13.43, 36.52, -13.08, 3, 36.39, -13.57, 
	36.23, -14.02, 35.96, -14.38, 3, 36.13, -14.83, 35.89, -16.78, 35.78, -18.27, 3, 37.12, -18.71, 38.12, 
	-18.48, 38.67, -19.94, 3, 38.51, -20.40, 37.54, -21.27, 37.26, -21.61, 3, 37.66, -23.42, 37.96, -22.37, 
	40.41, -22.91, 3, 41.63, -23.56, 41.49, -21.17, 42.08, -21.06, 3, 42.12, -20.18, 42.53, -18.20, 42.46, 
	-17.16, 3, 43.30, -18.53, 43.07, -20.07, 43.20, -21.61, 3, 47.09, -19.93, 45.63, -16.04, 45.79, -12.52, 
	3, 45.44, -12.18, 45.46, -12.63, 44.87, -12.52, 3, 45.11, -11.72, 46.00, -11.56, 46.54, -11.04, 3, 46.28, 
	-10.01, 46.60, -7.82, 46.91, -6.95, 3, 45.90, -2.09, 39.88, -2.79, 36.15, -1.39, 3, 36.58, -1.29, 37.58, 
	-1.05, 38.19, -1.39, 3, 39.76, -0.14, 38.10, 4.83, 37.82, 4.55, 3, 38.45, 6.43, 39.56, 8.48, 39.12, 
	9.93, 3, 39.06, 10.36, 34.40, 13.96, 33.36, 13.82, 3, 36.72, 17.17, 29.20, 18.73, 29.65, 18.83, 3, 29.53, 
	17.94, 29.61, 16.40, 29.84, 15.68, 3, 27.10, 18.16, 27.11, 11.50, 23.90, 10.85, 3, 24.94, 9.09, 24.31, 
	8.03, 24.83, 5.84, 3, 25.29, 5.50, 22.23, 5.15, 22.05, 2.50, 0, 1, 4.61, 33.67, 3, 4.61, 34.25, 5.05, 
	34.88, 4.61, 35.34, 3, 0.93, 34.37, -4.17, 34.89, -5.23, 31.82, 3, -5.82, 31.50, -4.01, 30.62, -3.18, 
	30.52, 3, -3.93, 25.38, 1.18, 22.34, -3.74, 18.83, 3, -2.37, 18.85, -0.40, 16.56, 0.90, 18.27, 3, 9.57, 
	12.45, 10.38, 22.08, 17.78, 21.80, 3, 19.04, 19.98, 22.33, 18.71, 24.46, 20.32, 3, 23.52, 21.93, 25.37, 
	22.87, 25.94, 22.91, 3, 26.83, 23.28, 25.49, 25.43, 26.31, 26.25, 3, 25.59, 26.31, 24.85, 25.77, 24.27, 
	26.25, 3, 25.00, 26.95, 25.58, 27.79, 25.94, 28.85, 3, 31.21, 29.19, 22.79, 33.29, 25.20, 37.01, 3, 
	23.20, 37.81, 21.70, 39.83, 19.45, 39.80, 3, 19.12, 39.80, 19.75, 40.67, 19.26, 40.91, 3, 16.88, 40.90, 
	15.88, 42.26, 14.07, 41.47, 3, 14.36, 40.43, 5.42, 35.28, 4.61, 33.67, 0, 1, -21.55, 31.82, 3, -21.10, 
	31.67, -18.37, 34.02, -15.80, 33.30, 3, -14.77, 32.76, -14.12, 33.63, -14.86, 34.54, 3, -11.98, 36.36, 
	-14.00, 39.82, -15.80, 40.54, 3, -15.31, 42.50, -14.17, 43.10, -14.69, 45.73, 3, -14.35, 46.08, -13.79, 
	46.19, -13.57, 46.66, 3, -14.75, 47.46, -15.34, 48.85, -16.17, 50.00, 3, -18.62, 49.10, -21.36, 44.22, 
	-21.55, 43.69, 3, -22.02, 43.34, -22.28, 43.85, -22.85, 43.51, 3, -23.19, 40.76, -25.19, 39.66, -26.56, 
	37.94, 3, -26.96, 38.10, -27.19, 38.42, -27.86, 38.31, 3, -27.74, 38.94, -27.69, 38.16, -28.23, 37.01, 
	3, -28.87, 35.96, -27.80, 34.91, -26.60, 34.85, 3, -24.19, 32.96, -27.16, 28.78, -22.11, 29.41, 3, -21.55, 
	30.18, -22.24, 31.11, -21.55, 31.82, 0,  }

stroke[2] = { 1, 2.27, 26.70, 3, 1.50, 25.70, -0.16, 26.88, -1.70, 27.84, 3, -6.64, 27.09, -2.94, 17.71, -8.52, 17.61, 
	3, -8.35, 16.45, -6.98, 16.50, -6.82, 15.34, 3, -7.15, 14.16, -8.01, 13.50, -8.52, 12.50, 3, -9.81, 
	12.91, -10.22, 14.21, -10.79, 15.34, 3, -13.12, 13.68, -12.62, 9.21, -14.20, 6.82, 3, -16.99, 8.02, 
	-16.53, 12.41, -15.34, 15.91, 3, -18.35, 18.96, -19.21, 24.16, -22.73, 26.70, 3, -22.29, 27.21, -22.12, 
	27.99, -22.16, 28.98, 3, -24.69, 28.34, -24.20, 30.72, -25.00, 31.82, 3, -26.70, 31.82, -28.41, 31.82, 
	-30.11, 31.82, 3, -30.62, 30.81, -31.49, 30.16, -31.82, 28.98, 3, -33.75, 29.50, -35.15, 30.57, -38.07, 
	30.11, 3, -37.87, 29.37, -37.07, 29.22, -36.93, 28.41, 3, -39.42, 25.97, -41.38, 23.01, -43.75, 20.45, 
	3, -43.85, 19.22, -41.74, 20.20, -40.91, 19.88, 3, -42.51, 17.47, -39.34, 16.89, -38.07, 15.34, 3, -36.96, 
	13.99, -38.89, 13.76, -36.93, 11.93, 3, -35.36, 10.46, -33.84, 9.34, -31.25, 9.66, 3, -34.77, 8.64, 
	-33.68, 3.00, -38.07, 2.84, 3, -38.07, 1.51, -38.07, 0.19, -38.07, -1.14, 3, -34.60, -1.49, -34.44, 
	-5.06, -35.80, -7.39, 3, -33.26, -8.02, -33.75, -5.64, -32.95, -4.55, 3, -29.88, -6.20, -28.91, -9.97, 
	-27.27, -13.07, 3, -27.65, -15.34, -29.74, -15.90, -31.82, -16.48, 3, -31.51, -21.29, -31.42, -26.84, 
	-34.66, -30.11, 3, -33.21, -33.87, -30.05, -37.64, -25.00, -34.66, 3, -23.76, -36.45, -22.52, -38.24, 
	-21.02, -39.77, 3, -21.34, -41.16, -23.22, -40.98, -22.73, -43.18, 3, -21.10, -44.20, -18.72, -44.48, 
	-17.61, -46.02, 3, -16.61, -45.51, -16.89, -43.72, -14.77, -44.32, 3, -10.63, -45.66, -10.31, -50.84, 
	-3.98, -50.00, 3, -4.94, -46.59, -4.30, -44.34, -1.70, -43.18, 3, -1.81, -41.58, -4.40, -42.47, -3.98, 
	-40.34, 3, -3.83, -39.16, -1.48, -40.19, -1.14, -39.20, 3, -0.55, -36.87, -3.07, -34.37, -0.57, -33.52, 
	3, -2.47, -32.39, -3.15, -30.04, -6.25, -30.11, 3, -7.77, -29.17, -7.25, -26.19, -8.52, -25.00, 3, -7.53, 
	-23.32, -5.49, -25.33, -3.98, -25.00, 3, -5.46, -21.61, -5.08, -19.75, -7.95, -17.61, 3, -6.95, -14.55, 
	-7.36, -13.09, -4.54, -12.50, 3, -5.08, -9.12, -3.79, -7.57, -1.70, -6.82, 3, -1.36, -9.03, 0.17, -10.94, 
	1.71, -13.07, 3, 2.22, -13.79, 2.03, -16.13, 3.41, -14.77, 3, 4.25, -15.26, 4.63, -16.20, 4.55, -17.61, 
	3, 8.55, -17.02, 9.45, -19.53, 11.36, -21.02, 3, 11.44, -22.04, 10.67, -22.22, 10.80, -23.30, 3, 7.80, 
	-23.64, 6.20, -22.59, 5.68, -20.45, 3, 3.64, -20.65, 2.94, -21.32, 1.14, -20.45, 3, -0.62, -26.86, 6.52, 
	-26.98, 7.39, -32.39, 3, 9.94, -32.48, 11.85, -31.93, 13.07, -30.68, 3, 14.96, -33.90, 16.19, -37.79, 
	18.18, -40.91, 3, 21.36, -41.24, 22.56, -39.61, 25.57, -39.77, 3, 25.57, -37.87, 23.29, -38.27, 22.73, 
	-36.93, 3, 23.51, -35.25, 26.34, -35.62, 28.41, -35.23, 3, 26.88, -32.69, 29.11, -31.70, 30.11, -30.11, 
	3, 30.51, -28.59, 28.94, -29.01, 28.41, -28.41, 3, 29.55, -21.49, 30.02, -16.53, 26.71, -11.93, 3, 27.70, 
	-10.46, 29.80, -10.10, 29.55, -7.39, 3, 31.20, -7.88, 30.19, -8.24, 30.11, -9.66, 3, 34.24, -11.02, 
	34.47, -16.29, 36.36, -19.89, 3, 38.73, -18.47, 38.35, -21.67, 39.77, -22.73, 3, 41.59, -22.09, 43.33, 
	-21.36, 42.61, -18.18, 3, 40.45, -17.51, 39.01, -16.10, 36.93, -15.34, 3, 37.69, -11.55, 41.62, -10.94, 
	43.75, -8.52, 3, 43.10, -7.85, 43.11, -6.51, 43.18, -5.11, 3, 41.44, -3.19, 39.83, -3.99, 37.50, -3.41, 
	3, 38.00, -5.23, 36.03, -4.59, 35.80, -5.68, 3, 30.57, -4.34, 27.56, 4.20, 29.55, 9.09, 3, 29.95, 10.63, 
	26.87, 8.69, 27.27, 10.23, 3, 25.90, 9.19, 28.05, 6.88, 27.27, 4.55, 3, 25.02, 2.33, 21.49, 5.04, 18.75, 
	5.68, 3, 19.53, 6.42, 19.31, 8.15, 19.32, 9.66, 3, 18.13, 9.42, 17.82, 10.05, 17.05, 10.23, 3, 17.37, 
	13.40, 16.79, 15.65, 15.34, 17.05, 3, 16.66, 19.24, 19.26, 16.20, 20.46, 15.91, 3, 21.29, 15.71, 21.85, 
	16.95, 21.59, 17.05, 3, 23.16, 16.47, 23.66, 14.71, 25.00, 14.21, 3, 27.87, 13.12, 29.79, 14.95, 34.66, 
	14.77, 3, 35.68, 20.15, 31.82, 20.64, 32.39, 25.57, 3, 29.98, 28.84, 26.27, 30.81, 22.73, 32.96, 3, 
	21.88, 31.43, 22.55, 30.16, 22.73, 27.27, 3, 21.40, 26.92, 18.47, 29.82, 17.61, 31.82, 3, 15.95, 31.78, 
	15.50, 30.52, 14.77, 29.55, 3, 13.19, 34.22, 9.07, 36.34, 8.52, 42.05, 3, 5.66, 41.06, 6.62, 48.35, 
	4.55, 50.00, 3, 2.46, 49.11, 0.97, 46.35, -1.14, 47.16, 3, -1.54, 44.15, -2.90, 42.11, -4.54, 40.34, 
	3, -0.70, 37.37, 1.33, 32.57, 2.27, 26.70, 2, -7.39, -38.64, 3, -7.15, -37.55, -7.18, -36.19, -5.68, 
	-36.36, 3, -6.30, -37.82, -3.95, -39.07, -5.68, -39.77, 3, -5.83, -38.97, -6.93, -39.12, -7.39, -38.64, 
	0,  }

stroke[3] = { 1, -1.91, -50.00, 3, -0.93, -49.96, -0.90, -49.09, -0.38, -48.72, 3, -0.72, -48.96, 1.37, -48.00, 0.89, 
	-47.96, 3, 1.40, -48.00, 1.81, -49.25, 2.17, -49.23, 3, 3.13, -49.20, 3.52, -48.19, 4.72, -47.96, 3, 
	9.79, -49.35, 10.64, -42.59, 10.84, -38.78, 3, 13.12, -37.89, 15.23, -39.27, 17.22, -37.24, 3, 16.05, 
	-36.97, 16.15, -35.43, 14.67, -35.46, 3, 14.33, -33.25, 13.45, -31.57, 13.39, -29.08, 3, 13.70, -28.05, 
	14.27, -28.76, 14.92, -28.32, 3, 14.58, -26.62, 12.08, -27.08, 12.12, -25.00, 3, 6.92, -24.25, 4.98, 
	-20.24, 0.89, -18.37, 3, 0.82, -17.79, 0.96, -17.41, 1.40, -17.35, 3, -2.09, -16.03, -1.84, -12.48, 
	-3.95, -9.95, 3, -1.30, -9.34, 2.05, -12.07, 4.72, -10.71, 3, 5.41, -10.96, 6.03, -11.28, 6.76, -11.48, 
	3, 7.42, -11.50, 7.17, -12.43, 7.53, -12.75, 3, 10.95, -11.94, 12.34, -16.03, 15.18, -14.80, 3, 16.67, 
	-16.45, 17.98, -18.28, 19.52, -19.90, 3, 20.58, -19.43, 22.38, -19.70, 23.34, -19.13, 3, 24.59, -20.11, 
	22.85, -21.74, 23.60, -23.47, 3, 24.40, -23.77, 25.39, -23.88, 25.64, -24.74, 3, 25.90, -24.58, 25.90, 
	-24.16, 26.40, -24.23, 3, 27.75, -25.18, 27.16, -28.07, 28.70, -28.83, 3, 29.63, -28.65, 28.65, -27.81, 
	28.95, -26.79, 3, 30.15, -28.05, 30.17, -30.50, 32.53, -30.61, 3, 33.41, -28.48, 35.48, -25.96, 33.80, 
	-23.47, 3, 34.26, -22.85, 34.51, -22.04, 34.06, -21.17, 3, 34.28, -20.42, 34.44, -21.76, 35.08, -21.43, 
	3, 34.51, -18.70, 36.70, -17.48, 35.84, -15.31, 3, 36.04, -14.74, 36.73, -14.67, 37.12, -14.29, 3, 37.28, 
	-10.73, 38.40, -8.30, 38.39, -3.83, 3, 37.20, -3.35, 36.27, -4.12, 35.59, -3.06, 3, 35.62, 1.42, 37.71, 
	3.83, 37.12, 8.93, 3, 36.78, 9.19, 36.17, 9.17, 36.10, 9.69, 3, 36.54, 13.44, 35.23, 17.01, 34.31, 19.64, 
	3, 33.43, 19.85, 33.33, 19.26, 32.53, 19.39, 3, 32.89, 16.45, 29.09, 15.53, 27.93, 13.27, 3, 25.91, 
	14.22, 24.68, 15.96, 22.58, 16.84, 3, 21.78, 16.28, 21.56, 15.14, 20.54, 14.80, 3, 21.05, 12.48, 21.39, 
	10.19, 21.05, 7.65, 3, 21.70, 7.29, 22.49, 7.06, 22.58, 6.12, 3, 21.87, 5.81, 21.10, 5.56, 20.79, 4.85, 
	3, 21.54, 3.62, 21.81, 1.51, 21.56, -0.25, 3, 19.40, 4.99, 16.29, 9.28, 13.65, 14.03, 3, 13.12, 14.14, 
	12.97, 13.86, 12.63, 13.78, 3, 11.62, 14.12, 12.07, 17.02, 10.59, 16.07, 3, 9.95, 16.74, 11.23, 16.93, 
	11.35, 17.60, 3, 10.14, 20.71, 9.37, 24.99, 10.33, 28.06, 3, 10.72, 29.03, 12.36, 28.75, 13.14, 29.34, 
	3, 10.57, 33.16, 9.43, 38.03, 9.82, 44.13, 3, 9.04, 44.37, 6.99, 45.77, 6.51, 44.64, 3, 6.20, 45.44, 
	5.61, 45.96, 4.47, 45.92, 3, 4.61, 46.75, 4.29, 47.11, 4.21, 47.70, 3, 2.00, 47.77, 1.99, 45.83, 1.91, 
	44.39, 3, 1.73, 46.08, 0.86, 47.07, 0.38, 48.47, 3, -0.83, 48.49, -0.47, 46.94, -1.40, 46.68, 3, -2.44, 
	47.28, -4.43, 47.84, -4.72, 47.45, 3, -5.12, 48.15, -5.51, 48.87, -5.74, 49.74, 3, -6.29, 49.79, -5.85, 
	48.84, -5.99, 48.47, 3, -7.10, 48.39, -6.62, 49.88, -7.78, 49.74, 3, -7.70, 49.15, -7.82, 48.77, -8.04, 
	48.47, 3, -8.53, 48.57, -8.24, 49.46, -9.06, 49.23, 3, -9.21, 48.42, -8.58, 48.45, -9.06, 47.96, 3, 
	-9.63, 48.58, -10.13, 49.27, -10.59, 50.00, 3, -11.14, 49.01, -10.56, 46.97, -10.33, 45.92, 3, -11.28, 
	44.81, -12.84, 45.76, -13.65, 44.39, 3, -13.76, 43.51, -13.55, 42.96, -13.39, 42.35, 3, -14.42, 42.37, 
	-14.68, 37.85, -16.71, 37.24, 3, -17.31, 38.43, -17.66, 39.87, -17.98, 41.33, 3, -18.46, 41.62, -19.57, 
	41.03, -19.77, 42.09, 3, -20.85, 40.71, -21.63, 39.02, -22.32, 37.24, 3, -21.66, 35.56, -20.60, 34.76, 
	-20.79, 33.16, 3, -20.96, 31.80, -22.95, 30.37, -23.34, 28.57, 3, -23.58, 27.46, -22.66, 27.02, -23.60, 
	26.02, 3, -26.24, 26.45, -27.33, 27.35, -30.48, 27.55, 3, -30.75, 24.49, -33.28, 24.90, -34.82, 23.47, 
	3, -33.78, 21.18, -34.05, 18.05, -33.80, 15.56, 3, -32.16, 14.28, -33.95, 12.40, -32.27, 10.97, 3, -33.50, 
	8.46, -35.74, 6.95, -37.12, 4.59, 3, -36.73, 3.96, -36.08, 3.58, -35.33, 3.32, 3, -36.13, 1.47, -36.50, 
	-0.79, -38.39, -1.53, 3, -38.27, -4.32, -39.02, -5.50, -38.14, -8.16, 3, -37.80, -7.74, -36.69, -8.08, 
	-36.35, -7.65, 3, -35.82, -8.22, -35.45, -8.96, -34.57, -9.18, 3, -33.71, -8.68, -34.38, -6.65, -33.80, 
	-5.87, 3, -33.05, -7.66, -31.11, -8.27, -30.49, -10.20, 3, -29.60, -8.79, -28.42, -7.68, -26.40, -7.40, 
	3, -26.56, -6.05, -26.44, -4.98, -25.13, -5.10, 3, -26.46, -2.63, -24.70, -1.51, -25.38, 1.79, 3, -23.04, 
	1.33, -24.11, -4.05, -21.81, -5.87, 3, -21.98, -6.13, -22.40, -6.13, -22.32, -6.63, 3, -20.85, -10.81, 
	-21.26, -15.29, -17.73, -17.35, 3, -17.71, -18.04, -18.15, -17.86, -17.73, -18.37, 3, -16.91, -18.82, 
	-16.21, -19.40, -15.69, -20.15, 3, -15.76, -20.68, -16.37, -20.66, -16.71, -20.92, 3, -16.29, -21.99, 
	-15.23, -22.44, -15.94, -23.98, 3, -14.75, -23.81, -15.00, -25.07, -14.67, -25.77, 3, -13.18, -26.66, 
	-12.17, -28.03, -10.84, -29.08, 3, -10.04, -28.90, -9.05, -28.00, -8.29, -28.57, 3, -9.97, -31.94, -10.98, 
	-35.87, -14.41, -37.50, 3, -14.27, -39.06, -13.53, -40.02, -12.88, -41.07, 3, -13.42, -41.55, -14.76, 
	-41.23, -15.18, -41.84, 3, -14.98, -42.06, -14.90, -42.41, -14.92, -42.86, 3, -12.10, -42.70, -8.95, 
	-42.48, -7.78, -40.05, 3, -6.65, -40.64, -8.55, -41.79, -8.80, -42.60, 3, -8.30, -43.29, -5.93, -42.07, 
	-5.74, -44.13, 3, -4.25, -43.63, -3.72, -44.70, -2.42, -44.90, 3, -2.30, -46.21, -2.67, -47.04, -3.19, 
	-47.70, 3, -2.92, -48.63, -2.43, -49.33, -1.91, -50.00, 0,  }

stroke[4] = { 1, -30.17, 7.18, 3, -32.27, 8.16, -33.52, 12.46, -35.92, 14.08, 3, -36.37, 15.92, -35.97, 18.62, -37.07, 
	19.83, 3, -38.44, 19.17, -39.53, 19.30, -40.23, 20.40, 3, -42.30, 19.83, -44.15, 20.81, -45.69, 19.83, 
	3, -45.81, 19.23, -45.49, 19.07, -45.40, 18.68, 3, -45.66, 18.07, -46.56, 19.22, -47.41, 18.97, 3, -47.09, 
	15.66, -47.20, 13.65, -45.69, 11.49, 3, -48.33, 9.62, -45.08, 4.47, -46.84, 2.59, 3, -45.31, 1.53, -43.96, 
	2.64, -42.53, 3.16, 3, -41.83, 1.56, -40.77, 0.33, -41.09, -2.30, 3, -41.91, -2.25, -42.29, -1.77, -43.10, 
	-1.72, 3, -43.65, -2.71, -43.81, -4.08, -44.83, -4.60, 3, -45.10, -4.39, -45.26, -4.08, -45.40, -3.74, 
	3, -45.80, -4.77, -46.00, -6.02, -46.26, -7.18, 3, -47.04, -7.55, -47.07, -8.20, -47.99, -7.76, 3, -47.74, 
	-8.57, -47.06, -8.94, -47.13, -10.06, 3, -48.53, -10.40, -48.09, -8.92, -49.14, -8.91, 3, -49.57, -10.24, 
	-49.22, -11.39, -48.56, -12.36, 3, -48.43, -12.83, -50.13, -12.83, -50.00, -12.36, 3, -50.57, -13.99, 
	-47.60, -14.55, -47.41, -16.38, 3, -45.91, -16.20, -45.11, -18.74, -42.24, -18.10, 3, -42.44, -20.06, 
	-38.95, -20.46, -38.22, -22.41, 3, -36.47, -22.20, -36.28, -20.74, -35.34, -20.40, 3, -35.39, -19.49, 
	-36.02, -18.29, -35.34, -17.53, 3, -34.49, -17.92, -34.15, -18.83, -33.62, -19.54, 3, -32.84, -19.75, 
	-33.04, -18.97, -32.47, -18.97, 3, -31.51, -19.25, -32.55, -20.13, -31.61, -20.69, 3, -29.16, -20.74, 
	-28.55, -18.96, -27.87, -17.24, 3, -26.41, -17.97, -26.59, -19.08, -25.57, -19.83, 3, -25.28, -21.17, 
	-26.05, -21.46, -26.44, -22.13, 3, -25.82, -23.87, -26.21, -25.10, -25.29, -26.72, 3, -22.10, -26.82, 
	-20.93, -30.05, -18.10, -29.60, 3, -18.85, -27.07, -19.73, -25.16, -17.82, -23.56, 3, -17.61, -22.68, 
	-18.31, -22.72, -18.10, -21.84, 3, -17.84, -21.23, -16.95, -22.38, -16.09, -22.13, 3, -17.50, -18.72, 
	-13.26, -18.74, -11.78, -16.67, 3, -9.60, -18.89, -7.69, -21.39, -5.46, -23.56, 3, -4.40, -23.28, -3.98, 
	-22.36, -3.45, -21.55, 3, -2.80, -21.77, -3.34, -23.16, -3.16, -23.85, 3, -2.05, -22.76, 0.09, -22.69, 
	0.86, -21.26, 3, 1.28, -21.90, 2.21, -22.02, 3.16, -22.13, 3, 2.61, -18.43, 2.08, -16.80, 1.72, -13.51, 
	3, -0.36, -12.52, -3.35, -11.54, -6.32, -12.93, 3, -7.14, -12.02, -8.57, -11.73, -9.77, -11.21, 3, -9.76, 
	-9.71, -9.23, -9.18, -8.91, -7.47, 3, -8.43, -7.47, -7.95, -7.47, -7.47, -7.47, 3, -7.41, -4.91, -5.35, 
	-5.14, -3.74, -6.03, 3, -2.74, -5.98, -2.64, -5.02, -1.72, -4.89, 3, -1.58, -4.04, -2.64, -3.26, -1.15, 
	-3.45, 3, -1.18, -2.71, -2.27, -3.04, -2.30, -2.30, 3, -1.76, -1.73, -1.26, -1.85, -1.72, -0.86, 3, 
	-1.64, -0.47, -1.00, -0.62, -0.57, -0.57, 3, 0.35, 1.26, -0.65, 5.76, 1.44, 7.18, 3, 1.11, 7.92, -0.10, 
	9.27, 0.57, 10.06, 3, -0.20, 10.52, -1.04, 10.93, -1.44, 11.78, 3, -3.69, 10.72, -5.37, 13.30, -5.17, 
	16.38, 3, -6.77, 17.49, -6.72, 19.00, -8.33, 20.40, 3, -9.25, 20.65, -9.22, 19.95, -9.77, 19.83, 3, 
	-9.56, 20.71, -10.06, 20.87, -10.06, 21.55, 3, -10.57, 21.30, -10.79, 20.75, -11.78, 20.98, 3, -11.63, 
	20.75, -11.48, 20.51, -11.49, 20.11, 3, -12.61, 20.27, -12.90, 19.60, -14.08, 19.83, 3, -15.14, 20.45, 
	-13.98, 21.57, -14.08, 22.41, 3, -14.35, 24.59, -15.84, 25.14, -16.67, 26.15, 3, -17.25, 26.06, -17.23, 
	25.37, -17.82, 25.29, 3, -19.38, 25.73, -20.20, 26.92, -20.98, 28.16, 3, -22.65, 27.44, -23.99, 26.38, 
	-25.00, 25.00, 3, -24.03, 22.88, -23.29, 22.76, -23.85, 19.83, 3, -27.48, 18.92, -22.86, 13.88, -22.99, 
	11.21, 3, -24.46, 11.26, -24.23, 13.03, -25.57, 13.22, 3, -24.74, 10.18, -26.48, 8.05, -25.57, 5.17, 
	3, -27.61, 5.44, -29.12, 7.76, -30.46, 7.76, 3, -30.51, 7.42, -30.40, 7.25, -30.17, 7.18, 0, 1, 18.68, 
	2.59, 3, 18.73, 2.26, 18.97, 2.43, 18.97, 2.59, 3, 22.45, 0.85, 24.82, -0.44, 28.74, -1.44, 3, 28.83, 
	-0.77, 28.69, -0.33, 28.45, 0.00, 3, 28.58, 0.83, 29.68, 0.68, 29.89, 1.44, 3, 34.08, 1.29, 37.10, 1.81, 
	40.23, 2.87, 3, 39.15, 4.35, 40.29, 4.84, 39.08, 6.03, 3, 40.45, 10.81, 45.26, 10.04, 50.00, 11.49, 
	3, 48.21, 13.92, 45.13, 15.05, 42.53, 16.67, 3, 41.81, 15.70, 41.38, 15.56, 40.80, 14.94, 3, 39.45, 
	15.31, 37.89, 15.97, 36.49, 15.80, 3, 36.82, 16.61, 36.82, 17.30, 36.49, 18.10, 3, 31.44, 18.76, 33.81, 
	24.16, 33.33, 28.16, 3, 30.35, 28.05, 29.27, 29.85, 26.15, 29.60, 3, 26.15, 29.12, 26.15, 28.64, 26.15, 
	28.16, 3, 25.23, 28.21, 24.30, 27.84, 23.56, 27.01, 3, 22.66, 27.06, 23.20, 28.56, 22.13, 28.45, 3, 
	22.09, 24.97, 18.10, 22.94, 20.11, 19.25, 3, 19.39, 18.07, 20.17, 16.97, 19.25, 15.80, 3, 16.87, 16.30, 
	13.90, 16.20, 11.49, 16.67, 3, 11.99, 15.31, 11.45, 15.27, 11.21, 14.08, 3, 12.16, 13.60, 12.75, 12.75, 
	13.79, 12.36, 3, 12.64, 11.50, 12.15, 9.98, 12.07, 8.05, 3, 13.59, 8.52, 13.88, 4.32, 16.09, 5.46, 3, 
	16.41, 6.29, 16.70, 7.15, 17.24, 7.76, 3, 18.31, 7.29, 19.29, 6.74, 19.83, 5.75, 3, 19.51, 5.11, 18.69, 
	4.97, 18.39, 4.31, 3, 18.19, 3.59, 19.66, 3.13, 18.68, 2.59, 0,  }