function param1()
  return "ブラシ間隔", 10, 100, 25
end

function param2()
	return "変形のジッタ", 0, 100, 25
end

function param3()
	return "大きさのジッタ", 0, 100, 25
end

function param4()
	return "位置のジッタ", 0, 100, 10
end

function param5()
	return "色のジッタ", 0, 100, 0
end

function param6()
	return "グリッドスナップ", 0, 1, 0
end

function param7()
	return "グリッド45度", 0, 1, 1
end

function param8()
	return "グリッド間隔", 1, 100, 65
end

function param9()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 20, 1
end

bs_setmode( 1 )

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.08
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param9() )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local TransRdm = ( 100 - ( math.random( 0,75 ) % 75 ) * bs_param2()/100 ) / 100

	local SpinCheck = 1
	local GridLock = bs_param6()
	local GridSpin = bs_param7()
	local GridReso = 16 * bs_param8() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end

	if ( GridLock==1 ) then	math.randomseed( gridX * gridX * gridY * gridY ) end

	local rdmSpin = math.random() * 3.14 * rdm0
	local rdmSize = math.random() * bs_param3()/500

	if ( SpinCheck == 0 ) then dx,dy = 0,0 rdmSpin = 0 end

	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms()) 
			rdmSize = rdm0 * math.random() * bs_param3()/1000
			if ( SpinCheck == 1 ) then rdmSpin = math.random() * 3.14 *rdm0 end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * TransRdm, (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, -18.70, -8.02, 3, -14.67, -4.75, -10.18, 0.41, -8.47, 5.57, 3, -15.41, -11.58, -5.87, -27.93, -1.45, 
	-41.76, 3, -1.53, -37.82, -0.34, -34.58, -0.38, -29.85, 3, 0.02, -29.80, -0.52, -30.70, 0.08, -30.46, 
	3, 0.02, -25.97, 3.01, -21.76, 3.28, -17.02, 3, 3.46, -17.05, 3.41, -17.30, 3.44, -17.48, 3, 5.47, -12.06, 
	5.54, -5.69, 4.81, 0.53, 3, 9.43, -5.48, 14.17, -11.38, 21.30, -14.89, 3, 21.66, -14.84, 21.12, -14.48, 
	21.15, -14.27, 3, 27.32, -15.88, 31.51, -21.85, 37.33, -24.81, 3, 35.53, -22.23, 34.15, -19.23, 32.44, 
	-16.56, 3, 29.99, -10.85, 29.26, -5.15, 24.96, -1.30, 3, 24.53, 1.35, 20.89, 3.67, 20.23, 5.57, 3, 18.57, 
	7.47, 16.64, 9.11, 14.12, 10.15, 3, 16.75, 10.68, 22.37, 9.14, 24.50, 9.54, 3, 31.60, 10.90, 39.82, 
	11.61, 46.49, 10.76, 3, 47.61, 10.30, 49.00, 10.12, 50.00, 9.54, 3, 44.04, 14.71, 32.97, 15.88, 26.49, 
	20.38, 3, 22.94, 21.32, 17.16, 22.62, 12.75, 22.37, 3, 18.71, 25.92, 23.10, 31.05, 29.24, 34.43, 3, 
	25.58, 33.89, 22.27, 33.04, 19.16, 32.14, 3, 18.59, 32.87, 17.35, 32.15, 16.72, 31.98, 3, 16.56, 32.39, 
	15.90, 32.29, 15.65, 32.59, 3, 10.43, 31.12, 4.92, 27.92, 0.99, 24.20, 3, 0.81, 24.22, 0.86, 24.48, 
	0.84, 24.66, 3, 0.43, 24.51, 0.46, 23.91, 0.08, 23.74, 3, -0.41, 29.01, 1.11, 36.29, -1.45, 40.84, 3, 
	-1.12, 36.29, -0.61, 29.71, -1.14, 24.05, 3, -4.76, 28.73, -7.79, 33.99, -13.21, 36.87, 3, -13.25, 36.62, 
	-13.06, 36.61, -13.05, 36.41, 3, -16.37, 38.23, -19.90, 39.84, -23.13, 41.76, 3, -20.79, 39.01, -17.96, 
	35.42, -16.56, 31.22, 3, -17.32, 29.41, -13.76, 26.86, -12.14, 25.42, 3, -14.23, 25.08, -17.73, 25.44, 
	-20.69, 25.88, 3, -20.75, 25.58, -21.28, 25.76, -21.14, 25.27, 3, -23.28, 26.00, -25.05, 24.73, -27.56, 
	24.35, 3, -27.60, 24.10, -27.41, 24.09, -27.40, 23.89, 3, -28.53, 23.74, -29.66, 23.60, -30.76, 23.44, 
	3, -30.99, 22.34, -32.63, 22.65, -33.51, 22.21, 3, -33.49, 22.03, -33.23, 22.09, -33.05, 22.06, 3, -34.58, 
	21.27, -36.50, 21.05, -38.09, 20.69, 3, -38.04, 20.48, -37.71, 20.56, -37.48, 20.53, 3, -41.77, 19.31, 
	-45.90, 18.27, -50.00, 17.79, 3, -48.19, 16.65, -45.40, 17.70, -44.35, 16.56, 3, -34.29, 18.62, -25.76, 
	11.56, -14.89, 14.43, 3, -21.41, 10.47, -27.20, 5.78, -30.31, -1.60, 3, -29.99, -1.67, -29.90, -1.50, 
	-29.69, -1.45, 3, -30.82, -3.39, -30.74, -4.69, -31.99, -6.49, 3, -31.49, -6.62, -31.67, -6.09, -31.37, 
	-6.03, 3, -31.30, -6.41, -31.73, -7.60, -32.14, -8.02, 3, -32.11, -8.19, -31.86, -8.14, -31.68, -8.17, 
	3, -33.89, -11.56, -35.17, -15.88, -37.18, -19.47, 3, -37.33, -20.82, -39.08, -23.70, -39.47, -26.03, 
	3, -35.49, -19.74, -30.68, -14.90, -24.20, -11.37, 3, -23.75, -11.51, -24.55, -11.60, -24.35, -11.98, 
	3, -22.17, -10.66, -20.16, -9.15, -18.40, -7.40, 3, -18.42, -7.69, -18.50, -7.91, -18.70, -8.02, 0 }