function param1()
  return "粒子数", 0, 100, 40
end

function param2()
	return "粒子密度", 0, 100, 60
end

function param3()
	return "大きさのジッタ", 0, 100, 25
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "ソフトエッジ", 0, 1, 1
end

function param6()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.5
end

function main( x, y, p )

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param6() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local mul = 0.01
	local itv = 1 + (100 - bs_param2())/10
	local rdmSpin = bs_grand( 0, 3.14 )
	local rdmSize = math.random()/5000 * bs_param3()
	local rdmShape = math.random(8)
	local xrdm = math.random( -w * itv, w * itv )
	local yrdm = math.random( -w * itv, w * itv )

	if ( bs_param5()==1 ) then

		xrdm = bs_grand( 0, w * itv * 0.8 )
		yrdm = bs_grand( 0, w * itv * 0.8 )
		
		if ( math.abs(xrdm) > 1.75*w*itv or math.abs(yrdm) > 1.75*w*itv ) then return 0 end
		
	end


	if w < 5 then
		w = 5
	end

	if ( not firstDraw ) then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if ( distance < w * (100-bs_param1())/100 ) then
				return 0
			end
	end

	local id = 1
	local code = ''

	local stroke = shape[ rdmShape ]

	repeat

		code = cmdcon[stroke[id]]

		if (code=='z') then

				bs_bezier_mul( (mul + rdmSize) * w, (mul + rdmSize) * w ) 
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( x + xrdm, y + yrdm )

				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( stroke, id+1 )
		end

	until id > #stroke

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = {}

shape[1] = { 1, 42.71, -22.26, 3, 28.57, -32.34, 14.78, -7.29, -1.35, -4.02, 3, -13.64, -18.67, -33.65, -17.78, -50.00, 
	-7.03, 3, -23.69, 4.04, -35.85, 26.73, 13.52, 22.26, 3, 10.38, 14.59, 6.95, 8.19, 3.45, 2.79, 3, 9.71, 
	-1.17, 16.64, -16.47, 50.00, 14.09, 3, 57.34, 9.45, 45.40, -9.05, 42.71, -22.26, 0 }
	
shape[2] = { 1, 10.82, -43.47, 3, 5.34, -43.34, -0.23, -42.61, -5.97, -41.42, 3, -1.16, -31.11, 6.62, -13.61, 14.74, 
	-2.05, 4, -13.43, -2.05, 3, -14.59, -0.49, -15.58, 1.01, -16.42, 2.43, 3, -19.92, -7.33, -24.81, -17.99, 
	-24.81, -25.56, 3, -26.39, -25.68, -27.85, -25.58, -29.29, -25.56, 3, -39.38, -25.41, -46.32, -21.98, 
	-50.00, -15.49, 3, -51.54, 0.69, -36.18, 14.62, -19.96, 16.79, 3, -18.55, 25.37, -10.56, 32.46, -3.36, 
	43.47, 3, -4.68, 22.06, 1.93, 7.69, 16.42, 0.37, 3, 21.34, 6.80, 26.27, 10.78, 30.78, 9.33, 3, 27.95, 
	4.79, 18.72, -19.63, 29.29, -21.27, 3, 30.68, -14.22, 45.85, -24.19, 50.00, -19.78, 3, 41.98, -38.41, 
	27.27, -43.87, 10.82, -43.47, 0 }

shape[3] = { 1, 17.24, -50.00, 3, 16.02, -29.76, 3.35, -23.38, 13.23, -9.59, 3, -1.13, -11.42, -7.95, 10.44, -43.78, 
	10.65, 3, -39.25, 41.90, 27.80, 35.48, 43.78, 50.00, 3, 44.51, 39.55, 31.45, 11.66, 27.48, 7.73, 3, 
	64.83, 4.46, 57.57, -49.89, 17.24, -50.00, 0 }

shape[4] = { 1, -50.00, 13.44, 3, -34.57, 27.54, -18.13, 21.81, -2.72, 37.77, 3, 9.15, 25.38, 8.25, 11.39, 9.50, 
	-2.40, 3, 31.65, 0.68, 50.27, -7.46, 50.00, -37.77, 3, 38.62, -32.91, 9.50, -25.59, -10.61, -32.80, 
	3, -22.38, -37.03, -6.83, -26.81, -17.11, -20.67, 3, -10.88, -16.71, -3.26, -5.03, 3.78, -3.35, 3, -8.42, 
	10.55, -4.14, 28.88, -22.60, -0.91, 3, -31.96, 9.03, -41.18, 13.98, -50.00, 13.44, 0 }

shape[5] = { 1, -21.45, -30.22, 3, -29.90, -31.98, -39.50, -29.06, -50.00, -21.08, 3, -41.73, -17.21, -32.67, -11.01, 
	-24.27, -6.98, 4, -28.64, 15.93, 3, -9.46, 12.01, -10.05, 51.83, 4.82, 30.22, 3, -13.42, 27.13, -10.08, 
	8.87, -14.77, -3.39, 3, -9.24, -2.27, -4.40, -3.41, -0.70, -8.28, 3, 8.73, -0.00, 22.34, -1.68, 31.95, 
	9.62, 3, 36.37, -7.34, 48.08, 4.63, 50.00, 3.81, 3, 39.56, -17.52, 15.11, -19.66, 8.60, -20.50, 3, 7.94, 
	-20.59, 6.72, -20.40, 6.13, -20.18, 3, 1.81, -18.48, -0.66, -16.65, -2.16, -14.67, 3, -7.88, -23.34, 
	-14.23, -28.71, -21.45, -30.22, 0 }

shape[6] = { 1, -9.22, -50.00, 3, 3.87, -29.58, -6.50, -11.55, -17.97, 4.99, 3, -20.70, 2.64, -22.61, -0.67, -23.04, 
	-5.91, 3, -43.84, -1.20, -47.57, 16.63, -33.49, 30.18, 3, -12.33, 48.82, -31.14, 55.10, 8.45, 50.00, 
	3, 15.70, 32.51, 15.74, 23.35, 12.29, 18.20, 3, 24.57, 10.12, 31.61, -8.40, 33.49, -37.56, 3, 22.96, 
	-22.24, 6.31, -39.08, -9.22, -50.00, 0 }

shape[7] = { 1, 25.40, 14.95, 3, 18.95, 16.78, 8.05, 22.19, 4.66, 19.07, 3, -1.59, 13.37, 3.13, -5.77, -4.38, -9.61, 
	3, -8.13, -11.10, -11.76, -13.18, -15.00, -15.60, 3, -20.68, -19.79, -14.77, -27.91, -19.57, -33.05, 
	3, -23.79, -37.60, -22.13, -46.76, -27.46, -50.00, 3, -27.60, -45.28, -44.12, -33.00, -43.78, -28.29, 
	3, -42.89, -15.70, -47.87, -24.19, -38.14, -6.82, 3, -38.00, -6.54, -39.15, 18.37, -39.01, 18.65, 3, 
	-36.94, 19.87, -29.81, 11.39, -27.56, 12.27, 3, -26.56, 12.63, -20.66, 13.74, -20.66, 13.74, 3, -20.66, 
	13.74, -22.48, 8.12, -22.26, 5.81, 3, -21.58, 1.33, -20.19, -2.31, -18.20, -5.65, 3, -16.97, -0.01, 
	-14.28, 5.19, -13.57, 10.95, 3, -13.23, 15.62, -13.88, 19.44, -15.28, 23.24, 3, -18.43, 22.19, -21.85, 
	21.88, -25.15, 22.10, 3, -21.91, 26.02, -14.88, 40.79, 9.12, 50.00, 3, 32.82, 49.45, 62.54, 63.80, 43.78, 
	23.56, 3, 43.27, 22.10, 27.63, 23.29, 25.40, 14.95, 0 }

shape[8] = { 1, -13.83, -50.00, 3, -7.32, -17.58, -39.65, -19.25, -28.60, -1.67, 3, -60.48, 7.63, -51.15, 42.23, 
	-39.70, 42.06, 3, -29.14, 41.90, -14.65, 37.92, -4.64, 26.90, 3, 7.48, 15.15, 25.34, 63.56, 26.16, 50.00, 
	3, 25.68, 46.73, 43.54, 42.35, 39.70, 39.07, 3, 39.51, 39.61, 34.40, 25.41, 34.22, 25.94, 3, 33.44, 
	24.41, 23.64, 13.92, 17.31, 34.00, 3, 17.27, 33.95, 17.20, 33.90, 17.17, 33.85, 3, 13.18, 30.58, 14.40, 
	13.71, 12.50, 10.49, 3, 2.58, 4.55, -5.99, 19.70, -15.53, 6.49, 3, 15.73, -12.21, 15.82, -51.53, -13.83, 
	-50.00, 0 }

