function param1()
  return "粒子数", 5, 100, 25
end

function param2()
  return "粒子密度", 0, 100, 70
end

function param3()
  return "大きさのジッタ", 0, 100, 20
end

function param4()
  return "色のジッタ", 0, 100, 0
end

function param5()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 20, 0.85
end

function set_leaf( w )
  bs_bezier_begin( 0, 0 )
  bs_bezier_c( -0.5, -0.5, -0.5, -1.0, 0, -1.5 )
  bs_bezier_c( 0.5, -1.0, 0.5, -0.5, 0, 0 )
  bs_bezier_mul( w * 4  , w * 4  )
  bs_bezier_move_center()
end

function default_size()
  return 10, 0.5
end
bs_setmode( 1 )

function main( x, y, p )

	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param5() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

  local w = bs_width()
  if w < 20 then
    w = 20
  end

  if not firstDraw then
    local distance = bs_distance( lastDrawX - x, lastDrawY - y )
    if distance < w/2 then
      return 0
    end
  end

  local num = 10 * bs_param1() / 100
	local offset = 1 + (100-bs_param2()) / 20

  local i
  for i = 0,num do
    local dx = x + bs_grand( 0, 1 )%1 * (1 -2 * ( math.random(2) % 2 )) * w * offset
    local dy = y + bs_grand( 0, 1 )%1 * (1 -2 * ( math.random(2) % 2 )) * w * offset
    local rnd = 0.5 + math.random() * bs_param3()/200 * ( 1 -2 * ( math.random(2) % 2 ))

    set_leaf( rnd*w/2 )

    bs_bezier_rotate( math.random() * 3.14 * 2 )
    bs_bezier_move( dx, dy )
    
	local r,g,b = bs_forebg(1.0)
    bs_fill( nr,ng,nb,a )
  end

  lastDrawX = x
  lastDrawY = y
  firstDraw = false

  return 1
end

lastDrawX = 0
lastDrawY = 0
firstDraw = true
