function param1()
  return "インク量", 0, 100, 30
end

function param2()
	return "線幅のジッタ", 0, 100, 15
end

function param3()
	return "延伸", 0, 100, 15
end

function param4()
	return "二重線", 0, 1, 0
end

function param5()
	return "二重線間隔", 0, 100, 30
end

function param6()
	return "軽量化", 0, 1, 1
end

function param7()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.2
end

function main( x, y, p )

	bs_setmode( 1 )

	local mul = 0.02
	local rdm0 = 1 -2 * ( math.random(2) % 2 )
	local rdmSize = rdm0 * math.random() * 0.05 * bs_param2()/100

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param7() )

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )

	if ( not firstDraw ) then
			if distance < w * (110-bs_param1())/100 then
				return 0
			end
	end


-- first stroke

	local idn = 2
	local id = 1
	local code = ''

	if ( bs_param6()==1 ) then idn = 1
	end

	shape = stroke[idn]

	repeat

		code = cmdcon[ shape[id] ]

		if (code=='z') then

				currentTime = bs_ms()
				local stretch = 1.5

				if ( previousTime==currentTime ) then
					stretch = 1.5
				else
					stretch = 1.5 + 2 * ( distance / (currentTime - previousTime) ) * bs_param3()/100
				end

				bs_bezier_rotate( bs_grand( 0, 3.14 ) )
				bs_bezier_mul( stretch * (mul+rdmSize) * w, (mul+rdmSize) * w ) 
				bs_bezier_move( 0, offset )
				bs_bezier_rotate(bs_atan( dx, dy ))
				bs_bezier_move( x, y )
				bs_fill( r,g,b,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape


-- dual stroke

	local checkDual = bs_param4()

	if ( checkDual > 0 ) then
	
		local offset = bs_param5() * ( 0.7 + 0.3 * p )

		local idn = 2
		local id = 1
		local code = ''

		if ( bs_param6()==1 ) then idn = 1
		end

		shape = stroke[idn]

		repeat

			code = cmdcon[ shape[id] ]

			if (code=='z') then

					local stretch = 1.5

					if ( previousTime==currentTime ) then
						stretch = 1.5
					else
						stretch = 1.5 + 2 * ( distance / (currentTime - previousTime) ) * bs_param3()/100
					end

					bs_bezier_rotate( bs_grand( 0, 3.14 ) )
					bs_bezier_mul( stretch * (mul+rdmSize) * w, (mul+rdmSize) * w ) 
					bs_bezier_move( 0, -1 * offset )
					bs_bezier_rotate(bs_atan( dx, dy ))
					bs_bezier_move( x, y )
					bs_fill( r,g,b,a )
					id = id + 1
			else
				id = ( cmd[code] or cmd.default )( shape, id+1 )
			end

		until id > #shape
	
	end

------------------------------------------------------------

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	previousTime = currentTime

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

currentTime, previousTime = 0, 0

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

stroke={}

stroke[1] = { 1, 4.27, 24.00, 3, -5.32, 23.45, -14.20, 20.22, -21.03, 17.57, 3, -26.80, 4.76, -29.74, 2.76, -31.88, 
	-0.11, 3, -33.94, -2.86, -36.56, -10.29, -35.73, -12.31, 3, -26.59, -12.69, -19.53, -14.37, -11.16, 
	-14.91, 3, 0.41, -15.70, -1.24, -15.65, 6.32, -16.29, 3, 10.49, -16.65, 17.05, -15.89, 23.22, -14.94, 
	3, 28.21, -14.18, 26.32, -13.31, 36.08, -13.40, 3, 34.79, -7.86, 32.61, 5.89, 26.58, 11.39, 3, 21.61, 
	12.69, 15.13, 18.89, 4.27, 24.00, 0 }

stroke[2] = { 1, 0.00, -18.90, 3, -0.64, -19.21, -3.96, -19.29, -4.06, -19.06, 3, -4.74, -17.48, -4.03, -15.20, -4.03, 
	-15.20, 3, -4.03, -15.20, -5.69, -15.44, -6.57, -15.38, 3, -7.50, -16.02, -9.90, -16.61, -11.00, -17.00, 
	3, -11.37, -16.61, -11.72, -16.31, -11.72, -16.31, 4, -12.38, -17.19, 3, -12.75, -17.14, -13.08, -17.01, 
	-13.34, -16.69, 3, -13.84, -16.09, -15.79, -17.58, -15.91, -16.86, 3, -17.73, -16.69, -17.85, -14.26, 
	-19.62, -14.03, 3, -20.55, -13.18, -21.22, -12.47, -21.22, -12.47, 3, -21.22, -12.47, -21.22, -13.29, 
	-21.66, -13.75, 3, -22.32, -13.66, -22.99, -13.56, -23.66, -13.47, 3, -23.96, -13.82, -25.52, -14.23, 
	-25.52, -14.23, 4, -27.28, -12.78, 3, -28.69, -11.37, -30.12, -11.63, -31.03, -12.63, 3, -32.55, -12.49, 
	-34.12, -12.38, -35.75, -12.31, 3, -36.25, -11.08, -35.43, -7.84, -34.28, -4.88, 3, -33.86, -4.98, -31.73, 
	-3.39, -31.57, -2.98, 3, -30.44, -0.11, -30.87, -1.46, -31.88, -0.13, 3, -31.24, 0.72, -30.54, 1.54, 
	-29.72, 2.53, 3, -29.28, 2.80, -28.82, 3.07, -28.38, 3.31, 3, -27.57, 3.76, -27.13, 7.14, -27.40, 7.73, 
	3, -26.54, 8.96, -21.81, 12.90, -20.79, 14.24, 3, -19.78, 15.59, -20.50, 15.78, -21.03, 17.56, 3, -18.62, 
	18.50, -16.95, 19.39, -14.09, 20.33, 3, -11.68, 18.81, -8.91, 20.62, -5.66, 22.10, 3, -4.94, 24.46, 
	-2.19, 24.48, -2.29, 25.19, 3, -0.35, 25.51, 2.27, 23.88, 4.28, 24.00, 3, 4.86, 23.72, 5.41, 23.44, 
	5.97, 23.16, 3, 6.11, 22.24, 6.78, 21.25, 6.78, 21.25, 4, 8.00, 22.09, 3, 8.76, 21.68, 9.47, 21.29, 
	10.19, 20.88, 3, 10.36, 20.61, 10.59, 20.36, 10.91, 20.09, 3, 12.82, 18.52, 14.75, 17.54, 14.75, 17.54, 
	3, 14.75, 17.54, 17.22, 16.02, 17.96, 15.97, 3, 20.04, 15.85, 20.42, 14.12, 20.42, 14.12, 4, 20.15, 
	11.61, 3, 22.34, 11.54, 23.33, 10.94, 24.59, 12.12, 3, 24.60, 12.13, 24.62, 12.12, 24.62, 12.12, 3, 
	25.30, 11.82, 25.94, 11.57, 26.56, 11.41, 3, 29.10, 9.09, 30.95, 5.32, 32.34, 1.31, 3, 31.74, 0.96, 
	31.18, 0.63, 31.00, 0.38, 3, 30.46, -0.41, 32.13, -5.46, 35.28, -9.78, 3, 35.56, -11.08, 35.85, -12.48, 
	36.06, -13.41, 3, 32.02, -13.37, 30.02, -13.50, 28.66, -13.72, 3, 28.33, -12.81, 25.32, -14.10, 23.31, 
	-14.80, 3, 21.51, -15.42, 21.95, -14.48, 20.50, -15.34, 3, 19.06, -16.42, 15.53, -13.90, 11.31, -14.94, 
	3, 8.60, -16.37, 10.33, -15.94, 6.36, -17.13, 3, 5.06, -17.52, 3.73, -17.10, 0.00, -18.90, 0 }

