function param1()
  return "ブラシ間隔", 10, 100, 20
end

function param2()
	return "大きさのジッタ", 0, 100, 30
end

function param3()
	return "位置のジッタ", 0, 100, 5
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "グリッドスナップ", 0, 1, 1
end

function param6()
	return "グリッド間隔", 1, 100, 50
end

function param7()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 20, 1
end

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.08
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param7() )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )
	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local canvasW = bs_canvas_width()
	local canvasH = bs_canvas_height() 
	local dpi = bs_canvas_dpi() 
	local GridReso = 16 * bs_param6() / 5

	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso
	local GridSpin = 1

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end


	math.randomseed( gridX * gridX * gridY * gridY )

	local rdmSpin = math.random() * 3.14
	local rdmSize = math.random() * bs_param2()/1000
	local rdm00 =  1 -2 * ( math.random(2) % 2 )

	local GridLock = bs_param5()
	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms()*x+y) 
			rdmSize = rdm0 * math.random() * bs_param2()/2000
			rdmSpin = math.random() * 3.14
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100  * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	local id = 1
	local code = ''
	local shapeID = math.random(3)

	stroke = {}
	stroke = shape[shapeID]

	repeat

		code = cmdcon[stroke[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * rdm00 , (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( stroke, id+1 )
		end

	until id > #stroke

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = {}

shape[1] = { 1, -9.55, -36.59, 3, -8.74, -36.26, -6.14, -33.24, -5.89, -36.18, 3, -3.48, -35.12, -6.23, -35.08, -5.89, 
	-32.93, 3, -8.10, -33.57, -9.58, -34.93, -12.80, -34.55, 3, -13.01, -36.52, -10.42, -35.69, -9.55, -36.59, 
	0, 1, 1.89, -29.27, 3, 3.29, -26.47, -0.71, -23.72, -1.02, -20.73, 3, -1.79, -24.50, 1.74, -25.99, 1.89, 
	-29.27, 0, 1, 26.05, -18.75, 3, 27.49, -18.88, 28.15, -18.16, 28.03, -16.61, 3, 27.42, -17.37, 25.60, 
	-16.83, 26.05, -18.75, 0, 1, 33.94, 12.20, 3, 36.67, 12.92, 37.30, 13.91, 39.63, 15.45, 3, 37.79, 19.69, 
	39.71, 22.37, 38.01, 25.20, 3, 37.23, 21.36, 37.64, 19.40, 38.01, 16.67, 3, 36.41, 15.41, 34.77, 14.22, 
	33.94, 12.20, 0, 1, 19.36, 27.53, 3, 19.48, 29.84, 16.83, 33.49, 14.52, 34.09, 3, 15.38, 31.78, 16.90, 
	29.57, 19.36, 27.53, 0, 1, 27.03, -29.67, 3, 25.42, -30.46, 26.40, -31.65, 25.41, -33.33, 3, 20.98, 
	-34.24, 17.28, -41.51, 13.21, -35.77, 3, 6.60, -34.52, 1.63, -33.63, -0.61, -39.84, 3, -1.26, -38.60, 
	-4.48, -38.60, -6.30, -36.59, 3, -6.08, -40.29, 1.97, -41.63, 2.64, -36.99, 3, 5.10, -36.71, 8.51, -36.78, 
	12.40, -36.99, 3, 14.16, -38.21, 15.10, -40.25, 18.50, -39.84, 3, 20.25, -42.01, 21.55, -44.64, 25.00, 
	-45.12, 3, 25.91, -47.33, 26.70, -49.66, 29.47, -50.00, 3, 28.73, -48.03, 26.18, -47.88, 26.63, -44.72, 
	3, 23.75, -44.61, 23.95, -41.43, 20.53, -41.87, 3, 20.48, -32.65, 27.34, -39.27, 27.03, -29.67, 0, 1, 
	25.36, -27.85, 3, 26.28, -26.15, 27.26, -24.53, 27.69, -22.15, 3, 25.63, -22.27, 26.03, -25.80, 25.36, 
	-27.85, 0, 1, 31.50, -13.82, 3, 32.71, -15.02, 33.02, -14.69, 34.35, -15.45, 3, 34.51, -14.66, 35.93, 
	-15.13, 35.57, -13.82, 3, 39.32, -14.95, 40.53, -18.62, 44.51, -19.51, 3, 44.86, -18.22, 43.87, -18.25, 
	43.70, -17.48, 3, 44.38, -17.48, 45.05, -17.48, 45.73, -17.48, 3, 44.46, -15.15, 47.41, -16.83, 46.14, 
	-14.23, 3, 44.49, -14.07, 44.89, -15.96, 43.70, -16.26, 3, 40.05, -16.25, 39.19, -13.45, 37.60, -11.38, 
	3, 40.67, -7.63, 36.15, -3.35, 38.01, -0.41, 3, 37.32, 1.34, 34.82, 1.28, 32.32, 1.22, 3, 30.37, 7.27, 
	22.03, 9.84, 21.75, 17.48, 3, 19.63, 15.38, 22.42, 13.07, 22.56, 9.35, 3, 23.66, 10.49, 23.57, 9.67, 
	25.00, 9.35, 3, 24.35, 6.34, 19.56, 7.47, 17.68, 5.69, 3, 15.89, 5.66, 16.49, 8.02, 14.43, 7.72, 3, 
	14.25, 9.24, 14.37, 9.83, 13.21, 10.98, 3, 12.35, 10.00, 14.11, 9.78, 13.21, 8.13, 3, 10.22, 8.05, 7.85, 
	9.06, 6.71, 11.79, 3, 4.76, 11.09, 3.48, 13.14, 2.64, 12.20, 3, 2.59, 12.80, 1.86, 13.77, 1.42, 15.04, 
	3, -0.52, 14.26, 2.40, 12.14, 1.02, 10.57, 3, -3.23, 9.34, -5.64, 3.28, -12.80, 3.66, 3, -10.14, 3.88, 
	-8.51, 2.06, -6.71, 2.44, 3, -3.31, 3.15, -1.55, 10.04, 3.05, 10.57, 3, 5.47, 10.85, 8.12, 9.48, 9.55, 
	7.32, 3, 12.79, 7.92, 17.87, 4.93, 15.24, 1.22, 3, 18.06, 1.70, 20.63, 6.57, 24.59, 6.10, 3, 26.46, 
	4.84, 28.09, 3.36, 29.47, 1.63, 3, 27.92, 0.37, 32.26, -1.46, 35.16, -2.03, 3, 35.09, -4.41, 35.30, 
	-6.50, 37.20, -6.91, 3, 37.12, -9.41, 36.59, -10.41, 37.60, -12.20, 3, 35.20, -12.37, 34.56, -14.30, 
	31.50, -13.82, 0, 1, -42.07, 0.00, 3, -41.36, 0.35, -40.68, 0.75, -40.04, 1.22, 3, -39.79, -0.59, -38.97, 
	-2.08, -37.60, -3.25, 3, -36.59, -2.45, -35.51, -2.31, -34.35, -2.85, 3, -34.60, -3.55, -39.71, 5.27, 
	-41.26, 4.47, 3, -41.15, 0.57, -42.47, 2.45, -46.14, 0.81, 3, -44.76, 0.63, -43.41, 0.36, -42.07, 0.00, 
	0, 1, 28.05, 7.92, 3, 29.58, 8.53, 30.09, 10.04, 32.32, 10.05, 3, 32.06, 11.07, 32.10, 12.34, 30.49, 
	12.18, 3, 31.17, 9.99, 28.55, 10.30, 28.05, 7.92, 0, 1, -15.65, 34.96, 3, -15.24, 35.91, -14.84, 36.86, 
	-14.43, 37.80, 3, -19.23, 36.95, -17.86, 35.64, -18.03, 30.34, 3, -18.18, 25.55, -22.73, 28.55, -26.22, 
	26.02, 3, -20.66, 27.21, -20.04, 23.07, -15.65, 21.54, 3, -16.73, 26.47, -14.68, 34.37, -15.65, 34.96, 
	0, 1, 36.79, 26.42, 3, 38.16, 30.85, 37.36, 33.71, 38.01, 39.02, 3, 37.54, 38.96, 37.28, 39.11, 37.20, 
	39.43, 3, 37.30, 36.37, 35.43, 30.52, 36.79, 26.42, 0, 1, 4.67, 34.15, 3, 1.98, 40.52, -6.39, 37.30, 
	-11.18, 40.24, 3, -10.67, 41.50, -9.65, 39.61, -9.15, 40.65, 3, -9.73, 41.84, -9.94, 42.19, -10.69, 
	43.46, 3, -11.80, 45.36, -11.67, 47.69, -12.80, 50.00, 3, -14.73, 48.31, -13.65, 45.47, -12.81, 43.61, 
	3, -11.52, 40.75, -13.39, 39.99, -13.62, 36.99, 3, -9.84, 37.45, 1.40, 37.94, 4.67, 34.15, 0, 1, -3.05, 
	-17.48, 3, -1.88, -16.91, -4.06, -16.53, -3.46, -15.45, 3, -5.56, -16.27, -6.79, -13.47, -7.78, -12.17, 
	3, -8.16, -11.66, -8.70, -10.99, -9.41, -11.00, 3, -9.97, -11.07, -10.42, -11.33, -10.77, -11.79, 3, 
	-11.80, -11.40, -12.83, -11.06, -13.89, -10.77, 3, -16.31, -10.07, -21.45, -9.01, -19.49, -5.64, 3, 
	-18.17, -3.38, -18.02, -5.29, -18.08, -2.29, 3, -18.12, -0.15, -16.63, 1.83, -14.84, 2.85, 3, -15.40, 
	4.79, -18.10, 4.55, -19.48, 5.69, 3, -21.43, 7.28, -21.73, 10.41, -22.62, 12.61, 3, -23.56, 14.92, -26.65, 
	16.64, -27.07, 18.96, 3, -27.33, 20.40, -28.58, 24.34, -30.69, 24.39, 3, -27.75, 21.59, -35.26, 21.27, 
	-36.79, 21.95, 3, -37.45, 20.15, -31.53, 20.79, -30.61, 19.48, 3, -29.61, 18.07, -28.50, 17.35, -27.97, 
	15.81, 3, -27.16, 13.44, -25.29, 11.31, -23.37, 9.76, 3, -23.23, 7.86, -22.11, 6.56, -20.55, 5.62, 3, 
	-17.45, 3.73, -17.40, 4.26, -18.50, 0.80, 3, -19.04, -0.93, -19.33, -2.71, -19.72, -4.47, 3, -21.56, 
	-5.32, -24.07, -8.38, -26.22, -6.50, 3, -26.04, -6.75, -25.90, -7.02, -25.81, -7.32, 3, -27.51, -6.89, 
	-28.44, -5.76, -29.20, -4.28, 3, -30.51, -1.69, -30.40, -3.41, -32.32, -2.85, 3, -29.95, -7.30, -24.65, 
	-8.78, -29.88, -13.82, 3, -26.67, -13.14, -28.07, -11.52, -25.54, -10.25, 3, -22.30, -8.64, -20.65, 
	-10.05, -17.77, -11.64, 3, -15.24, -13.05, -12.96, -11.89, -10.34, -13.21, 3, -8.01, -14.38, -5.72, 
	-17.18, -3.05, -17.48, 0,  }

 shape[2] = { 1, 12.62, -50.00, 3, 12.99, -49.98, 12.76, -49.35, 13.21, -49.41, 3, 12.88, -46.86, 13.10, -45.03, 12.82, 
	-43.35, 3, 12.59, -43.38, 12.65, -43.70, 12.62, -43.93, 3, 8.63, -42.19, 6.81, -38.26, 3.23, -36.11, 
	3, 2.59, -33.34, 4.27, -31.62, 4.40, -29.65, 3, 3.14, -31.06, 2.65, -33.24, 1.08, -34.34, 3, 3.01, -36.39, 
	4.86, -38.52, 6.56, -40.80, 3, 9.48, -42.97, 12.83, -44.70, 12.62, -50.00, 0, 1, 32.78, -46.09, 3, 33.01, 
	-43.05, 29.43, -42.13, 29.45, -38.65, 3, 28.03, -38.86, 28.37, -40.83, 28.08, -42.17, 3, 23.96, -41.84, 
	20.91, -43.37, 17.12, -42.76, 3, 21.88, -44.57, 31.04, -41.07, 32.78, -46.09, 0, 1, 11.25, 27.30, 3, 
	12.54, 30.90, 14.92, 33.42, 14.97, 38.26, 3, 17.68, 40.25, 20.28, 42.34, 20.45, 46.87, 3, 21.20, 48.15, 
	22.95, 48.41, 23.39, 50.00, 3, 21.27, 48.98, 19.55, 47.58, 19.08, 44.91, 3, 19.39, 44.83, 19.25, 44.30, 
	19.86, 44.52, 3, 18.50, 42.46, 16.95, 39.66, 13.80, 40.02, 3, 13.48, 37.33, 14.39, 35.21, 13.41, 32.97, 
	3, 12.64, 31.23, 11.07, 29.72, 11.25, 27.30, 0, 1, 5.58, -25.15, 3, 6.17, -23.97, 8.62, -21.28, 8.12, 
	-17.71, 3, 9.13, -17.14, 10.33, -15.99, 9.69, -14.38, 3, 9.05, -14.03, 8.66, -14.64, 8.32, -13.99, 3, 
	7.56, -13.08, 9.22, -11.50, 8.51, -10.86, 3, 10.32, -10.95, 12.43, -11.54, 14.38, -12.04, 3, 15.18, 
	-13.09, 15.62, -13.37, 16.73, -14.19, 3, 15.07, -14.92, 13.28, -14.75, 10.86, -14.97, 3, 12.61, -15.94, 
	14.80, -15.27, 16.93, -15.75, 3, 17.62, -15.60, 17.64, -14.77, 18.30, -14.58, 3, 22.72, -16.40, 28.42, 
	-18.68, 34.34, -19.28, 3, 35.83, -19.43, 37.54, -19.21, 38.85, -19.67, 3, 39.83, -20.01, 40.43, -21.14, 
	41.59, -21.04, 3, 42.68, -21.64, 43.48, -22.54, 44.72, -22.99, 3, 42.97, -21.22, 40.55, -20.12, 39.04, 
	-18.10, 3, 34.56, -18.38, 30.19, -17.74, 26.91, -16.73, 3, 25.34, -16.25, 24.02, -15.32, 22.60, -14.97, 
	3, 22.19, -14.87, 21.98, -15.16, 21.62, -14.97, 3, 20.52, -14.39, 19.72, -13.19, 18.88, -12.43, 3, 18.43, 
	-12.49, 18.04, -12.63, 17.91, -13.01, 3, 17.50, -12.96, 17.85, -12.15, 17.51, -12.03, 3, 14.74, -11.75, 
	11.22, -10.23, 7.53, -10.08, 3, 7.37, -8.87, 7.03, -7.84, 7.14, -6.36, 3, 2.95, -4.40, 1.78, 3.46, 3.62, 
	8.51, 3, 3.19, 10.16, 3.62, 10.53, 3.23, 12.23, 3, 2.65, 12.37, 2.02, 12.46, 1.66, 12.82, 3, 1.65, 13.48, 
	2.24, 13.55, 2.64, 13.80, 3, 2.45, 14.58, 1.71, 14.82, 1.86, 15.95, 3, 3.44, 16.64, 3.66, 14.39, 4.79, 
	13.99, 3, 7.48, 16.71, 1.18, 16.08, 0.49, 17.91, 3, 0.09, 18.30, 0.11, 17.82, -0.29, 17.71, 3, -3.95, 
	20.58, -9.48, 21.58, -12.43, 25.15, 3, -11.46, 26.27, -12.24, 28.31, -12.04, 31.02, 3, -16.61, 35.51, 
	-17.12, 44.07, -22.60, 47.65, 3, -21.78, 46.52, -21.17, 45.17, -20.06, 44.33, 3, -18.75, 37.01, -11.24, 
	33.33, -13.99, 24.36, 3, -15.56, 24.36, -17.12, 24.36, -18.69, 24.36, 3, -11.88, 21.91, -4.14, 20.39, 
	-0.10, 15.17, 3, -0.44, 12.65, 0.69, 11.86, 2.64, 10.47, 3, 2.24, 8.68, 2.74, 7.07, 2.45, 4.99, 3, 2.05, 
	2.17, -0.04, -0.22, 2.05, -2.25, 3, 0.86, -2.81, -3.10, -2.67, -2.45, -3.42, 3, -4.79, -3.81, -5.56, 
	-2.63, -7.73, -2.84, 3, -9.12, -1.72, -10.02, 0.31, -12.62, -1.86, 3, -11.95, -2.50, -11.99, -3.84, 
	-11.45, -4.60, 3, -12.49, -6.75, -14.53, -7.91, -14.58, -11.06, 3, -18.22, -13.68, -25.46, -11.59, -29.84, 
	-11.25, 3, -30.95, -11.17, -31.75, -11.65, -32.78, -11.06, 3, -35.73, -9.35, -35.09, -5.51, -37.28, 
	-3.23, 3, -37.06, -2.98, -36.89, -1.69, -37.28, -1.47, 3, -38.78, -0.03, -40.81, 0.87, -41.98, 2.64, 
	3, -42.36, 0.86, -40.16, 0.51, -39.24, -0.68, 3, -38.25, -1.97, -37.71, -4.58, -36.89, -6.55, 3, -36.39, 
	-7.75, -35.40, -8.18, -35.71, -10.08, 3, -38.48, -11.81, -42.94, -11.85, -44.72, -14.58, 3, -43.36, 
	-14.54, -40.44, -11.99, -38.65, -13.60, 3, -37.58, -12.97, -36.43, -12.43, -35.52, -11.64, 3, -32.52, 
	-12.49, -27.98, -12.60, -23.97, -13.01, 3, -20.14, -13.40, -17.38, -12.68, -14.19, -13.80, 3, -13.00, 
	-11.29, -13.72, -9.30, -12.43, -7.14, 3, -11.00, -7.35, -10.59, -5.32, -9.88, -4.21, 3, -4.95, -4.62, 
	4.73, -1.80, 4.40, -8.51, 3, 4.66, -8.78, 5.25, -8.71, 5.77, -8.71, 3, 5.56, -11.05, 6.86, -13.46, 7.73, 
	-15.36, 3, 6.77, -18.38, 6.23, -21.82, 5.58, -25.15, 0, 1, -21.62, -29.06, 3, -21.44, -29.59, -21.01, 
	-28.79, -20.45, -29.06, 3, -19.06, -26.47, -14.70, -26.85, -14.58, -22.99, 3, -15.49, -24.23, -16.75, 
	-25.13, -17.71, -26.32, 3, -19.93, -25.79, -20.57, -28.27, -21.62, -29.06, 0, 1, 28.87, 2.84, 3, 29.53, 
	6.17, 28.16, 10.54, 30.04, 13.41, 3, 30.67, 14.37, 31.33, 13.92, 32.39, 14.58, 3, 32.51, 14.66, 32.27, 
	15.26, 32.39, 15.36, 3, 32.80, 15.73, 33.83, 15.66, 34.34, 15.95, 3, 36.30, 17.02, 38.09, 19.14, 39.82, 
	19.47, 3, 39.84, 23.19, 40.39, 27.07, 41.00, 30.23, 3, 39.29, 28.03, 38.40, 24.19, 38.85, 20.45, 3, 
	35.93, 18.87, 34.25, 16.05, 29.84, 15.95, 3, 29.23, 13.24, 27.68, 10.08, 27.69, 6.95, 3, 27.69, 5.83, 
	28.23, 4.70, 27.30, 4.01, 3, 24.11, 3.70, 22.42, 5.08, 19.67, 3.82, 3, 21.89, 2.76, 25.84, 3.84, 28.87, 
	2.84, 0,  }

shape[3] = { 1, 7.72, -47.32, 3, 8.92, -46.84, 8.81, -44.42, 8.39, -43.29, 3, 10.59, -43.42, 13.24, -44.26, 15.77, 
	-44.97, 3, 12.19, -42.40, 5.54, -42.90, 3.69, -38.59, 3, 3.10, -42.09, 7.20, -43.80, 7.72, -47.32, 0, 
	1, 50.00, 0.00, 3, 46.59, -0.27, 45.84, 2.11, 43.29, 2.68, 3, 43.09, 4.82, 41.24, 7.05, 38.59, 7.72, 
	3, 39.34, 6.45, 40.55, 5.65, 41.61, 4.70, 3, 40.75, 3.10, 37.97, 3.42, 37.58, 1.34, 3, 39.30, 1.30, 
	39.69, 2.59, 40.94, 3.02, 3, 43.00, 1.47, 46.83, -1.79, 50.00, 0.00, 0, 1, 37.25, 2.01, 3, 36.58, 2.01, 
	35.91, 2.01, 35.24, 2.01, 3, 35.30, 1.51, 37.43, 0.67, 37.25, 2.01, 0, 1, 21.48, 5.70, 3, 24.29, 8.15, 
	24.52, 13.18, 29.19, 13.76, 3, 31.72, 15.37, 33.51, 17.72, 35.57, 19.80, 3, 38.59, 18.74, 42.10, 19.94, 
	43.96, 21.14, 3, 41.62, 22.09, 38.59, 19.19, 35.57, 20.81, 3, 38.30, 25.24, 41.68, 29.02, 42.62, 35.24, 
	3, 38.98, 27.13, 35.07, 19.30, 28.19, 14.43, 3, 26.47, 18.75, 23.20, 21.52, 17.79, 22.15, 3, 18.29, 
	21.32, 19.16, 21.40, 18.46, 20.13, 3, 20.41, 21.09, 19.95, 19.37, 20.81, 18.46, 3, 21.53, 18.40, 20.96, 
	19.65, 21.14, 20.13, 3, 24.54, 19.62, 26.14, 17.30, 27.18, 14.43, 3, 24.99, 13.59, 24.14, 16.97, 21.81, 
	17.11, 3, 21.31, 16.26, 23.72, 15.45, 24.50, 14.77, 3, 23.85, 11.39, 22.54, 8.67, 21.48, 5.70, 0, 1, 
	-22.82, 43.29, 3, -23.08, 45.37, -24.81, 45.99, -25.84, 47.32, 3, -26.34, 46.81, -26.38, 45.84, -26.51, 
	44.97, 3, -25.10, 44.59, -24.87, 43.03, -22.82, 43.29, 0, 1, -19.46, -28.52, 3, -19.17, -28.03, -19.20, 
	-27.22, -18.12, -27.52, 3, -19.34, -26.61, -20.63, -25.78, -21.48, -24.50, 3, -21.71, -22.77, -20.61, 
	-21.68, -21.81, -20.81, 3, -22.98, -22.98, -24.57, -26.78, -21.48, -27.85, 3, -23.58, -30.06, -27.54, 
	-30.23, -29.87, -30.54, 3, -31.28, -30.48, -29.86, -31.05, -29.87, -31.54, 3, -35.61, -31.77, -34.85, 
	-22.68, -41.95, -23.15, 3, -38.92, -26.39, -35.38, -29.11, -32.55, -32.55, 3, -32.84, -33.38, -34.04, 
	-33.30, -33.89, -34.56, 3, -27.32, -34.76, -25.37, -30.34, -20.13, -29.19, 3, -18.98, -30.39, -17.39, 
	-31.14, -16.44, -32.55, 3, -11.48, -29.36, -7.79, -34.92, -2.35, -35.23, 3, -4.63, -32.59, -9.34, -32.38, 
	-12.42, -30.54, 3, -14.84, -31.97, -16.78, -28.16, -19.46, -28.52, 0, 1, 29.53, -29.87, 3, 32.55, -26.42, 
	37.49, -31.22, 40.60, -29.53, 3, 40.33, -28.69, 38.83, -29.06, 38.25, -28.52, 3, 38.42, -26.79, 40.61, 
	-27.08, 40.94, -25.50, 3, 39.33, -26.13, 37.88, -26.92, 36.91, -28.19, 3, 28.09, -27.89, 23.18, -23.59, 
	17.79, -19.13, 3, 17.00, -19.24, 16.40, -19.53, 15.77, -19.80, 3, 14.83, -19.06, 14.23, -17.99, 12.75, 
	-17.78, 3, 14.04, -19.63, 15.67, -21.13, 17.11, -22.82, 3, 24.03, -22.07, 25.68, -26.28, 29.53, -29.87, 
	0, 1, -7.72, -26.51, 3, -6.61, -26.82, -5.20, -24.56, -3.69, -24.16, 3, -3.79, -23.71, -4.53, -23.88, 
	-5.03, -23.83, 3, -1.33, -20.60, 2.41, -17.40, 8.39, -16.44, 3, 5.11, -14.09, 2.01, -6.83, 4.70, -2.68, 
	3, 3.39, -3.27, 2.74, -4.52, 1.01, -4.70, 3, 1.29, -6.20, 2.87, -6.42, 3.36, -7.72, 3, 3.80, -14.80, 
	1.35, -18.02, -3.69, -20.13, 3, -4.25, -23.04, -6.50, -24.26, -7.72, -26.51, 0, 1, -26.85, -11.41, 3, 
	-26.37, -12.39, -25.43, -12.90, -23.83, -12.75, 3, -22.82, -13.87, -23.60, -16.78, -21.81, -17.11, 3, 
	-21.36, -15.10, -20.89, -13.11, -21.14, -10.40, 3, -21.73, -10.71, -21.75, -11.58, -22.15, -12.08, 3, 
	-23.21, -11.91, -22.69, -10.16, -23.49, -9.73, 3, -21.85, -7.10, -19.97, -5.38, -17.79, -4.03, 3, -17.31, 
	-1.04, -15.74, 0.86, -14.43, 3.02, 3, -18.07, 0.28, -20.71, -6.36, -25.84, -8.72, 3, -25.62, -10.18, 
	-26.22, -10.80, -26.85, -11.41, 0, 1, -31.54, 23.15, 3, -28.40, 21.87, -24.48, 18.38, -20.13, 20.47, 
	3, -22.47, 22.29, -25.11, 21.06, -27.52, 21.81, 3, -31.35, 23.01, -30.58, 26.89, -32.55, 30.20, 3, -33.63, 
	28.75, -31.73, 26.47, -31.88, 25.84, 3, -32.53, 25.48, -33.25, 25.20, -32.89, 23.83, 3, -35.07, 22.10, 
	-37.44, 20.55, -38.25, 17.45, 3, -39.12, 17.71, -39.68, 18.26, -39.93, 19.13, 3, -42.88, 17.00, -47.03, 
	22.51, -50.00, 18.46, 3, -45.99, 21.16, -43.70, 16.33, -38.93, 16.78, 3, -38.97, 16.15, -39.15, 15.66, 
	-39.60, 15.44, 3, -39.34, 13.81, -38.82, 16.90, -37.58, 16.44, 3, -36.61, 19.72, -34.12, 21.48, -31.54, 
	23.15, 0, 1, -19.13, 37.25, 3, -18.92, 38.02, -20.27, 40.12, -20.81, 41.28, 3, -22.06, 40.67, -19.74, 
	38.19, -19.13, 37.25, 0, 1, -12.75, 5.70, 3, -11.64, 10.52, -9.93, 14.74, -8.72, 19.46, 3, -6.36, 21.80, 
	-3.84, 23.97, 0.00, 24.83, 3, 2.37, 23.51, 4.37, 21.82, 7.72, 21.48, 3, 5.81, 23.08, 0.78, 23.85, 1.34, 
	25.84, 3, -1.59, 26.08, -5.31, 25.13, -7.38, 23.49, 3, -8.59, 26.94, -6.31, 29.80, -3.69, 30.54, 3, 
	-3.95, 33.91, -0.09, 37.59, -1.34, 41.95, 3, -4.25, 35.90, -4.81, 27.52, -12.42, 26.17, 3, -12.12, 21.29, 
	-14.61, 19.19, -14.43, 14.43, 3, -13.13, 14.57, -13.24, 14.80, -12.42, 14.09, 3, -13.09, 11.95, -13.46, 
	8.16, -12.75, 5.70, 2, -8.72, 25.84, 3, -9.63, 22.27, -8.61, 16.78, -11.41, 15.10, 3, -11.72, 16.20, 
	-11.61, 17.72, -13.09, 16.78, 3, -12.61, 20.55, -10.90, 24.88, -8.72, 25.84, 0,  }