function param1()
  return "粒子数", 1, 100, 20
end

function param2()
  return "重力影響", 0, 100, 15
end

function param3()
	return "オフセット", 0, 100, 20
end

function param4()
	return "角度のジッタ", 0, 100, 50
end

function param5()
	return "長さ", 0, 100, 20
end

function param6()
	return "奥行", 0, 100, 20
end

function param7()
	return "軌跡のジッタ", 0, 100, 0
end

function param8()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0
end

bs_setmode( 1 )

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end

function use_base()
  return true
end

function main( x, y, p )

	local mul = 0.025

	local press = p
	local w = bs_width()
	local maxW = bs_width_max() 
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param8() )

	local rdmSize = bs_grand( 0, 0.1 ) % 0.1 * 0.05

	local number = roundCalc( bs_param1()/2 )
	local offset = bs_param3()*10
	local canvasW = bs_canvas_width() 
	local canvasH = bs_canvas_height() 

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )

	if ( not firstDraw ) then
			if ( distance < w * 0.5 ) then
				return 0
			end
	else
			firstDrawX,firstDrawY = x,y

			local bsx,bsy = bs_base()
			if ( bsx>-1) then firstDrawX,firstDrawY = bsx,bsy end

			for i=1,number do
					DrawX[i] = firstDrawX
					DrawY[i] = firstDrawY
					gravity[i] = 0
					rdmAngle[i] = bs_grand( 0, 3.14159 / number ) * bs_param4()/100
					rdmZ[i] = math.random((100-bs_param6()),100)/100
						if ( bs_param6() == 0 ) then rdmZ[i]=1 end
			end
	end

	if ( DrawCount>(1+bs_param5()*4) ) then return 0 end

	for i=1,number do

		local velocity = 10
		local angle = rdmAngle[i] + (i-1) * 3.14159 * 2 / number
		local rdmX = bs_grand(0,10*w) * bs_param7()/100
		local rdmY = bs_grand(0,10*w) * bs_param7()/100

		local gravityT = gravity[i]
		local DrawXT = DrawX[i]
		local DrawYT = DrawY[i]
		local notOffset = 1

		if ( DrawCount>1 ) then notOffset=0 end

		gravityT = gravityT + 0.025
		DrawXT = DrawXT + rdmZ[i] * ( rdmX -1 * math.cos(angle) * velocity - offset*math.cos(angle)*notOffset )
		DrawYT = DrawYT + rdmZ[i] * ( rdmY -1 * math.sin(angle) * velocity + velocity * gravityT * gravityT * bs_param2()/100 - offset*math.sin(angle)*notOffset )

		local DrawRotate = bs_atan( DrawX[i]-DrawXT, DrawY[i]-DrawYT ) 
		local stretch = 1 + bs_distance( DrawX[i]-DrawXT, DrawY[i]-DrawYT )
		if ( DrawCount==1 ) then stretch=1 end

		gravity[i] = gravityT
		DrawX[i] = DrawXT 
		DrawY[i] = DrawYT


		if ( canvasH < DrawYT*0.5 ) then return 0 end

		local id = 1
		local code = ''

		repeat

			code = cmdcon[shape[id]]

			if (code=='z') then
					local sharp = DrawCount/10
					if ( sharp>1 ) then sharp = 1 end

					bs_bezier_mul( mul * sharp * stretch , mul * (10*press+1) * sharp )
					bs_bezier_rotate( DrawRotate )
					bs_bezier_move( DrawXT, DrawYT )
					bs_fill( r,g,b,a )
					id = id + 1
			else
				id = ( cmd[code] or cmd.default )( shape, id+1 )
			end

		until id > #shape

	end


	lastDrawX = x
	lastDrawY = y
	firstDraw = false
	previousTime = currentTime

	DrawCount = DrawCount+1

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true
firstDrawX,firstDrawY = 0,0

DrawCount = 1
DrawX = {}
DrawY = {}
gravity = {}
rdmAngle = {}
rdmZ = {}

currentTime, previousTime = 0, 0

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, -0.06, -50.00, 3, 27.95, -50.00, 49.97, -28.49, 49.97, 0.03, 3, 49.97, 28.67, 29.21, 49.93, -0.00, 
	50.00, 3, -28.08, 50.06, -49.97, 28.30, -49.97, 0.03, 3, -49.97, -28.11, -28.33, -50.00, -0.06, -50.00, 
	0 }