function param1()
  return "ブラシ間隔", 10, 100, 50
end

function param2()
	return "回転", 0, 1, 0
end

function param3()
	return "大きさのジッタ", 0, 100, 20
end

function param4()
	return "位置のジッタ", 0, 100, 20
end

function param5()
	return "色のジッタ", 0, 100, 0
end

function param6()
	return "グリッドスナップ", 0, 1, 0
end

function param7()
	return "グリッド45度", 0, 1, 1
end

function param8()
	return "グリッド間隔", 1, 100, 40
end

function param9()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0.75
end
bs_setmode( 1 )

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.08
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param9() )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )
	local rdmShape = math.random(6)

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param5()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local SpinCheck = bs_param2()	
	local GridLock = bs_param6()
	local GridSpin = bs_param7()
	local GridReso = 16 * bs_param8() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end

	if ( GridLock==1 ) then	math.randomseed( gridX * gridX * gridY * gridY ) end

	local rdmSpin = math.random() * 3.14
	local rdmSize = math.random() * bs_param3()/500

	if ( SpinCheck == 0 ) then dx,dy = 0,0 rdmSpin = 0 end

	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms()) 
			rdmSize = rdm0 * math.random() * bs_param3()/1000
			if ( SpinCheck == 1 ) then rdmSpin = math.random() * 3.14/5 end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param4()/100  * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	shape = stroke[rdmShape]

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * rdm0, (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

stroke = {}

stroke[1] = { 1, 1.95, 27.62, 3, -3.00, 27.62, -6.87, 26.50, -10.58, 22.88, 3, -12.47, 21.04, -12.41, 20.08, -15.25, 
	19.95, 3, -17.81, 19.84, -20.28, 19.14, -22.60, 18.05, 3, -27.50, 15.76, -31.38, 11.87, -35.04, 7.99, 
	3, -36.93, 5.99, -39.33, 4.98, -41.92, 4.01, 3, -44.96, 2.87, -47.01, 3.63, -50.00, 4.22, 3, -50.00, 
	3.55, -47.26, 1.33, -46.54, 0.96, 3, -44.13, -0.26, -41.27, -0.60, -38.62, -0.82, 3, -32.24, -1.37, 
	-27.09, 0.47, -21.31, 2.82, 3, -25.56, -4.07, -20.29, -12.51, -18.52, -19.32, 3, -10.29, -14.44, -2.09, 
	-8.83, 0.98, 0.73, 3, 1.40, -1.10, -0.56, -3.04, 0.98, -4.70, 3, 2.64, -3.77, 2.31, -1.90, 2.41, -0.31, 
	3, 2.47, 0.77, 0.80, 1.68, 1.67, 3.10, 3, 1.94, 1.65, 2.82, 3.23, 3.07, 3.66, 3, 2.89, 0.95, 3.60, -2.19, 
	3.79, -4.92, 3, 3.84, -5.70, 4.93, -7.27, 5.35, -5.77, 3, 5.55, -5.10, 5.09, -4.02, 5.57, -3.44, 3, 
	8.24, -9.41, 10.75, -15.80, 15.32, -20.63, 3, 17.61, -23.05, 20.48, -24.17, 23.04, -26.12, 3, 24.23, 
	-27.02, 28.01, -29.89, 28.02, -27.62, 3, 28.02, -26.34, 28.62, -25.08, 29.44, -24.13, 3, 30.71, -22.66, 
	30.41, -20.02, 30.42, -18.09, 3, 30.42, -14.30, 29.94, -10.52, 29.00, -6.84, 3, 27.19, 0.29, 23.77, 
	7.18, 17.83, 11.74, 3, 29.43, 11.70, 40.84, 8.47, 49.58, 0.60, 3, 50.20, 1.49, 48.89, 3.66, 50.00, 3.80, 
	3, 50.00, 20.77, 26.23, 25.19, 13.65, 19.82, 3, 14.71, 20.63, 15.60, 21.66, 16.85, 22.18, 3, 17.77, 
	22.57, 19.30, 22.34, 19.64, 23.58, 3, 13.65, 23.93, 7.78, 26.31, 1.95, 27.62, 2, 4.46, 0.60, 3, 4.46, 
	0.18, 4.83, -0.60, 4.46, -0.94, 3, 4.45, -0.52, 4.08, 0.26, 4.46, 0.60, 2, 1.81, 4.91, 3, 2.23, 5.61, 
	1.99, 6.96, 2.51, 7.56, 3, 2.37, 6.55, 2.58, 5.52, 1.81, 4.91, 2, 12.40, 19.12, 3, 12.12, 19.06, 11.54, 
	18.60, 11.28, 18.98, 3, 11.78, 19.13, 12.13, 19.31, 12.40, 19.12, 0 }

stroke[2] = { 1, 13.65, 41.05, 3, 12.94, 41.05, 12.23, 41.05, 11.52, 41.05, 3, 7.71, 40.25, 2.15, 39.50, 0.17, 36.26, 
	3, -0.31, 35.46, -0.45, 34.46, -0.71, 33.60, 3, -0.98, 32.73, -0.93, 31.73, -1.24, 30.76, 3, -1.46, 
	30.11, -2.06, 29.66, -2.31, 28.99, 3, -2.76, 27.76, -2.72, 26.52, -3.19, 25.27, 3, -4.25, 28.70, -4.42, 
	30.11, -6.03, 32.71, 3, -7.26, 33.67, -8.44, 34.68, -9.75, 35.55, 3, -15.01, 36.88, -19.09, 38.39, -24.65, 
	37.32, 3, -26.82, 36.91, -29.36, 36.15, -31.92, 35.55, 3, -34.16, 35.03, -37.32, 33.70, -39.01, 33.95, 
	3, -40.36, 34.16, -41.41, 35.55, -43.09, 35.37, 3, -45.11, 27.73, -43.69, 19.12, -40.07, 12.32, 3, -37.58, 
	9.73, -34.24, 7.98, -29.97, 7.18, 3, -30.84, 6.57, -31.88, 6.14, -33.16, 5.94, 3, -37.34, 2.31, -41.89, 
	0.12, -44.33, -4.70, 3, -45.77, -7.55, -46.48, -10.65, -47.70, -14.10, 3, -48.34, -15.92, -48.73, -17.49, 
	-50.00, -18.71, 3, -50.00, -18.88, -50.00, -19.06, -50.00, -19.24, 3, -47.21, -20.28, -44.04, -22.04, 
	-40.96, -22.96, 3, -37.78, -23.91, -34.47, -24.43, -31.56, -24.73, 3, -25.93, -25.33, -20.19, -21.04, 
	-17.38, -16.93, 3, -15.68, -14.45, -14.89, -11.49, -13.30, -8.78, 3, -12.54, -8.71, -12.47, -7.95, -11.53, 
	-8.07, 3, -11.10, -8.03, -10.52, -6.62, -10.46, -7.36, 3, -9.88, -10.56, -10.31, -13.77, -9.22, -16.58, 
	3, -8.66, -18.02, -7.32, -19.54, -6.38, -21.01, 3, -3.53, -25.49, 0.13, -29.69, 3.90, -32.36, 3, 3.86, 
	-32.16, 3.70, -32.08, 3.55, -32.00, 3, 3.35, -31.64, 3.35, -31.63, 3.72, -31.83, 3, 6.73, -34.20, 9.25, 
	-37.06, 11.35, -40.34, 3, 10.93, -40.39, 11.55, -40.81, 11.52, -41.05, 3, 11.76, -41.05, 12.00, -41.05, 
	12.23, -41.05, 3, 18.68, -33.23, 22.68, -19.66, 18.62, -8.78, 3, 21.63, -12.16, 25.83, -16.62, 31.74, 
	-16.22, 3, 33.90, -16.08, 34.82, -14.97, 36.88, -14.45, 3, 37.04, -13.37, 38.15, -13.24, 38.30, -12.15, 
	3, 39.69, -11.89, 40.60, -11.02, 41.49, -10.02, 3, 42.18, -9.25, 42.47, -8.06, 43.26, -7.54, 3, 44.31, 
	-6.85, 45.93, -7.10, 47.16, -6.47, 3, 48.23, -5.94, 48.75, -4.79, 50.00, -4.52, 3, 50.00, -4.46, 50.00, 
	-4.40, 50.00, -4.34, 3, 49.48, -3.03, 47.73, -2.39, 46.81, -1.33, 3, 44.55, 1.27, 44.66, 5.36, 42.20, 
	7.18, 3, 41.66, 7.58, 40.82, 7.81, 40.07, 8.24, 3, 38.47, 9.16, 36.84, 10.49, 35.46, 11.08, 3, 30.53, 
	13.20, 24.78, 10.84, 18.44, 10.37, 3, 22.83, 11.30, 25.12, 14.33, 28.01, 16.75, 3, 30.86, 16.69, 32.99, 
	19.02, 35.11, 19.77, 3, 36.14, 20.13, 37.90, 19.85, 38.12, 21.01, 3, 38.29, 21.88, 36.53, 23.44, 35.99, 
	24.02, 3, 33.26, 26.99, 31.16, 30.14, 28.37, 32.36, 3, 28.13, 31.91, 29.07, 31.80, 28.54, 31.65, 3, 
	24.79, 35.98, 20.21, 40.06, 13.65, 41.05, 0 }

stroke[3] = { 1, -50.00, -16.09, 3, -50.00, -16.86, -50.00, -17.63, -50.00, -18.41, 3, -46.19, -14.83, -42.55, -10.48, 
	-38.72, -6.47, 3, -35.42, -3.01, -31.37, -0.19, -27.45, 2.49, 3, -26.94, 2.83, -26.02, 3.64, -26.12, 
	3.15, 3, -28.15, -0.20, -31.86, -5.82, -32.42, -11.28, 3, -32.93, -16.21, -31.50, -20.41, -29.27, -24.54, 
	3, -27.00, -25.24, -26.75, -29.00, -25.29, -31.01, 3, -22.79, -29.32, -19.57, -28.33, -17.66, -26.04, 
	3, -15.75, -24.92, -13.62, -24.60, -11.69, -23.55, 3, -6.74, -20.85, -3.77, -16.29, -0.25, -12.27, 3, 
	-0.18, -13.36, 0.38, -13.96, 1.24, -14.26, 3, 3.10, -13.28, 1.94, -10.42, 2.40, -8.46, 3, 3.29, -8.57, 
	2.57, -10.29, 3.73, -10.12, 3, 4.59, -8.65, 3.02, -7.55, 3.07, -6.14, 3, 3.13, -4.57, 5.04, -2.75, 5.06, 
	-1.16, 3, 5.21, -2.83, 5.07, -4.92, 5.56, -6.63, 3, 5.21, -7.93, 4.20, -9.30, 4.56, -10.78, 3, 5.61, 
	-10.81, 5.85, -10.41, 7.05, -10.95, 3, 7.59, -9.81, 7.83, -8.50, 7.55, -7.30, 3, 9.99, -11.42, 10.78, 
	-16.39, 14.18, -20.40, 3, 16.39, -23.00, 19.46, -24.75, 22.64, -26.70, 3, 23.95, -27.50, 25.27, -29.23, 
	26.45, -28.52, 3, 29.53, -30.08, 32.15, -32.11, 35.90, -33.00, 3, 36.29, -33.00, 36.68, -33.00, 37.06, 
	-33.00, 3, 37.33, -30.84, 36.21, -28.84, 36.24, -26.87, 3, 36.26, -25.09, 37.14, -23.30, 37.40, -21.56, 
	3, 38.32, -15.22, 38.19, -9.03, 37.23, -3.48, 3, 39.79, -7.17, 45.28, -8.92, 50.00, -9.45, 3, 50.00, 
	-9.29, 50.00, -9.12, 50.00, -8.96, 3, 49.95, -8.96, 49.89, -8.96, 49.83, -8.96, 3, 49.63, -8.11, 48.75, 
	-7.94, 48.18, -7.46, 3, 47.84, -5.98, 47.05, -4.94, 46.35, -3.81, 3, 45.58, 3.24, 42.84, 6.97, 40.05, 
	11.94, 3, 35.24, 17.22, 29.98, 22.22, 22.97, 25.71, 3, 20.69, 26.84, 18.40, 28.29, 16.17, 29.02, 3, 
	14.25, 29.65, 12.41, 29.99, 10.70, 31.18, 3, 8.08, 32.31, 4.37, 31.89, 2.07, 33.00, 3, 1.96, 33.00, 
	1.85, 33.00, 1.74, 33.00, 3, 0.96, 31.62, -2.37, 33.89, -3.73, 32.34, 3, -2.26, 32.09, -2.55, 30.78, 
	-1.58, 29.85, 3, -6.37, 30.32, -11.57, 27.91, -15.84, 27.03, 3, -18.23, 26.54, -21.15, 26.53, -23.63, 
	25.87, 3, -26.07, 25.22, -28.72, 24.34, -30.76, 23.22, 3, -33.32, 21.81, -35.19, 19.62, -37.06, 17.25, 
	3, -42.43, 10.46, -48.32, 4.07, -49.67, -6.30, 3, -49.33, -9.32, -49.30, -12.77, -50.00, -16.09, 2, 
	6.22, -2.49, 3, 6.50, -3.04, 6.52, -3.85, 6.72, -4.48, 3, 6.48, -4.52, 6.44, -4.75, 6.22, -4.81, 3, 
	6.01, -4.34, 5.91, -0.89, 6.22, -2.49, 0 }

stroke[4] = { 1, 12.35, -48.31, 3, 12.35, -48.24, 13.61, -47.16, 13.77, -46.98, 3, 14.68, -45.90, 15.26, -44.77, 15.97, 
	-43.52, 3, 17.58, -40.67, 19.14, -37.71, 19.25, -34.36, 3, 19.36, -30.99, 20.78, -27.82, 20.81, -24.42, 
	3, 20.83, -22.60, 20.48, -20.86, 19.81, -19.17, 3, 19.39, -18.09, 18.25, -16.95, 18.20, -16.36, 3, 18.25, 
	-16.28, 19.86, -17.03, 19.90, -17.05, 3, 21.11, -17.37, 20.90, -16.46, 21.80, -15.91, 3, 21.80, -14.86, 
	20.48, -15.03, 19.85, -14.71, 3, 18.64, -13.42, 17.33, -12.23, 16.25, -10.81, 3, 25.00, -14.63, 34.75, 
	-11.21, 43.10, -8.71, 3, 41.87, -7.32, 46.08, -6.60, 46.94, -5.87, 3, 47.67, -5.25, 50.00, -3.08, 50.00, 
	-2.11, 3, 47.11, 2.81, 44.31, 7.86, 39.73, 11.41, 3, 35.17, 14.95, 30.32, 15.47, 24.80, 16.18, 3, 23.00, 
	15.79, 19.96, 16.35, 18.61, 15.32, 3, 17.64, 14.58, 15.04, 13.05, 13.55, 13.18, 3, 15.26, 14.29, 16.83, 
	15.59, 18.35, 16.93, 3, 18.96, 17.50, 18.26, 17.75, 19.14, 18.39, 3, 19.77, 18.85, 20.01, 18.93, 20.15, 
	19.78, 3, 23.86, 22.01, 27.35, 26.86, 26.55, 31.26, 3, 25.85, 35.10, 26.56, 39.03, 26.16, 42.78, 3, 
	26.00, 44.27, 25.98, 46.68, 24.20, 47.23, 3, 23.82, 48.57, 24.72, 47.96, 22.88, 48.31, 3, 22.33, 48.42, 
	21.05, 49.55, 21.05, 48.28, 3, 20.42, 48.38, 19.82, 48.28, 19.27, 47.97, 3, 18.36, 47.33, 17.82, 47.53, 
	16.71, 47.13, 3, 15.58, 46.72, 14.33, 46.52, 13.55, 46.33, 3, 10.29, 45.10, 6.74, 44.68, 3.40, 42.86, 
	3, -4.24, 38.70, -8.28, 30.40, -8.35, 21.88, 3, -13.08, 28.68, -21.32, 32.74, -29.05, 35.08, 3, -29.52, 
	34.68, -31.90, 35.20, -32.50, 35.23, 3, -34.11, 35.67, -35.90, 35.67, -37.55, 35.46, 3, -41.36, 34.98, 
	-44.81, 33.36, -48.68, 32.09, 3, -50.95, 31.34, -49.80, 28.86, -49.36, 26.80, 3, -48.89, 24.65, -48.27, 
	22.52, -47.61, 20.41, 3, -46.74, 17.62, -45.02, 13.07, -42.10, 11.68, 3, -41.53, 10.09, -40.00, 9.69, 
	-39.32, 8.53, 3, -38.61, 7.33, -37.00, 6.19, -35.65, 5.54, 3, -32.86, 4.21, -29.51, 2.66, -26.35, 3.13, 
	3, -28.76, 1.28, -32.36, 2.14, -34.56, 0.35, 3, -35.05, -0.05, -35.61, -0.22, -36.25, -0.17, 3, -37.12, 
	-1.05, -38.18, -1.71, -39.12, -2.51, 3, -39.91, -3.18, -41.10, -4.30, -41.60, -5.02, 3, -42.03, -5.66, 
	-42.94, -6.70, -43.61, -7.41, 3, -44.08, -7.92, -44.69, -9.75, -45.55, -9.92, 3, -45.93, -11.64, -47.04, 
	-13.30, -47.64, -15.01, 3, -48.35, -17.02, -49.35, -18.92, -50.00, -20.96, 3, -50.87, -23.70, -49.01, 
	-22.86, -47.20, -23.73, 3, -45.94, -24.33, -44.94, -25.33, -43.54, -25.68, 3, -42.15, -26.02, -40.73, 
	-25.34, -39.38, -25.87, 3, -35.95, -27.22, -32.81, -27.68, -29.13, -26.83, 3, -27.55, -26.47, -25.58, 
	-25.81, -24.10, -25.22, 3, -22.73, -24.68, -20.95, -24.10, -19.60, -23.42, 3, -19.42, -24.23, -19.74, 
	-28.64, -17.91, -25.93, 3, -16.95, -24.52, -15.87, -23.66, -14.80, -22.27, 3, -14.14, -21.43, -10.16, 
	-14.90, -8.65, -15.62, 3, -9.47, -18.98, -8.99, -22.52, -9.10, -25.96, 3, -9.23, -29.97, -8.11, -34.17, 
	-5.93, -37.53, 3, -4.08, -40.37, -1.58, -42.68, 1.44, -44.24, 3, 3.13, -45.11, 4.94, -45.75, 6.77, -46.22, 
	3, 8.65, -46.71, 10.33, -48.31, 12.35, -48.31, 2, -14.95, -19.96, 3, -14.94, -20.47, -16.19, -22.32, 
	-16.60, -21.91, 3, -16.01, -21.27, -16.07, -20.02, -14.95, -19.96, 0 }

stroke[5] = { 1, 50.00, -10.59, 3, 50.00, -9.57, 50.00, -8.55, 50.00, -7.53, 3, 49.93, -7.53, 49.85, -7.53, 49.78, 
	-7.53, 3, 48.37, 3.91, 45.97, 14.34, 37.34, 19.32, 3, 35.29, 20.33, 31.94, 20.97, 30.57, 21.94, 3, 29.84, 
	21.61, 28.56, 22.53, 27.29, 21.94, 3, 28.12, 24.88, 29.35, 28.49, 28.38, 30.46, 3, 30.38, 31.91, 29.39, 
	34.55, 30.57, 36.14, 3, 24.61, 36.99, 21.25, 39.17, 17.68, 42.69, 3, 14.03, 46.29, 10.19, 48.62, 3.93, 
	49.89, 3, 3.71, 49.89, 3.49, 49.89, 3.27, 49.89, 3, -0.60, 48.60, -3.84, 46.67, -7.86, 45.53, 3, -8.71, 
	38.13, -8.33, 30.19, -7.21, 25.00, 3, -10.51, 28.69, -14.85, 31.46, -20.09, 33.52, 3, -26.12, 35.88, 
	-32.18, 36.26, -38.43, 36.35, 3, -44.27, 32.58, -48.74, 27.45, -50.00, 19.10, 3, -50.00, 17.72, -50.00, 
	16.34, -50.00, 14.96, 3, -49.38, 13.90, -49.37, 12.01, -48.91, 10.81, 3, -47.61, 7.43, -44.98, 4.04, 
	-42.58, 2.07, 3, -40.62, 0.47, -36.32, -1.47, -33.19, -2.51, 3, -28.03, -4.22, -21.66, -2.46, -15.07, 
	-3.17, 3, -21.96, -5.21, -30.04, -4.42, -35.59, -7.10, 3, -40.10, -9.27, -42.72, -13.63, -43.67, -19.10, 
	3, -44.24, -22.38, -44.86, -28.61, -44.32, -30.68, 3, -44.14, -31.38, -43.17, -32.02, -42.80, -33.08, 
	3, -41.73, -36.09, -41.68, -40.65, -40.39, -43.12, 3, -37.72, -48.23, -29.90, -49.20, -24.45, -46.62, 
	3, -16.09, -42.65, -12.07, -31.69, -8.30, -22.82, 3, -7.27, -20.41, -6.03, -18.13, -5.02, -16.05, 3, 
	-4.77, -15.54, -4.45, -13.06, -4.15, -14.74, 3, -3.45, -14.63, -3.90, -15.70, -3.93, -16.05, 3, -4.53, 
	-23.60, -4.67, -27.21, -0.66, -32.21, 3, 1.43, -34.80, 3.91, -37.44, 6.33, -38.97, 3, 8.48, -40.33, 
	11.46, -41.97, 13.76, -42.47, 3, 14.96, -42.73, 16.26, -42.43, 17.47, -42.69, 3, 19.97, -43.21, 22.86, 
	-44.83, 25.33, -45.96, 3, 28.09, -47.22, 31.09, -48.73, 32.97, -49.89, 3, 33.11, -49.89, 33.26, -49.89, 
	33.40, -49.89, 3, 33.40, -49.82, 33.40, -49.75, 33.40, -49.67, 3, 34.87, -49.73, 36.90, -47.62, 37.77, 
	-45.96, 3, 41.02, -39.81, 43.75, -32.15, 41.48, -23.69, 3, 40.39, -19.63, 37.78, -15.82, 35.81, -12.34, 
	3, 35.64, -12.05, 34.49, -11.70, 35.37, -11.25, 3, 37.49, -10.72, 40.07, -12.25, 42.57, -12.99, 3, 45.15, 
	-13.76, 47.68, -14.58, 49.56, -14.74, 3, 50.01, -13.32, 49.31, -11.75, 50.00, -10.59, 0 }

stroke[6] = { 1, 6.43, -46.78, 3, 6.80, -46.78, 7.17, -46.78, 7.54, -46.78, 3, 15.66, -40.88, 15.44, -26.62, 17.09, 
	-14.25, 3, 20.83, -16.09, 25.30, -18.47, 30.70, -18.66, 3, 38.90, -18.94, 45.11, -14.48, 50.00, -11.30, 
	3, 50.00, -10.75, 50.00, -10.20, 50.00, -9.65, 3, 47.67, -2.52, 45.39, 3.66, 40.07, 7.81, 3, 38.40, 
	9.12, 36.50, 9.60, 34.37, 10.39, 3, 30.84, 11.70, 26.95, 13.65, 22.43, 13.70, 3, 25.04, 16.52, 28.85, 
	18.33, 31.62, 21.42, 3, 35.83, 26.11, 37.79, 32.82, 42.46, 37.04, 3, 43.02, 38.00, 41.81, 39.63, 43.57, 
	39.25, 3, 40.08, 42.82, 33.74, 43.21, 27.94, 42.92, 3, 19.62, 42.51, 11.08, 39.26, 6.25, 35.75, 3, 5.76, 
	35.40, 4.85, 35.19, 4.96, 34.47, 3, 3.05, 35.64, 1.49, 37.24, -0.37, 38.70, 3, -2.19, 40.13, -4.46, 
	41.06, -6.80, 42.01, 3, -11.31, 43.82, -16.48, 45.60, -22.43, 45.87, 3, -25.02, 45.98, -28.11, 45.63, 
	-29.96, 46.78, 3, -30.09, 46.78, -30.21, 46.78, -30.33, 46.78, 3, -31.47, 46.79, -31.74, 45.00, -32.17, 
	44.03, 3, -33.72, 40.56, -37.11, 33.96, -35.85, 28.77, 3, -33.82, 20.45, -27.47, 12.63, -21.14, 10.02, 
	3, -25.05, 8.90, -28.64, 7.23, -31.80, 5.06, 3, -32.81, 4.36, -33.56, 3.31, -34.56, 2.67, 3, -36.02, 
	1.72, -37.64, 1.36, -38.97, 0.46, 3, -46.26, -4.44, -48.26, -13.07, -50.00, -24.54, 3, -50.00, -25.28, 
	-50.00, -26.01, -50.00, -26.75, 3, -49.77, -27.36, -48.85, -27.80, -48.34, -27.11, 3, -47.01, -29.01, 
	-43.33, -28.43, -40.81, -28.03, 3, -39.55, -27.84, -38.17, -27.21, -36.95, -27.11, 3, -35.22, -26.98, 
	-33.24, -27.75, -31.43, -27.85, 3, -24.22, -28.25, -19.27, -26.16, -15.26, -23.62, 3, -14.22, -22.97, 
	-13.21, -22.04, -11.95, -21.78, 3, -10.13, -31.97, -7.30, -42.83, 3.13, -44.21, 3, 4.06, -45.23, 5.05, 
	-46.21, 6.43, -46.78, 0 }
