function param1()
  return "粒子の量", 0, 100, 30
end

function param2()
	return "粒子密度", 0, 100, 100
end

function param3()
	return "大きさのジッタ", 0, 100, 10
end

function param4()
	return "筆圧粒大きさ", 0, 100, 50
end

function param5()
	return "不透明度ジッタ", 0, 100, 100
end

function param6()
	return "筆圧透明度", 0, 1, 0
end

function main( x, y, p )

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param6() )

	local sizeGain = w + bs_width_max() * 0.5 * bs_param4()/100
	local prsGain = 1.5 + 0.5 * bs_param4()/100

	local mul = 0.0075
	local itv = 0.25 + 0.75 * (100 - bs_param2())/25
	local rdm0 = 1 - 2 * ( math.random(2) % 2 )
	local rdm1 = bs_grand( 0, 3.14 )
	local rdm2 = rdm0 * math.random()/5000 * bs_param3()
	local rdmA = 0
		if ( bs_param5()>0 )
			then rdmA = bs_grand( 0, bs_param5() )/100
			a = a + a*rdmA * rdm0
			if ( a>255 ) then a=255 end
			if ( a<0 ) then a=0 end
		end
	local xrdm = math.random( -w * itv, w * itv )
	local yrdm = math.random( -w * itv, w * itv )


	if ( not firstDraw ) then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if ( distance <  (20+100-bs_param1())/200 * sizeGain * ( 1 - p/prsGain ) ) then
				return 0
			end
	end

	local id = 1
	local code = ''

	local stroke = shape[ math.random(3) ]

	repeat

		code = cmdcon[ stroke[id] ]

		if (code=='z') then

				bs_bezier_mul( (mul + rdm2) * sizeGain , (mul + rdm2) * sizeGain ) 
				bs_bezier_rotate(bs_atan( dx, dy )+rdm1 )
				bs_bezier_move( x + xrdm, y + yrdm )

				bs_fill( r,g,b,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( stroke, id+1 )
		end

	until id > #stroke

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


bs_setmode( 1 )
lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = {}

shape[1] = { 1, 21.75, 41.88, 3, 55.79, 30.53, 37.96, 24.27, 19.89, 9.92, 3, 23.67, -1.60, 44.28, 9.82, 46.08, 9.36, 
	3, 43.87, -2.88, 55.72, -14.83, 50.00, -16.26, 3, 44.28, -17.68, 0.21, -5.37, 33.09, -33.63, 3, 36.34, 
	-44.28, -6.97, -68.83, 6.23, -30.38, 3, 8.08, -21.12, -1.18, -13.94, -1.18, -13.94, 3, -4.43, -11.16, 
	-31.83, -10.10, -4.14, -38.87, 3, -13.60, -49.31, -38.98, -48.69, -42.36, -41.88, 3, -26.14, -31.22, 
	-50.41, -20.02, -50.00, -14.55, 3, -16.01, -21.81, -28.28, -8.85, -13.41, -1.35, 3, -17.40, 10.61, -44.96, 
	-0.97, -48.59, 11.09, 3, -29.67, 19.41, -40.55, 33.54, -23.37, 36.08, 3, -20.15, 30.67, -24.26, 15.42, 
	-1.18, 11.31, 3, 2.75, 30.30, 14.33, 29.37, 21.75, 41.88, 0 }

shape[2] = { 1, 2.40, 50.00, 3, 8.01, 25.39, 26.94, 33.86, 42.87, 26.18, 3, 42.87, 22.94, 29.67, 25.64, 25.15, 19.87, 
	3, 34.77, 15.49, 40.87, 6.11, 38.58, -7.75, 3, 36.30, -21.61, 18.89, -31.44, 18.89, -31.44, 3, 22.65, 
	-36.42, 26.07, -38.02, 22.60, -43.97, 3, 13.11, -40.27, -5.78, -52.22, -12.23, -43.18, 3, -18.69, -34.15, 
	-9.00, -9.05, -9.00, -9.05, 3, -27.94, -21.45, -20.09, -24.10, -30.91, -50.00, 3, -40.64, -43.83, -51.56, 
	20.81, -42.87, 21.10, 3, -34.18, 21.38, -22.29, 14.55, -21.32, -4.07, 3, -10.51, 9.76, -3.62, 15.35, 
	-18.29, 25.85, 3, -39.78, 57.32, -23.64, 58.39, 2.40, 50.00, 2, 13.81, 15.57, 3, 11.35, 17.74, 4.81, 
	23.79, 2.36, 21.53, 3, -3.82, 15.90, 0.34, -2.41, -6.02, -7.52, 3, 0.76, -13.28, 11.02, -21.90, 17.43, 
	-29.69, 3, 17.43, -29.69, 8.55, 2.25, 13.81, 15.57, 0 }

shape[3] = { 1, -1.22, 18.26, 3, -4.66, 15.15, -7.18, 11.24, -8.16, 6.92, 3, -20.60, 20.80, -39.84, 4.81, -43.21, 
	15.99, 3, -21.91, 25.36, -34.16, 41.26, -14.81, 44.13, 3, -11.41, 38.42, -21.49, 23.85, -1.22, 18.26, 
	0, 1, 43.54, -36.03, 3, 44.74, -39.58, -2.61, -62.11, 14.60, -33.69, 3, 16.69, -23.26, 4.95, -13.87, 
	4.95, -13.87, 3, 1.30, -10.74, -29.54, -9.55, 1.62, -41.93, 3, -9.02, -53.69, -37.60, -52.99, -41.40, 
	-45.32, 3, -3.22, -31.96, -50.46, -20.71, -50.00, -14.55, 3, -15.13, -22.00, -21.01, 1.08, -15.16, 0.95, 
	3, -11.53, -6.79, 4.90, -7.80, 4.90, -7.80, 3, 4.90, -2.19, 5.08, 10.98, 11.12, 12.92, 3, 16.31, 5.07, 
	33.12, 8.03, 33.12, 8.03, 3, 32.64, -10.06, 16.91, 3.86, 18.85, -19.55, 3, 29.86, -32.93, 34.94, -21.92, 
	43.54, -36.03, 0, 1, 11.93, 27.55, 3, 11.92, 37.01, 32.96, 37.87, 41.53, 45.32, 3, 41.41, 36.74, 39.06, 
	28.54, 50.00, 20.20, 3, 35.67, 16.44, 21.39, 9.18, 11.93, 27.55, 0 }