function param1()
  return "描画閾値", 0, 100, 10
end

function param2()
	return "ブラシ間隔", 1, 100, 30
end

function param3()
	return "口径蝕", 0, 100, 50
end

function param4()
	return "大きさのジッタ", 0, 100, 40
end

function param5()
	return "明度の加算", 0, 100, 50
end

function param6()
	return "カラーピック", 0, 1, 0
end

function param7()
	return "色収差", 0, 100, 20
end

function param8()
	return "透明度のジッタ", 0, 100, 50
end

function param9()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 1
end

function use_base()
  return true
end


function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.02
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local r0,g0,b0 =r,g,b
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param9() )

	local ValueOffset = 1 + 2*bs_param5()/100

	local GridReso = 16 * bs_param2() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

--ランダム変数

	math.randomseed( gridX * gridX * gridY * gridY )
	local rdm0 = 1 -2 * ( math.random(2) % 2 )
	local rdmSpin = math.random() * 3.14
	local rdmSize = math.random() * bs_param4()/750

--ブラシ座標色抽出・明度加算

	local sr,sg,sb,sa = bs_pixel_get( gridX, gridY ) 
	local colorPick = bs_param6()
	if ( colorPick==1 ) then 
		r,g,b = sr,sg,sb 
		if ( sa==0 ) then a = 0 end
	end

	r,g,b = r*ValueOffset, g*ValueOffset, b*ValueOffset
			if (r > 255) then r = 255 end
			if (g > 255) then g = 255 end
			if (b > 255) then b = 255 end

--色収差処理

	local abrtnChk = bs_param7()
	local r1,g1,b1 = bs_bg()
	local abrtnR1,abrtnG1,abrtnB1,abrtnR2,abrtnG2,abrtnB2
				= r*(r1/255),g*(g1/255),b*(b1/255),r*((255-r1)/255),g*((255-g1)/255),b*((255-b1)/255)

	local abrtnLumi1 = (0.298912 * abrtnR1 + 0.586611 * abrtnG1 + 0.114478 * abrtnB1) / 255
	local abrtnLumi2 = (0.298912 * abrtnR2 + 0.586612 * abrtnG2 + 0.114478 * abrtnB2) / 255
	local abrtnA1 = abrtnLumi1 * 0.85*a * abrtnChk/100
	local abrtnA2 = abrtnLumi2 * 0.85*a * abrtnChk/100

--ブラシ座標の輝度計算

	local luminance = (0.298912 * sr + 0.586611 * sg + 0.114478 * sb) / 255


--グリッドスナップ

	local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
	local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
	if ( remX>0 ) then 
			gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
			if ( remY>0 ) then gridY = gridY - GridReso/2
				else gridY = gridY + GridReso/2
			end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * (1 -2 * ( math.random(2) % 2 ))


--キャンバス中心座標

	local centerX,centerY = 0.5*bs_canvas_width(),0.5*bs_canvas_height()
	local centerDistance = bs_distance( centerX,centerY )
	local maxDistance = centerDistance

--基準点・口径蝕変形率計算

	local bsx,bsy = bs_base()
	if ( bsx>=0 ) then 
		centerX,centerY = bsx,bsy
		local baseDistance = bs_distance( bsx,bsy )
		local checkDistance = baseDistance - centerDistance 
		if ( checkDistance<0 ) then maxDistance = 2*centerDistance - baseDistance
			else maxDistance = baseDistance
		end
	end

	local BokheTransform = 0.75 + 0.25 * (100-bs_param3())/100
	local gridDistance = bs_distance( gridX - centerX, gridY - centerY )
	local vignette = BokheTransform + (1 - BokheTransform) * ( 1 - gridDistance/maxDistance )


--最小ブラシ間隔調整

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < GridReso/3 then
				return 0
			end
	end

--ブラシ描画

	w = bs_width_max()
	if ( bs_param1()>0 ) then
		if ( bs_param1() > luminance*100 ) then return 0 end
	end

	shape = stroke[1]

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * vignette, (mul+rdmSize) * w )
				bs_bezier_rotate( bs_atan( gridX-centerX, gridY-centerY ) )
				bs_bezier_move( gridX, gridY )
				bs_fill( r,g,b,0.85*a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape


	shape = stroke[2]

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w * vignette, (mul+rdmSize) * w )
				bs_bezier_rotate( bs_atan( gridX-centerX, gridY-centerY ) )
				bs_bezier_move( gridX, gridY )
				bs_fill( r,g,b,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape


--色収差描画

	if ( abrtnChk>0 ) then

		shape = stroke[3]

		local id = 1
		local code = ''

		repeat

			code = cmdcon[shape[id]]

			if (code=='z') then
					bs_bezier_mul( (mul+rdmSize) * w * vignette, (mul+rdmSize) * w )
					bs_bezier_rotate( bs_atan( gridX-centerX, gridY-centerY ) )
					bs_bezier_move( gridX, gridY )
					bs_fill( abrtnR1,abrtnG1,abrtnB1,abrtnA1 )
					id = id + 1
			else
				id = ( cmd[code] or cmd.default )( shape, id+1 )
			end

		until id > #shape

		shape = stroke[4]

		local id = 1
		local code = ''

		repeat

			code = cmdcon[shape[id]]

			if (code=='z') then
					bs_bezier_mul( (mul+rdmSize) * w * vignette, (mul+rdmSize) * w )
					bs_bezier_rotate( bs_atan( gridX-centerX, gridY-centerY ) )
					bs_bezier_move( gridX, gridY )
					bs_fill( abrtnR2,abrtnG2,abrtnB2,abrtnA2 )
					id = id + 1
			else
				id = ( cmd[code] or cmd.default )( shape, id+1 )
			end

		until id > #shape

	end

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

stroke = {}

stroke[1] = { 1, -0.08, -45.41, 3, 25.38, -45.41, 45.38, -25.86, 45.38, 0.05, 3, 45.38, 26.07, 26.51, 45.38, -0.02, 
	45.44, 3, -25.53, 45.50, -45.42, 25.73, -45.42, 0.05, 3, -45.42, -25.52, -25.76, -45.41, -0.08, -45.41, 
	0 }

stroke[2] ={ 1, -0.08, -44.74, 3, -25.38, -44.74, -44.75, -25.15, -44.75, 0.04, 3, -44.75, 25.35, -25.16, 44.83, 
	-0.02, 44.77, 3, 26.12, 44.72, 44.71, 25.69, 44.71, 0.05, 3, 44.71, -25.48, 25.00, -44.74, -0.08, -44.74, 
	2, -0.02, 42.77, 3, -24.03, 42.83, -42.75, 24.22, -42.75, 0.04, 3, -42.75, -24.02, -24.25, -42.74, -0.07, 
	-42.74, 3, 23.89, -42.74, 42.71, -24.34, 42.71, 0.04, 3, 42.71, 24.54, 24.96, 42.72, -0.02, 42.77, 0 }

stroke[3] = { 1, -45.37, 0.02, 3, -45.37, -24.42, -26.04, -44.34, -1.82, -45.29, 3, -2.42, -45.31, -3.02, -45.33, 
	-3.63, -45.33, 3, -28.67, -45.33, -48.98, -25.03, -48.98, 0.02, 3, -48.98, 25.07, -28.67, 45.37, -3.63, 
	45.37, 3, -3.02, 45.37, -2.42, 45.35, -1.82, 45.32, 3, -26.04, 44.38, -45.37, 24.46, -45.37, 0.02, 0 }

stroke[4] = { 1, 45.33, 0.02, 3, 45.33, 24.46, 25.99, 44.38, 1.78, 45.32, 3, 2.38, 45.35, 2.98, 45.37, 3.58, 45.37, 
	3, 28.63, 45.37, 48.94, 25.07, 48.94, 0.02, 3, 48.94, -25.03, 28.63, -45.33, 3.58, -45.33, 3, 2.98, 
	-45.33, 2.38, -45.31, 1.78, -45.29, 3, 25.99, -44.34, 45.33, -24.42, 45.33, 0.02, 0 }

