function param1()
  return "ブラシ間隔", 10, 100, 40
end

function param2()
	return "グリッドスナップ", 0, 1, 1
end

function param3()
	return "グリッド間隔", 1, 100, 50
end

function param4()
  return "色のジッタ", 0, 100, 0
end

function param5()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 30, 1
end



function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.2
	local rdm0 = 1 - 2 * ( math.random(2) % 2 )

	local rdmSize = math.random() / 50000
	local rdmSpin = math.random() * 3.14

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param5() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end


	local GridLock = bs_param2()
	local GridReso = 16 * bs_param3() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

	local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
	local remY = y % GridReso - ( y + GridReso/2 ) % GridReso

			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end


	if ( GridLock==1 ) then	math.randomseed( gridX * gridX * gridY * gridY ) end

	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms())
			if ( SpinCheck == 1 ) then rdmSpin = math.random() * 3.14 end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param2()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param2()/100  * (1 -2 * ( math.random(2) % 2 ))

	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 



	if w < 2 then
		w = 2
	end

	if ( not firstDraw ) then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if ( distance < w * bs_param1()/6 ) then
				return 0
			end
	end

	local stroke = {}
	local id = 1
	local code = ''
	local shapeID = math.random(4)

	stroke = shape[shapeID]

	repeat

		code = cmdcon[stroke[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w, (mul+rdmSize) * w * rdm0) 
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( stroke, id+1 )
		end

	until id > #stroke

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = {}

shape[1] = { 1, 1.30, -24.57, 3, 1.13, -24.56, 0.90, -24.62, 0.89, -24.47, 3, 0.69, -24.48, 0.81, -24.81, 0.58, -24.77, 
	3, 0.68, -25.05, 1.45, -25.12, 1.30, -24.57, 0, 1, -5.57, -22.83, 3, -5.37, -22.94, -5.42, -22.65, -5.37, 
	-22.62, 3, -5.08, -22.50, -4.54, -22.58, -4.55, -22.11, 3, -4.82, -22.11, -5.09, -22.11, -5.37, -22.11, 
	3, -5.51, -22.47, -5.55, -22.54, -5.98, -22.42, 3, -6.03, -22.74, -5.73, -22.71, -5.57, -22.83, 0, 1, 
	14.11, -22.73, 3, 14.43, -22.64, 14.45, -22.31, 14.31, -22.01, 3, 13.87, -21.87, 13.99, -22.30, 13.80, 
	-22.42, 3, 13.81, -22.61, 14.14, -22.49, 14.11, -22.73, 0, 1, -11.01, -22.32, 3, -10.56, -22.35, -10.55, 
	-22.01, -10.19, -22.21, 3, -10.26, -21.90, -10.26, -22.02, -10.19, -21.70, 3, -10.33, -21.71, -10.48, 
	-21.72, -10.49, -21.60, 3, -10.71, -21.86, -10.35, -22.13, -10.90, -21.90, 3, -10.89, -22.09, -11.03, 
	-22.12, -11.01, -22.32, 0, 1, -9.67, -21.91, 3, -9.43, -21.74, -9.22, -21.54, -8.96, -21.39, 3, -9.01, 
	-21.24, -9.11, -21.13, -9.16, -20.98, 3, -9.63, -21.06, -10.04, -21.20, -10.08, -21.70, 3, -9.85, -21.67, 
	-9.70, -21.73, -9.67, -21.91, 0, 1, 0.37, -21.50, 3, 0.36, -21.23, 0.03, -21.29, -0.24, -21.29, 3, -0.23, 
	-21.55, 0.10, -21.49, 0.37, -21.50, 0, 1, -20.02, -21.19, 3, -20.02, -21.08, -20.02, -20.98, -20.02, 
	-20.88, 3, -20.16, -20.88, -20.30, -20.88, -20.43, -20.88, 3, -20.35, -21.03, -20.28, -21.20, -20.02, 
	-21.19, 0, 1, 7.96, -20.37, 3, 8.10, -20.67, 8.31, -20.19, 8.57, -20.26, 3, 8.43, -19.97, 8.07, -20.29, 
	7.96, -20.37, 0, 1, -6.80, -19.34, 3, -6.64, -19.37, -6.63, -19.25, -6.50, -19.24, 3, -6.47, -18.81, 
	-6.63, -18.84, -6.50, -18.52, 3, -6.66, -18.60, -6.94, -18.32, -6.70, -18.32, 3, -6.68, -18.10, -7.06, 
	-18.27, -7.21, -18.22, 3, -7.20, -18.33, -7.24, -18.40, -7.32, -18.42, 3, -7.17, -18.76, -6.68, -18.75, 
	-6.80, -19.34, 0, 1, -17.56, -19.14, 3, -17.48, -19.16, -17.47, -19.10, -17.46, -19.04, 3, -16.83, -19.18, 
	-16.58, -19.11, -16.03, -19.04, 3, -15.79, -18.69, -15.47, -18.43, -15.10, -18.22, 3, -15.09, -17.95, 
	-15.68, -17.88, -15.51, -18.32, 3, -15.77, -17.98, -16.30, -18.56, -16.54, -18.22, 3, -16.66, -18.23, 
	-16.77, -18.38, -16.85, -18.42, 3, -16.94, -18.47, -17.15, -18.45, -17.26, -18.52, 3, -17.38, -18.60, 
	-17.37, -19.01, -17.67, -18.83, 3, -17.69, -18.92, -17.63, -18.93, -17.56, -18.93, 3, -17.56, -19.00, 
	-17.56, -19.07, -17.56, -19.14, 0, 1, -2.29, -18.93, 3, -2.23, -18.93, -2.16, -18.93, -2.09, -18.93, 
	3, -2.09, -18.83, -2.09, -18.73, -2.09, -18.63, 3, -2.19, -18.63, -2.29, -18.63, -2.40, -18.63, 3, -2.42, 
	-18.79, -2.30, -18.80, -2.29, -18.93, 0, 1, 12.36, -18.93, 3, 12.31, -18.85, 12.26, -18.77, 12.26, -18.63, 
	3, 12.07, -18.67, 11.64, -18.49, 11.75, -18.83, 3, 11.99, -18.83, 12.05, -19.01, 12.36, -18.93, 0, 1, 
	15.54, -18.63, 3, 15.64, -18.63, 15.75, -18.63, 15.85, -18.63, 3, 15.91, -18.11, 16.59, -18.21, 16.67, 
	-17.70, 3, 16.58, -17.57, 15.99, -17.68, 16.26, -17.91, 3, 15.81, -17.94, 15.48, -18.09, 15.54, -18.63, 
	0, 1, 30.40, -18.32, 3, 30.17, -18.25, 29.96, -17.94, 29.69, -18.22, 3, 29.70, -18.52, 30.38, -18.91, 
	30.40, -18.32, 0, 1, 2.42, -18.42, 3, 2.34, -18.22, 1.97, -18.14, 1.81, -18.32, 3, 1.87, -18.66, 2.19, 
	-18.47, 2.42, -18.42, 0, 1, -14.18, -17.81, 3, -14.18, -17.60, -14.46, -17.67, -14.39, -17.40, 3, -14.48, 
	-17.50, -14.77, -17.43, -14.70, -17.70, 3, -14.58, -17.79, -14.42, -17.84, -14.18, -17.81, 0, 1, -21.66, 
	-17.60, 3, -21.66, -17.40, -21.66, -17.19, -21.66, -16.98, 3, -22.23, -16.94, -22.44, -16.88, -22.79, 
	-17.19, 3, -22.83, -17.83, -22.13, -17.73, -21.66, -17.60, 0, 1, -2.09, -16.37, 3, -2.31, -16.34, -2.43, 
	-16.24, -2.70, -16.27, 3, -2.95, -16.29, -3.20, -16.55, -3.42, -16.57, 3, -3.75, -16.62, -3.72, -16.63, 
	-3.93, -16.88, 3, -4.01, -16.97, -4.18, -16.98, -4.14, -17.19, 3, -3.87, -17.96, -3.14, -17.52, -2.60, 
	-17.29, 3, -2.48, -17.16, -2.56, -17.13, -2.60, -16.99, 3, -2.52, -16.69, -2.05, -16.79, -2.09, -16.37, 
	0, 1, -26.28, -16.47, 3, -26.49, -16.55, -26.55, -16.37, -26.69, -16.37, 3, -26.84, -16.38, -26.97, 
	-16.58, -27.00, -16.57, 3, -27.27, -16.56, -27.46, -16.10, -27.71, -16.47, 3, -27.76, -16.82, -27.41, 
	-16.78, -27.30, -16.98, 3, -26.91, -16.70, -26.48, -17.01, -26.28, -16.47, 0, 1, -13.47, -16.17, 3, 
	-13.20, -16.20, -13.02, -16.13, -13.06, -15.86, 3, -13.25, -15.66, -13.55, -15.80, -13.47, -16.17, 0, 
	1, 9.90, -15.76, 3, 9.90, -15.55, 9.90, -15.35, 9.90, -15.14, 3, 9.12, -15.07, 9.27, -16.08, 9.90, -15.76, 
	0, 1, 29.17, -15.34, 3, 29.17, -15.14, 29.17, -14.94, 29.17, -14.73, 3, 28.28, -14.62, 28.22, -15.34, 
	27.53, -15.45, 3, 27.60, -15.54, 27.66, -15.63, 27.53, -15.65, 3, 27.57, -15.77, 27.71, -15.91, 27.74, 
	-15.75, 3, 28.34, -15.74, 28.79, -15.58, 29.17, -15.34, 0, 1, -10.39, -15.24, 3, -10.64, -15.16, -11.06, 
	-15.08, -11.11, -15.45, 3, -10.95, -15.60, -10.29, -15.66, -10.39, -15.24, 0, 1, 11.24, -14.83, 3, 10.88, 
	-14.61, 10.21, -14.96, 10.11, -15.34, 3, 10.44, -15.66, 10.54, -15.17, 10.93, -15.24, 3, 11.09, -15.17, 
	10.91, -14.74, 11.24, -14.83, 0, 1, -9.98, -15.34, 3, -9.16, -15.42, -9.09, -14.73, -8.54, -14.52, 3, 
	-8.12, -14.63, -8.09, -14.55, -7.62, -14.52, 3, -7.70, -14.22, -7.93, -14.08, -7.83, -13.60, 3, -8.82, 
	-13.53, -9.34, -13.94, -10.08, -14.12, 3, -9.92, -14.53, -10.35, -14.91, -9.98, -15.34, 0, 1, 0.68, 
	-15.14, 3, 0.68, -15.04, 0.55, -15.06, 0.48, -15.04, 3, 0.52, -14.84, 0.70, -14.78, 0.68, -14.52, 3, 
	0.45, -14.29, 0.28, -14.56, -0.04, -14.52, 3, -0.06, -14.99, 0.27, -15.11, 0.68, -15.14, 0, 1, -23.92, 
	-14.52, 3, -23.92, -14.42, -23.92, -14.32, -23.92, -14.22, 3, -24.06, -14.22, -24.19, -14.22, -24.33, 
	-14.22, 3, -24.24, -14.37, -24.18, -14.54, -23.92, -14.52, 0, 1, 14.21, -14.42, 3, 14.43, -14.44, 14.26, 
	-14.06, 14.31, -13.91, 3, 14.42, -13.98, 14.42, -14.15, 14.62, -14.12, 3, 14.62, -13.98, 14.62, -13.84, 
	14.62, -13.71, 3, 14.41, -13.61, 14.00, -13.82, 14.11, -13.19, 3, 13.84, -13.19, 13.52, -13.15, 13.39, 
	-13.30, 3, 13.21, -13.57, 13.59, -13.44, 13.70, -13.60, 3, 13.74, -13.67, 13.65, -13.85, 13.70, -13.91, 
	3, 13.84, -14.09, 14.19, -14.13, 14.21, -14.42, 0, 1, 23.13, -14.12, 3, 23.15, -13.72, 22.65, -13.84, 
	22.72, -13.40, 3, 22.47, -13.70, 22.13, -13.91, 22.00, -14.32, 3, 22.23, -14.45, 22.77, -14.18, 23.13, 
	-14.12, 0, 1, -4.85, -14.22, 3, -4.82, -13.98, -4.87, -13.82, -4.96, -13.71, 3, -5.14, -13.69, -5.17, 
	-13.83, -5.37, -13.81, 3, -5.38, -14.13, -5.10, -14.16, -4.85, -14.22, 0, 1, -24.33, -14.12, 3, -24.15, 
	-13.94, -24.36, -13.71, -24.64, -13.71, 3, -24.67, -13.97, -24.60, -14.15, -24.33, -14.12, 0, 1, 4.16, 
	-13.81, 3, 4.16, -13.64, 4.16, -13.47, 4.16, -13.30, 3, 3.92, -13.33, 3.78, -13.46, 3.45, -13.40, 3, 
	3.40, -13.82, 3.93, -13.67, 4.16, -13.81, 0, 1, 23.64, -13.71, 3, 23.62, -13.59, 23.66, -13.52, 23.74, 
	-13.50, 3, 23.67, -13.15, 23.43, -13.43, 23.23, -13.50, 3, 23.25, -13.68, 23.41, -13.73, 23.64, -13.71, 
	0, 1, -0.65, -13.50, 3, -0.22, -13.54, -0.58, -13.17, -0.55, -12.99, 3, -0.79, -13.14, -0.71, -13.24, 
	-0.65, -13.50, 0, 1, 4.47, -13.50, 3, 4.81, -13.50, 4.98, -13.33, 5.40, -13.40, 3, 4.83, -13.05, 5.84, 
	-13.20, 5.80, -12.78, 3, 5.17, -12.88, 4.62, -12.76, 4.47, -13.50, 0, 1, -4.96, -13.19, 3, -4.98, -12.77, 
	-5.56, -12.91, -5.37, -12.27, 3, -5.57, -12.27, -5.50, -11.99, -5.78, -12.07, 3, -5.86, -11.68, -5.65, 
	-11.58, -5.67, -11.25, 3, -6.12, -11.35, -6.15, -11.03, -6.39, -10.94, 3, -6.42, -10.81, -6.35, -10.65, 
	-6.39, -10.53, 3, -6.43, -10.40, -6.66, -10.40, -6.70, -10.32, 3, -6.78, -10.17, -6.79, -9.88, -6.90, 
	-9.71, 3, -6.99, -9.57, -7.07, -9.38, -7.31, -9.40, 3, -7.32, -9.50, -7.44, -9.48, -7.52, -9.50, 3, 
	-7.50, -9.89, -7.28, -10.09, -7.01, -10.22, 3, -6.92, -10.51, -7.15, -10.49, -7.11, -10.73, 3, -6.65, 
	-11.22, -6.92, -11.80, -6.29, -12.07, 3, -6.42, -12.38, -6.26, -12.36, -6.29, -12.78, 3, -5.67, -12.75, 
	-5.50, -13.46, -4.96, -13.19, 0, 1, 24.15, -13.19, 3, 24.35, -13.15, 24.34, -12.90, 24.66, -12.99, 3, 
	24.65, -12.73, 24.52, -12.59, 24.25, -12.58, 3, 24.43, -12.94, 24.19, -12.83, 24.15, -13.19, 0, 1, -0.65, 
	-12.88, 3, -0.71, -12.60, -0.76, -12.31, -1.17, -12.37, 3, -1.15, -12.49, -1.19, -12.56, -1.27, -12.58, 
	3, -1.18, -12.80, -1.02, -12.94, -0.65, -12.88, 0, 1, -0.86, -11.86, 3, -1.15, -11.84, -1.42, -11.85, 
	-1.37, -12.17, 3, -1.09, -12.28, -0.80, -12.33, -0.86, -11.86, 0, 1, 8.06, -12.27, 3, 8.74, -12.07, 
	7.86, -11.30, 8.47, -11.25, 3, 8.54, -11.08, 7.99, -11.08, 8.06, -11.25, 3, 7.87, -11.13, 7.71, -10.98, 
	7.55, -10.84, 3, 7.39, -10.84, 7.32, -11.60, 7.65, -11.45, 3, 7.78, -11.78, 7.32, -11.53, 7.45, -11.86, 
	3, 7.60, -12.01, 8.12, -11.70, 8.06, -12.27, 0, 1, 16.98, -11.76, 3, 17.09, -11.36, 17.69, -11.45, 17.70, 
	-10.94, 3, 18.53, -11.00, 18.57, -10.25, 18.41, -9.81, 3, 18.05, -9.83, 17.73, -10.42, 17.90, -10.63, 
	3, 17.51, -10.82, 17.37, -11.27, 16.88, -11.35, 3, 16.95, -11.44, 16.98, -11.58, 16.98, -11.76, 0, 1, 
	36.66, -11.55, 3, 36.76, -11.55, 36.86, -11.55, 36.96, -11.55, 3, 36.96, -11.45, 36.96, -11.35, 36.96, 
	-11.24, 3, 36.74, -11.23, 36.64, -11.33, 36.66, -11.55, 0, 1, 26.41, -11.35, 3, 26.71, -11.26, 26.27, 
	-11.09, 26.41, -10.84, 3, 26.47, -10.73, 26.64, -10.73, 26.61, -10.53, 3, 26.35, -10.32, 26.15, -10.79, 
	25.79, -10.53, 3, 25.93, -10.87, 26.28, -11.00, 26.41, -11.35, 0, 1, -12.95, -10.53, 3, -13.29, -10.54, 
	-13.51, -10.66, -13.57, -10.94, 3, -13.30, -11.17, -12.88, -10.95, -12.95, -10.53, 0, 1, -1.47, -10.12, 
	3, -1.42, -9.76, -1.11, -9.66, -1.16, -9.20, 3, -1.43, -9.00, -1.76, -9.43, -2.29, -9.30, 3, -2.31, 
	-9.76, -3.05, -9.50, -3.01, -10.02, 3, -3.26, -10.06, -3.23, -9.83, -3.52, -9.91, 3, -3.58, -10.13, 
	-3.78, -10.21, -3.73, -10.53, 3, -3.00, -10.68, -2.47, -10.02, -1.47, -10.12, 0, 1, -12.54, -10.42, 
	3, -12.50, -10.10, -12.76, -10.10, -13.06, -10.12, 3, -13.01, -10.48, -12.84, -10.55, -12.54, -10.42, 
	0, 1, 29.99, -10.42, 3, 30.16, -10.42, 30.39, -10.47, 30.40, -10.32, 3, 30.52, -9.96, 29.78, -10.05, 
	29.99, -10.42, 0, 1, 30.71, -10.42, 3, 31.15, -10.22, 31.72, -10.13, 32.15, -9.91, 3, 31.98, -9.65, 
	31.49, -9.78, 30.92, -9.71, 3, 30.76, -9.97, 30.50, -10.05, 30.71, -10.42, 0, 1, -26.79, -10.12, 3, 
	-26.74, -9.80, -26.94, -9.72, -26.99, -9.50, 3, -27.19, -9.65, -27.41, -9.77, -27.71, -9.81, 3, -27.70, 
	-9.96, -27.70, -10.10, -27.82, -10.12, 3, -27.61, -10.61, -27.14, -10.11, -26.79, -10.12, 0, 1, 25.89, 
	-10.02, 3, 25.97, -9.74, 25.69, -9.81, 25.69, -9.61, 3, 25.44, -9.67, 25.64, -10.12, 25.89, -10.02, 
	0, 1, -19.31, -9.60, 3, -19.02, -9.63, -18.75, -9.62, -18.80, -9.30, 3, -18.97, -9.39, -19.34, -9.29, 
	-19.31, -9.60, 0, 1, -7.21, -9.30, 3, -7.41, -9.09, -7.57, -9.12, -7.83, -9.20, 3, -7.73, -9.57, -7.52, 
	-9.26, -7.21, -9.30, 0, 1, 6.93, -8.68, 3, 6.49, -8.83, 6.46, -8.33, 6.22, -8.58, 3, 6.17, -9.00, 7.01, 
	-9.40, 6.93, -8.68, 0, 1, -17.77, -8.89, 3, -17.61, -8.92, -17.59, -8.79, -17.46, -8.78, 3, -17.36, 
	-8.17, -17.81, -8.11, -17.77, -7.55, 3, -18.38, -7.61, -18.38, -7.07, -18.90, -7.04, 3, -18.98, -7.37, 
	-18.81, -7.43, -18.69, -7.55, 3, -18.69, -7.80, -18.87, -7.86, -18.80, -8.17, 3, -18.39, -8.17, -17.91, 
	-8.29, -17.77, -8.58, 3, -17.73, -8.66, -17.80, -8.80, -17.77, -8.89, 0, 1, -6.29, -8.27, 3, -6.26, 
	-7.86, -5.77, -7.90, -5.78, -7.45, 3, -6.04, -7.23, -6.36, -7.55, -6.50, -7.35, 3, -6.68, -7.37, -6.56, 
	-7.70, -6.70, -7.76, 3, -7.75, -7.79, -8.23, -7.44, -8.96, -7.86, 3, -8.95, -8.04, -9.03, -8.13, -9.16, 
	-8.17, 3, -8.93, -8.70, -8.22, -8.23, -7.93, -8.79, 3, -7.45, -8.72, -7.25, -8.38, -6.91, -8.17, 3, 
	-6.66, -8.17, -6.60, -8.35, -6.29, -8.27, 0, 1, -32.63, -8.38, 3, -32.57, -7.93, -32.01, -7.78, -32.22, 
	-7.35, 3, -32.58, -7.27, -32.99, -7.67, -32.74, -7.86, 3, -32.84, -8.00, -33.01, -8.07, -33.15, -8.17, 
	3, -33.13, -8.40, -32.89, -8.39, -32.63, -8.38, 0, 1, 15.23, -8.38, 3, 15.40, -8.40, 15.41, -8.28, 15.54, 
	-8.27, 3, 15.57, -7.94, 15.42, -7.78, 15.13, -7.76, 3, 15.15, -7.94, 15.01, -7.98, 15.03, -8.17, 3, 
	15.20, -8.13, 15.22, -8.25, 15.23, -8.38, 0, 1, -4.45, -6.63, 3, -4.81, -6.54, -4.63, -7.08, -4.55, 
	-7.15, 3, -4.59, -7.34, -4.77, -7.40, -4.75, -7.66, 3, -4.40, -7.79, -3.97, -7.84, -3.63, -7.97, 3, 
	-3.39, -7.86, -3.50, -7.41, -3.32, -7.25, 3, -3.48, -6.83, -4.18, -6.95, -4.45, -6.63, 0, 1, 24.05, 
	-7.76, 3, 24.08, -7.52, 23.75, -7.65, 23.74, -7.45, 3, 23.43, -7.58, 23.76, -7.90, 24.05, -7.76, 0, 
	1, -22.90, -7.55, 3, -22.76, -7.52, -22.81, -7.30, -22.79, -7.15, 3, -22.90, -7.15, -23.00, -7.15, -23.10, 
	-7.15, 3, -23.18, -7.42, -22.90, -7.35, -22.90, -7.55, 0, 1, 14.72, -7.45, 3, 14.70, -7.68, 15.09, -7.50, 
	15.23, -7.55, 3, 15.16, -7.32, 14.84, -7.33, 14.83, -7.04, 3, 14.65, -7.01, 14.47, -7.44, 14.83, -7.35, 
	3, 14.84, -7.44, 14.78, -7.45, 14.72, -7.45, 0, 1, 24.25, -7.55, 3, 24.80, -7.62, 24.90, -7.24, 25.07, 
	-6.94, 3, 24.65, -6.73, 24.29, -7.08, 24.25, -7.55, 0, 1, 5.29, -7.35, 3, 5.29, -7.25, 5.29, -7.15, 
	5.29, -7.04, 3, 5.95, -7.22, 5.82, -6.62, 6.32, -6.63, 3, 6.24, -6.56, 6.06, -6.13, 6.42, -6.22, 3, 
	6.45, -5.99, 6.12, -6.11, 6.11, -5.92, 3, 5.69, -6.07, 5.11, -6.08, 4.98, -6.53, 3, 4.84, -6.48, 4.45, 
	-6.65, 4.47, -6.43, 3, 4.24, -6.54, 4.10, -6.74, 4.06, -7.04, 3, 4.43, -7.41, 4.80, -7.23, 5.29, -7.35, 
	0, 1, 19.44, -6.84, 3, 19.44, -6.45, 19.61, -6.48, 19.95, -6.43, 3, 19.94, -5.97, 20.28, -5.87, 20.36, 
	-5.51, 3, 20.24, -5.42, 19.98, -5.33, 19.85, -5.51, 3, 19.82, -5.54, 19.88, -5.69, 19.85, -5.71, 3, 
	19.73, -5.80, 19.46, -5.64, 19.54, -5.92, 3, 19.05, -5.84, 19.08, -6.28, 18.62, -6.22, 3, 18.56, -6.44, 
	18.40, -6.56, 18.31, -6.74, 3, 18.17, -6.74, 18.04, -6.74, 17.90, -6.74, 3, 18.07, -7.66, 18.77, -6.66, 
	19.44, -6.84, 0, 1, 3.86, -6.94, 3, 3.83, -6.76, 3.68, -6.71, 3.45, -6.73, 3, 3.46, -7.12, 3.60, -6.99, 
	3.86, -6.94, 0, 1, -15.52, -6.84, 3, -15.51, -6.94, -15.39, -6.92, -15.31, -6.94, 3, -14.87, -6.93, 
	-14.34, -6.48, -14.08, -6.63, 3, -13.88, -6.25, -13.52, -6.03, -13.06, -5.92, 3, -13.13, -5.54, -12.88, 
	-5.48, -12.95, -5.10, 3, -13.35, -4.58, -13.99, -4.99, -14.59, -5.10, 3, -14.54, -5.25, -14.44, -5.35, 
	-14.39, -5.51, 3, -14.77, -5.95, -15.37, -6.17, -15.52, -6.84, 0, 1, 28.87, -6.94, 3, 29.00, -6.94, 
	29.14, -6.94, 29.28, -6.94, 3, 29.28, -6.80, 29.28, -6.67, 29.28, -6.53, 3, 28.96, -6.48, 28.82, -6.62, 
	28.87, -6.94, 0, 1, -3.93, -6.53, 3, -4.08, -6.19, -4.40, -6.05, -4.65, -5.81, 3, -4.63, -5.69, -4.67, 
	-5.63, -4.75, -5.61, 3, -4.85, -5.47, -4.65, -5.31, -4.65, -5.30, 3, -4.66, -5.18, -4.84, -5.16, -4.85, 
	-5.10, 3, -4.88, -5.00, -4.76, -4.87, -4.75, -4.89, 3, -4.83, -4.71, -4.96, -4.81, -5.06, -4.69, 3, 
	-5.21, -4.50, -5.14, -4.08, -5.67, -4.17, 3, -5.80, -4.48, -5.72, -4.99, -5.78, -5.09, 3, -5.57, -5.26, 
	-5.24, -5.31, -5.06, -5.50, 3, -5.20, -6.01, -4.85, -5.95, -5.06, -6.53, 3, -4.48, -6.53, -4.44, -6.61, 
	-3.93, -6.53, 0, 1, -37.55, -5.71, 3, -37.69, -5.81, -37.93, -5.81, -38.06, -5.91, 3, -37.94, -6.11, 
	-37.71, -6.47, -37.45, -6.22, 3, -37.41, -5.98, -37.64, -6.00, -37.55, -5.71, 0, 1, 14.00, -5.61, 3, 
	13.92, -5.52, 13.89, -5.38, 13.90, -5.20, 3, 13.45, -5.14, 13.55, -5.75, 14.00, -5.61, 0, 1, -10.08, 
	-5.40, 3, -9.91, -5.40, -9.74, -5.40, -9.57, -5.40, 3, -9.48, -5.15, -9.29, -5.00, -9.26, -4.69, 3, 
	-9.59, -4.55, -10.02, -4.40, -10.39, -4.58, 3, -10.29, -4.86, -10.16, -5.11, -10.08, -5.40, 0, 1, 23.23, 
	-5.20, 3, 23.08, -4.70, 23.10, -4.03, 22.82, -3.66, 3, 22.32, -3.57, 22.34, -4.01, 22.00, -4.07, 3, 
	22.02, -4.19, 22.03, -4.31, 22.10, -4.38, 3, 22.13, -4.41, 22.40, -4.46, 22.41, -4.48, 3, 22.46, -4.58, 
	22.35, -4.84, 22.31, -4.79, 3, 22.56, -5.08, 22.61, -5.24, 23.23, -5.20, 0, 1, 0.27, -4.69, 3, 0.33, 
	-4.46, 0.07, -4.54, 0.07, -4.38, 3, 0.33, -4.06, 0.96, -4.11, 0.99, -3.56, 3, 0.81, -3.54, 0.72, -3.73, 
	0.68, -3.56, 3, 0.61, -3.65, 0.41, -3.82, 0.17, -3.87, 3, 0.06, -3.88, -0.29, -3.97, -0.45, -3.97, 3, 
	-0.59, -3.97, -0.77, -3.79, -1.06, -3.97, 3, -1.09, -3.99, -1.15, -4.17, -1.17, -4.17, 3, -1.30, -4.21, 
	-1.88, -4.02, -1.78, -4.38, 3, -1.97, -4.36, -2.12, -4.31, -2.19, -4.17, 3, -2.53, -4.18, -2.44, -4.61, 
	-2.81, -4.58, 3, -2.54, -4.62, -2.31, -4.93, -2.09, -4.89, 3, -2.03, -4.88, -1.97, -4.59, -1.78, -4.69, 
	3, -1.53, -4.67, -1.46, -4.84, -1.37, -4.99, 3, -0.90, -5.02, -0.73, -4.74, -0.35, -4.69, 3, -0.02, 
	-4.63, 0.05, -4.91, 0.27, -4.69, 0, 1, -19.20, -3.15, 3, -19.52, -2.88, -19.85, -3.26, -20.33, -3.15, 
	3, -20.42, -3.30, -20.41, -3.55, -20.74, -3.46, 3, -20.63, -3.91, -21.09, -3.79, -21.05, -4.17, 3, -21.23, 
	-4.27, -21.56, -4.21, -21.67, -4.38, 3, -21.70, -4.55, -21.59, -4.57, -21.46, -4.58, 3, -21.10, -4.40, 
	-20.58, -4.37, -20.44, -3.97, 3, -20.03, -4.06, -19.87, -3.77, -19.62, -3.56, 3, -19.48, -3.44, -19.16, 
	-3.37, -19.20, -3.15, 0, 1, 31.84, -4.07, 3, 31.47, -4.04, 31.35, -4.26, 31.02, -4.27, 3, 31.12, -4.48, 
	31.89, -4.62, 31.84, -4.07, 0, 1, -10.08, -4.17, 3, -10.10, -3.88, -10.75, -3.69, -10.49, -3.46, 3, 
	-10.71, -3.18, -10.79, -3.73, -11.11, -3.46, 3, -11.10, -3.60, -11.09, -3.75, -11.21, -3.76, 3, -11.06, 
	-4.13, -10.64, -4.22, -10.08, -4.17, 0, 1, 32.45, -4.17, 3, 32.64, -4.30, 32.63, -3.97, 32.66, -3.97, 
	3, 32.78, -3.95, 32.82, -4.36, 33.27, -4.17, 3, 33.04, -3.96, 32.89, -3.67, 32.45, -3.66, 3, 32.25, 
	-3.90, 32.25, -3.94, 32.45, -4.17, 0, 1, -25.46, -3.66, 3, -25.58, -3.11, -25.04, -2.79, -25.46, -2.53, 
	3, -25.30, -2.45, -24.96, -2.50, -24.95, -1.92, 3, -25.49, -1.78, -25.97, -2.52, -26.28, -2.94, 3, -26.77, 
	-2.83, -26.71, -3.26, -27.20, -3.15, 3, -27.02, -3.78, -26.00, -4.28, -25.46, -3.66, 0, 1, 36.66, -3.97, 
	3, 36.82, -4.00, 36.83, -3.87, 36.96, -3.87, 3, 36.98, -3.61, 36.80, -3.55, 36.76, -3.35, 3, 36.48, 
	-3.35, 36.52, -3.84, 36.66, -3.97, 0, 1, -6.09, -3.87, 3, -5.85, -3.90, -5.69, -3.85, -5.57, -3.76, 
	3, -5.58, -3.46, -6.18, -3.49, -6.09, -3.87, 0, 1, 2.94, -3.87, 3, 3.25, -3.94, 3.13, -3.58, 3.45, -3.66, 
	3, 3.45, -3.49, 3.45, -3.32, 3.45, -3.15, 3, 3.13, -2.84, 2.68, -2.98, 2.42, -3.25, 3, 2.58, -3.47, 
	2.94, -3.49, 2.94, -3.87, 0, 1, 13.08, -2.33, 3, 12.99, -1.87, 12.60, -2.16, 12.26, -2.33, 3, 12.15, 
	-2.39, 12.06, -2.22, 12.06, -2.23, 3, 11.91, -2.27, 11.90, -2.45, 11.75, -2.53, 3, 11.64, -2.59, 11.27, 
	-2.55, 11.14, -2.64, 3, 11.10, -2.66, 11.06, -2.83, 11.03, -2.84, 3, 10.78, -2.93, 10.59, -2.84, 10.42, 
	-2.94, 3, 10.37, -2.97, 10.45, -3.21, 10.42, -3.25, 3, 10.34, -3.34, 9.96, -3.14, 10.01, -3.35, 3, 10.33, 
	-4.12, 11.18, -3.75, 11.44, -3.15, 3, 11.98, -3.17, 12.48, -3.16, 12.47, -2.64, 3, 12.47, -2.33, 12.95, 
	-2.50, 13.08, -2.33, 0, 1, 25.07, -2.94, 3, 25.10, -3.09, 25.92, -3.18, 25.79, -2.84, 3, 25.44, -2.76, 
	25.40, -2.99, 25.07, -2.94, 0, 1, -12.03, -2.84, 3, -11.62, -2.97, -11.15, -2.86, -10.59, -2.74, 3, 
	-10.58, -2.21, -11.13, -2.24, -11.52, -2.12, 3, -10.99, -1.96, -11.63, -1.87, -11.21, -1.61, 3, -11.19, 
	-1.39, -11.29, -1.28, -11.52, -1.30, 3, -11.71, -1.12, -11.91, -0.94, -12.13, -0.79, 3, -12.42, -0.88, 
	-12.47, -1.20, -12.54, -1.51, 3, -12.24, -1.65, -12.04, -1.89, -11.62, -1.92, 3, -12.04, -2.05, -11.90, 
	-2.66, -12.03, -2.84, 0, 1, 26.10, -2.94, 3, 26.62, -2.83, 26.81, -2.95, 27.23, -2.84, 3, 27.25, -2.31, 
	26.09, -2.55, 26.10, -2.94, 0, 1, -6.70, -2.63, 3, -6.53, -2.43, -6.24, -2.34, -6.29, -1.92, 3, -6.19, 
	-1.92, -6.09, -1.92, -5.98, -1.92, 3, -5.59, -1.69, -6.61, -2.01, -6.39, -1.61, 3, -6.11, -1.44, -5.53, 
	-1.69, -5.16, -1.51, 3, -5.10, -0.97, -5.64, -1.03, -5.98, -0.89, 3, -6.21, -1.41, -7.44, -0.94, -7.52, 
	-1.61, 3, -7.21, -1.68, -7.32, -1.68, -7.01, -1.61, 3, -6.92, -1.90, -7.15, -1.87, -7.11, -2.12, 3, 
	-7.47, -2.20, -7.50, -1.97, -7.83, -2.02, 3, -8.08, -2.66, -7.14, -2.54, -6.70, -2.63, 0, 1, 2.73, -1.81, 
	3, 2.48, -1.86, 2.51, -1.63, 2.22, -1.71, 3, 2.26, -1.96, 2.03, -1.93, 2.11, -2.22, 3, 2.45, -2.39, 
	2.77, -2.28, 2.73, -1.81, 0, 1, 16.77, -2.33, 3, 17.02, -2.34, 17.27, -2.34, 17.39, -2.23, 3, 17.30, 
	-2.11, 17.25, -1.95, 17.28, -1.71, 3, 17.33, -1.52, 17.68, -1.63, 17.59, -1.30, 3, 16.81, -1.29, 16.69, 
	-1.26, 16.16, -1.00, 3, 16.13, -1.27, 16.30, -1.33, 16.57, -1.30, 3, 16.57, -1.54, 16.39, -1.60, 16.46, 
	-1.92, 3, 16.94, -1.84, 16.88, -2.03, 16.77, -2.33, 0, 1, -31.91, -2.12, 3, -31.58, -2.08, -31.65, -1.63, 
	-31.50, -1.41, 3, -31.37, -1.66, -31.12, -1.29, -31.09, -1.51, 3, -30.90, -1.51, -30.97, -1.32, -30.89, 
	-1.20, 3, -30.81, -1.07, -30.58, -1.00, -30.58, -0.79, 3, -30.76, -0.81, -31.10, -0.69, -30.99, -1.00, 
	3, -31.23, -1.00, -31.29, -0.82, -31.61, -0.89, 3, -31.78, -0.99, -31.77, -1.27, -32.12, -1.20, 3, -32.06, 
	-1.45, -32.14, -1.82, -31.91, -2.12, 0, 1, 1.81, -1.71, 3, 2.55, -1.51, 2.07, -0.28, 1.40, -0.69, 3, 
	1.41, -1.15, 1.82, -1.23, 1.81, -1.71, 0, 1, -21.77, -1.61, 3, -21.68, -1.53, -21.54, -1.50, -21.36, 
	-1.51, 3, -21.41, -1.22, -21.61, -1.07, -21.66, -0.79, 3, -21.84, -0.79, -22.01, -0.79, -22.18, -0.79, 
	3, -22.11, -1.14, -21.81, -1.25, -21.77, -1.61, 0, 1, -29.97, -1.20, 3, -29.86, -1.20, -29.76, -1.20, 
	-29.66, -1.20, 3, -29.63, -1.03, -29.76, -1.02, -29.76, -0.89, 3, -29.83, -0.89, -29.90, -0.89, -29.97, 
	-0.89, 3, -29.97, -1.00, -29.97, -1.10, -29.97, -1.20, 0, 1, 4.47, -1.10, 3, 4.65, -1.17, 4.71, -0.96, 
	4.88, -0.89, 3, 5.06, -0.82, 5.47, -0.88, 5.39, -0.59, 3, 5.84, -0.64, 6.03, -0.55, 6.21, -0.69, 3, 
	6.42, -0.48, 6.63, -0.28, 6.83, -0.07, 3, 7.29, -0.28, 7.87, -0.04, 8.16, 0.23, 3, 8.10, 0.52, 7.84, 
	0.59, 7.85, 0.95, 3, 7.69, 0.96, 7.46, 0.90, 7.44, 1.05, 3, 7.19, 0.96, 7.21, 0.60, 6.83, 0.65, 3, 6.77, 
	0.42, 7.02, 0.50, 7.03, 0.34, 3, 6.95, -0.15, 6.75, 0.42, 6.62, 0.44, 3, 6.56, 0.45, 6.50, 0.35, 6.42, 
	0.34, 3, 6.27, 0.32, 5.89, 0.41, 5.60, 0.34, 3, 5.58, 0.33, 5.62, 0.14, 5.60, 0.13, 3, 5.49, 0.08, 5.31, 
	0.17, 5.19, 0.13, 3, 5.14, 0.12, 5.02, -0.06, 4.98, -0.07, 3, 4.72, -0.15, 4.39, -0.10, 4.16, -0.18, 
	3, 4.00, -0.23, 3.98, -0.55, 3.76, -0.38, 3, 3.76, -0.52, 3.76, -0.65, 3.76, -0.79, 3, 3.98, -1.09, 
	4.49, -0.51, 4.47, -1.10, 0, 1, 30.61, -1.00, 3, 30.58, -0.76, 30.34, -0.76, 30.20, -0.89, 3, 30.23, 
	-1.13, 30.47, -1.13, 30.61, -1.00, 0, 1, 19.33, -0.79, 3, 19.38, -0.60, 19.56, -0.53, 19.54, -0.28, 
	3, 19.23, -0.30, 19.08, -0.50, 18.82, -0.59, 3, 18.84, -0.81, 19.08, -0.81, 19.33, -0.79, 0, 1, 15.75, 
	-0.69, 3, 15.88, -0.69, 16.02, -0.69, 16.16, -0.69, 3, 16.00, -0.47, 15.97, -0.12, 15.64, -0.07, 3, 
	15.64, -0.31, 15.82, -0.38, 15.75, -0.69, 0, 1, -3.01, -0.59, 3, -2.76, -0.29, -2.66, 0.15, -2.60, 0.64, 
	3, -2.78, 0.81, -3.65, 0.82, -3.32, 1.16, 3, -3.41, 1.41, -4.03, 1.43, -4.24, 1.26, 3, -4.17, 0.83, 
	-3.64, 1.25, -3.52, 1.06, 3, -3.44, 0.49, -4.08, 0.66, -4.24, 0.34, 3, -4.22, -0.02, -3.78, 0.05, -3.52, 
	-0.07, 3, -3.37, -0.26, -3.09, -0.33, -3.01, -0.59, 0, 1, -8.34, 0.13, 3, -8.13, 0.36, -8.05, 0.08, 
	-7.73, 0.13, 3, -7.73, 0.47, -8.02, 0.52, -8.34, 0.54, 3, -8.34, 0.41, -8.34, 0.27, -8.34, 0.13, 0, 
	1, -12.54, 0.75, 3, -12.29, 0.66, -12.14, 0.47, -11.83, 0.44, 3, -11.32, 0.77, -11.76, 1.20, -12.13, 
	1.46, 3, -12.72, 1.30, -13.08, 1.21, -13.57, 1.16, 3, -13.50, 0.58, -14.22, 0.78, -14.49, 0.54, 3, -14.60, 
	0.21, -13.56, 0.21, -13.67, 0.54, 3, -13.26, 0.33, -12.74, 0.46, -12.54, 0.75, 0, 1, -23.31, 0.44, 3, 
	-22.91, 0.42, -22.55, 0.44, -22.28, 0.54, 3, -22.42, 0.77, -22.70, 0.88, -22.79, 1.16, 3, -23.07, 1.02, 
	-23.39, 0.94, -23.31, 0.44, 0, 1, -8.03, 0.65, 3, -8.13, 1.33, -8.56, 1.69, -8.65, 2.39, 3, -8.83, 2.48, 
	-8.95, 2.63, -9.16, 2.70, 3, -9.16, 3.03, -9.33, 3.21, -9.26, 3.62, 3, -9.37, 3.62, -9.47, 3.62, -9.57, 
	3.62, 3, -9.62, 3.84, -9.50, 4.04, -9.57, 4.23, 3, -9.58, 4.26, -9.76, 4.21, -9.78, 4.23, 3, -9.91, 
	4.36, -9.94, 4.98, -10.29, 4.95, 3, -10.68, 5.02, -10.49, 4.51, -10.49, 4.34, 3, -10.49, 4.30, -10.63, 
	4.18, -10.60, 4.03, 3, -10.56, 3.85, -10.35, 3.71, -10.39, 3.52, 3, -10.26, 3.52, -10.12, 3.52, -9.98, 
	3.52, 3, -10.04, 3.27, -10.13, 3.05, -10.09, 2.70, 3, -9.82, 2.69, -9.98, 2.26, -9.57, 2.39, 3, -9.46, 
	2.16, -9.45, 1.82, -9.16, 1.77, 3, -9.33, 1.42, -9.00, 1.31, -8.96, 1.16, 3, -8.90, 0.96, -9.13, 0.79, 
	-8.85, 0.65, 3, -8.58, 0.65, -8.31, 0.65, -8.03, 0.65, 0, 1, -27.51, 0.75, 3, -27.09, 0.70, -27.61, 
	1.02, -27.20, 1.05, 3, -27.22, 1.28, -27.46, 1.27, -27.71, 1.26, 3, -27.79, 0.94, -27.43, 1.06, -27.51, 
	0.75, 0, 1, -20.84, 0.95, 3, -20.95, 1.09, -20.95, 1.33, -21.05, 1.46, 3, -21.33, 1.54, -21.26, 1.26, 
	-21.46, 1.26, 3, -21.48, 0.91, -21.08, 0.73, -20.84, 0.95, 0, 1, 4.06, 0.95, 3, 4.64, 0.72, 5.14, 1.44, 
	5.80, 1.46, 3, 5.60, 1.93, 4.76, 2.23, 4.16, 1.98, 3, 4.37, 1.66, 4.45, 1.16, 4.06, 0.95, 0, 1, 24.25, 
	1.36, 3, 24.53, 1.68, 23.98, 1.76, 24.25, 1.98, 3, 24.04, 2.35, 23.61, 2.03, 23.33, 2.18, 3, 23.56, 
	1.83, 23.51, 1.20, 24.25, 1.36, 0, 1, 9.49, 1.57, 3, 9.88, 1.63, 9.38, 1.99, 9.90, 1.98, 3, 9.85, 2.48, 
	9.00, 2.45, 9.29, 3.00, 3, 8.77, 3.08, 9.00, 2.86, 9.08, 2.49, 3, 9.17, 2.12, 9.13, 1.64, 9.49, 1.57, 
	0, 1, -20.23, 1.67, 3, -19.32, 1.62, -19.03, 2.18, -18.18, 2.18, 3, -18.09, 2.50, -17.80, 2.63, -17.46, 
	2.70, 3, -17.72, 3.65, -18.70, 2.93, -19.31, 2.80, 3, -19.28, 2.22, -19.87, 2.27, -20.23, 2.08, 3, -20.23, 
	1.94, -20.23, 1.81, -20.23, 1.67, 0, 1, -10.19, 1.67, 3, -10.23, 1.87, -10.22, 2.11, -10.49, 2.08, 3, 
	-10.68, 1.90, -10.46, 1.68, -10.19, 1.67, 0, 1, 41.47, 1.98, 3, 41.46, 2.16, 41.60, 2.19, 41.58, 2.39, 
	3, 41.16, 2.46, 41.22, 2.06, 40.76, 2.18, 3, 40.56, 2.08, 41.22, 1.97, 41.47, 1.98, 0, 1, -14.70, 2.59, 
	3, -14.59, 2.28, -14.42, 2.71, -14.29, 2.70, 3, -14.32, 2.84, -14.54, 2.78, -14.70, 2.80, 3, -14.63, 
	2.71, -14.57, 2.61, -14.70, 2.59, 0, 1, 27.12, 2.49, 3, 27.52, 2.40, 27.52, 2.71, 27.64, 2.90, 3, 27.99, 
	2.73, 28.09, 2.90, 28.56, 2.80, 3, 28.56, 3.10, 28.38, 3.23, 28.15, 3.31, 3, 27.88, 3.38, 27.95, 3.10, 
	27.84, 3.00, 3, 27.55, 3.06, 27.66, 3.07, 27.33, 3.21, 3, 27.48, 2.75, 27.03, 2.89, 27.12, 2.49, 0, 
	1, 13.49, 3.31, 3, 13.35, 3.02, 13.23, 3.58, 12.98, 3.52, 3, 12.93, 3.06, 12.59, 3.54, 12.36, 3.31, 
	3, 12.77, 3.07, 12.16, 3.03, 12.16, 3.00, 3, 12.18, 2.79, 12.31, 2.80, 12.57, 2.59, 3, 13.13, 2.80, 
	13.41, 2.70, 14.00, 2.80, 3, 14.02, 2.98, 13.88, 3.01, 13.90, 3.21, 3, 13.98, 3.32, 14.24, 3.41, 14.31, 
	3.41, 3, 14.57, 3.41, 14.59, 3.22, 14.82, 3.21, 3, 15.00, 3.20, 15.23, 3.51, 15.44, 3.21, 3, 15.68, 
	3.56, 15.28, 4.14, 14.82, 4.13, 3, 14.96, 3.69, 14.34, 4.00, 14.41, 3.62, 3, 14.15, 3.89, 13.12, 3.67, 
	13.49, 3.31, 0, 1, -15.00, 2.80, 3, -14.61, 2.92, -14.31, 3.13, -14.39, 3.72, 3, -14.84, 3.67, -14.73, 
	4.03, -15.11, 3.82, 3, -14.83, 3.49, -15.22, 3.11, -15.00, 2.80, 0, 1, 18.72, 3.41, 3, 18.64, 3.50, 
	18.61, 3.64, 18.62, 3.82, 3, 18.21, 3.88, 18.16, 3.59, 18.10, 3.31, 3, 18.41, 3.19, 18.45, 3.28, 18.72, 
	3.41, 0, 1, -1.47, 4.13, 3, -1.15, 4.12, -1.12, 4.39, -1.06, 4.64, 3, -1.23, 4.64, -1.41, 4.64, -1.58, 
	4.64, 3, -1.61, 4.40, -1.56, 4.25, -1.47, 4.13, 0, 1, 3.96, 4.13, 3, 4.10, 4.20, 4.15, 4.35, 4.16, 4.54, 
	3, 4.07, 4.46, 3.93, 4.43, 3.76, 4.44, 3, 3.79, 4.30, 3.94, 4.27, 3.96, 4.13, 0, 1, -15.31, 4.23, 3, 
	-15.21, 4.23, -15.11, 4.23, -15.00, 4.23, 3, -14.91, 4.42, -15.31, 4.57, -15.00, 4.64, 3, -15.18, 4.97, 
	-15.28, 4.39, -15.31, 4.23, 0, 1, -5.98, 4.23, 3, -5.55, 4.45, -5.20, 4.75, -4.96, 5.15, 3, -4.99, 5.17, 
	-5.25, 5.36, -5.27, 5.36, 3, -5.39, 5.37, -5.41, 5.17, -5.47, 5.15, 3, -5.60, 5.12, -5.95, 5.29, -6.29, 
	5.15, 3, -6.42, 5.10, -6.72, 4.69, -7.01, 4.64, 3, -6.90, 4.23, -6.47, 4.53, -6.39, 4.74, 3, -6.08, 
	4.52, -6.23, 4.43, -5.98, 4.23, 0, 1, 17.49, 4.23, 3, 17.81, 4.26, 17.81, 4.59, 17.90, 4.85, 3, 17.46, 
	4.94, 17.46, 4.60, 17.49, 4.23, 0, 1, -15.72, 4.74, 3, -15.40, 4.70, -15.32, 4.89, -15.10, 4.95, 3, 
	-15.10, 5.37, -15.41, 5.46, -15.72, 5.56, 3, -15.63, 5.89, -15.81, 5.95, -15.92, 6.08, 3, -16.58, 5.67, 
	-15.42, 5.37, -15.72, 4.74, 0, 1, 35.43, 5.15, 3, 35.17, 4.89, 35.08, 5.09, 34.71, 4.95, 3, 34.88, 4.74, 
	35.56, 4.58, 35.43, 5.15, 0, 1, 35.94, 4.95, 3, 36.08, 4.95, 36.21, 4.95, 36.35, 4.95, 3, 36.35, 5.02, 
	36.35, 5.09, 36.35, 5.15, 3, 36.21, 5.15, 36.08, 5.15, 35.94, 5.15, 3, 35.94, 5.09, 35.94, 5.02, 35.94, 
	4.95, 0, 1, 17.39, 5.05, 3, 17.51, 5.10, 17.60, 5.18, 17.59, 5.36, 3, 17.50, 5.44, 17.36, 5.47, 17.18, 
	5.46, 3, 17.20, 5.34, 17.16, 5.28, 17.08, 5.26, 3, 17.10, 5.11, 17.39, 5.22, 17.39, 5.05, 0, 1, 20.97, 
	5.46, 3, 20.84, 5.59, 20.78, 6.00, 21.18, 5.87, 3, 21.17, 6.10, 20.74, 5.92, 20.56, 5.98, 3, 20.72, 
	5.82, 20.59, 5.39, 20.97, 5.46, 0, 1, 12.26, 6.28, 3, 12.02, 6.25, 12.20, 5.80, 11.85, 5.87, 3, 12.00, 
	5.42, 12.41, 5.83, 12.26, 6.28, 0, 1, -10.39, 6.90, 3, -10.66, 7.62, -11.25, 7.03, -11.93, 7.10, 3, 
	-11.93, 7.00, -11.93, 6.90, -11.93, 6.79, 3, -12.38, 6.87, -12.35, 6.46, -12.65, 6.38, 3, -12.68, 6.22, 
	-12.55, 6.21, -12.54, 6.08, 3, -11.98, 5.89, -11.13, 6.29, -10.80, 6.90, 3, -10.66, 6.90, -10.53, 6.90, 
	-10.39, 6.90, 0, 1, 21.90, 6.28, 3, 21.85, 6.58, 21.68, 6.75, 21.38, 6.79, 3, 21.40, 6.68, 21.36, 6.61, 
	21.28, 6.59, 3, 20.77, 6.59, 20.20, 6.65, 20.26, 6.08, 3, 20.82, 6.21, 21.03, 6.06, 21.59, 5.97, 3, 
	21.57, 6.20, 21.67, 6.30, 21.90, 6.28, 0, 1, -2.09, 6.18, 3, -1.98, 6.70, -2.39, 6.70, -2.50, 7.00, 
	3, -2.35, 7.36, -2.23, 7.45, -2.19, 7.72, 3, -2.34, 7.88, -2.59, 7.93, -2.91, 7.92, 3, -2.95, 7.62, 
	-3.11, 7.63, -3.11, 7.41, 3, -3.12, 6.91, -2.56, 6.66, -2.50, 6.18, 3, -2.36, 6.18, -2.23, 6.18, -2.09, 
	6.18, 0, 1, 11.85, 6.38, 3, 12.26, 6.29, 11.94, 6.71, 11.95, 6.79, 3, 12.00, 7.05, 12.14, 7.16, 12.16, 
	7.41, 3, 11.81, 7.37, 11.72, 7.59, 11.55, 7.72, 3, 11.40, 7.69, 11.51, 7.41, 11.34, 7.41, 3, 11.37, 
	7.27, 11.60, 7.32, 11.75, 7.31, 3, 11.81, 7.03, 11.62, 6.49, 11.85, 6.38, 0, 1, -20.95, 6.59, 3, -20.93, 
	6.77, -21.12, 6.86, -20.95, 6.90, 3, -21.05, 7.16, -21.40, 6.82, -21.36, 6.59, 3, -21.21, 6.47, -21.10, 
	6.47, -20.95, 6.59, 0, 1, 9.29, 7.20, 3, 9.37, 6.97, 9.86, 7.16, 10.11, 7.10, 3, 10.03, 7.19, 10.00, 
	7.33, 10.01, 7.51, 3, 9.63, 7.55, 9.74, 7.10, 9.29, 7.20, 0, 1, -25.56, 7.41, 3, -25.67, 7.74, -25.92, 
	8.01, -26.28, 7.82, 3, -26.23, 7.50, -25.81, 7.21, -25.56, 7.41, 0, 1, -18.39, 7.51, 3, -18.37, 7.29, 
	-17.95, 7.47, -17.77, 7.41, 3, -17.75, 7.50, -17.81, 7.51, -17.87, 7.51, 3, -18.10, 7.57, -17.75, 7.67, 
	-17.98, 7.82, 3, -18.19, 7.86, -18.25, 7.75, -18.39, 7.72, 3, -18.32, 7.63, -18.26, 7.53, -18.39, 7.51, 
	0, 1, -17.46, 7.61, 3, -17.24, 8.11, -16.17, 7.76, -15.82, 8.13, 3, -15.99, 8.49, -16.42, 8.87, -16.74, 
	8.84, 3, -16.98, 8.82, -16.93, 8.74, -17.05, 8.64, 3, -17.37, 8.37, -17.45, 8.15, -17.46, 7.61, 0, 1, 
	-8.03, 7.72, 3, -7.66, 7.62, -7.85, 8.26, -7.93, 8.33, 3, -7.86, 8.44, -7.70, 8.44, -7.73, 8.64, 3, 
	-8.13, 8.65, -8.13, 9.06, -8.55, 9.05, 3, -8.79, 8.50, -8.03, 8.34, -8.03, 7.72, 0, 1, 1.70, 7.92, 3, 
	1.63, 8.20, 1.91, 8.13, 1.91, 8.33, 3, 2.38, 8.02, 2.27, 8.57, 2.73, 8.54, 3, 2.46, 8.88, 2.06, 9.09, 
	1.40, 9.05, 3, 1.11, 8.83, 0.90, 8.52, 0.58, 8.33, 3, 0.77, 7.79, 1.18, 8.01, 1.70, 7.92, 0, 1, -12.65, 
	8.33, 3, -12.59, 8.41, -12.54, 8.50, -12.54, 8.64, 3, -12.86, 8.56, -12.74, 8.92, -13.06, 8.84, 3, -13.00, 
	8.59, -12.97, 8.32, -12.65, 8.33, 0, 1, 30.40, 9.05, 3, 30.40, 9.19, 30.40, 9.32, 30.40, 9.46, 3, 29.83, 
	9.77, 29.10, 9.28, 28.66, 9.46, 3, 28.63, 9.25, 28.38, 9.26, 28.35, 9.05, 3, 28.11, 9.01, 28.13, 9.24, 
	27.84, 9.15, 3, 28.15, 8.83, 28.71, 8.83, 29.07, 8.84, 3, 29.08, 8.84, 29.06, 9.04, 29.07, 9.05, 3, 
	29.09, 9.07, 29.72, 8.96, 29.68, 8.95, 3, 29.71, 8.96, 29.74, 9.25, 29.79, 9.25, 3, 30.02, 9.27, 30.14, 
	8.96, 30.40, 9.05, 0, 1, -12.65, 9.36, 3, -12.83, 9.17, -12.91, 9.44, -13.26, 9.36, 3, -13.17, 9.08, 
	-12.67, 8.92, -12.65, 9.36, 0, 1, -21.77, 9.77, 3, -21.97, 9.96, -22.79, 9.90, -23.00, 9.77, 3, -23.07, 
	9.49, -22.79, 9.56, -22.79, 9.36, 3, -22.24, 9.28, -22.13, 9.65, -21.77, 9.77, 0, 1, -13.67, 10.18, 
	3, -13.75, 9.89, -13.52, 9.91, -13.57, 9.66, 3, -13.17, 9.77, -12.97, 9.44, -12.75, 9.66, 3, -12.92, 
	9.95, -13.02, 9.76, -13.36, 9.77, 3, -13.56, 9.75, -13.11, 10.34, -13.67, 10.18, 0, 1, -5.67, 9.66, 
	3, -5.66, 9.67, -5.13, 9.86, -4.85, 9.87, 3, -4.70, 9.87, -4.66, 9.74, -4.55, 9.77, 3, -4.30, 9.82, 
	-4.34, 9.98, -4.14, 10.07, 3, -4.08, 10.10, -4.02, 9.95, -3.93, 9.97, 3, -3.95, 9.97, -3.64, 10.15, 
	-3.52, 10.18, 3, -3.52, 10.35, -3.52, 10.52, -3.52, 10.69, 3, -4.06, 10.67, -4.21, 10.35, -4.75, 10.59, 
	3, -5.07, 10.29, -5.60, 10.20, -5.67, 9.66, 0, 1, 5.60, 9.97, 3, 5.44, 10.66, 5.11, 11.19, 4.27, 11.20, 
	3, 4.37, 11.11, 4.24, 10.82, 4.37, 10.69, 3, 4.40, 10.66, 4.56, 10.72, 4.58, 10.69, 3, 4.63, 10.58, 
	4.62, 10.24, 4.68, 10.18, 3, 4.91, 9.92, 5.36, 9.63, 5.60, 9.97, 0, 1, 19.33, 9.77, 3, 19.56, 9.81, 
	19.32, 10.33, 19.64, 10.28, 3, 19.42, 10.53, 18.74, 10.37, 18.82, 9.97, 3, 18.88, 9.80, 19.31, 9.98, 
	19.33, 9.77, 0, 1, -14.18, 11.61, 3, -14.47, 11.66, -14.27, 11.28, -14.29, 11.10, 3, -14.31, 10.90, 
	-14.44, 10.75, -14.39, 10.59, 3, -14.37, 10.54, -13.90, 10.55, -14.08, 10.18, 3, -13.50, 10.04, -13.54, 
	10.52, -13.36, 10.79, 3, -13.52, 11.18, -13.93, 11.32, -14.18, 11.61, 0, 1, -9.98, 11.72, 3, -9.94, 
	11.91, -9.58, 11.80, -9.67, 12.12, 3, -9.38, 12.14, -9.00, 12.07, -8.85, 12.23, 3, -8.96, 12.46, -9.32, 
	12.44, -9.67, 12.43, 3, -9.86, 12.24, -9.95, 11.96, -10.39, 12.02, 3, -10.47, 11.93, -10.50, 11.79, 
	-10.49, 11.61, 3, -10.82, 11.53, -11.17, 11.47, -11.41, 11.31, 3, -11.23, 10.91, -10.58, 10.97, -10.39, 
	10.59, 3, -10.31, 10.64, -10.22, 10.69, -10.08, 10.69, 3, -10.21, 11.13, -9.60, 11.37, -9.98, 11.72, 
	0, 1, 7.96, 11.10, 3, 8.30, 11.10, 8.23, 11.51, 8.47, 11.61, 3, 9.32, 11.35, 9.88, 11.79, 10.11, 12.43, 
	3, 9.68, 12.64, 9.55, 12.50, 9.09, 12.64, 3, 8.68, 12.49, 8.60, 12.03, 8.06, 12.02, 3, 8.09, 11.65, 
	8.04, 11.35, 7.96, 11.10, 0, 1, 18.52, 11.10, 3, 18.90, 11.18, 18.67, 11.78, 18.31, 11.72, 3, 18.32, 
	11.53, 18.18, 11.50, 18.21, 11.31, 3, 18.29, 11.22, 18.49, 11.24, 18.52, 11.10, 0, 1, 23.54, 12.12, 
	3, 23.20, 12.36, 22.64, 12.11, 22.31, 12.02, 3, 22.50, 11.56, 23.52, 11.44, 23.54, 12.12, 0, 1, -18.49, 
	12.02, 3, -18.35, 12.19, -18.09, 12.24, -18.18, 12.64, 3, -18.36, 12.63, -18.45, 12.71, -18.49, 12.84, 
	3, -18.70, 12.75, -18.60, 12.13, -18.49, 12.02, 0, 1, 18.72, 12.12, 3, 18.50, 12.21, 18.49, 12.51, 18.21, 
	12.53, 3, 18.23, 12.45, 18.17, 12.44, 18.10, 12.43, 3, 18.10, 12.36, 18.10, 12.29, 18.10, 12.23, 3, 
	18.35, 12.23, 18.41, 12.05, 18.72, 12.12, 0, 1, 1.30, 12.74, 3, 1.47, 13.23, 1.26, 13.06, 0.78, 13.05, 
	3, 0.94, 12.93, 1.03, 12.75, 1.30, 12.74, 0, 1, 3.04, 13.66, 3, 3.02, 13.78, 3.06, 13.84, 3.14, 13.87, 
	3, 3.07, 14.06, 2.30, 14.45, 2.22, 13.97, 3, 2.03, 14.06, 2.09, 14.39, 1.70, 14.28, 3, 1.68, 13.77, 
	2.35, 13.97, 2.22, 13.36, 3, 2.31, 13.43, 2.45, 13.47, 2.63, 13.46, 3, 2.35, 13.94, 2.52, 13.63, 3.04, 
	13.66, 0, 1, -15.31, 13.46, 3, -15.22, 13.44, -15.21, 13.50, -15.21, 13.56, 3, -15.16, 14.06, -14.36, 
	13.81, -14.39, 14.38, 3, -14.90, 14.28, -15.52, 13.97, -15.31, 13.46, 0, 1, 3.24, 13.97, 3, 3.45, 13.97, 
	3.37, 14.25, 3.65, 14.17, 3, 3.57, 14.27, 3.54, 14.41, 3.55, 14.58, 3, 3.34, 14.58, 3.42, 14.31, 3.14, 
	14.38, 3, 3.13, 14.19, 3.27, 14.16, 3.24, 13.97, 0, 1, 15.44, 14.48, 3, 15.63, 14.38, 15.80, 14.58, 
	15.95, 14.58, 3, 16.16, 14.59, 16.47, 14.47, 16.57, 14.48, 3, 16.95, 14.54, 17.01, 14.85, 17.18, 15.30, 
	3, 17.02, 15.09, 16.42, 15.31, 16.26, 15.10, 3, 16.30, 14.94, 16.58, 15.01, 16.46, 14.69, 3, 16.16, 
	14.69, 16.03, 14.87, 15.95, 15.10, 3, 15.79, 14.89, 15.40, 14.90, 15.44, 14.48, 0, 1, 7.55, 15.10, 3, 
	7.46, 15.46, 7.08, 15.51, 6.63, 15.51, 3, 6.68, 15.29, 6.78, 15.29, 6.93, 15.40, 3, 7.20, 15.36, 7.24, 
	15.10, 7.55, 15.10, 0, 1, -0.65, 15.51, 3, -0.51, 15.64, -0.51, 15.99, -0.65, 16.12, 3, -0.96, 16.04, 
	-1.24, 16.13, -1.47, 16.02, 3, -1.59, 15.96, -1.59, 15.52, -1.88, 15.71, 3, -1.59, 15.30, -1.10, 15.73, 
	-0.65, 15.51, 0, 1, -20.95, 15.92, 3, -20.50, 15.81, -20.48, 16.13, -20.23, 16.23, 3, -20.44, 16.49, 
	-21.02, 16.27, -20.95, 15.92, 0, 1, 24.97, 17.05, 3, 25.01, 17.46, 24.33, 17.16, 24.05, 17.25, 3, 24.07, 
	16.75, 24.70, 16.82, 24.97, 17.05, 0, 1, 9.70, 17.05, 3, 9.96, 17.40, 10.86, 17.12, 11.24, 17.35, 3, 
	11.09, 17.61, 10.69, 17.63, 10.52, 17.87, 3, 10.09, 17.66, 9.91, 17.47, 9.49, 17.46, 3, 9.50, 17.25, 
	9.77, 17.32, 9.70, 17.05, 0, 1, 0.99, 17.15, 3, 1.15, 17.12, 1.16, 17.24, 1.30, 17.25, 3, 1.30, 17.45, 
	1.30, 17.66, 1.30, 17.86, 3, 1.36, 17.97, 1.53, 17.97, 1.50, 18.17, 3, 0.97, 18.26, 1.05, 18.95, 0.37, 
	18.89, 3, 0.19, 18.65, 0.58, 18.34, 0.88, 18.28, 3, 0.81, 17.83, 0.74, 17.54, 0.99, 17.15, 0, 1, 25.18, 
	17.15, 3, 25.35, 17.15, 25.52, 17.15, 25.69, 17.15, 3, 25.68, 17.41, 25.54, 17.54, 25.28, 17.56, 3, 
	25.29, 17.37, 25.15, 17.34, 25.18, 17.15, 0, 1, -13.06, 17.45, 3, -12.82, 17.45, -12.58, 17.45, -12.34, 
	17.45, 3, -12.34, 17.59, -12.34, 17.73, -12.34, 17.86, 3, -12.55, 18.02, -13.16, 17.92, -13.06, 17.45, 
	0, 1, -8.96, 17.66, 3, -8.75, 17.66, -8.55, 17.66, -8.34, 17.66, 3, -8.19, 17.92, -7.85, 17.99, -7.62, 
	18.17, 3, -8.06, 18.57, -8.43, 17.83, -8.85, 18.17, 3, -8.94, 18.05, -8.99, 17.90, -8.96, 17.66, 0, 
	1, 28.15, 18.07, 3, 28.29, 18.07, 28.42, 18.07, 28.56, 18.07, 3, 28.53, 18.28, 28.28, 18.27, 28.25, 
	18.48, 3, 28.11, 18.45, 28.17, 18.22, 28.15, 18.07, 0, 1, -17.98, 19.50, 3, -17.66, 19.50, -17.30, 19.44, 
	-17.36, 19.81, 3, -17.67, 19.82, -18.04, 19.87, -17.98, 19.50, 0, 1, 18.62, 19.71, 3, 18.63, 19.48, 
	19.05, 19.67, 19.23, 19.61, 3, 19.14, 19.79, 19.04, 19.96, 18.72, 19.91, 3, 18.74, 19.80, 18.70, 19.73, 
	18.62, 19.71, 0, 1, -13.77, 20.02, 3, -13.61, 20.29, -13.54, 20.41, -13.77, 20.63, 3, -14.07, 20.59, 
	-14.09, 20.27, -14.49, 20.32, 3, -14.39, 20.09, -14.14, 19.99, -13.77, 20.02, 0, 1, -13.06, 20.84, 3, 
	-13.03, 20.60, -12.60, 20.78, -12.54, 20.84, 3, -12.57, 21.02, -12.72, 21.07, -12.95, 21.04, 3, -12.94, 
	20.92, -12.98, 20.86, -13.06, 20.84, 0, 1, -2.09, 20.73, 3, -1.65, 20.92, -1.54, 21.09, -0.96, 20.94, 
	3, -1.06, 21.71, -0.14, 20.92, -0.14, 21.66, 3, -0.66, 21.85, -1.84, 21.44, -2.09, 20.73, 0, 1, 8.78, 
	20.94, 3, 8.71, 21.29, 8.75, 21.73, 8.26, 21.66, 3, 8.27, 21.51, 8.28, 21.37, 8.16, 21.35, 3, 8.39, 
	21.24, 8.35, 20.86, 8.78, 20.94, 0, 1, 12.26, 21.97, 3, 12.82, 22.25, 13.07, 22.03, 13.49, 22.17, 3, 
	13.49, 22.27, 13.49, 22.37, 13.49, 22.48, 3, 12.96, 22.47, 12.48, 22.58, 12.26, 21.97, 0, 1, 2.73, 24.02, 
	3, 3.20, 24.02, 2.79, 24.52, 2.52, 24.42, 3, 2.52, 24.22, 2.80, 24.29, 2.73, 24.02, 0, 1, 33.99, 24.02, 
	3, 34.19, 24.06, 34.43, 24.05, 34.40, 24.32, 3, 34.21, 24.28, 33.96, 24.28, 33.99, 24.02, 0, 1, -6.80, 
	24.22, 3, -6.66, 24.38, -6.27, 24.30, -6.29, 24.63, 3, -6.64, 24.67, -6.88, 24.60, -6.80, 24.22, 0, 
	1, -12.54, -27.13, 3, -12.15, -27.19, -12.12, -26.87, -11.83, -26.82, 3, -11.91, -26.80, -12.62, -26.55, 
	-12.54, -27.13, 0, 1, -12.95, -16.88, 3, -12.77, -16.98, -12.64, -17.11, -12.54, -17.29, 3, -12.21, 
	-17.11, -12.52, -16.92, -12.44, -16.47, 3, -12.62, -16.48, -12.71, -16.40, -12.75, -16.27, 3, -12.81, 
	-16.38, -12.85, -16.58, -12.95, -16.88, 0, 1, -14.28, -11.55, 3, -14.58, -11.58, -14.60, -11.32, -14.90, 
	-11.35, 3, -14.97, -11.45, -15.14, -11.45, -15.10, -11.66, 3, -15.65, -11.46, -15.87, -12.11, -16.13, 
	-11.86, 3, -16.46, -12.24, -16.92, -12.51, -17.26, -12.89, 3, -17.15, -13.27, -17.05, -12.85, -16.85, 
	-12.78, 3, -16.61, -12.71, -16.06, -12.80, -16.13, -12.48, 3, -15.89, -12.51, -15.75, -12.64, -15.41, 
	-12.58, 3, -15.51, -12.21, -14.95, -12.49, -15.00, -12.17, 3, -14.61, -12.39, -14.33, -12.16, -13.98, 
	-12.06, 3, -13.96, -11.74, -14.08, -11.28, -13.67, -11.35, 3, -13.79, -10.91, -14.08, -11.65, -14.08, 
	-11.35, 3, -14.26, -11.31, -14.27, -11.43, -14.28, -11.55, 0, 1, -21.05, -10.02, 3, -21.23, -10.13, 
	-21.01, -10.20, -21.05, -10.32, 3, -21.11, -10.53, -21.40, -10.59, -21.46, -10.73, 3, -21.52, -10.88, 
	-21.36, -10.90, -21.36, -10.94, 3, -21.36, -11.15, -21.75, -11.26, -21.56, -11.45, 3, -21.23, -11.36, 
	-21.35, -11.72, -21.15, -11.76, 3, -20.52, -11.67, -20.72, -10.75, -19.82, -10.94, 3, -19.90, -10.52, 
	-19.91, -9.91, -19.61, -9.60, 3, -19.64, -9.36, -19.89, -9.72, -19.92, -9.81, 3, -20.48, -9.70, -20.53, 
	-10.09, -21.05, -10.02, 0, 1, -11.31, -10.73, 3, -11.50, -10.34, -11.84, -10.10, -11.72, -9.40, 3, -11.97, 
	-9.13, -12.27, -8.92, -12.34, -8.48, 3, -12.55, -8.58, -12.83, -8.61, -12.85, -8.89, 3, -13.11, -8.88, 
	-13.17, -8.70, -13.36, -8.89, 3, -13.33, -9.30, -12.86, -9.28, -12.85, -9.71, 3, -12.45, -9.68, -12.44, 
	-10.05, -12.03, -10.02, 3, -11.96, -10.10, -11.89, -10.24, -11.83, -10.32, 3, -11.81, -10.34, -11.73, 
	-10.31, -11.72, -10.32, 3, -11.66, -10.44, -11.56, -10.82, -11.31, -10.73, 0, 1, 0.68, -8.17, 3, 1.10, 
	-8.23, 1.34, -8.46, 1.81, -8.48, 3, 1.94, -7.83, 0.93, -7.82, 1.09, -7.55, 3, 0.98, -7.38, 0.66, -7.87, 
	0.68, -8.17, 0, 1, 8.37, -3.35, 3, 8.51, -3.66, 8.45, -3.12, 8.16, -3.25, 3, 7.96, -3.21, 8.08, -2.85, 
	7.75, -2.94, 3, 7.88, -3.27, 7.42, -3.02, 7.55, -3.35, 3, 7.16, -3.23, 6.87, -3.01, 6.93, -2.43, 3, 
	6.40, -2.50, 6.84, -2.94, 6.73, -3.45, 3, 6.83, -3.46, 6.81, -3.58, 6.83, -3.66, 3, 7.32, -3.85, 7.67, 
	-4.19, 7.86, -4.68, 3, 8.02, -4.71, 8.03, -4.59, 8.16, -4.58, 3, 8.58, -4.95, 8.55, -5.76, 9.19, -5.91, 
	3, 9.04, -6.16, 8.97, -6.10, 9.09, -6.43, 3, 9.53, -6.50, 9.88, -6.65, 10.01, -7.04, 3, 10.49, -6.90, 
	10.45, -6.57, 10.52, -6.22, 3, 10.23, -6.14, 9.98, -6.01, 9.70, -5.91, 3, 9.82, -5.79, 9.99, -5.73, 
	9.91, -5.40, 3, 9.44, -5.39, 8.76, -5.43, 8.98, -4.48, 3, 8.72, -4.33, 8.51, -4.13, 8.27, -3.97, 3, 
	8.28, -3.80, 7.93, -3.31, 8.37, -3.35, 0, 1, 9.19, -4.38, 3, 9.42, -4.24, 8.93, -3.96, 8.88, -3.76, 
	3, 8.50, -4.05, 9.16, -4.16, 9.19, -4.38, 0, 1, -17.77, -0.28, 3, -18.11, -0.54, -17.75, -1.10, -17.67, 
	-1.30, 3, -17.56, -1.58, -17.61, -2.06, -17.56, -2.12, 3, -17.57, -2.12, -17.37, -2.22, -17.36, -2.23, 
	3, -17.28, -2.30, -17.08, -2.37, -16.95, -2.53, 3, -16.56, -2.36, -16.50, -1.97, -16.64, -1.51, 3, -16.44, 
	-1.41, -16.44, -1.16, -16.64, -1.41, 3, -16.99, -1.45, -17.01, -0.99, -17.16, -0.79, 3, -17.18, -0.76, 
	-17.33, -0.82, -17.36, -0.79, 3, -17.52, -0.62, -17.54, -0.37, -17.77, -0.28, 0, 1, 40.14, -1.92, 3, 
	39.89, -1.78, 39.64, -2.15, 39.63, -1.92, 3, 39.23, -2.04, 40.28, -2.37, 40.14, -1.92, 0, 1, -0.96, 
	1.98, 3, -0.75, 1.78, -0.47, 1.65, -0.14, 1.57, 3, 0.21, 1.91, 0.54, 2.18, 0.99, 2.18, 3, 0.99, 2.32, 
	0.99, 2.45, 0.99, 2.59, 3, 0.56, 2.61, 0.20, 2.56, -0.04, 2.39, 3, -0.24, 2.39, -0.17, 2.67, -0.45, 
	2.59, 3, -0.82, 2.43, -0.03, 2.61, -0.24, 2.28, 3, -0.35, 2.05, -0.60, 1.95, -0.96, 1.98, 0, 1, 2.73, 
	4.03, 3, 2.47, 3.84, 2.90, 4.02, 3.04, 4.03, 3, 3.12, 4.01, 3.14, 3.92, 3.24, 3.92, 3, 3.32, 3.27, 2.89, 
	3.11, 2.83, 2.59, 3, 3.29, 2.55, 3.55, 2.69, 3.76, 2.90, 3, 4.01, 2.90, 4.03, 2.71, 4.27, 2.69, 3, 4.58, 
	2.67, 4.77, 2.86, 4.98, 3.00, 3, 4.92, 3.31, 4.77, 2.90, 4.58, 3.00, 3, 4.45, 3.32, 4.09, 3.41, 4.06, 
	3.82, 3, 3.37, 4.05, 3.47, 5.07, 3.14, 5.67, 3, 2.77, 5.54, 2.68, 5.52, 2.42, 5.46, 3, 2.60, 5.17, 2.55, 
	5.22, 2.52, 4.54, 3, 2.91, 4.75, 2.93, 4.07, 2.73, 4.03, 0, 1, -23.10, 4.54, 3, -23.17, 4.64, -23.34, 
	4.65, -23.31, 4.85, 3, -23.49, 4.85, -23.52, 4.73, -23.72, 4.74, 3, -23.86, 4.75, -24.02, 4.95, -24.02, 
	4.95, 3, -24.13, 4.94, -24.26, 4.76, -24.33, 4.74, 3, -24.44, 4.71, -24.65, 4.80, -24.74, 4.74, 3, -24.93, 
	4.63, -25.16, 4.30, -25.15, 4.03, 3, -25.23, 4.08, -25.32, 4.13, -25.46, 4.13, 3, -25.45, 3.81, -25.72, 
	3.61, -25.76, 3.11, 3, -25.57, 3.06, -25.51, 2.88, -25.25, 2.90, 3, -25.02, 3.59, -24.17, 3.66, -23.51, 
	3.93, 3, -23.61, 4.03, -23.55, 4.48, -23.41, 4.64, 3, -23.32, 4.59, -23.24, 4.53, -23.10, 4.54, 0, 1, 
	7.75, 5.56, 3, 7.73, 5.80, 8.18, 6.06, 8.68, 6.08, 3, 8.58, 6.67, 8.84, 6.28, 9.09, 6.49, 3, 8.81, 6.61, 
	8.43, 6.98, 8.98, 7.10, 3, 8.94, 7.45, 8.42, 6.95, 8.47, 7.20, 3, 8.10, 6.68, 7.43, 6.47, 6.62, 6.38, 
	3, 6.62, 6.25, 6.62, 6.11, 6.62, 5.97, 3, 6.61, 5.79, 6.28, 5.91, 6.21, 5.77, 3, 6.11, 5.87, 6.01, 5.97, 
	5.91, 6.08, 3, 5.49, 5.96, 5.88, 5.62, 5.80, 5.26, 3, 6.16, 5.21, 6.47, 5.11, 6.93, 5.15, 3, 7.07, 5.42, 
	7.28, 5.63, 7.55, 5.77, 3, 7.64, 5.72, 7.73, 5.68, 7.75, 5.56, 0, 1, -28.84, 6.49, 3, -29.09, 6.54, 
	-29.06, 6.88, -29.45, 6.80, 3, -29.38, 6.52, -28.99, 6.58, -28.94, 6.28, 3, -28.84, 6.35, -28.84, 6.52, 
	-28.63, 6.49, 3, -28.66, 6.62, -28.84, 6.59, -28.84, 6.49, 0, 1, 14.52, 8.13, 3, 14.51, 8.51, 14.92, 
	8.48, 15.23, 8.54, 3, 14.79, 9.28, 16.33, 8.67, 16.26, 9.36, 3, 15.94, 9.24, 15.99, 9.39, 15.75, 9.25, 
	3, 15.50, 9.51, 15.34, 9.45, 15.34, 9.77, 3, 15.04, 9.83, 14.94, 9.44, 14.72, 9.36, 3, 14.63, 9.32, 
	14.49, 9.44, 14.52, 9.46, 3, 14.27, 9.31, 14.29, 9.23, 14.11, 9.05, 3, 14.33, 8.96, 14.34, 8.67, 14.31, 
	8.33, 3, 14.22, 8.31, 14.22, 8.37, 14.21, 8.44, 3, 13.99, 8.40, 14.32, 8.08, 14.52, 8.13, 0, 1, 20.15, 
	8.23, 3, 20.25, 8.36, 20.20, 8.57, 20.15, 8.84, 3, 19.88, 8.92, 19.95, 8.64, 19.74, 8.64, 3, 19.78, 
	8.40, 20.06, 8.41, 20.15, 8.23, 0, 1, 32.56, 11.41, 3, 32.77, 11.46, 32.42, 11.80, 32.15, 11.71, 3, 
	32.14, 11.61, 32.02, 11.63, 31.94, 11.61, 3, 31.97, 11.23, 32.09, 10.94, 32.56, 11.00, 3, 32.60, 11.24, 
	32.37, 11.22, 32.45, 11.51, 3, 32.54, 11.53, 32.55, 11.47, 32.56, 11.41, 0, 1, 22.82, 11.31, 3, 22.77, 
	11.39, 22.71, 11.47, 22.72, 11.61, 3, 22.39, 11.78, 22.30, 11.23, 22.20, 11.51, 3, 21.97, 11.32, 22.56, 
	11.09, 22.82, 11.31, 0, 1, -0.24, 12.02, 3, -0.19, 12.30, -0.63, 12.14, -0.76, 12.33, 3, -0.79, 12.39, 
	-0.71, 12.59, -0.76, 12.64, 3, -0.92, 12.79, -1.45, 12.74, -1.37, 13.15, 3, -1.55, 12.97, -1.35, 12.88, 
	-1.47, 12.53, 3, -1.05, 12.51, -1.14, 11.98, -0.76, 11.92, 3, -0.77, 11.66, -0.95, 11.60, -0.76, 11.41, 
	3, -0.47, 11.49, -0.41, 11.81, -0.24, 12.02, 0, 1, 4.88, 18.89, 3, 4.85, 19.47, 5.57, 18.73, 5.80, 19.30, 
	3, 5.48, 19.55, 4.68, 19.40, 4.68, 18.99, 3, 4.80, 19.01, 4.86, 18.97, 4.88, 18.89, 0, 1, 26.82, 22.07, 
	3, 27.09, 22.19, 26.55, 22.33, 26.51, 22.48, 3, 26.20, 22.47, 26.16, 22.21, 25.89, 22.17, 3, 25.95, 
	22.09, 26.00, 22.00, 26.00, 21.86, 3, 26.38, 21.76, 26.70, 22.24, 26.82, 22.07, 0, 1, 20.87, -19.24, 
	3, 21.20, -19.11, 21.24, -19.32, 21.69, -19.04, 3, 21.82, -18.95, 22.11, -18.82, 22.10, -18.83, 3, 22.21, 
	-18.69, 22.38, -18.23, 22.20, -18.01, 3, 21.66, -18.32, 20.98, -18.50, 20.87, -19.24, 0, 1, 10.42, -10.84, 
	3, 10.71, -10.86, 10.94, -10.81, 11.03, -10.63, 3, 11.27, -10.83, 11.68, -10.87, 12.16, -10.84, 3, 12.39, 
	-10.56, 12.54, -10.19, 12.98, -10.12, 3, 12.61, -9.65, 13.51, -9.74, 13.59, -9.40, 3, 13.44, -9.28, 
	13.34, -9.10, 13.08, -9.09, 3, 12.70, -9.19, 12.68, -9.65, 12.16, -9.61, 3, 12.02, -9.95, 11.71, -10.11, 
	11.54, -10.43, 3, 11.43, -9.94, 10.98, -10.33, 10.52, -10.12, 3, 10.49, -10.39, 10.66, -10.45, 10.93, 
	-10.43, 3, 10.85, -10.66, 10.34, -10.46, 10.42, -10.84, 0, 1, 12.77, 12.43, 3, 13.02, 12.38, 13.39, 
	12.45, 13.70, 12.23, 3, 13.69, 12.53, 13.46, 12.61, 13.29, 12.74, 3, 13.35, 13.22, 13.15, 13.36, 13.29, 
	13.66, 3, 12.80, 13.62, 12.75, 14.01, 12.26, 13.97, 3, 12.15, 13.78, 12.13, 13.49, 12.06, 13.25, 3, 
	12.37, 13.33, 12.36, 13.08, 12.67, 13.15, 3, 12.63, 12.95, 12.74, 12.78, 12.78, 12.95, 3, 13.00, 12.93, 
	12.64, 12.69, 12.77, 12.43, 0, 1, -2.91, 14.69, 3, -2.83, 15.15, -2.26, 15.13, -1.88, 15.30, 3, -1.84, 
	15.47, -2.27, 15.65, -2.29, 15.40, 3, -2.43, 15.51, -2.50, 15.68, -2.60, 15.81, 3, -2.99, 15.52, -3.52, 
	15.36, -3.63, 14.79, 3, -3.27, 14.87, -3.23, 14.64, -2.91, 14.69, 0 }

shape[2] = { 1, -13.17, -37.76, 3, -13.30, -37.47, -13.13, -37.42, -13.17, -37.00, 3, -13.52, -36.98, -13.53, -36.88, 
	-13.83, -37.00, 3, -13.69, -37.36, -13.67, -37.29, -13.74, -37.76, 3, -13.62, -37.88, -13.29, -37.88, 
	-13.17, -37.76, 0, 1, -21.43, -36.44, 3, -21.14, -36.37, -20.93, -35.88, -21.06, -35.69, 3, -21.20, 
	-35.93, -21.50, -35.99, -21.43, -36.44, 0, 1, -9.42, -35.13, 3, -9.39, -35.25, -9.18, -35.20, -9.04, 
	-35.22, 3, -9.01, -35.00, -9.06, -34.86, -9.14, -34.75, 3, -9.40, -34.71, -9.23, -35.10, -9.42, -35.13, 
	0, 1, 0.15, -34.75, 3, 0.25, -34.75, 0.34, -34.75, 0.44, -34.75, 3, 0.28, -34.23, 0.94, -34.20, 0.62, 
	-33.81, 3, 0.39, -33.86, 0.31, -34.06, 0.06, -34.09, 3, 0.02, -34.51, 0.35, -34.40, 0.15, -34.75, 0, 
	1, -9.61, -34.38, 3, -9.48, -34.38, -9.36, -34.38, -9.23, -34.38, 3, -9.25, -34.27, -9.21, -34.21, -9.14, 
	-34.19, 3, -9.13, -33.90, -9.48, -33.96, -9.42, -33.63, 3, -9.71, -33.65, -9.58, -34.09, -9.61, -34.38, 
	0, 1, 3.72, -31.28, 3, 3.77, -30.98, 3.59, -30.91, 3.53, -30.72, 3, 3.39, -30.80, 3.33, -30.95, 3.34, 
	-31.19, 3, 3.43, -31.26, 3.56, -31.29, 3.72, -31.28, 0, 1, -13.27, -31.18, 3, -13.55, -30.54, -13.21, 
	-30.45, -13.36, -29.97, 3, -14.21, -29.97, -13.91, -31.16, -13.27, -31.18, 0, 1, -21.90, -29.40, 3, 
	-22.03, -29.22, -21.72, -28.38, -22.18, -28.65, 3, -21.97, -28.68, -21.98, -29.18, -22.28, -29.21, 3, 
	-22.25, -29.38, -22.12, -29.43, -21.90, -29.40, 0, 1, -8.48, -27.43, 3, -8.70, -27.09, -9.08, -26.90, 
	-9.23, -26.49, 3, -9.42, -26.62, -9.24, -27.11, -9.70, -26.96, 3, -9.45, -27.25, -9.63, -27.39, -9.61, 
	-27.90, 3, -9.10, -28.37, -8.85, -27.64, -8.48, -27.43, 0, 1, 7.57, -27.15, 3, 7.88, -27.50, 8.36, -26.88, 
	8.04, -26.59, 3, 7.69, -26.58, 7.82, -27.06, 7.57, -27.15, 0, 1, 8.23, -26.12, 3, 8.15, -25.98, 7.99, 
	-25.91, 7.76, -25.93, 3, 7.76, -26.02, 7.76, -26.12, 7.76, -26.21, 3, 8.05, -26.32, 8.00, -26.25, 8.23, 
	-26.12, 0, 1, -18.90, -25.84, 3, -18.77, -25.84, -18.65, -25.84, -18.52, -25.84, 3, -18.84, -25.28, 
	-17.87, -24.94, -18.15, -24.43, 3, -18.56, -24.49, -18.53, -24.41, -18.81, -24.61, 3, -18.63, -25.08, 
	-18.90, -25.30, -18.90, -25.84, 0, 1, 3.06, -23.68, 3, 4.19, -23.34, 3.69, -22.17, 3.81, -21.33, 3, 
	3.54, -21.32, 3.27, -22.16, 3.63, -22.17, 3, 2.94, -22.53, 3.07, -22.91, 3.06, -23.68, 0, 1, -1.25, 
	-23.58, 3, -0.78, -23.40, -0.62, -23.07, -0.03, -23.21, 3, -0.16, -22.77, -0.82, -22.87, -1.25, -22.74, 
	3, -1.33, -23.13, -2.00, -22.93, -2.29, -23.11, 3, -2.12, -23.45, -1.52, -23.35, -1.25, -23.58, 0, 1, 
	8.32, -23.49, 3, 8.51, -23.49, 8.70, -23.49, 8.88, -23.49, 3, 8.88, -23.33, 8.95, -23.25, 9.07, -23.21, 
	3, 8.87, -23.13, 8.52, -23.14, 8.23, -23.21, 3, 8.27, -23.28, 8.32, -23.36, 8.32, -23.49, 0, 1, -5.38, 
	-23.21, 3, -5.43, -22.88, -5.30, -22.72, -5.10, -22.65, 3, -5.11, -22.41, -5.42, -22.46, -5.67, -22.46, 
	3, -5.68, -22.72, -5.84, -22.85, -5.85, -23.11, 3, -5.63, -23.07, -5.65, -23.29, -5.38, -23.21, 0, 1, 
	-5.29, -22.27, 3, -5.29, -22.11, -5.29, -21.96, -5.29, -21.80, 3, -5.48, -21.85, -5.59, -22.00, -5.76, 
	-22.08, 3, -5.68, -22.22, -5.52, -22.28, -5.29, -22.27, 0, 1, -21.62, -21.14, 3, -21.46, -21.02, -21.25, 
	-20.95, -21.25, -20.67, 3, -21.49, -20.44, -21.56, -20.91, -21.81, -20.96, 3, -21.79, -21.06, -21.62, 
	-21.02, -21.62, -21.14, 0, 1, 17.05, -20.58, 3, 17.05, -20.39, 17.05, -20.20, 17.05, -20.02, 3, 16.75, 
	-19.97, 16.80, -20.27, 16.58, -20.30, 3, 16.64, -20.48, 16.83, -20.55, 17.05, -20.58, 0, 1, -21.62, 
	-20.48, 3, -21.48, -20.34, -21.09, -20.46, -21.15, -20.11, 3, -21.27, -19.87, -21.61, -20.20, -21.62, 
	-20.02, 3, -21.84, -20.04, -21.68, -20.43, -21.62, -20.48, 0, 1, -0.88, -20.48, 3, -0.75, -20.48, -0.63, 
	-20.48, -0.50, -20.48, 3, -0.56, -19.94, 0.26, -19.26, -0.41, -18.98, 3, -0.16, -18.73, 0.13, -18.52, 
	0.15, -18.05, 3, -0.14, -17.80, -0.54, -18.11, -0.78, -17.95, 3, -0.57, -18.15, -0.86, -18.27, -0.78, 
	-18.61, 3, -1.40, -18.30, -0.68, -19.11, -1.16, -19.17, 3, -0.88, -19.39, -1.18, -20.10, -0.88, -20.48, 
	0, 1, 8.98, -20.39, 3, 9.06, -20.04, 8.56, -20.06, 8.41, -20.20, 3, 8.50, -20.37, 8.71, -20.41, 8.98, 
	-20.39, 0, 1, -9.98, -20.02, 3, -9.76, -19.99, -9.63, -19.87, -9.33, -19.92, 3, -9.22, -19.69, -9.28, 
	-19.28, -8.95, -19.26, 3, -8.98, -19.14, -9.12, -19.12, -9.14, -18.98, 3, -8.32, -18.72, -8.92, -17.31, 
	-9.51, -17.76, 3, -9.74, -17.93, -10.02, -18.85, -9.98, -19.17, 3, -9.94, -19.52, -9.67, -19.60, -9.98, 
	-20.02, 0, 1, 9.07, -20.02, 3, 9.15, -19.82, 9.22, -19.60, 9.35, -19.45, 3, 9.03, -18.98, 9.06, -18.72, 
	8.70, -18.33, 3, 8.56, -18.35, 8.66, -18.61, 8.51, -18.61, 3, 8.54, -18.74, 8.74, -18.69, 8.88, -18.70, 
	3, 8.81, -19.01, 8.62, -19.19, 8.32, -19.27, 3, 8.49, -19.73, 8.28, -19.62, 8.13, -19.92, 3, 8.54, -19.86, 
	8.66, -20.08, 9.07, -20.02, 0, 1, 13.67, -19.73, 3, 13.59, -19.60, 13.53, -19.44, 13.29, -19.45, 3, 
	13.10, -19.88, 13.45, -19.83, 13.67, -19.73, 0, 1, -4.73, -19.64, 3, -4.63, -18.80, -5.45, -19.02, -6.04, 
	-19.08, 3, -6.08, -19.78, -5.21, -19.74, -4.73, -19.64, 0, 1, 2.50, -19.55, 3, 2.97, -19.94, 3.44, -19.29, 
	3.72, -19.45, 3, 3.63, -19.11, 3.10, -19.20, 2.69, -19.17, 3, 2.56, -19.23, 2.67, -19.53, 2.50, -19.55, 
	0, 1, -16.83, -17.67, 3, -16.82, -17.88, -16.44, -17.71, -16.27, -17.76, 3, -16.36, -17.37, -16.23, 
	-17.30, -16.37, -16.92, 3, -16.92, -16.97, -16.66, -17.36, -16.83, -17.67, 0, 1, -20.96, -17.67, 3, 
	-20.49, -17.54, -21.19, -17.09, -21.43, -17.39, 3, -21.37, -17.58, -20.99, -17.45, -20.96, -17.67, 0, 
	1, -24.44, -16.83, 3, -24.46, -16.63, -24.69, -16.64, -24.72, -16.45, 3, -25.08, -16.54, -24.83, -16.96, 
	-24.44, -16.83, 0, 1, 13.86, -16.73, 3, 13.98, -16.73, 14.11, -16.73, 14.23, -16.73, 3, 14.41, -16.10, 
	14.75, -16.04, 14.51, -15.32, 3, 14.21, -15.24, 14.22, -15.47, 14.04, -15.51, 3, 13.96, -15.38, 14.24, 
	-15.19, 13.86, -15.04, 3, 13.70, -15.59, 13.68, -16.31, 13.86, -16.73, 0, 1, 5.13, -14.85, 3, 4.56, 
	-14.88, 4.28, -15.19, 4.19, -15.70, 3, 4.27, -15.65, 4.34, -15.60, 4.47, -15.60, 3, 4.41, -15.89, 4.04, 
	-15.86, 3.91, -16.07, 3, 4.79, -16.60, 5.26, -15.71, 5.13, -14.85, 0, 1, -29.04, -16.17, 3, -29.14, 
	-15.63, -29.51, -15.94, -29.88, -15.70, 3, -29.92, -15.89, -29.82, -15.95, -29.79, -16.07, 3, -29.45, 
	-15.88, -29.33, -16.08, -29.04, -16.17, 0, 1, 7.01, -16.17, 3, 7.64, -16.21, 7.96, -15.60, 8.41, -16.17, 
	3, 8.77, -16.21, 8.60, -15.73, 9.07, -15.89, 3, 9.05, -15.62, 8.76, -15.63, 8.69, -15.42, 3, 8.50, -15.47, 
	8.37, -15.60, 8.32, -15.79, 3, 7.77, -15.83, 7.10, -15.48, 6.63, -15.79, 3, 6.58, -16.09, 7.10, -15.83, 
	7.01, -16.17, 0, 1, -5.20, -16.07, 3, -5.10, -16.07, -5.01, -16.07, -4.91, -16.07, 3, -4.86, -15.59, 
	-4.95, -15.69, -4.45, -15.60, 3, -4.75, -15.04, -3.54, -14.33, -4.45, -14.01, 3, -4.59, -14.59, -5.09, 
	-14.80, -5.38, -15.23, 3, -4.98, -15.36, -5.47, -15.81, -5.20, -16.07, 0, 1, 5.88, -15.98, 3, 6.10, 
	-16.01, 6.24, -15.96, 6.35, -15.89, 3, 6.35, -15.70, 6.09, -15.77, 6.16, -15.51, 3, 5.87, -15.47, 5.86, 
	-15.71, 5.88, -15.98, 0, 1, 0.62, -14.95, 3, 0.15, -14.85, 0.05, -15.12, -0.13, -15.32, 3, -0.75, -14.97, 
	-1.70, -15.13, -2.47, -14.76, 3, -2.68, -14.96, -2.86, -15.25, -2.66, -15.60, 3, -2.28, -15.61, -2.22, 
	-15.30, -1.72, -15.42, 3, -1.17, -16.07, 0.57, -15.98, 0.62, -14.95, 0, 1, -7.73, -15.23, 3, -7.49, 
	-15.27, -7.45, -15.51, -7.17, -15.51, 3, -7.12, -15.21, -6.80, -15.19, -6.60, -15.04, 3, -6.85, -14.68, 
	-7.03, -15.06, -7.45, -15.04, 3, -8.20, -15.01, -8.92, -14.43, -9.51, -14.95, 3, -9.29, -15.59, -8.08, 
	-15.56, -7.73, -15.23, 0, 1, -12.52, -15.32, 3, -12.36, -15.06, -12.40, -15.10, -12.14, -15.04, 3, -12.20, 
	-14.92, -12.34, -14.87, -12.52, -14.85, 3, -12.30, -14.60, -12.22, -14.50, -11.95, -14.48, 3, -12.13, 
	-14.35, -11.81, -14.02, -12.05, -13.82, 3, -12.90, -13.88, -12.93, -14.52, -12.70, -15.23, 3, -12.59, 
	-15.21, -12.54, -15.25, -12.52, -15.32, 0, 1, -10.17, -15.32, 3, -9.94, -15.34, -9.72, -15.34, -9.61, 
	-15.23, 3, -9.54, -14.97, -9.79, -15.04, -9.80, -14.85, 3, -9.92, -15.01, -10.24, -14.97, -10.17, -15.32, 
	0, 1, -16.37, -14.38, 3, -16.19, -14.21, -16.13, -14.38, -15.90, -14.38, 3, -15.86, -14.08, -15.48, 
	-14.11, -15.52, -13.73, 3, -15.66, -13.87, -16.01, -13.80, -15.99, -14.10, 3, -16.20, -14.00, -16.37, 
	-13.86, -16.74, -13.91, 3, -16.59, -14.05, -16.41, -14.15, -16.37, -14.38, 0, 1, -20.78, -14.20, 3, 
	-20.69, -14.12, -20.56, -14.10, -20.40, -14.10, 3, -20.40, -13.98, -20.40, -13.85, -20.40, -13.73, 3, 
	-20.62, -13.73, -20.84, -13.73, -21.06, -13.73, 3, -21.13, -14.05, -20.68, -13.85, -20.78, -14.20, 0, 
	1, -14.67, -14.20, 3, -14.69, -13.93, -14.84, -13.80, -15.14, -13.82, 3, -15.07, -14.03, -14.96, -14.20, 
	-14.67, -14.20, 0, 1, -20.68, -13.54, 3, -20.46, -13.58, -20.48, -13.37, -20.21, -13.45, 3, -20.21, 
	-13.29, -20.21, -13.13, -20.21, -12.98, 3, -20.38, -12.99, -20.41, -12.86, -20.59, -12.88, 3, -20.79, 
	-13.14, -20.53, -13.27, -20.68, -13.54, 0, 1, 8.79, -13.45, 3, 9.12, -13.37, 9.21, -12.99, 9.07, -12.70, 
	3, 8.50, -12.61, 8.60, -12.98, 8.51, -13.16, 3, 8.52, -13.34, 8.82, -13.23, 8.79, -13.45, 0, 1, -3.32, 
	-12.79, 3, -3.60, -12.55, -3.34, -12.36, -3.60, -12.13, 3, -3.97, -12.10, -4.11, -12.31, -4.07, -12.70, 
	3, -3.93, -12.84, -3.59, -12.78, -3.32, -12.79, 0, 1, -4.54, -12.60, 3, -4.31, -12.52, -4.13, -12.38, 
	-4.16, -12.04, 3, -4.47, -12.04, -4.52, -12.31, -4.54, -12.60, 0, 1, 9.54, -12.60, 3, 9.83, -12.07, 
	9.69, -11.67, 10.01, -11.19, 3, 10.11, -10.78, 9.69, -10.89, 9.73, -10.54, 3, 9.70, -11.17, 9.06, -11.62, 
	8.98, -12.23, 3, 9.00, -12.51, 9.47, -12.35, 9.54, -12.60, 0, 1, 13.29, -12.32, 3, 12.78, -12.27, 11.94, 
	-11.73, 11.70, -12.51, 3, 12.39, -12.22, 13.06, -12.83, 13.29, -12.32, 0, 1, 14.89, -12.32, 3, 14.45, 
	-12.44, 14.58, -12.01, 14.14, -12.13, 3, 14.15, -12.30, 14.02, -12.33, 14.05, -12.51, 3, 14.50, -12.28, 
	14.73, -12.91, 14.89, -12.32, 0, 1, 4.94, -12.41, 3, 5.27, -12.37, 5.21, -11.93, 5.50, -11.85, 3, 5.73, 
	-12.25, 6.11, -12.49, 6.82, -12.41, 3, 6.80, -12.31, 6.84, -12.25, 6.91, -12.23, 3, 6.81, -11.83, 6.26, 
	-12.04, 6.16, -11.48, 3, 5.35, -11.47, 4.53, -11.66, 3.91, -11.38, 3, 3.94, -11.66, 4.06, -11.86, 4.19, 
	-12.04, 3, 4.38, -12.04, 4.31, -11.78, 4.56, -11.85, 3, 4.80, -11.93, 4.80, -12.24, 4.94, -12.41, 0, 
	1, -8.58, -12.23, 3, -7.60, -11.85, -8.08, -10.71, -7.45, -10.16, 3, -7.66, -9.92, -8.07, -10.29, -8.29, 
	-10.35, 3, -8.13, -10.89, -8.69, -10.70, -8.67, -11.10, 3, -8.27, -11.31, -8.86, -11.92, -8.58, -12.23, 
	0, 1, 3.63, -11.95, 3, 3.59, -11.67, 3.43, -11.52, 3.16, -11.48, 3, 3.08, -11.95, 3.32, -12.10, 3.63, 
	-11.95, 0, 1, -0.78, -11.48, 3, -0.95, -11.02, -1.56, -11.52, -1.63, -10.91, 3, -2.17, -11.06, -2.50, 
	-11.14, -2.94, -11.19, 3, -3.02, -11.46, -2.81, -11.44, -2.85, -11.66, 3, -1.98, -11.81, -1.26, -11.65, 
	-0.78, -11.48, 0, 1, -15.24, -11.29, 3, -15.97, -10.74, -14.34, -9.87, -15.33, -9.50, 3, -15.11, -9.78, 
	-15.55, -9.98, -15.80, -10.07, 3, -15.90, -10.52, -15.65, -10.86, -15.90, -11.29, 3, -15.83, -11.63, 
	-15.35, -11.44, -15.24, -11.29, 0, 1, -10.83, -11.48, 3, -10.87, -11.18, -10.54, -11.26, -10.64, -10.91, 
	3, -11.17, -10.64, -12.06, -10.89, -12.61, -11.01, 3, -12.45, -11.64, -11.24, -11.36, -10.83, -11.48, 
	0, 1, -18.24, -10.63, 3, -18.18, -10.16, -18.49, -10.07, -18.71, -9.88, 3, -19.36, -9.82, -19.38, -10.13, 
	-19.93, -9.97, 3, -19.87, -10.70, -18.71, -10.31, -18.24, -10.63, 0, 1, 5.60, -10.26, 3, 5.71, -9.63, 
	6.12, -8.85, 6.54, -8.47, 3, 6.51, -7.81, 6.45, -7.52, 6.82, -7.16, 3, 6.35, -6.66, 6.23, -7.79, 5.88, 
	-8.00, 3, 5.97, -8.13, 5.97, -8.35, 6.07, -8.47, 3, 5.91, -8.79, 5.75, -8.53, 5.41, -8.66, 3, 5.33, 
	-9.13, 5.36, -9.21, 5.60, -9.51, 3, 5.52, -9.64, 5.36, -9.71, 5.13, -9.69, 3, 5.16, -10.01, 5.55, -9.96, 
	5.60, -10.26, 0, 1, -21.15, -9.60, 3, -21.48, -9.55, -21.56, -9.75, -21.71, -9.88, 3, -21.61, -10.26, 
	-21.04, -10.00, -21.15, -9.60, 0, 1, -24.16, -9.97, 3, -24.08, -9.92, -24.00, -9.88, -23.87, -9.88, 
	3, -23.69, -9.44, -24.28, -9.35, -23.87, -9.22, 3, -24.31, -8.91, -24.44, -9.72, -24.16, -9.97, 0, 1, 
	-11.20, -9.79, 3, -11.11, -9.79, -11.02, -9.79, -10.92, -9.79, 3, -10.98, -9.18, -10.85, -8.97, -11.11, 
	-8.57, 3, -11.28, -8.55, -11.31, -8.68, -11.48, -8.66, 3, -11.20, -9.24, -11.38, -9.19, -11.20, -9.79, 
	0, 1, 1.47, -9.69, 3, 1.47, -9.57, 1.47, -9.44, 1.47, -9.32, 3, 1.17, -9.21, 1.24, -9.46, 1.09, -9.51, 
	3, 1.15, -9.63, 1.29, -9.68, 1.47, -9.69, 0, 1, 15.92, -9.13, 3, 15.89, -8.94, 15.67, -8.95, 15.64, 
	-8.75, 3, 15.90, -8.64, 15.81, -8.17, 16.11, -8.10, 3, 16.13, -7.83, 16.12, -7.58, 15.83, -7.63, 3, 
	15.54, -7.89, 15.95, -8.30, 15.45, -8.38, 3, 15.57, -8.79, 15.48, -8.79, 15.36, -9.13, 3, 15.63, -9.21, 
	15.65, -9.21, 15.92, -9.13, 0, 1, 10.48, -8.66, 3, 10.65, -8.49, 10.69, -8.19, 10.76, -7.91, 3, 10.39, 
	-7.92, 10.24, -8.14, 10.01, -8.28, 3, 9.80, -8.21, 9.64, -8.09, 9.35, -8.10, 3, 9.39, -8.26, 9.28, -8.27, 
	9.16, -8.28, 3, 9.45, -8.66, 9.92, -8.79, 10.48, -8.66, 0, 1, -3.79, -8.57, 3, -3.56, -8.51, -3.59, 
	-8.20, -3.22, -8.28, 3, -3.63, -8.17, -3.33, -7.85, -3.51, -7.63, 3, -3.05, -7.52, -3.18, -6.82, -2.66, 
	-6.78, 3, -2.87, -6.68, -2.84, -6.33, -3.22, -6.41, 3, -3.33, -6.81, -3.35, -7.28, -3.79, -7.35, 3, 
	-3.56, -7.73, -4.26, -8.21, -3.79, -8.57, 0, 1, -10.45, -8.28, 3, -10.62, -7.75, -10.18, -7.64, -10.64, 
	-7.35, 3, -10.42, -7.19, -10.42, -6.82, -10.08, -6.78, 3, -10.23, -6.53, -10.05, -5.94, -10.45, -5.94, 
	3, -10.45, -6.03, -10.45, -6.13, -10.45, -6.22, 3, -11.26, -6.58, -10.99, -7.44, -11.39, -8.19, 3, -10.88, 
	-8.23, -10.90, -8.25, -10.45, -8.28, 0, 1, 1.19, -8.10, 3, 1.59, -7.95, 1.85, -8.22, 2.13, -7.91, 3, 
	2.39, -7.93, 2.24, -8.35, 2.59, -8.28, 3, 2.71, -8.09, 2.98, -7.76, 2.78, -7.53, 3, 2.11, -7.75, 1.39, 
	-7.20, 0.72, -7.63, 3, 0.77, -7.88, 1.20, -7.77, 1.19, -8.10, 0, 1, 0.53, -7.53, 3, 0.13, -7.50, 0.28, 
	-7.88, 0.34, -8.10, 3, 0.57, -8.13, 0.55, -7.93, 0.81, -8.00, 3, 0.70, -7.86, 0.69, -7.62, 0.53, -7.53, 
	0, 1, -6.88, -7.63, 3, -7.34, -7.66, -7.44, -7.54, -8.01, -7.72, 3, -7.90, -8.05, -6.99, -7.89, -6.88, 
	-7.63, 0, 1, -0.41, -7.91, 3, -0.11, -7.99, -0.28, -7.60, -0.03, -7.63, 3, -0.21, -7.31, -0.36, -7.79, 
	-0.60, -7.72, 3, -0.57, -7.82, -0.41, -7.78, -0.41, -7.91, 0, 1, -19.46, -6.41, 3, -19.15, -5.96, -18.67, 
	-5.70, -18.81, -4.81, 3, -19.88, -5.19, -19.09, -6.36, -20.12, -6.69, 3, -19.95, -7.03, -19.91, -7.12, 
	-20.31, -7.25, 3, -20.10, -8.38, -18.84, -6.91, -19.46, -6.41, 0, 1, -16.74, -7.25, 3, -16.33, -7.29, 
	-16.60, -6.80, -16.46, -6.78, 3, -16.83, -6.45, -17.05, -7.05, -16.74, -7.25, 0, 1, 20.43, -5.66, 3, 
	20.75, -5.51, 20.55, -4.84, 20.80, -4.62, 3, 20.64, -4.66, 20.63, -4.55, 20.62, -4.44, 3, 20.44, -4.48, 
	20.38, -4.64, 20.15, -4.62, 3, 20.17, -5.05, 20.25, -5.08, 20.15, -5.47, 3, 20.22, -5.55, 20.40, -5.52, 
	20.43, -5.66, 0, 1, -6.42, -4.16, 3, -6.36, -4.05, -6.05, -4.14, -5.85, -3.97, 3, -6.08, -3.70, -5.93, 
	-3.44, -5.76, -3.03, 3, -6.74, -3.17, -6.48, -4.56, -7.26, -4.91, 3, -7.32, -5.24, -7.15, -5.36, -7.07, 
	-5.56, 3, -6.49, -5.39, -6.32, -4.81, -6.13, -4.25, 3, -6.29, -4.27, -6.30, -4.16, -6.42, -4.16, 0, 
	1, 15.64, -5.28, 3, 15.82, -5.24, 15.81, -5.01, 16.11, -5.09, 3, 16.14, -4.98, 15.84, -4.77, 15.83, 
	-5.00, 3, 15.74, -5.00, 15.76, -4.88, 15.73, -4.81, 3, 15.45, -4.93, 15.44, -5.08, 15.64, -5.28, 0, 
	1, 17.42, -5.28, 3, 17.31, -5.02, 16.96, -4.99, 16.67, -4.91, 3, 16.72, -5.44, 17.10, -5.13, 17.42, 
	-5.28, 0, 1, 8.51, -5.09, 3, 8.61, -4.88, 8.67, -4.63, 8.98, -4.62, 3, 8.70, -4.53, 7.97, -4.49, 7.66, 
	-4.72, 3, 7.73, -5.10, 8.36, -5.06, 8.51, -5.09, 0, 1, 14.33, -5.09, 3, 14.25, -4.83, 14.46, -4.85, 
	14.42, -4.62, 3, 14.30, -4.50, 13.98, -4.50, 13.86, -4.62, 3, 13.80, -4.99, 14.07, -5.04, 14.33, -5.09, 
	0, 1, 4.85, -4.91, 3, 5.18, -4.58, 5.93, -4.68, 6.35, -4.44, 3, 6.05, -4.07, 5.04, -4.09, 4.66, -4.34, 
	3, 4.73, -4.52, 4.82, -4.69, 4.85, -4.91, 0, 1, -0.60, -4.25, 3, -0.33, -4.30, -0.46, -4.74, -0.03, 
	-4.62, 3, 0.09, -3.54, -1.35, -4.52, -2.19, -3.87, 3, -2.49, -3.79, -2.32, -4.18, -2.57, -4.16, 3, -2.80, 
	-4.04, -3.07, -3.97, -3.04, -3.59, 3, -3.79, -3.43, -3.88, -3.93, -4.35, -4.06, 3, -3.71, -4.56, -2.91, 
	-4.24, -2.19, -4.25, 3, -1.61, -4.26, -0.88, -4.88, -0.60, -4.25, 0, 1, -9.89, -4.34, 3, -9.61, -4.37, 
	-9.60, -4.13, -9.33, -4.15, 3, -9.40, -3.88, -9.77, -3.91, -9.70, -3.50, 3, -10.19, -3.54, -10.52, -3.70, 
	-10.83, -3.69, 3, -10.84, -3.77, -10.79, -3.77, -10.73, -3.78, 3, -10.73, -3.84, -10.73, -3.90, -10.73, 
	-3.97, 3, -10.62, -3.86, -10.56, -3.70, -10.26, -3.78, 3, -10.03, -3.85, -10.02, -4.17, -9.89, -4.34, 
	0, 1, -14.58, -3.87, 3, -14.36, -3.81, -14.19, -3.70, -14.21, -3.40, 3, -14.50, -3.39, -14.53, -3.65, 
	-14.58, -3.87, 0, 1, 6.35, -2.84, 3, 7.02, -2.63, 7.54, -1.64, 6.54, -1.43, 3, 6.38, -1.78, 6.27, -2.15, 
	6.16, -2.75, 3, 6.27, -2.73, 6.33, -2.77, 6.35, -2.84, 0, 1, 3.16, -2.47, 3, 3.22, -2.12, 3.01, -2.05, 
	2.69, -2.09, 3, 2.81, -2.25, 2.88, -2.46, 3.16, -2.47, 0, 1, 17.61, -2.37, 3, 17.70, -2.37, 17.80, -2.37, 
	17.89, -2.37, 3, 18.29, -1.60, 18.13, -0.90, 18.17, -0.12, 3, 17.87, -0.11, 17.82, 0.15, 17.42, 0.07, 
	3, 17.66, -0.95, 17.30, -1.43, 17.61, -2.37, 0, 1, 10.20, -2.00, 3, 11.27, -1.63, 11.83, -1.58, 12.92, 
	-1.25, 3, 13.35, -1.45, 13.26, -1.52, 13.76, -1.34, 3, 13.81, -1.20, 13.65, -0.85, 13.86, -0.87, 3, 
	13.26, -1.10, 12.21, -0.83, 11.42, -0.50, 3, 11.54, -0.87, 11.11, -0.69, 11.23, -1.06, 3, 11.02, -1.12, 
	10.93, -0.79, 10.95, -1.15, 3, 10.51, -1.02, 9.17, -0.74, 9.16, -1.53, 3, 9.48, -1.55, 9.78, -1.75, 
	9.92, -1.43, 3, 9.99, -1.64, 10.23, -1.69, 10.20, -2.00, 0, 1, 22.02, -1.81, 3, 21.55, -1.73, 21.52, 
	-1.70, 21.18, -1.43, 3, 21.18, -1.56, 21.18, -1.68, 21.18, -1.81, 3, 21.47, -1.98, 21.76, -2.03, 22.02, 
	-1.81, 0, 1, 5.41, -1.71, 3, 5.79, -1.59, 5.13, -1.27, 5.41, -1.24, 3, 5.25, -0.97, 4.87, -1.26, 4.94, 
	-1.53, 3, 5.00, -1.69, 5.39, -1.52, 5.41, -1.71, 0, 1, -9.42, -1.53, 3, -9.14, -1.49, -9.10, -1.22, 
	-8.86, -1.15, 3, -8.81, -0.85, -9.32, -1.12, -9.23, -0.78, 3, -9.35, -0.94, -9.55, -1.02, -9.51, -1.34, 
	3, -9.42, -1.34, -9.44, -1.45, -9.42, -1.53, 0, 1, 6.72, -1.34, 3, 7.06, -1.24, 7.20, -0.94, 7.29, -0.59, 
	3, 6.91, -0.68, 7.25, -0.06, 6.91, -0.12, 3, 7.09, 0.07, 7.09, 0.45, 7.57, 0.35, 3, 7.33, 0.79, 7.21, 
	0.99, 7.47, 1.48, 3, 7.21, 1.33, 7.05, 1.72, 7.29, 1.76, 3, 7.27, 1.96, 6.89, 1.80, 6.72, 1.85, 3, 6.76, 
	1.54, 7.00, 1.45, 7.19, 1.29, 3, 7.07, 0.78, 6.27, -0.10, 6.91, -0.49, 3, 6.83, -0.63, 6.61, -0.63, 
	6.44, -0.68, 3, 6.39, -1.05, 6.68, -1.07, 6.72, -1.34, 0, 1, 14.05, -1.34, 3, 14.56, -1.41, 14.78, -1.20, 
	15.08, -1.06, 3, 15.02, -0.68, 14.86, -0.40, 14.42, -0.40, 3, 14.44, -0.85, 14.03, -0.89, 14.05, -1.34, 
	0, 1, 2.03, -1.24, 3, 2.45, -0.80, 3.22, -1.58, 3.72, -1.06, 3, 3.66, -0.99, 3.32, -0.76, 3.72, -0.78, 
	3, 3.47, -0.25, 2.86, -0.59, 2.22, -0.40, 3, 2.18, -0.63, 2.65, -0.35, 2.50, -0.68, 3, 2.11, -0.94, 
	1.31, -0.07, 1.00, -0.78, 3, 1.04, -1.40, 1.97, -0.82, 2.03, -1.24, 0, 1, -2.01, -1.15, 3, -1.66, -0.90, 
	-1.40, -0.57, -1.25, -0.12, 3, -1.54, 0.10, -2.05, -0.09, -2.29, -0.21, 3, -2.14, -0.51, -2.25, -0.63, 
	-2.29, -0.96, 3, -2.21, -1.04, -2.03, -1.02, -2.01, -1.15, 0, 1, -9.23, -0.68, 3, -9.07, -0.60, -8.96, 
	-0.46, -8.76, -0.40, 3, -8.91, -0.27, -8.88, 0.05, -9.23, -0.03, 3, -9.23, -0.15, -9.23, -0.28, -9.23, 
	-0.40, 3, -9.31, -0.42, -9.32, -0.36, -9.33, -0.31, 3, -9.61, -0.40, -9.22, -0.56, -9.23, -0.68, 0, 
	1, -5.76, -0.68, 3, -5.51, -0.45, -5.44, -0.63, -5.20, -0.40, 3, -5.18, -0.27, -5.67, -0.21, -5.38, 
	-0.12, 3, -5.66, 0.23, -5.92, -0.57, -5.76, -0.68, 0, 1, -6.32, -0.59, 3, -6.36, -0.41, -7.05, -0.09, 
	-7.07, -0.49, 3, -6.94, -0.64, -6.59, -0.58, -6.32, -0.59, 0, 1, -12.05, -0.02, 3, -11.87, -0.02, -11.98, 
	0.29, -11.77, 0.26, 3, -11.95, 0.48, -12.27, 0.57, -12.42, 0.82, 3, -12.56, 0.67, -12.91, 0.75, -12.89, 
	0.45, 3, -12.58, 0.36, -12.15, 0.46, -12.05, -0.02, 0, 1, -8.76, -0.02, 3, -8.54, 0.14, -8.74, 0.68, 
	-9.04, 0.63, 3, -9.28, 0.37, -8.94, 0.12, -8.76, -0.02, 0, 1, -13.17, 0.16, 3, -12.97, 0.15, -13.13, 
	0.50, -13.08, 0.63, 3, -13.20, 0.63, -13.33, 0.63, -13.45, 0.63, 3, -13.47, 0.37, -13.17, 0.41, -13.17, 
	0.16, 0, 1, -1.63, 0.16, 3, -1.55, 0.22, -1.46, 0.28, -1.44, 0.16, 3, -1.28, 0.19, -1.23, 0.32, -1.25, 
	0.54, 3, -1.45, 0.31, -1.67, 0.62, -1.82, 0.44, 3, -1.78, 0.32, -1.65, 0.30, -1.63, 0.16, 0, 1, 11.79, 
	2.88, 3, 12.02, 2.91, 12.25, 2.48, 12.45, 2.79, 3, 12.45, 3.07, 12.01, 3.11, 11.89, 2.98, 3, 12.03, 
	3.21, 12.31, 3.31, 12.54, 3.45, 3, 12.54, 3.79, 12.10, 3.70, 12.26, 4.20, 3, 11.64, 3.98, 12.00, 3.35, 
	11.60, 2.98, 3, 12.22, 2.17, 10.93, 1.09, 11.98, 0.73, 3, 11.76, 1.15, 11.87, 1.26, 12.26, 1.48, 3, 
	12.37, 2.25, 12.27, 2.56, 11.79, 2.88, 0, 1, -18.24, 0.82, 3, -17.88, 0.87, -17.98, 1.37, -17.59, 1.38, 
	3, -17.60, 1.72, -17.90, 1.76, -18.24, 1.76, 3, -18.28, 1.67, -18.32, 1.59, -18.43, 1.57, 3, -18.48, 
	1.20, -18.35, 1.02, -18.24, 0.82, 0, 1, -7.07, 1.10, 3, -6.97, 1.31, -6.83, 1.49, -6.88, 1.85, 3, -7.52, 
	1.89, -7.95, 1.11, -7.07, 1.10, 0, 1, 29.06, 1.20, 3, 29.39, 1.20, 29.43, 1.81, 29.34, 1.95, 3, 29.12, 
	1.77, 29.21, 1.58, 29.06, 1.20, 0, 1, 3.16, 1.48, 3, 3.08, 1.89, 3.28, 2.04, 3.25, 2.41, 3, 3.18, 2.37, 
	3.10, 2.32, 2.97, 2.32, 3, 2.99, 2.95, 3.06, 3.08, 2.88, 3.54, 3, 3.08, 3.56, 3.17, 3.47, 3.16, 3.26, 
	3, 3.60, 3.57, 3.41, 4.95, 2.78, 5.04, 3, 3.05, 4.55, 2.59, 4.07, 2.31, 3.82, 3, 2.19, 3.22, 2.69, 2.73, 
	2.22, 2.23, 3, 2.30, 1.74, 2.69, 1.57, 3.16, 1.48, 0, 1, 21.27, 1.85, 3, 21.29, 2.12, 21.28, 2.37, 20.99, 
	2.32, 3, 20.87, 2.05, 20.94, 1.89, 21.27, 1.85, 0, 1, 18.27, 1.95, 3, 18.60, 1.96, 18.07, 2.26, 18.36, 
	2.23, 3, 18.34, 2.33, 18.18, 2.29, 18.17, 2.41, 3, 18.01, 2.43, 17.98, 2.30, 17.80, 2.32, 3, 17.80, 
	2.04, 18.27, 2.23, 18.27, 1.95, 0, 1, -5.20, 2.41, 3, -5.25, 2.84, -5.18, 3.29, -4.82, 3.73, 3, -4.95, 
	3.85, -4.86, 4.19, -5.10, 4.20, 3, -5.06, 4.44, -4.82, 4.48, -4.82, 4.76, 3, -4.92, 4.85, -5.01, 4.95, 
	-5.10, 5.04, 3, -5.66, 4.84, -5.26, 4.01, -5.85, 4.01, 3, -5.51, 3.52, -5.99, 2.55, -5.20, 2.41, 0, 
	1, 21.55, 3.07, 3, 20.87, 3.08, 21.04, 3.94, 20.62, 4.20, 3, 20.07, 3.71, 21.22, 1.84, 21.55, 3.07, 
	0, 1, 7.19, 2.88, 3, 7.08, 3.19, 6.71, 2.98, 6.54, 2.98, 3, 6.69, 2.86, 7.05, 2.73, 7.19, 2.88, 0, 1, 
	-2.19, 2.88, 3, -1.90, 3.40, -1.19, 2.95, -0.97, 3.45, 3, -1.27, 3.44, -1.49, 3.64, -1.91, 3.73, 3, 
	-1.99, 3.27, -2.35, 3.35, -2.66, 3.54, 3, -2.63, 3.20, -2.26, 3.19, -2.19, 2.88, 0, 1, -12.99, 3.17, 
	3, -12.52, 3.58, -12.62, 4.21, -12.70, 5.04, 3, -12.95, 4.86, -13.22, 4.60, -13.08, 4.29, 3, -12.47, 
	4.63, -13.22, 3.31, -12.99, 3.17, 0, 1, 16.02, 4.20, 3, 15.87, 4.43, 15.70, 4.63, 15.36, 4.67, 3, 15.48, 
	4.41, 15.65, 4.21, 16.02, 4.20, 0, 1, 26.25, 4.67, 3, 26.46, 4.64, 26.61, 4.68, 26.72, 4.76, 3, 26.73, 
	4.93, 26.60, 4.96, 26.62, 5.14, 3, 26.45, 5.03, 26.17, 5.03, 26.25, 4.67, 0, 1, -12.61, 5.14, 3, -12.42, 
	5.16, -12.43, 5.39, -12.23, 5.42, 3, -12.31, 5.56, -12.47, 5.62, -12.70, 5.61, 3, -12.73, 5.39, -12.69, 
	5.25, -12.61, 5.14, 0, 1, 26.25, 5.42, 3, 26.70, 5.58, 26.66, 6.50, 26.15, 6.73, 3, 25.96, 6.52, 26.50, 
	6.00, 26.15, 5.89, 3, 26.07, 5.62, 26.28, 5.65, 26.25, 5.42, 0, 1, 22.68, 5.79, 3, 22.64, 6.00, 22.22, 
	5.83, 22.02, 5.89, 3, 22.20, 5.66, 22.47, 5.52, 22.68, 5.79, 0, 1, 8.41, 5.70, 3, 8.34, 5.97, 8.55, 
	5.94, 8.51, 6.17, 3, 8.32, 6.26, 8.06, 6.48, 7.85, 6.26, 3, 7.85, 5.89, 8.04, 5.70, 8.41, 5.70, 0, 1, 
	20.99, 5.70, 3, 21.23, 5.81, 21.63, 5.75, 21.65, 6.08, 3, 21.47, 5.91, 20.88, 6.16, 20.99, 5.70, 0, 
	1, -0.88, 6.26, 3, -0.80, 6.34, -0.67, 6.37, -0.50, 6.36, 3, -0.47, 6.67, -0.96, 6.46, -0.78, 6.92, 
	3, -0.48, 7.04, -0.71, 6.62, -0.41, 6.73, 3, -0.41, 7.41, -0.10, 7.80, 0.15, 8.52, 3, -0.08, 8.68, -0.07, 
	9.08, 0.06, 9.36, 3, -0.05, 9.47, -0.27, 9.47, -0.50, 9.46, 3, -0.34, 8.41, -1.43, 7.53, -0.88, 6.26, 
	0, 1, 12.17, 6.36, 3, 12.36, 6.41, 12.82, 6.21, 12.73, 6.55, 3, 12.54, 6.49, 12.08, 6.70, 12.17, 6.36, 
	0, 1, 8.13, 6.55, 3, 8.20, 6.76, 8.53, 6.71, 8.70, 6.83, 3, 8.69, 7.11, 8.08, 7.05, 7.94, 6.92, 3, 7.95, 
	6.73, 8.20, 6.80, 8.13, 6.55, 0, 1, 3.25, 6.73, 3, 3.51, 6.69, 3.34, 7.08, 3.53, 7.11, 3, 3.28, 7.20, 
	3.17, 7.43, 2.88, 7.48, 3, 2.77, 7.37, 2.61, 7.31, 2.69, 7.01, 3, 3.00, 7.18, 3.10, 6.96, 3.25, 6.73, 
	0, 1, 6.44, 6.73, 3, 6.54, 7.12, 6.00, 7.23, 6.07, 6.83, 3, 6.15, 6.75, 6.28, 6.73, 6.44, 6.73, 0, 1, 
	5.50, 7.11, 3, 5.08, 7.27, 4.51, 7.54, 4.10, 7.20, 3, 3.99, 7.22, 4.02, 7.37, 4.00, 7.48, 3, 3.74, 7.56, 
	3.76, 7.35, 3.53, 7.39, 3, 3.98, 6.78, 4.94, 6.74, 5.50, 7.11, 0, 1, 18.08, 6.92, 3, 18.28, 6.98, 18.35, 
	7.15, 18.64, 7.11, 3, 18.62, 7.17, 18.41, 7.47, 18.64, 7.48, 3, 18.37, 7.75, 18.08, 7.24, 18.08, 6.92, 
	0, 1, 9.07, 7.39, 3, 8.82, 7.81, 8.98, 8.02, 9.07, 8.52, 3, 8.40, 8.53, 8.20, 8.08, 8.13, 7.48, 3, 8.51, 
	7.52, 8.65, 7.32, 9.07, 7.39, 0, 1, 30.38, 7.67, 3, 30.36, 7.78, 30.40, 7.84, 30.47, 7.86, 3, 30.33, 
	8.01, 30.09, 8.04, 30.19, 8.42, 3, 29.90, 8.43, 29.95, 8.09, 29.91, 7.86, 3, 30.08, 7.82, 30.14, 7.66, 
	30.38, 7.67, 0, 1, -17.21, 7.86, 3, -16.94, 7.78, -16.97, 7.99, -16.74, 7.95, 3, -16.66, 8.25, -16.98, 
	8.15, -17.02, 8.33, 3, -17.23, 8.31, -17.22, 8.09, -17.21, 7.86, 0, 1, -12.52, 8.05, 3, -12.79, 8.24, 
	-13.54, 8.65, -13.83, 8.23, 3, -13.50, 7.86, -13.15, 8.09, -12.52, 8.05, 0, 1, -16.46, 8.42, 3, -16.55, 
	8.64, -16.78, 8.72, -17.11, 8.70, 3, -17.09, 8.41, -16.73, 8.18, -16.46, 8.42, 0, 1, 30.38, 8.42, 3, 
	30.71, 8.49, 30.49, 8.85, 30.28, 8.89, 3, 30.33, 9.14, 30.80, 9.21, 30.56, 9.45, 3, 30.27, 9.46, 30.30, 
	9.16, 29.91, 9.27, 3, 29.79, 9.03, 30.12, 8.81, 29.91, 8.80, 3, 30.06, 8.67, 30.28, 8.60, 30.38, 8.42, 
	0, 1, 13.86, 8.61, 3, 13.95, 8.83, 14.36, 8.73, 14.23, 9.17, 3, 13.84, 9.25, 13.68, 8.81, 13.86, 8.61, 
	0, 1, 26.43, 9.55, 3, 26.04, 9.41, 25.64, 9.28, 25.40, 8.99, 3, 25.90, 8.97, 26.47, 8.36, 26.43, 9.55, 
	0, 1, -16.74, 8.80, 3, -16.40, 8.80, -16.60, 9.35, -16.18, 9.27, 3, -16.22, 9.48, -16.67, 9.34, -16.74, 
	9.27, 3, -16.74, 9.11, -16.74, 8.95, -16.74, 8.80, 0, 1, 22.02, 8.89, 3, 22.09, 9.32, 22.60, 9.50, 22.40, 
	9.92, 3, 22.10, 9.85, 21.99, 9.58, 21.74, 9.45, 3, 21.74, 9.17, 21.98, 9.14, 22.02, 8.89, 0, 1, 24.84, 
	9.45, 3, 24.45, 9.68, 24.31, 9.36, 23.90, 9.36, 3, 23.99, 9.00, 24.88, 8.93, 24.84, 9.45, 0, 1, 4.66, 
	9.45, 3, 5.02, 9.61, 4.76, 9.81, 5.13, 9.92, 3, 4.87, 10.21, 5.06, 10.42, 5.13, 10.58, 3, 5.06, 10.83, 
	4.59, 10.67, 4.57, 10.96, 3, 4.94, 11.03, 5.07, 11.03, 5.22, 11.52, 3, 4.59, 11.48, 4.52, 11.09, 4.10, 
	10.67, 3, 4.09, 10.27, 4.07, 9.83, 4.19, 9.55, 3, 4.33, 9.50, 4.67, 9.66, 4.66, 9.45, 0, 1, 14.51, 9.83, 
	3, 14.92, 10.07, 14.58, 10.68, 14.89, 10.86, 3, 14.93, 11.12, 14.38, 10.79, 14.42, 11.05, 3, 14.06, 
	10.79, 14.41, 10.40, 14.23, 10.02, 3, 14.31, 9.94, 14.49, 9.96, 14.51, 9.83, 0, 1, -4.54, 10.02, 3, 
	-4.26, 10.45, -3.71, 10.63, -3.51, 11.14, 3, -4.25, 11.85, -4.98, 10.50, -4.54, 10.02, 0, 1, 1.37, 10.49, 
	3, 1.35, 10.61, 1.19, 10.58, 1.19, 10.49, 3, 1.06, 10.52, 1.11, 10.72, 1.09, 10.86, 3, 0.74, 10.87, 
	0.33, 10.93, 0.44, 10.49, 3, 0.85, 10.59, 1.12, 10.26, 1.37, 10.49, 0, 1, 0.15, 10.58, 3, -0.06, 10.95, 
	0.28, 10.92, 0.53, 11.05, 3, 0.18, 11.49, -0.46, 10.85, -0.88, 11.05, 3, -0.76, 10.65, -0.36, 10.30, 
	0.15, 10.58, 0, 1, -12.70, 10.77, 3, -12.36, 10.68, -12.61, 11.17, -12.42, 11.24, 3, -12.17, 11.27, 
	-12.51, 10.71, -12.14, 10.86, 3, -11.97, 11.42, -11.93, 11.39, -11.77, 11.99, 3, -11.97, 11.88, -12.15, 
	11.75, -12.52, 11.80, 3, -12.56, 11.54, -12.17, 11.71, -12.14, 11.52, 3, -12.27, 11.37, -12.47, 11.28, 
	-12.71, 11.24, 3, -12.70, 11.08, -12.70, 10.92, -12.70, 10.77, 0, 1, -7.54, 10.96, 3, -7.71, 11.51, 
	-8.22, 11.30, -8.67, 11.43, 3, -8.66, 11.26, -8.78, 11.23, -8.76, 11.05, 3, -8.38, 11.11, -8.00, 10.56, 
	-7.54, 10.96, 0, 1, 26.25, 10.96, 3, 26.70, 11.07, 27.20, 11.12, 27.28, 11.61, 3, 27.22, 11.77, 26.83, 
	11.61, 26.81, 11.80, 3, 26.63, 11.76, 26.73, 11.44, 26.43, 11.52, 3, 26.80, 11.10, 26.28, 11.41, 26.25, 
	10.96, 0, 1, -9.61, 11.05, 3, -9.26, 11.08, -8.87, 11.06, -8.86, 11.43, 3, -9.26, 11.45, -9.61, 11.43, 
	-9.61, 11.05, 0, 1, -3.60, 11.52, 3, -3.31, 11.63, -3.16, 11.51, -2.85, 11.71, 3, -3.10, 11.90, -3.61, 
	11.99, -3.60, 11.52, 0, 1, 27.00, 12.08, 3, 27.23, 11.80, 27.58, 12.18, 27.75, 12.27, 3, 27.57, 12.86, 
	28.15, 13.62, 27.28, 13.77, 3, 27.16, 13.06, 27.48, 12.47, 27.00, 12.08, 0, 1, 0.44, 13.21, 3, 1.15, 
	13.43, 1.49, 14.04, 1.47, 14.99, 3, 0.47, 14.84, 0.54, 14.18, 0.44, 13.21, 0, 1, 9.45, 13.30, 3, 9.45, 
	13.21, 9.56, 13.23, 9.63, 13.21, 3, 9.70, 13.21, 9.76, 13.21, 9.82, 13.21, 3, 9.66, 13.39, 9.83, 13.90, 
	9.35, 13.77, 3, 9.32, 13.58, 9.37, 13.48, 9.54, 13.49, 3, 9.55, 13.38, 9.52, 13.32, 9.45, 13.30, 0, 
	1, 6.91, 13.49, 3, 7.16, 13.46, 7.15, 13.69, 7.19, 13.87, 3, 6.73, 14.10, 7.08, 14.37, 6.44, 14.43, 
	3, 6.33, 14.31, 6.41, 14.28, 6.44, 14.15, 3, 5.93, 14.22, 5.60, 14.61, 5.13, 14.24, 3, 5.80, 13.79, 
	6.65, 14.39, 6.91, 13.49, 0, 1, -7.35, 13.68, 3, -7.19, 13.67, -7.16, 13.79, -6.98, 13.77, 3, -7.10, 
	14.27, -6.76, 14.30, -6.51, 14.43, 3, -6.52, 14.86, -6.43, 15.38, -6.70, 15.56, 3, -6.99, 15.33, -7.47, 
	14.66, -7.07, 14.33, 3, -7.26, 14.21, -7.44, 14.07, -7.35, 13.68, 0, 1, 9.91, 13.87, 3, 10.01, 13.87, 
	10.10, 13.87, 10.20, 13.87, 3, 10.32, 14.36, 10.59, 14.55, 10.38, 14.99, 3, 9.97, 15.03, 10.19, 14.43, 
	9.73, 14.52, 3, 9.72, 14.23, 9.84, 14.07, 9.91, 13.87, 0, 1, -2.57, 14.81, 3, -2.84, 14.82, -3.08, 14.82, 
	-3.04, 14.52, 3, -2.93, 14.42, -2.48, 14.44, -2.57, 14.81, 0, 1, -2.10, 14.43, 3, -1.80, 14.53, -1.89, 
	14.44, -1.54, 14.43, 3, -1.51, 14.76, -2.02, 14.85, -2.19, 14.71, 3, -2.14, 14.64, -2.09, 14.56, -2.10, 
	14.43, 0, 1, -11.11, 15.27, 3, -11.11, 15.40, -11.11, 15.52, -11.11, 15.65, 3, -11.52, 15.78, -11.45, 
	15.42, -11.67, 15.37, 3, -11.59, 15.03, -11.44, 15.36, -11.11, 15.27, 0, 1, 22.59, 15.84, 3, 22.91, 
	15.80, 23.11, 15.87, 23.34, 15.93, 3, 22.93, 16.05, 23.39, 17.52, 23.90, 17.34, 3, 23.72, 17.64, 23.48, 
	17.46, 23.15, 17.43, 3, 23.16, 16.81, 22.78, 16.37, 22.59, 15.84, 0, 1, 6.16, 16.31, 3, 6.67, 16.89, 
	6.27, 17.65, 6.82, 18.00, 3, 6.65, 18.19, 6.47, 18.02, 6.63, 18.37, 3, 6.40, 18.38, 6.18, 18.39, 6.07, 
	18.28, 3, 6.11, 17.80, 6.08, 17.72, 5.78, 17.34, 3, 6.04, 17.12, 6.12, 16.73, 6.16, 16.31, 0, 1, 25.50, 
	16.31, 3, 25.59, 16.31, 25.68, 16.31, 25.78, 16.31, 3, 25.83, 16.65, 26.00, 16.87, 25.87, 17.15, 3, 
	25.63, 16.88, 25.32, 16.76, 25.50, 16.31, 0, 1, 17.24, 17.25, 3, 17.46, 17.27, 17.59, 17.39, 17.89, 
	17.34, 3, 17.82, 17.56, 17.16, 17.67, 17.24, 17.25, 0, 1, 15.17, 17.53, 3, 15.68, 17.48, 15.89, 17.93, 
	15.73, 18.28, 3, 15.48, 18.09, 15.22, 17.91, 15.17, 17.53, 0, 1, 2.22, 18.09, 3, 1.98, 18.48, 1.87, 
	17.95, 1.37, 18.09, 3, 1.53, 17.73, 2.02, 17.94, 2.22, 18.09, 0, 1, -1.53, 18.00, 3, -1.55, 18.16, -1.42, 
	18.19, -1.44, 18.37, 3, -1.65, 18.50, -1.79, 18.13, -1.82, 18.37, 3, -2.05, 18.28, -1.74, 17.96, -1.53, 
	18.00, 0, 1, 19.21, 19.03, 3, 19.23, 19.27, 18.84, 19.10, 18.93, 19.40, 3, 18.71, 18.99, 18.16, 19.38, 
	18.08, 18.75, 3, 18.52, 18.45, 18.86, 18.93, 19.21, 19.03, 0, 1, 15.45, 19.22, 3, 15.63, 19.02, 15.85, 
	19.56, 15.83, 19.87, 3, 15.72, 19.79, 15.58, 19.75, 15.36, 19.78, 3, 15.19, 19.45, 15.67, 19.30, 15.45, 
	19.22, 0, 1, -9.98, 19.59, 3, -9.95, 19.46, -9.75, 19.51, -9.61, 19.50, 3, -9.62, 19.73, -9.63, 19.95, 
	-9.42, 19.97, 3, -9.43, 20.20, -9.74, 19.99, -9.79, 19.97, 3, -9.83, 20.13, -9.72, 20.14, -9.61, 20.16, 
	3, -9.69, 20.51, -9.95, 20.19, -10.07, 20.06, 3, -9.97, 20.03, -9.72, 19.69, -9.98, 19.59, 0, 1, 29.06, 
	19.78, 3, 29.10, 19.97, 29.00, 20.03, 28.97, 20.15, 3, 29.01, 20.24, 29.05, 20.32, 29.16, 20.34, 3, 
	28.79, 20.59, 28.93, 20.09, 28.59, 20.06, 3, 28.68, 19.90, 28.77, 19.73, 29.06, 19.78, 0, 1, 11.32, 
	21.19, 3, 11.48, 21.19, 11.57, 21.12, 11.60, 21.00, 3, 11.57, 21.59, 11.52, 22.01, 11.98, 22.59, 3, 
	11.63, 23.06, 11.53, 21.99, 11.32, 22.31, 3, 11.11, 22.22, 11.48, 21.84, 11.04, 21.84, 3, 11.01, 21.46, 
	11.14, 20.83, 10.76, 20.62, 3, 11.15, 20.19, 11.21, 20.84, 11.32, 21.19, 0, 1, 25.40, 20.53, 3, 25.57, 
	20.55, 25.61, 20.69, 25.59, 20.91, 3, 25.30, 21.03, 25.00, 20.97, 24.74, 20.91, 3, 24.91, 20.72, 25.40, 
	20.87, 25.40, 20.53, 0, 1, 2.97, 21.00, 3, 3.03, 21.22, 2.95, 21.49, 3.34, 21.56, 3, 3.26, 21.73, 3.31, 
	22.03, 3.16, 22.13, 3, 2.98, 21.89, 2.65, 21.68, 2.59, 21.09, 3, 2.68, 21.02, 2.81, 20.99, 2.97, 21.00, 
	0, 1, 7.38, 21.84, 3, 7.31, 22.15, 6.91, 22.13, 6.63, 22.22, 3, 6.75, 21.97, 7.04, 21.57, 7.38, 21.84, 
	0, 1, -0.41, 24.56, 3, -1.03, 24.56, -0.43, 24.10, -0.78, 24.09, 3, -0.59, 23.63, -0.21, 24.33, -0.41, 
	24.56, 0, 1, 17.52, 24.00, 3, 17.85, 23.95, 17.75, 24.33, 18.08, 24.28, 3, 17.87, 24.69, 18.53, 25.28, 
	17.80, 25.41, 3, 17.84, 24.96, 17.34, 24.65, 17.52, 24.00, 0, 1, 4.38, 24.75, 3, 4.37, 25.06, 3.91, 
	24.92, 4.00, 25.32, 3, 3.68, 25.29, 3.55, 25.08, 3.16, 25.13, 3, 3.33, 24.59, 3.96, 24.91, 4.38, 24.75, 
	0, 1, 12.17, 24.94, 3, 11.96, 25.30, 11.24, 25.23, 10.95, 25.03, 3, 11.28, 24.59, 11.68, 25.23, 12.17, 
	24.94, 0, 1, -8.01, 26.25, 3, -7.99, 26.52, -8.00, 26.77, -8.29, 26.72, 3, -8.49, 26.53, -8.29, 26.25, 
	-8.01, 26.25, 0, 1, 4.75, 28.69, 3, 5.08, 28.62, 5.17, 28.94, 5.03, 29.07, 3, 4.79, 29.10, 4.73, 28.94, 
	4.75, 28.69, 0, 1, -2.85, 29.16, 3, -2.58, 29.21, -2.56, 29.50, -2.19, 29.45, 3, -2.17, 29.52, -2.56, 
	29.77, -2.47, 30.01, 3, -2.57, 29.91, -2.84, 29.51, -2.94, 29.73, 3, -3.12, 29.72, -3.01, 29.42, -3.22, 
	29.45, 3, -3.16, 29.09, -2.91, 29.52, -2.85, 29.16, 0, 1, 1.37, 31.42, 3, 1.65, 31.76, 2.03, 32.01, 
	2.22, 32.45, 3, 1.99, 32.83, 1.63, 32.48, 1.37, 32.36, 3, 1.66, 31.95, 1.30, 32.03, 1.37, 31.42, 0, 
	1, 16.24, 27.60, 3, 16.50, 27.82, 16.11, 28.10, 16.33, 28.36, 3, 15.82, 28.36, 15.96, 27.77, 16.24, 
	27.60, 0, 1, 2.03, 32.73, 3, 2.36, 32.78, 2.47, 33.05, 2.69, 33.20, 3, 2.47, 33.42, 2.02, 33.06, 2.03, 
	32.73, 0, 1, 12.20, 31.17, 3, 12.47, 31.16, 12.42, 31.45, 12.67, 31.45, 3, 12.66, 31.72, 12.51, 31.85, 
	12.20, 31.83, 3, 12.08, 31.54, 12.23, 31.56, 12.20, 31.17, 0, 1, -1.07, 35.92, 3, -0.87, 36.07, -0.65, 
	36.19, -0.41, 36.30, 3, -0.37, 36.56, -0.76, 36.39, -0.78, 36.58, 3, -1.02, 36.33, -0.88, 36.26, -1.07, 
	35.92, 0, 1, 3.91, 37.77, 3, 4.08, 37.76, 4.11, 37.89, 4.28, 37.86, 3, 4.12, 37.95, 4.13, 38.21, 3.81, 
	38.15, 3, 3.80, 37.98, 3.93, 37.95, 3.91, 37.77, 0, 1, -13.92, -23.96, 3, -13.90, -24.09, -13.64, -23.99, 
	-13.64, -24.15, 3, -13.46, -24.08, -13.39, -23.90, -13.36, -23.68, 3, -13.54, -23.50, -13.53, -23.73, 
	-13.83, -23.68, 3, -13.47, -22.73, -13.31, -22.26, -13.27, -21.33, 3, -13.77, -21.09, -13.99, -21.78, 
	-14.49, -21.61, 3, -14.43, -21.84, -14.13, -21.82, -13.92, -21.89, 3, -13.79, -22.41, -14.11, -22.93, 
	-14.49, -23.21, 3, -14.29, -23.38, -14.11, -24.06, -13.92, -23.68, 3, -13.81, -23.70, -13.80, -23.96, 
	-13.92, -23.96, 0, 1, -17.30, -18.42, 3, -17.15, -18.61, -16.99, -18.80, -16.65, -18.80, 3, -16.68, 
	-18.42, -16.47, -18.38, -16.74, -18.23, 3, -16.76, -18.15, -16.70, -18.15, -16.65, -18.14, 3, -16.78, 
	-17.95, -17.15, -18.32, -17.30, -18.42, 0, 1, 5.13, -14.85, 3, 5.54, -14.70, 5.71, -14.31, 5.78, -13.82, 
	3, 5.67, -13.71, 5.45, -13.72, 5.22, -13.73, 3, 5.22, -14.01, 5.31, -14.21, 5.50, -14.29, 3, 5.38, -14.48, 
	4.90, -14.60, 5.13, -14.85, 0, 1, 0.25, -12.70, 3, 0.57, -12.65, 0.77, -12.73, 1.00, -12.79, 3, 1.37, 
	-12.04, 1.05, -10.89, 1.75, -10.54, 3, 1.50, -10.22, 1.26, -10.19, 1.28, -9.79, 3, 0.60, -9.83, 1.12, 
	-11.56, 0.43, -11.29, 3, 0.33, -11.61, 0.32, -12.17, 0.25, -12.70, 0, 1, -6.32, -11.29, 3, -6.66, -11.09, 
	-6.74, -11.33, -6.98, -11.48, 3, -5.90, -11.49, -4.22, -11.94, -3.23, -11.19, 3, -3.19, -10.85, -3.68, 
	-11.02, -3.69, -10.73, 3, -4.21, -11.11, -5.08, -11.07, -5.48, -10.73, 3, -5.76, -10.63, -5.64, -10.93, 
	-5.67, -11.10, 3, -5.94, -10.89, -6.12, -10.67, -6.32, -11.29, 0, 1, -14.67, -7.06, 3, -14.67, -6.97, 
	-14.67, -6.88, -14.67, -6.78, 3, -14.88, -6.99, -14.99, -6.70, -15.33, -6.78, 3, -15.15, -7.08, -14.97, 
	-6.84, -14.67, -7.06, 0, 1, 19.86, -6.22, 3, 19.88, -6.30, 19.96, -6.31, 19.96, -6.41, 3, 20.02, -6.41, 
	20.08, -6.41, 20.15, -6.41, 3, 19.97, -6.24, 20.23, -6.09, 20.33, -5.94, 3, 20.02, -5.51, 20.16, -6.32, 
	19.86, -6.22, 0, 1, -9.33, 4.01, 3, -9.38, 3.94, -9.42, 3.86, -9.42, 3.73, 3, -9.80, 4.08, -10.05, 3.80, 
	-10.27, 4.11, 3, -10.45, 4.10, -10.38, 3.85, -10.64, 3.92, 3, -10.02, 3.53, -9.18, 3.41, -8.39, 3.45, 
	3, -8.44, 3.59, -8.53, 3.68, -8.58, 3.82, 3, -9.21, 3.72, -9.23, 4.23, -9.80, 4.20, 3, -9.78, 3.99, 
	-9.56, 4.00, -9.33, 4.01, 0, 1, 18.17, 4.85, 3, 18.18, 4.68, 18.52, 4.93, 18.64, 4.95, 3, 18.56, 5.22, 
	18.52, 5.27, 18.74, 5.42, 3, 18.54, 5.73, 18.77, 6.20, 18.74, 6.73, 3, 18.52, 6.73, 18.46, 6.89, 18.17, 
	6.83, 3, 18.03, 6.54, 18.46, 6.21, 18.08, 6.26, 3, 18.20, 5.77, 18.59, 5.14, 18.17, 4.85, 0, 1, 4.00, 
	5.61, 3, 4.31, 5.51, 3.71, 5.87, 3.81, 6.17, 3, 3.91, 6.39, 4.44, 6.17, 4.38, 6.54, 3, 4.00, 6.64, 3.89, 
	6.37, 3.34, 6.54, 3, 3.36, 6.22, 3.42, 5.84, 2.97, 5.98, 3, 2.94, 5.76, 2.98, 5.62, 3.06, 5.51, 3, 3.16, 
	5.79, 3.63, 5.75, 3.63, 5.42, 3, 3.72, 5.58, 3.83, 6.05, 4.00, 5.61, 0, 1, 14.33, 6.45, 3, 14.46, 6.80, 
	14.07, 6.63, 14.14, 6.92, 3, 14.01, 6.86, 13.96, 6.72, 13.95, 6.55, 3, 13.68, 6.78, 13.25, 6.73, 13.01, 
	6.55, 3, 13.04, 6.33, 13.42, 6.45, 13.48, 6.26, 3, 13.68, 6.76, 13.98, 6.28, 14.33, 6.45, 0, 1, -8.20, 
	9.74, 3, -8.57, 8.82, -7.80, 7.79, -8.10, 7.11, 3, -8.09, 6.93, -7.79, 7.04, -7.82, 6.83, 3, -7.49, 
	6.96, -7.54, 7.49, -7.45, 7.86, 3, -7.74, 7.79, -7.63, 8.12, -7.92, 8.05, 3, -7.91, 8.29, -7.78, 8.41, 
	-7.54, 8.42, 3, -7.38, 9.27, -7.90, 9.44, -8.20, 9.83, 3, -8.31, 9.81, -8.25, 9.74, -8.20, 9.74, 0, 
	1, -5.38, 7.77, 3, -5.44, 7.37, -5.13, 7.33, -4.91, 7.20, 3, -4.62, 7.16, -4.67, 7.46, -4.45, 7.48, 
	3, -4.18, 7.36, -4.74, 7.29, -4.63, 7.01, 3, -4.41, 7.05, -4.43, 6.84, -4.16, 6.92, 3, -4.32, 7.45, 
	-3.62, 7.13, -3.69, 7.58, 3, -4.47, 7.85, -4.91, 7.23, -5.38, 7.77, 0, 1, 17.89, 9.64, 3, 18.38, 9.31, 
	18.91, 9.41, 19.21, 9.27, 3, 19.39, 9.45, 19.73, 9.80, 19.58, 10.02, 3, 19.30, 9.90, 19.12, 9.94, 19.02, 
	10.21, 3, 18.64, 9.93, 18.53, 10.20, 17.99, 10.21, 3, 18.03, 10.03, 17.92, 9.87, 17.89, 10.02, 3, 17.65, 
	9.99, 18.02, 9.86, 17.89, 9.64, 0, 1, 8.41, 10.58, 3, 8.64, 10.02, 9.22, 10.99, 9.35, 10.30, 3, 9.70, 
	10.33, 10.09, 10.31, 10.10, 10.68, 3, 9.75, 10.62, 9.56, 10.53, 9.45, 10.86, 3, 9.12, 10.57, 8.78, 10.69, 
	8.41, 10.58, 0, 1, 19.30, 12.46, 3, 19.50, 12.74, 19.28, 12.90, 19.39, 13.30, 3, 19.10, 13.06, 19.16, 
	12.81, 19.30, 12.46, 0, 1, -10.17, 18.56, 3, -10.06, 18.58, -10.12, 18.65, -10.17, 18.65, 3, -10.18, 
	18.96, -9.68, 19.44, -10.26, 19.50, 3, -10.12, 18.92, -10.57, 18.93, -10.64, 18.56, 3, -10.50, 18.63, 
	-10.24, 18.63, -10.17, 18.56, 0, 1, 20.33, 24.66, 3, 20.47, 24.27, 21.27, 24.13, 21.55, 24.19, 3, 21.50, 
	24.27, 21.45, 24.34, 21.46, 24.47, 3, 21.19, 24.24, 20.90, 24.53, 21.18, 24.75, 3, 21.06, 24.91, 20.60, 
	24.82, 20.33, 24.66, 0, 1, 7.66, 24.38, 3, 7.87, 24.17, 8.47, 25.11, 8.51, 25.69, 3, 7.56, 25.73, 8.12, 
	24.89, 7.57, 24.75, 3, 7.55, 24.63, 7.88, 24.40, 7.66, 24.38, 0, 1, -0.69, 24.94, 3, -0.70, 24.57, -0.21, 
	25.09, -0.03, 25.13, 3, -0.11, 25.33, -0.26, 25.46, -0.60, 25.41, 3, -0.64, 25.21, -0.53, 25.16, -0.50, 
	25.03, 3, -0.51, 24.94, -0.62, 24.96, -0.69, 24.94, 0, 1, -4.98, 21.11, 3, -4.88, 21.11, -4.79, 21.11, 
	-4.70, 21.11, 3, -4.68, 21.39, -4.41, 21.68, -4.04, 21.86, 3, -4.12, 21.99, -4.18, 22.15, -4.42, 22.14, 
	3, -4.53, 21.82, -4.74, 21.59, -4.88, 21.29, 3, -5.24, 21.33, -4.82, 21.71, -5.17, 21.48, 3, -5.17, 
	21.30, -4.91, 21.36, -4.98, 21.11, 0, 1, -0.69, -27.62, 3, -0.49, -27.54, -0.37, -27.38, -0.03, -27.43, 
	3, 0.07, -26.66, 0.18, -26.28, -0.31, -25.74, 3, -0.67, -25.67, -0.76, -25.86, -1.06, -25.84, 3, -0.90, 
	-26.37, -0.33, -26.85, -0.69, -27.62, 0, 1, 10.85, -6.13, 3, 11.06, -5.74, 11.74, -5.41, 11.51, -4.91, 
	3, 11.53, -4.80, 11.68, -4.83, 11.79, -4.81, 3, 11.84, -4.33, 11.53, -4.20, 11.60, -3.69, 3, 11.03, 
	-4.31, 11.05, -5.05, 10.57, -5.66, 3, 10.55, -5.93, 10.75, -5.98, 10.85, -6.13, 0, 1, 1.47, -5.28, 3, 
	2.44, -5.10, 2.40, -4.55, 2.41, -3.78, 3, 2.07, -3.73, 1.95, -3.89, 1.75, -3.97, 3, 1.78, -4.09, 1.92, 
	-4.12, 1.94, -4.25, 3, 1.85, -4.41, 1.64, -4.46, 1.38, -4.44, 3, 1.35, -4.73, 1.66, -4.86, 1.47, -5.28, 
	0 }

shape[3] = { 1, -5.67, -28.42, 3, -5.54, -27.99, -6.24, -28.15, -6.25, -28.33, 3, -6.29, -28.54, -5.73, -28.58, -5.67, 
	-28.42, 0, 1, -8.91, -28.08, 3, -8.57, -28.13, -8.36, -27.76, -8.50, -27.58, 3, -8.84, -27.54, -8.83, 
	-27.86, -8.91, -28.08, 0, 1, 10.45, -26.34, 3, 10.71, -26.36, 10.81, -26.20, 10.86, -26.01, 3, 10.59, 
	-25.98, 10.46, -26.11, 10.45, -26.34, 0, 1, 12.36, -26.01, 3, 12.37, -25.80, 12.23, -25.75, 12.19, -25.59, 
	3, 11.82, -25.63, 11.42, -25.65, 11.36, -26.01, 3, 11.61, -26.20, 12.07, -26.04, 12.36, -26.01, 0, 1, 
	16.51, -26.01, 3, 16.76, -26.01, 17.06, -26.06, 17.01, -25.76, 3, 16.65, -25.84, 16.74, -25.48, 16.43, 
	-25.51, 3, 16.42, -25.71, 16.42, -25.91, 16.51, -26.01, 0, 1, -16.80, -25.43, 3, -16.84, -25.10, -17.17, 
	-25.02, -17.47, -25.18, 3, -17.38, -25.52, -17.05, -25.66, -16.80, -25.43, 0, 1, -2.51, -25.51, 3, -1.99, 
	-25.59, -2.03, -25.24, -1.60, -25.43, 3, -1.70, -25.25, -1.96, -25.23, -1.85, -24.84, 3, -2.21, -24.79, 
	-2.32, -24.98, -2.68, -24.93, 3, -2.88, -25.14, -2.47, -25.20, -2.51, -25.51, 0, 1, -8.58, -25.34, 3, 
	-8.32, -25.35, -8.34, -25.08, -8.00, -25.17, 3, -7.89, -24.71, -8.44, -24.90, -8.66, -24.76, 3, -8.63, 
	-24.96, -8.81, -24.94, -8.74, -25.17, 3, -8.60, -25.15, -8.59, -25.24, -8.58, -25.34, 0, 1, -14.31, 
	-25.01, 3, -14.38, -24.84, -14.89, -24.92, -14.98, -25.01, 3, -14.87, -25.40, -14.51, -25.19, -14.31, 
	-25.01, 0, 1, -12.40, -25.26, 3, -12.32, -25.26, -12.23, -25.26, -12.15, -25.26, 3, -12.11, -24.94, 
	-12.26, -24.82, -12.48, -24.76, 3, -12.49, -24.97, -12.50, -25.16, -12.40, -25.26, 0, 1, -5.84, -24.84, 
	3, -5.65, -24.89, -5.59, -24.39, -5.50, -24.59, 3, -5.31, -24.42, -5.60, -24.03, -5.84, -24.01, 3, -5.92, 
	-24.44, -6.03, -24.47, -5.84, -24.84, 0, 1, -12.73, -24.34, 3, -12.68, -24.59, -12.56, -24.27, -12.40, 
	-24.34, 3, -12.44, -24.13, -12.51, -24.05, -12.32, -23.93, 3, -12.56, -23.69, -12.70, -24.34, -12.73, 
	-24.34, 0, 1, -5.92, -23.85, 3, -5.55, -23.88, -5.47, -23.64, -5.50, -23.27, 3, -5.68, -23.42, -5.78, 
	-23.65, -5.92, -23.85, 0, 1, 11.03, -23.10, 3, 10.74, -23.03, 10.68, -23.19, 10.53, -23.27, 3, 10.60, 
	-23.58, 11.08, -23.39, 11.03, -23.10, 0, 1, 4.55, -22.60, 3, 4.42, -22.30, 4.67, -21.93, 4.47, -21.60, 
	3, 3.91, -21.59, 4.45, -22.18, 4.05, -22.27, 3, 4.08, -22.52, 4.33, -22.79, 4.55, -22.60, 0, 1, -19.63, 
	-22.52, 3, -19.35, -22.50, -19.09, -22.19, -19.30, -21.94, 3, -19.71, -21.89, -19.77, -22.24, -19.63, 
	-22.52, 0, 1, 10.61, -22.43, 3, 10.75, -22.46, 10.76, -22.36, 10.86, -22.35, 3, 10.93, -22.09, 10.73, 
	-22.09, 10.70, -21.94, 3, 10.51, -21.95, 10.66, -22.29, 10.61, -22.43, 0, 1, 14.43, -22.43, 3, 14.61, 
	-22.22, 14.37, -21.90, 14.77, -21.77, 3, 14.22, -21.37, 12.96, -21.84, 12.11, -21.44, 3, 12.19, -21.55, 
	12.19, -21.74, 12.27, -21.85, 3, 13.14, -21.91, 13.74, -22.46, 14.43, -22.43, 0, 1, 7.37, -22.18, 3, 
	7.73, -21.97, 8.53, -22.18, 8.53, -21.60, 3, 8.03, -21.47, 7.40, -21.37, 7.21, -21.77, 3, 7.31, -22.04, 
	7.33, -21.95, 7.37, -22.18, 0, 1, 20.83, -22.18, 3, 20.80, -22.02, 20.51, -22.12, 20.58, -21.85, 3, 
	20.50, -21.94, 20.28, -21.88, 20.33, -22.10, 3, 20.43, -22.20, 20.63, -22.20, 20.83, -22.18, 0, 1, 1.81, 
	-21.60, 3, 1.50, -21.69, 1.57, -21.40, 1.31, -21.44, 3, 0.90, -21.61, 0.72, -21.61, 0.31, -21.44, 3, 
	0.05, -22.06, 1.27, -21.77, 1.64, -22.02, 3, 1.45, -21.57, 1.80, -22.05, 1.81, -21.60, 0, 1, -17.97, 
	-21.85, 3, -17.94, -21.59, -18.33, -21.55, -18.47, -21.69, 3, -18.46, -21.90, -18.19, -21.85, -17.97, 
	-21.85, 0, 1, -15.97, -21.77, 3, -15.82, -21.40, -16.09, -21.19, -15.97, -20.69, 3, -16.32, -20.99, 
	-16.18, -21.44, -15.97, -21.77, 0, 1, -12.98, -21.69, 3, -12.68, -21.63, -12.58, -21.37, -12.32, -21.27, 
	3, -11.97, -21.35, -11.84, -21.22, -11.65, -21.52, 3, -11.42, -21.45, -11.81, -21.22, -11.48, -21.19, 
	3, -12.00, -20.96, -12.41, -20.97, -13.23, -21.02, 3, -13.11, -21.28, -13.17, -21.42, -13.48, -21.44, 
	3, -13.52, -21.73, -13.03, -21.48, -12.98, -21.69, 0, 1, -8.99, -21.44, 3, -8.97, -21.05, -9.23, -20.96, 
	-9.41, -21.19, 3, -9.42, -21.44, -9.16, -21.61, -8.99, -21.44, 0, 1, -5.34, -21.52, 3, -5.18, -21.38, 
	-5.48, -21.23, -5.09, -21.27, 3, -5.02, -20.98, -5.21, -20.95, -5.17, -20.69, 3, -5.86, -20.61, -6.17, 
	-20.65, -6.50, -20.52, 3, -7.37, -21.25, -6.12, -21.60, -5.34, -21.52, 0, 1, 24.24, -19.86, 3, 24.30, 
	-19.43, 24.02, -19.35, 23.66, -19.36, 3, 23.64, -19.52, 23.60, -19.64, 23.49, -19.69, 3, 23.67, -19.82, 
	23.96, -19.83, 24.24, -19.86, 0, 1, 4.30, -19.44, 3, 4.46, -19.48, 4.51, -19.62, 4.71, -19.61, 3, 4.77, 
	-19.02, 5.22, -19.75, 5.46, -19.44, 3, 5.37, -18.92, 4.35, -18.98, 4.05, -19.28, 3, 3.79, -19.06, 3.72, 
	-19.05, 3.30, -19.11, 3, 3.31, -19.26, 3.20, -19.29, 3.22, -19.44, 3, 3.49, -19.51, 4.16, -19.86, 4.30, 
	-19.44, 0, 1, 18.17, -19.36, 3, 18.08, -19.06, 18.15, -18.81, 17.84, -18.61, 3, 17.00, -19.41, 16.04, 
	-17.64, 15.27, -18.36, 3, 15.98, -18.93, 17.13, -19.39, 18.17, -19.36, 0, 1, 10.86, -18.78, 3, 10.74, 
	-18.79, 10.63, -18.79, 10.61, -18.70, 3, 10.51, -18.73, 10.44, -18.80, 10.45, -18.95, 3, 10.33, -18.86, 
	10.28, -18.72, 10.20, -18.61, 3, 9.97, -18.80, 9.90, -18.90, 9.53, -18.78, 3, 9.85, -19.24, 10.66, -19.63, 
	10.86, -18.78, 0, 1, 11.11, -19.11, 3, 11.18, -19.13, 11.19, -19.08, 11.19, -19.03, 3, 11.59, -18.80, 
	11.98, -19.00, 12.36, -18.70, 3, 12.37, -18.55, 12.25, -18.52, 12.27, -18.36, 3, 11.76, -18.40, 11.45, 
	-18.65, 11.03, -18.78, 3, 11.09, -18.85, 11.12, -18.97, 11.11, -19.11, 0, 1, 14.35, -18.70, 3, 14.22, 
	-18.50, 13.96, -18.42, 13.85, -18.20, 3, 13.59, -18.16, 13.59, -18.38, 13.60, -18.61, 3, 13.80, -18.76, 
	14.07, -18.84, 14.35, -18.70, 0, 1, 0.89, -18.53, 3, 1.17, -18.49, 1.09, -17.99, 0.73, -18.11, 3, 0.66, 
	-18.38, 0.80, -18.43, 0.89, -18.53, 0, 1, -14.89, -18.11, 3, -14.82, -17.59, -15.20, -17.53, -15.56, 
	-17.45, 3, -15.60, -18.04, -16.57, -17.34, -16.56, -17.86, 3, -16.77, -17.51, -17.37, -17.63, -17.63, 
	-17.86, 3, -16.82, -18.05, -15.89, -18.18, -14.89, -18.11, 0, 1, -12.32, -18.03, 3, -12.35, -17.41, 
	-12.27, -17.08, -12.07, -16.53, 3, -12.42, -16.61, -12.39, -16.30, -12.65, -16.29, 3, -12.51, -16.51, 
	-12.78, -16.67, -12.48, -16.78, 3, -12.79, -17.13, -12.85, -18.21, -12.32, -18.03, 0, 1, -6.00, -18.11, 
	3, -5.69, -18.10, -5.46, -18.00, -5.42, -17.70, 3, -5.84, -17.64, -5.84, -17.49, -6.17, -17.70, 3, -6.23, 
	-17.95, -5.94, -17.86, -6.00, -18.11, 0, 1, -1.68, -18.03, 3, -1.63, -17.73, -1.93, -17.78, -2.18, -17.78, 
	3, -2.21, -18.06, -1.82, -17.92, -1.68, -18.03, 0, 1, -14.15, -17.95, 3, -13.95, -17.90, -13.76, -17.84, 
	-13.73, -17.62, 3, -13.90, -17.62, -14.06, -17.62, -14.23, -17.62, 3, -14.26, -17.79, -14.17, -17.84, 
	-14.15, -17.95, 0, 1, -8.41, -17.53, 3, -8.25, -17.57, -8.20, -17.71, -8.00, -17.70, 3, -7.73, -17.64, 
	-7.56, -17.47, -7.50, -17.20, 3, -8.33, -17.06, -8.88, -17.24, -9.82, -17.45, 3, -9.55, -18.05, -8.77, 
	-17.88, -8.41, -17.53, 0, 1, 14.43, -17.78, 3, 14.50, -17.47, 13.99, -17.72, 14.10, -17.37, 3, 13.98, 
	-17.52, 13.67, -17.49, 13.69, -17.78, 3, 14.02, -17.85, 14.10, -17.85, 14.43, -17.78, 0, 1, -2.60, -17.70, 
	3, -2.27, -17.45, -3.06, -17.35, -3.18, -17.53, 3, -3.15, -17.91, -2.65, -17.50, -2.60, -17.70, 0, 1, 
	7.21, -17.62, 3, 7.29, -17.62, 7.37, -17.62, 7.46, -17.62, 3, 7.37, -17.41, 7.43, -17.44, 7.37, -17.12, 
	3, 7.16, -17.13, 7.21, -17.40, 7.21, -17.62, 0, 1, 21.00, -17.37, 3, 21.06, -16.91, 20.62, -16.97, 20.33, 
	-16.87, 3, 20.28, -17.31, 20.72, -17.25, 21.00, -17.37, 0, 1, 14.27, -17.20, 3, 14.25, -17.10, 14.29, 
	-17.05, 14.35, -17.03, 3, 14.30, -16.75, 14.07, -16.65, 14.10, -16.29, 3, 13.84, -16.27, 13.83, -16.51, 
	13.52, -16.45, 3, 13.59, -16.88, 13.74, -17.23, 14.27, -17.20, 0, 1, -5.92, -16.87, 3, -5.43, -16.79, 
	-5.32, -15.94, -5.84, -15.87, 3, -5.78, -16.09, -6.01, -16.03, -6.09, -16.12, 3, -6.00, -16.46, -6.17, 
	-16.63, -5.92, -16.87, 0, 1, 0.98, -16.87, 3, 1.33, -16.84, 0.92, -16.52, 1.14, -16.45, 3, 1.07, -16.31, 
	0.85, -16.24, 0.73, -16.37, 3, 0.72, -16.62, 0.90, -16.69, 0.98, -16.87, 0, 1, 4.38, -16.70, 3, 4.07, 
	-16.37, 4.54, -16.22, 4.46, -15.79, 3, 4.29, -15.96, 4.14, -15.76, 3.97, -15.70, 3, 4.09, -15.58, 4.29, 
	-15.53, 4.55, -15.54, 3, 4.53, -15.44, 4.57, -15.39, 4.63, -15.37, 3, 4.51, -15.13, 4.25, -15.03, 3.97, 
	-14.96, 3, 3.59, -15.33, 4.13, -16.13, 3.72, -16.45, 3, 3.82, -16.78, 4.06, -16.77, 4.38, -16.70, 0, 
	1, -19.30, -16.62, 3, -19.09, -16.63, -19.04, -16.49, -18.88, -16.45, 3, -18.77, -16.26, -19.09, -16.14, 
	-18.88, -16.12, 3, -19.11, -15.87, -19.40, -16.26, -19.30, -16.62, 0, 1, 17.26, -16.37, 3, 17.55, -16.17, 
	17.46, -16.04, 17.67, -15.70, 3, 17.55, -15.61, 17.30, -15.63, 17.34, -15.37, 3, 17.34, -15.65, 17.22, 
	-16.14, 17.26, -16.37, 0, 1, 10.78, -15.87, 3, 10.86, -15.87, 10.94, -15.87, 11.03, -15.87, 3, 10.99, 
	-15.42, 10.70, -15.54, 10.86, -15.04, 3, 10.73, -14.90, 10.54, -15.07, 10.36, -15.12, 3, 10.28, -15.76, 
	10.90, -15.33, 10.78, -15.87, 0, 1, 1.31, -15.29, 3, 1.36, -15.03, 1.82, -15.19, 1.97, -15.04, 3, 1.62, 
	-14.34, 0.49, -14.88, -0.19, -14.46, 3, -0.25, -14.88, 0.01, -14.98, 0.23, -15.12, 3, 0.60, -15.10, 
	1.20, -14.87, 1.31, -15.29, 0, 1, 21.16, -15.21, 3, 21.00, -15.09, 20.92, -14.90, 20.83, -14.71, 3, 
	20.23, -14.82, 20.00, -14.57, 19.25, -14.54, 3, 19.23, -14.87, 19.43, -14.97, 19.50, -15.21, 3, 20.04, 
	-14.70, 20.67, -15.43, 21.16, -15.21, 0, 1, 14.77, -15.04, 3, 14.60, -14.79, 14.34, -14.63, 14.19, -14.38, 
	3, 13.75, -14.81, 13.37, -14.36, 12.69, -14.38, 3, 13.20, -14.81, 13.65, -14.90, 14.77, -15.04, 0, 1, 
	-9.16, -14.87, 3, -9.15, -14.97, -9.01, -14.94, -8.91, -14.96, 3, -8.75, -14.69, -8.98, -14.46, -8.83, 
	-14.13, 3, -8.95, -14.08, -9.04, -14.00, -9.16, -13.96, 3, -9.13, -13.74, -8.91, -13.71, -8.91, -13.46, 
	3, -9.53, -13.27, -8.80, -12.43, -9.74, -12.38, 3, -9.68, -12.79, -9.52, -13.10, -9.33, -13.38, 3, -9.39, 
	-13.46, -9.48, -13.50, -9.58, -13.54, 3, -9.33, -14.01, -9.27, -14.62, -9.16, -14.87, 0, 1, 9.28, -13.88, 
	3, 8.35, -13.63, 7.19, -14.66, 5.96, -14.38, 3, 6.64, -15.29, 8.82, -14.86, 9.28, -13.88, 0, 1, 10.53, 
	-14.71, 3, 10.82, -14.70, 10.86, -14.43, 10.86, -14.13, 3, 10.71, -14.05, 10.65, -13.89, 10.36, -13.96, 
	3, 10.16, -14.20, 10.69, -14.25, 10.53, -14.71, 0, 1, -8.16, -14.46, 3, -8.17, -14.22, -8.27, -14.06, 
	-8.58, -14.13, 3, -8.56, -14.36, -8.43, -14.48, -8.16, -14.46, 0, 1, -19.30, -14.13, 3, -19.23, -13.89, 
	-19.41, -13.91, -19.38, -13.71, 3, -19.60, -13.80, -19.85, -13.77, -20.04, -13.63, 3, -20.16, -13.68, 
	-20.20, -13.81, -20.21, -13.96, 3, -19.90, -14.02, -19.65, -14.12, -19.30, -14.13, 0, 1, -18.22, -14.04, 
	3, -18.22, -13.57, -18.70, -14.05, -18.88, -13.71, 3, -18.99, -13.74, -19.01, -13.86, -19.13, -13.88, 
	3, -18.91, -14.08, -18.69, -14.10, -18.22, -14.04, 0, 1, 3.80, -14.04, 3, 4.08, -13.99, 4.25, -13.83, 
	4.21, -13.46, 3, 3.91, -13.48, 3.56, -13.75, 3.80, -14.04, 0, 1, -12.98, -13.79, 3, -12.42, -14.00, 
	-11.81, -13.27, -11.40, -13.71, 3, -11.20, -13.53, -11.61, -13.25, -11.82, -13.21, 3, -12.02, -13.27, 
	-12.21, -13.32, -12.23, -13.55, 3, -12.39, -13.45, -12.63, -13.44, -12.82, -13.38, 3, -12.85, -13.54, 
	-13.05, -13.53, -12.98, -13.79, 0, 1, -2.76, -13.88, 3, -2.30, -13.83, -2.28, -13.54, -2.35, -13.13, 
	3, -2.82, -13.12, -3.04, -13.59, -2.76, -13.88, 0, 1, 4.80, -12.63, 3, 4.84, -12.17, 5.23, -12.07, 5.54, 
	-11.88, 3, 5.54, -11.56, 4.88, -12.11, 5.13, -11.63, 3, 4.19, -11.88, 2.75, -11.37, 2.30, -12.13, 3, 
	3.21, -12.38, 3.75, -12.66, 4.80, -12.63, 0, 1, 14.19, -11.30, 3, 14.19, -10.96, 13.88, -10.95, 13.52, 
	-10.97, 3, 13.53, -11.70, 13.04, -11.83, 13.27, -12.63, 3, 13.55, -12.61, 13.99, -12.74, 13.94, -12.38, 
	3, 13.36, -12.72, 14.00, -11.50, 14.19, -11.30, 0, 1, 7.12, -11.72, 3, 7.01, -11.72, 6.90, -11.72, 6.79, 
	-11.72, 3, 6.84, -12.02, 6.93, -12.27, 6.79, -12.55, 3, 6.99, -12.52, 6.95, -12.26, 7.21, -12.30, 3, 
	7.20, -12.08, 7.24, -11.82, 7.12, -11.72, 0, 1, 26.73, -12.55, 3, 26.97, -12.48, 27.04, -12.25, 27.14, 
	-12.05, 3, 27.07, -11.90, 26.96, -11.79, 26.81, -11.72, 3, 26.66, -11.71, 26.64, -11.82, 26.48, -11.80, 
	3, 26.78, -12.17, 26.57, -11.84, 26.48, -12.30, 3, 26.74, -12.21, 26.75, -12.21, 26.73, -12.55, 0, 1, 
	0.23, -12.30, 3, 0.39, -12.30, 0.56, -12.30, 0.73, -12.30, 3, 0.48, -12.03, 0.81, -11.70, 0.31, -11.72, 
	3, 0.38, -12.01, 0.19, -12.04, 0.23, -12.30, 0, 1, -23.45, -12.22, 3, -22.87, -12.24, -22.58, -11.98, 
	-22.12, -11.88, 3, -22.39, -11.40, -23.11, -12.00, -23.62, -11.63, 3, -23.75, -12.11, -23.21, -11.85, 
	-23.45, -12.22, 0, 1, -19.55, -12.22, 3, -19.15, -12.34, -19.34, -11.87, -19.30, -11.63, 3, -19.56, 
	-11.65, -19.58, -11.91, -19.55, -12.22, 0, 1, 11.28, -12.22, 3, 11.86, -12.23, 11.94, -11.40, 12.36, 
	-11.72, 3, 11.87, -10.88, 10.48, -11.51, 9.53, -11.72, 3, 9.62, -11.45, 8.98, -11.63, 8.78, -11.80, 
	3, 9.41, -12.52, 10.83, -11.76, 11.28, -12.22, 0, 1, 17.09, -11.80, 3, 17.06, -11.66, 16.47, -11.66, 
	16.43, -11.80, 3, 16.29, -11.57, 16.20, -11.31, 15.85, -11.30, 3, 15.73, -12.25, 16.75, -11.87, 17.09, 
	-11.80, 0, 1, 0.15, -11.63, 3, 0.44, -11.52, 0.45, -11.64, 0.73, -11.55, 3, 0.49, -11.30, 0.69, -11.11, 
	0.64, -10.64, 3, 0.45, -10.61, 0.33, -10.65, 0.23, -10.72, 3, 0.42, -11.06, 0.15, -11.26, 0.15, -11.63, 
	0, 1, -15.14, -11.38, 3, -15.07, -11.04, -15.30, -10.99, -15.31, -10.72, 3, -15.38, -10.78, -15.50, 
	-10.81, -15.64, -10.80, 3, -15.58, -10.88, -15.55, -10.99, -15.56, -11.14, 3, -15.84, -11.17, -15.69, 
	-10.77, -16.06, -10.89, 3, -16.07, -11.09, -16.07, -11.29, -15.97, -11.38, 3, -15.54, -11.36, -15.48, 
	-11.47, -15.14, -11.38, 0, 1, -8.41, -11.05, 3, -8.07, -10.76, -7.60, -10.59, -7.33, -10.22, 3, -8.45, 
	-9.90, -9.51, -10.06, -10.74, -10.47, 3, -9.94, -11.06, -9.18, -10.87, -8.41, -11.05, 0, 1, -5.84, -10.97, 
	3, -5.91, -10.45, -5.88, -9.73, -6.67, -9.72, 3, -6.71, -10.05, -6.46, -10.06, -6.42, -10.31, 3, -6.44, 
	-10.48, -6.64, -10.19, -6.75, -10.39, 3, -6.57, -10.70, -6.35, -10.98, -5.84, -10.97, 0, 1, 21.83, -10.89, 
	3, 21.70, -10.61, 21.70, -10.52, 21.66, -10.31, 3, 21.55, -10.31, 21.44, -10.31, 21.33, -10.31, 3, 21.29, 
	-10.71, 21.58, -10.78, 21.83, -10.89, 0, 1, -12.90, -10.80, 3, -11.88, -10.65, -13.12, -9.42, -12.65, 
	-8.97, 3, -12.61, -8.75, -12.96, -8.90, -12.98, -8.73, 3, -13.22, -8.91, -12.71, -9.60, -13.23, -9.64, 
	3, -13.19, -9.88, -13.06, -10.02, -12.82, -10.06, 3, -12.79, -10.50, -12.75, -10.50, -12.90, -10.80, 
	0, 1, -19.71, -10.31, 3, -19.51, -10.33, -19.51, -9.78, -19.63, -9.56, 3, -19.83, -9.63, -19.85, -10.14, 
	-19.71, -10.31, 0, 1, 8.62, -10.31, 3, 9.04, -10.13, 8.97, -9.51, 8.54, -9.39, 3, 8.55, -9.60, 8.41, 
	-9.65, 8.37, -9.81, 3, 8.37, -10.05, 8.59, -10.09, 8.62, -10.31, 0, 1, 5.13, -10.14, 3, 5.24, -10.11, 
	5.26, -9.99, 5.38, -9.97, 3, 5.39, -9.77, 5.34, -9.63, 5.21, -9.56, 3, 4.99, -9.50, 5.05, -9.73, 4.96, 
	-9.81, 3, 4.77, -9.75, 4.90, -9.37, 4.55, -9.47, 3, 4.53, -9.90, 4.90, -9.96, 5.13, -10.14, 0, 1, 7.12, 
	-10.06, 3, 7.15, -9.72, 7.09, -9.48, 6.79, -9.47, 3, 6.80, -9.57, 6.77, -9.62, 6.71, -9.64, 3, 6.79, 
	-9.83, 6.88, -10.03, 7.12, -10.06, 0, 1, 3.63, -9.81, 3, 3.97, -9.84, 4.17, -9.73, 4.38, -9.64, 3, 4.38, 
	-9.42, 4.38, -9.20, 4.38, -8.98, 3, 3.67, -9.20, 3.82, -7.73, 3.88, -7.48, 3, 3.87, -7.38, 3.73, -7.41, 
	3.63, -7.40, 3, 3.57, -6.07, 3.89, -4.79, 3.14, -4.24, 3, 2.79, -4.66, 2.55, -7.05, 3.30, -7.31, 3, 
	3.00, -8.32, 3.46, -8.95, 3.63, -9.81, 0, 1, 26.48, -9.72, 3, 26.61, -9.46, 26.78, -9.63, 27.06, -9.64, 
	3, 27.07, -9.44, 27.07, -9.24, 26.98, -9.14, 3, 26.61, -9.10, 26.37, -9.20, 26.15, -9.31, 3, 26.20, 
	-9.50, 26.42, -9.53, 26.48, -9.72, 0, 1, -6.34, -9.64, 3, -5.70, -9.09, -6.10, -8.50, -5.75, -7.90, 
	3, -5.83, -7.59, -6.15, -7.51, -6.17, -7.15, 3, -6.36, -7.12, -6.49, -7.16, -6.58, -7.23, 3, -6.41, 
	-7.55, -6.67, -7.69, -6.67, -8.06, 3, -6.82, -8.07, -6.84, -7.96, -7.00, -7.98, 3, -6.80, -8.23, -6.54, 
	-8.41, -6.34, -8.64, 3, -6.31, -8.86, -6.45, -8.92, -6.67, -8.89, 3, -6.48, -9.14, -6.57, -9.18, -6.59, 
	-9.56, 3, -6.47, -9.55, -6.35, -9.54, -6.34, -9.64, 0, 1, 0.64, -9.31, 3, 0.68, -8.89, 0.31, -8.87, 
	0.23, -8.56, 3, 0.15, -8.70, -0.03, -8.74, -0.19, -8.81, 3, -0.01, -8.89, 0.08, -9.04, 0.23, -9.14, 
	3, 0.19, -9.30, 0.05, -9.35, 0.06, -9.56, 3, 0.30, -9.77, 0.55, -9.50, 0.64, -9.31, 0, 1, 4.88, -9.47, 
	3, 4.95, -9.46, 4.96, -9.39, 5.05, -9.39, 3, 5.05, -9.34, 5.05, -9.28, 5.05, -9.23, 3, 4.85, -9.23, 
	4.80, -9.08, 4.55, -9.14, 3, 4.46, -9.45, 4.83, -9.30, 4.88, -9.47, 0, 1, 2.47, -8.98, 3, 2.41, -8.70, 
	2.26, -8.52, 1.89, -8.56, 3, 1.70, -9.18, 2.33, -9.73, 2.47, -8.98, 0, 1, -3.01, -8.64, 3, -2.93, -8.64, 
	-2.85, -8.64, -2.76, -8.64, 3, -2.83, -8.44, -2.74, -8.07, -3.01, -8.06, 3, -2.83, -8.33, -3.19, -8.43, 
	-3.01, -8.64, 0, 1, -27.19, -8.48, 3, -26.98, -8.47, -26.99, -8.17, -27.11, -8.06, 3, -27.37, -8.07, 
	-27.47, -8.25, -27.77, -8.23, 3, -27.75, -8.48, -27.09, -8.10, -27.19, -8.48, 0, 1, 22.16, -8.06, 3, 
	22.08, -7.84, 21.95, -7.66, 21.66, -7.65, 3, 21.63, -8.07, 21.38, -7.84, 21.16, -7.98, 3, 21.41, -8.40, 
	21.74, -7.77, 22.16, -8.06, 0, 1, -2.85, -7.90, 3, -2.91, -7.74, -2.99, -7.59, -3.01, -7.40, 3, -3.14, 
	-7.47, -3.13, -7.66, -3.18, -7.81, 3, -3.10, -7.88, -2.99, -7.90, -2.85, -7.90, 0, 1, -23.70, -7.65, 
	3, -23.40, -7.64, -22.98, -7.76, -23.12, -7.31, 3, -23.45, -7.28, -23.70, -7.34, -23.70, -7.65, 0, 1, 
	8.95, -7.40, 3, 8.88, -7.22, 8.61, -7.07, 8.45, -7.23, 3, 8.46, -7.58, 8.79, -7.62, 8.95, -7.40, 0, 
	1, -16.64, -7.31, 3, -16.65, -7.49, -16.34, -7.35, -16.22, -7.40, 3, -16.10, -7.24, -16.22, -6.85, -16.06, 
	-6.73, 3, -16.37, -6.37, -16.40, -6.15, -16.39, -5.57, 3, -16.50, -5.57, -16.61, -5.57, -16.72, -5.57, 
	3, -16.67, -5.84, -16.75, -5.99, -16.89, -6.07, 3, -16.38, -6.30, -17.20, -7.08, -16.39, -7.15, 3, -16.42, 
	-7.25, -16.49, -7.32, -16.64, -7.31, 0, 1, 2.22, -6.98, 3, 1.20, -6.74, 0.32, -6.63, -1.02, -6.32, 3, 
	-0.97, -6.38, -0.93, -6.45, -0.94, -6.57, 3, -1.15, -6.59, -1.21, -6.45, -1.18, -6.23, 3, -1.36, -6.36, 
	-1.74, -6.29, -1.93, -6.40, 3, -0.95, -7.25, 0.91, -7.67, 2.22, -6.98, 0, 1, -9.66, -7.23, 3, -9.56, 
	-7.25, -9.51, -7.21, -9.49, -7.15, 3, -9.75, -6.69, -9.49, -6.36, -9.33, -5.90, 3, -9.75, -4.83, -10.13, 
	-3.34, -9.74, -2.66, 3, -9.44, -2.64, -9.34, -2.81, -9.08, -2.83, 3, -9.08, -2.94, -9.08, -3.05, -9.08, 
	-3.16, 3, -8.66, -3.30, -8.26, -3.37, -7.91, -3.08, 3, -7.85, -2.48, -8.50, -2.61, -8.66, -2.25, 3, 
	-8.84, -2.30, -8.93, -2.42, -9.08, -2.50, 3, -9.71, -1.59, -10.65, -1.77, -11.49, -1.58, 3, -11.56, 
	-2.11, -10.65, -2.34, -10.24, -2.66, 3, -10.59, -4.30, -10.28, -5.77, -9.66, -7.23, 0, 1, 7.54, -7.23, 
	3, 7.90, -6.70, 8.79, -7.20, 9.03, -6.57, 3, 7.85, -5.96, 6.36, -6.23, 4.88, -6.48, 3, 4.80, -6.94, 
	5.52, -6.69, 5.21, -7.15, 3, 5.99, -7.00, 6.86, -6.74, 7.54, -7.23, 0, 1, -23.20, -7.15, 3, -23.21, 
	-6.85, -23.51, -6.85, -23.45, -6.48, 3, -23.58, -6.48, -23.77, -6.52, -23.78, -6.40, 3, -23.90, -6.55, 
	-23.59, -6.72, -23.78, -7.07, 3, -23.49, -7.00, -23.46, -7.19, -23.20, -7.15, 0, 1, -10.82, -6.23, 3, 
	-10.81, -5.92, -11.06, -5.87, -11.32, -5.82, 3, -11.80, -6.26, -12.86, -5.97, -13.48, -5.74, 3, -13.55, 
	-5.83, -13.59, -5.96, -13.56, -6.15, 3, -13.92, -6.45, -14.60, -5.94, -14.64, -6.57, 3, -14.36, -6.53, 
	-14.02, -6.80, -13.98, -6.57, 3, -12.69, -7.30, -11.86, -6.63, -10.82, -6.23, 0, 1, -2.68, -6.40, 3, 
	-3.19, -6.09, -2.67, -5.26, -3.34, -5.15, 3, -3.46, -5.47, -3.23, -6.01, -3.68, -6.15, 3, -3.70, -6.50, 
	-3.54, -6.54, -3.68, -6.82, 3, -3.21, -7.01, -2.72, -7.00, -2.68, -6.40, 0, 1, -21.79, -6.90, 3, -20.56, 
	-6.13, -18.45, -7.53, -17.72, -6.07, 3, -18.13, -5.80, -18.57, -6.12, -18.71, -6.40, 3, -20.24, -6.09, 
	-20.96, -5.90, -22.04, -6.48, 3, -21.96, -6.63, -21.70, -6.59, -21.79, -6.90, 0, 1, -4.01, -6.73, 3, 
	-4.07, -6.54, -4.08, -6.31, -4.18, -6.15, 3, -6.03, -6.17, -6.80, -4.89, -8.41, -5.40, 3, -7.20, -6.23, 
	-5.47, -6.85, -4.01, -6.73, 0, 1, 29.47, -5.90, 3, 29.66, -5.93, 29.79, -5.89, 29.89, -5.82, 3, 29.80, 
	-5.65, 29.68, -5.29, 29.47, -5.49, 3, 29.44, -5.63, 29.54, -5.64, 29.64, -5.65, 3, 29.58, -5.74, 29.45, 
	-5.74, 29.47, -5.90, 0, 1, 2.47, -5.49, 3, 2.30, -5.66, 2.07, -5.53, 2.06, -5.32, 3, 1.96, -5.42, 1.76, 
	-5.41, 1.56, -5.40, 3, 1.61, -5.85, 2.38, -6.05, 2.47, -5.49, 0, 1, -16.47, -5.15, 3, -16.42, -4.80, 
	-16.50, -4.57, -16.89, -4.66, 3, -16.87, -4.94, -16.82, -5.20, -16.47, -5.15, 0, 1, -0.27, -5.07, 3, 
	0.62, -5.18, -0.33, -4.01, 0.23, -4.07, 3, 0.25, -3.69, -0.03, -3.61, -0.11, -3.33, 3, -0.18, -3.56, 
	-0.39, -3.65, -0.52, -3.83, 3, -0.18, -4.32, -0.50, -4.54, -0.27, -5.07, 0, 1, 13.10, -4.74, 3, 13.47, 
	-4.77, 13.63, -4.60, 13.69, -4.32, 3, 13.31, -4.26, 13.66, -3.46, 13.44, -3.24, 3, 13.18, -3.27, 13.06, 
	-3.42, 12.85, -3.49, 3, 13.39, -3.65, 13.44, -4.34, 13.10, -4.74, 0, 1, -30.10, -4.49, 3, -30.03, -4.17, 
	-30.49, -4.38, -30.68, -4.32, 3, -30.61, -4.46, -30.27, -4.74, -30.10, -4.49, 0, 1, 26.23, -4.57, 3, 
	26.46, -4.64, 26.45, -4.46, 26.65, -4.49, 3, 26.45, -4.25, 26.40, -3.85, 26.40, -3.41, 3, 26.14, -3.32, 
	26.21, -3.40, 25.90, -3.41, 3, 26.23, -3.66, 26.20, -4.22, 26.23, -4.57, 0, 1, -12.90, -4.41, 3, -12.94, 
	-4.28, -13.02, -4.20, -13.06, -4.07, 3, -13.29, -4.01, -13.23, -4.24, -13.40, -4.24, 3, -13.33, -4.42, 
	-13.06, -4.56, -12.90, -4.41, 0, 1, 23.99, -4.49, 3, 24.18, -4.40, 24.29, -4.24, 24.32, -3.99, 3, 23.98, 
	-4.13, 23.62, -3.51, 23.49, -4.07, 3, 23.64, -4.08, 23.66, -3.97, 23.82, -3.99, 3, 23.56, -4.30, 23.82, 
	-4.23, 23.99, -4.49, 0, 1, 22.66, -3.58, 3, 22.67, -3.81, 22.80, -3.93, 23.07, -3.91, 3, 23.02, -3.99, 
	22.88, -3.99, 22.91, -4.16, 3, 23.74, -4.40, 23.32, -3.26, 22.66, -3.58, 0, 1, -7.00, -3.99, 3, -6.83, 
	-3.99, -6.67, -3.99, -6.50, -3.99, 3, -6.10, -3.41, -6.56, -2.39, -6.58, -1.50, 3, -6.73, -1.50, -7.07, 
	-1.72, -7.17, -1.50, 3, -7.65, -2.27, -7.12, -3.13, -7.00, -3.99, 0, 1, 16.43, -3.83, 3, 16.69, -3.76, 
	17.04, -3.77, 17.34, -3.83, 3, 17.40, -3.07, 16.40, -3.44, 16.34, -2.99, 3, 16.00, -2.93, 15.92, -3.12, 
	15.60, -3.08, 3, 15.73, -3.48, 16.38, -3.35, 16.43, -3.83, 0, 1, 22.08, -3.66, 3, 22.02, -3.36, 21.44, 
	-3.52, 21.25, -3.58, 3, 21.47, -3.71, 21.82, -3.77, 22.08, -3.66, 0, 1, -23.70, -3.66, 3, -23.42, -3.69, 
	-23.61, -3.25, -23.20, -3.41, 3, -23.36, -3.18, -23.55, -2.98, -23.78, -2.83, 3, -23.97, -2.89, -23.99, 
	-3.12, -24.11, -3.24, 3, -24.16, -3.56, -23.82, -3.50, -23.70, -3.66, 0, 1, -13.40, -3.33, 3, -13.11, 
	-3.36, -12.92, -3.30, -12.98, -2.99, 3, -13.08, -3.01, -13.13, -2.98, -13.15, -2.91, 3, -13.31, -2.97, 
	-13.37, -3.13, -13.40, -3.33, 0, 1, -4.01, -2.50, 3, -3.87, -2.51, -4.10, -2.84, -4.01, -3.08, 3, -3.23, 
	-3.18, -2.77, -3.01, -1.68, -3.33, 3, -1.63, -3.06, -1.84, -3.07, -1.68, -2.91, 3, -1.43, -2.85, -1.52, 
	-3.14, -1.27, -3.08, 3, -1.27, -2.94, -1.27, -2.80, -1.27, -2.66, 3, -2.16, -2.48, -2.75, -2.58, -3.68, 
	-2.66, 3, -3.70, -1.67, -5.26, -2.08, -5.51, -2.83, 3, -5.04, -2.50, -4.49, -2.75, -4.01, -2.50, 0, 
	1, 11.36, -3.33, 3, 11.24, -3.22, 11.28, -2.97, 11.28, -2.74, 3, 11.01, -2.74, 10.96, -2.51, 10.61, 
	-2.58, 3, 10.56, -3.04, 10.41, -2.94, 10.28, -3.24, 3, 10.77, -3.49, 10.95, -3.05, 11.36, -3.33, 0, 
	1, 10.03, -3.24, 3, 10.22, -3.16, 10.30, -2.96, 10.28, -2.66, 3, 9.55, -2.53, 8.78, -1.99, 8.20, -2.83, 
	3, 8.78, -3.20, 9.46, -3.16, 10.03, -3.24, 0, 1, -13.65, -0.92, 3, -13.87, -0.86, -13.81, -1.08, -13.98, 
	-1.08, 3, -13.91, -1.27, -13.93, -1.53, -13.73, -1.58, 3, -13.86, -1.65, -13.85, -1.85, -14.06, -1.83, 
	3, -13.87, -2.22, -13.38, -2.31, -13.40, -2.91, 3, -12.89, -2.46, -13.32, -1.47, -13.65, -0.92, 0, 1, 
	3.55, -2.83, 3, 3.50, -2.56, 3.61, -2.44, 3.63, -2.25, 3, 2.94, -2.16, 2.32, -1.86, 1.89, -2.25, 3, 
	1.70, -2.19, 1.67, -1.97, 1.47, -1.91, 3, 1.22, -1.94, 1.10, -2.09, 0.89, -2.16, 3, 1.37, -3.11, 2.53, 
	-2.77, 3.55, -2.83, 0, 1, -15.72, -2.83, 3, -15.71, -2.62, -15.57, -2.57, -15.72, -2.41, 3, -15.39, 
	-2.45, -15.14, -2.38, -15.14, -2.08, 3, -15.52, -2.05, -15.60, -2.00, -15.89, -2.16, 3, -16.10, -2.10, 
	-16.15, -1.87, -16.31, -1.75, 3, -17.21, -1.80, -17.76, -1.89, -18.55, -2.16, 3, -18.04, -2.73, -16.56, 
	-2.26, -15.72, -2.83, 0, 1, 5.21, -2.66, 3, 4.85, -2.09, 4.09, -2.16, 3.72, -2.41, 3, 4.01, -2.67, 4.84, 
	-3.00, 5.21, -2.66, 0, 1, -7.17, -1.42, 3, -7.12, -1.37, -6.77, -1.22, -6.75, -1.42, 3, -6.67, -1.36, 
	-6.67, -1.22, -6.50, -1.25, 3, -6.50, -0.64, -6.72, -0.64, -6.75, -0.17, 3, -7.11, -0.36, -7.29, -1.01, 
	-7.17, -1.42, 0, 1, 9.70, -1.33, 3, 9.88, -1.18, 9.87, -0.84, 9.86, -0.50, 3, 9.75, -0.50, 9.64, -0.50, 
	9.53, -0.50, 3, 9.33, -0.95, 9.76, -0.83, 9.70, -1.33, 0, 1, 26.56, -0.59, 3, 26.03, -0.55, 25.93, -0.17, 
	25.40, -0.34, 3, 25.31, -1.05, 26.45, -1.21, 26.56, -0.59, 0, 1, -3.59, -0.92, 3, -3.50, -0.65, -3.49, 
	-0.44, -3.51, -0.25, 3, -3.59, -0.25, -3.68, -0.25, -3.76, -0.25, 3, -3.79, -0.56, -3.67, -0.71, -3.59, 
	-0.92, 0, 1, 16.10, -0.83, 3, 16.28, -0.82, 16.27, -0.63, 16.26, -0.42, 3, 15.93, -0.45, 15.89, -0.67, 
	16.10, -0.83, 0, 1, 6.63, -0.75, 3, 6.69, -0.44, 6.31, -0.57, 6.29, -0.34, 3, 6.17, -0.35, 6.26, -0.58, 
	6.13, -0.59, 3, 6.14, -0.80, 6.40, -0.75, 6.63, -0.75, 0, 1, 19.00, -0.42, 3, 19.30, -0.24, 19.45, -0.24, 
	19.75, -0.42, 3, 19.76, 0.00, 19.88, 0.10, 19.75, 0.33, 3, 19.23, 0.36, 18.81, 0.42, 18.34, 0.08, 3, 
	18.61, -0.04, 18.92, -0.12, 19.00, -0.42, 0, 1, 16.01, -0.25, 3, 16.30, -0.15, 16.24, 0.03, 16.10, 0.25, 
	3, 15.82, 0.20, 15.98, -0.07, 16.01, -0.25, 0, 1, 8.12, -0.17, 3, 8.37, 0.03, 8.47, -0.05, 8.87, -0.09, 
	3, 8.82, 0.18, 8.92, 0.30, 8.95, 0.50, 3, 8.35, 0.42, 8.36, 0.96, 7.87, 1.00, 3, 7.70, 0.60, 7.76, -0.05, 
	8.12, -0.17, 0, 1, 9.62, -0.09, 3, 9.70, -0.09, 9.78, -0.09, 9.86, -0.09, 3, 9.73, 0.20, 9.88, 0.16, 
	10.03, 0.33, 3, 9.57, 0.82, 10.49, 2.76, 9.37, 2.07, 3, 9.75, 1.86, 9.11, 1.74, 9.03, 1.49, 3, 8.45, 
	1.52, 8.13, 1.89, 7.79, 1.49, 3, 7.61, 1.48, 7.75, 1.79, 7.71, 1.91, 3, 7.35, 2.01, 7.26, 1.94, 6.87, 
	1.91, 3, 6.91, 1.73, 6.82, 1.69, 6.79, 1.58, 3, 6.38, 1.69, 5.82, 1.66, 5.30, 1.66, 3, 5.29, 1.51, 5.40, 
	1.48, 5.38, 1.33, 3, 4.86, 1.43, 4.22, 1.39, 4.05, 0.91, 3, 5.84, 0.70, 7.09, 1.45, 9.12, 0.99, 3, 9.18, 
	1.07, 9.21, 1.18, 9.20, 1.33, 3, 9.31, 1.33, 9.42, 1.33, 9.53, 1.33, 3, 9.61, 0.82, 9.64, 0.35, 9.62, 
	-0.09, 0, 1, -3.59, 0.08, 3, -3.32, 0.23, -3.53, 0.69, -3.18, 0.91, 3, -3.19, 1.12, -3.53, 1.44, -3.34, 
	1.58, 3, -3.53, 1.79, -3.81, 1.73, -4.01, 1.58, 3, -4.05, 1.45, -3.91, 1.15, -4.09, 1.16, 3, -3.68, 
	0.90, -4.07, 0.31, -3.59, 0.08, 0, 1, 2.97, 0.33, 3, 3.26, 1.14, 2.65, 1.86, 2.97, 2.49, 3, 2.63, 2.57, 
	2.62, 2.80, 2.22, 2.66, 3, 2.27, 2.43, 2.12, 2.00, 2.30, 1.91, 3, 2.23, 1.79, 2.18, 1.64, 1.97, 1.66, 
	3, 1.95, 1.41, 2.20, 1.15, 1.89, 1.08, 3, 1.96, 0.83, 2.16, 1.13, 2.30, 1.08, 3, 2.12, 0.68, 2.55, 0.12, 
	2.97, 0.33, 0, 1, 13.69, 0.49, 3, 13.98, 0.64, 13.45, 0.63, 13.60, 0.91, 3, 12.88, 1.41, 11.86, 0.79, 
	11.44, 1.16, 3, 11.36, 0.97, 11.54, 0.89, 11.53, 0.66, 3, 12.15, 0.18, 13.01, 0.45, 13.69, 0.49, 0, 
	1, -9.91, 0.49, 3, -9.96, 0.80, -10.24, 0.88, -10.32, 1.16, 3, -10.35, 1.49, -9.97, 1.41, -9.99, 1.74, 
	3, -10.61, 2.46, -9.92, 4.12, -11.07, 4.57, 3, -11.40, 4.33, -10.92, 3.86, -11.40, 3.65, 3, -10.88, 
	3.56, -11.33, 2.97, -10.82, 2.82, 3, -10.88, 2.50, -11.27, 2.50, -11.24, 2.07, 3, -11.13, 2.07, -11.01, 
	2.07, -10.90, 2.07, 3, -11.01, 1.82, -11.31, 1.76, -11.40, 1.49, 3, -11.60, 1.49, -11.65, 1.64, -11.90, 
	1.57, 3, -11.81, 1.11, -11.23, 1.61, -11.24, 0.99, 3, -11.05, 0.95, -11.12, 1.15, -10.99, 1.16, 3, -10.68, 
	0.85, -10.52, 0.02, -9.91, 0.49, 0, 1, 1.56, 0.58, 3, 1.62, 0.87, 1.43, 0.90, 1.47, 1.16, 3, 1.25, 1.10, 
	1.05, 1.03, 0.89, 0.91, 3, 0.97, 0.67, 1.33, 0.41, 1.56, 0.58, 0, 1, 16.26, 0.49, 3, 16.27, 0.89, 16.28, 
	1.29, 15.85, 1.24, 3, 15.78, 0.83, 15.72, 0.48, 16.26, 0.49, 0, 1, -4.92, 1.24, 3, -5.48, 1.77, -5.96, 
	1.73, -6.92, 1.74, 3, -7.01, 1.48, -6.79, 1.54, -6.75, 1.41, 3, -7.03, 1.33, -7.02, 1.52, -7.00, 1.74, 
	3, -8.09, 1.66, -8.60, 1.65, -9.24, 1.74, 3, -8.08, 0.63, -6.32, 0.72, -4.92, 1.24, 0, 1, 0.64, 0.99, 
	3, 0.56, 1.10, 0.56, 1.30, 0.48, 1.41, 3, -0.13, 1.50, -0.71, 1.55, -0.93, 1.82, 3, -0.93, 1.71, -0.93, 
	1.60, -0.93, 1.49, 3, -1.39, 1.82, -1.98, 1.78, -1.85, 1.08, 3, -1.13, 1.13, -0.19, 0.99, 0.64, 0.99, 
	0, 1, -12.65, 1.33, 3, -12.67, 1.54, -12.67, 1.86, -12.65, 2.07, 3, -13.02, 2.13, -13.86, 2.18, -14.56, 
	2.16, 3, -14.56, 1.96, -14.42, 1.91, -14.48, 1.66, 3, -14.82, 1.59, -14.63, 2.05, -14.98, 1.99, 3, -15.12, 
	1.88, -14.98, 1.49, -15.23, 1.49, 3, -15.12, 1.15, -14.59, 1.24, -14.23, 1.16, 3, -14.19, 1.32, -14.20, 
	1.52, -13.98, 1.49, 3, -13.63, 0.90, -13.31, 1.23, -12.65, 1.33, 0, 1, -3.51, 2.24, 3, -3.53, 2.47, 
	-3.78, 2.47, -3.84, 2.66, 3, -4.00, 2.65, -3.90, 2.38, -4.09, 2.41, 3, -3.96, 2.14, -3.81, 2.19, -3.51, 
	2.24, 0, 1, 25.40, 2.66, 3, 25.62, 2.63, 25.67, 2.77, 25.65, 2.99, 3, 25.54, 2.99, 25.43, 2.99, 25.32, 
	2.99, 3, 25.31, 2.84, 25.42, 2.81, 25.40, 2.66, 0, 1, -0.77, 2.74, 3, -0.50, 3.72, -0.60, 5.02, -0.77, 
	6.31, 3, -1.45, 6.26, -1.24, 5.64, -1.35, 5.15, 3, -0.42, 4.58, -1.76, 3.55, -0.77, 2.74, 0, 1, -6.92, 
	2.99, 3, -6.96, 3.26, -6.89, 3.41, -6.75, 3.49, 3, -6.73, 3.71, -6.92, 3.70, -7.08, 3.74, 3, -7.02, 
	4.14, -6.78, 4.34, -6.92, 4.73, 3, -6.98, 4.69, -7.05, 4.65, -7.17, 4.65, 3, -7.33, 4.76, -7.00, 5.09, 
	-7.33, 5.15, 3, -7.22, 5.28, -7.05, 5.36, -6.83, 5.40, 3, -6.88, 5.81, -7.10, 6.08, -6.83, 6.56, 3, 
	-7.06, 6.50, -7.00, 6.72, -7.17, 6.73, 3, -6.66, 7.52, -7.61, 7.73, -7.75, 8.22, 3, -8.32, 7.71, -7.46, 
	6.66, -7.58, 5.65, 3, -7.92, 5.77, -8.31, 5.86, -8.66, 5.98, 3, -8.75, 5.67, -8.69, 5.53, -9.00, 5.31, 
	3, -8.90, 5.08, -8.66, 4.99, -8.33, 4.98, 3, -8.22, 5.09, -8.22, 5.37, -8.33, 5.48, 3, -8.09, 5.33, 
	-7.54, 5.50, -7.42, 5.23, 3, -7.74, 4.65, -7.83, 3.27, -6.92, 2.99, 0, 1, 22.74, 3.15, 3, 22.76, 3.39, 
	22.75, 3.61, 22.49, 3.57, 3, 22.52, 3.42, 22.41, 3.40, 22.41, 3.49, 3, 22.16, 3.34, 22.46, 3.04, 22.74, 
	3.15, 0, 1, 21.99, 3.32, 3, 22.21, 3.30, 22.21, 3.49, 22.24, 3.65, 3, 22.09, 3.64, 22.07, 3.75, 21.91, 
	3.73, 3, 21.84, 3.50, 22.03, 3.52, 21.99, 3.32, 0, 1, -24.95, 3.82, 3, -25.36, 3.61, -25.57, 4.26, -25.94, 
	3.82, 3, -25.76, 3.65, -24.96, 3.43, -24.95, 3.82, 0, 1, 12.44, 3.57, 3, 12.56, 3.64, 12.70, 3.69, 12.69, 
	3.90, 3, 12.52, 4.08, 12.36, 3.88, 12.19, 3.82, 3, 12.20, 3.66, 12.47, 3.76, 12.44, 3.57, 0, 1, 16.34, 
	3.98, 3, 16.15, 4.17, 16.37, 4.31, 16.34, 4.57, 3, 15.74, 4.61, 15.67, 5.06, 15.02, 4.73, 3, 15.02, 
	4.59, 15.02, 4.45, 15.02, 4.32, 3, 15.60, 4.34, 15.72, 3.91, 16.34, 3.98, 0, 1, 1.81, 4.57, 3, 2.09, 
	4.64, 2.77, 4.76, 2.89, 4.73, 3, 2.99, 4.84, 2.74, 5.30, 2.72, 5.56, 3, 2.12, 5.63, 1.73, 5.58, 1.31, 
	5.31, 3, 1.40, 4.99, 1.70, 4.88, 1.81, 4.57, 0, 1, 8.62, 4.73, 3, 9.02, 5.06, 9.69, 4.78, 10.11, 4.81, 
	3, 10.10, 4.91, 10.13, 4.96, 10.20, 4.98, 3, 10.30, 5.25, 9.93, 5.04, 10.03, 5.31, 3, 9.76, 5.29, 9.41, 
	5.10, 9.37, 5.48, 3, 8.95, 5.54, 8.76, 5.31, 8.45, 5.48, 3, 8.55, 5.15, 8.74, 5.10, 8.62, 4.73, 0, 1, 
	5.63, 4.98, 3, 5.77, 5.12, 5.84, 5.32, 6.13, 5.31, 3, 5.95, 5.60, 6.00, 6.13, 5.38, 6.14, 3, 5.33, 6.02, 
	5.48, 5.71, 5.30, 5.73, 3, 5.77, 5.66, 5.46, 5.30, 5.63, 4.98, 0, 1, -16.64, 5.23, 3, -16.92, 6.47, 
	-18.12, 5.68, -19.05, 5.56, 3, -18.13, 5.07, -17.40, 5.11, -16.64, 5.23, 0, 1, -14.64, 6.98, 3, -15.21, 
	6.61, -15.17, 5.62, -14.81, 5.15, 3, -13.83, 5.20, -14.27, 6.40, -14.64, 6.98, 0, 1, -10.41, 5.06, 3, 
	-10.12, 5.25, -9.81, 5.41, -9.91, 5.98, 3, -10.27, 6.06, -10.65, 6.12, -10.82, 6.39, 3, -11.15, 6.16, 
	-11.76, 6.28, -12.07, 6.23, 3, -11.71, 5.54, -10.69, 5.90, -10.41, 5.06, 0, 1, -4.42, 5.06, 3, -4.13, 
	5.12, -4.31, 5.45, -4.42, 5.56, 3, -4.10, 5.51, -3.57, 5.22, -3.34, 5.56, 3, -3.61, 6.11, -4.23, 5.81, 
	-4.67, 6.14, 3, -4.93, 6.21, -4.83, 5.92, -5.09, 5.98, 3, -5.05, 5.49, -4.57, 5.45, -4.42, 5.06, 0, 
	1, 1.97, 6.31, 3, 2.15, 6.36, 2.24, 6.49, 2.39, 6.56, 3, 2.27, 6.80, 2.27, 7.16, 1.89, 7.14, 3, 2.20, 
	6.99, 1.81, 6.52, 1.97, 6.31, 0, 1, -1.43, 6.48, 3, -0.98, 6.66, -1.02, 6.83, -0.77, 7.22, 3, -1.22, 
	7.20, -1.35, 6.86, -1.43, 6.48, 0, 1, 24.49, 6.48, 3, 24.65, 6.66, 24.75, 6.91, 25.07, 6.73, 3, 25.11, 
	7.29, 24.16, 6.72, 24.49, 6.48, 0, 1, 18.59, 6.98, 3, 18.75, 7.18, 18.98, 6.84, 19.17, 7.06, 3, 19.14, 
	7.71, 18.16, 7.43, 18.59, 6.98, 0, 1, -21.54, 7.39, 3, -21.47, 7.45, -21.35, 7.85, -21.54, 7.89, 3, 
	-21.15, 8.19, -20.91, 8.29, -20.54, 8.30, 3, -21.04, 8.98, -21.99, 8.21, -22.79, 8.30, 3, -22.75, 7.36, 
	-22.09, 7.48, -21.54, 7.39, 0, 1, -11.24, 7.47, 3, -10.99, 7.51, -10.96, 7.75, -10.74, 7.81, 3, -11.17, 
	8.48, -10.74, 9.24, -11.15, 9.97, 3, -11.48, 10.00, -11.41, 10.03, -11.74, 10.13, 3, -11.81, 9.83, -11.41, 
	9.58, -11.65, 9.38, 3, -11.34, 9.30, -11.39, 8.87, -11.24, 8.64, 3, -11.45, 8.52, -11.45, 8.19, -11.74, 
	8.14, 3, -11.65, 7.83, -11.43, 7.66, -11.24, 7.47, 0, 1, 12.36, 7.56, 3, 12.66, 7.70, 12.70, 8.10, 12.85, 
	8.39, 3, 12.41, 8.68, 12.00, 8.55, 11.69, 8.89, 3, 11.48, 8.88, 11.37, 8.77, 11.36, 8.55, 3, 11.69, 
	8.22, 12.45, 8.31, 12.36, 7.56, 0, 1, 2.72, 7.89, 3, 2.81, 8.08, 3.06, 8.36, 2.89, 8.55, 3, 2.37, 8.64, 
	2.57, 8.05, 2.72, 7.89, 0, 1, -1.85, 7.97, 3, -1.58, 8.25, -1.21, 7.98, -0.69, 8.06, 3, -0.58, 8.22, 
	-0.75, 8.39, -0.60, 8.64, 3, -1.27, 8.76, -1.91, 9.31, -2.68, 9.05, 3, -2.58, 8.52, -1.99, 8.47, -1.85, 
	7.97, 0, 1, -18.05, 8.22, 3, -18.10, 8.31, -18.24, 8.31, -18.22, 8.47, 3, -18.38, 8.44, -18.57, 8.44, 
	-18.55, 8.22, 3, -18.33, 8.11, -18.23, 8.17, -18.05, 8.22, 0, 1, 1.81, 8.14, 3, 2.07, 8.10, 2.03, 8.36, 
	2.22, 8.39, 3, 2.19, 8.66, 1.98, 8.75, 1.89, 8.97, 3, 1.63, 8.76, 1.75, 8.35, 1.81, 8.14, 0, 1, -14.81, 
	8.39, 3, -14.60, 8.30, -14.41, 8.64, -14.31, 8.39, 3, -14.10, 8.40, -14.18, 8.70, -14.06, 8.80, 3, -13.69, 
	8.51, -13.56, 9.04, -13.23, 9.05, 3, -13.66, 10.00, -15.09, 9.52, -15.97, 9.55, 3, -16.08, 9.08, -15.64, 
	9.16, -15.64, 8.80, 3, -15.40, 8.76, -15.17, 9.07, -15.22, 8.64, 3, -14.97, 8.58, -15.06, 8.87, -14.81, 
	8.80, 3, -14.57, 8.73, -14.92, 8.59, -14.81, 8.39, 0, 1, -6.75, 8.97, 3, -6.98, 9.90, -8.16, 9.87, -8.74, 
	9.47, 3, -8.23, 8.88, -7.58, 8.40, -6.75, 8.97, 0, 1, -4.76, 8.64, 3, -4.62, 8.61, -4.61, 8.72, -4.51, 
	8.72, 3, -4.62, 9.03, -4.49, 9.28, -4.67, 9.63, 3, -4.87, 9.56, -4.89, 9.30, -4.92, 9.05, 3, -4.67, 
	8.99, -4.66, 8.89, -4.76, 8.64, 0, 1, 1.72, 9.05, 3, 1.81, 9.27, 2.14, 9.25, 2.06, 9.63, 3, 1.74, 9.64, 
	1.82, 9.73, 1.56, 9.63, 3, 1.67, 9.49, 1.78, 9.35, 1.72, 9.05, 0, 1, -18.47, 9.63, 3, -18.33, 9.63, 
	-18.19, 9.63, -18.05, 9.63, 3, -17.86, 10.10, -18.39, 10.17, -18.30, 10.55, 3, -18.52, 10.61, -18.47, 
	10.38, -18.63, 10.38, 3, -18.29, 10.23, -18.47, 10.05, -18.47, 9.63, 0, 1, 3.72, 9.72, 3, 3.73, 10.09, 
	3.62, 10.34, 3.30, 10.38, 3, 3.27, 10.31, 3.23, 10.23, 3.14, 10.22, 3, 3.24, 9.96, 3.29, 9.65, 3.72, 
	9.72, 0, 1, -1.27, 10.47, 3, -1.17, 10.63, -1.31, 11.10, -1.68, 11.05, 3, -1.74, 10.66, -1.49, 10.57, 
	-1.27, 10.47, 0, 1, 8.87, 10.88, 3, 9.08, 10.89, 9.03, 11.16, 9.03, 11.38, 3, 9.59, 10.84, 10.36, 11.18, 
	10.61, 11.79, 3, 9.96, 11.81, 8.43, 12.00, 8.20, 11.13, 3, 8.50, 11.12, 8.77, 11.09, 8.87, 10.88, 0, 
	1, -25.03, 11.79, 3, -25.41, 11.82, -25.49, 11.54, -25.78, 11.46, 3, -25.77, 10.55, -24.64, 11.17, -25.03, 
	11.79, 0, 1, 15.76, 11.05, 3, 15.97, 11.25, 15.59, 11.22, 15.68, 11.55, 3, 15.40, 11.57, 15.16, 11.63, 
	15.02, 11.79, 3, 14.84, 11.55, 14.56, 11.58, 14.35, 11.55, 3, 14.54, 10.93, 15.17, 11.13, 15.76, 11.05, 
	0, 1, -28.27, 11.21, 3, -28.28, 11.42, -28.39, 11.53, -28.60, 11.55, 3, -28.56, 11.81, -28.29, 11.84, 
	-28.27, 12.13, 3, -28.38, 12.13, -28.49, 12.13, -28.60, 12.13, 3, -28.79, 11.77, -28.81, 10.97, -28.27, 
	11.21, 0, 1, -8.25, 11.30, 3, -8.05, 11.29, -8.00, 11.44, -7.75, 11.38, 3, -7.70, 11.60, -7.85, 12.04, 
	-7.66, 12.13, 3, -7.83, 12.29, -7.96, 12.50, -8.16, 12.63, 3, -7.84, 12.84, -8.43, 12.81, -8.08, 13.12, 
	3, -8.31, 13.18, -8.25, 12.96, -8.41, 12.96, 3, -8.23, 12.47, -8.50, 12.15, -8.66, 11.79, 3, -8.44, 
	11.71, -8.29, 11.55, -8.25, 11.30, 0, 1, -1.27, 11.46, 3, -1.30, 11.73, -1.40, 11.94, -1.77, 11.88, 
	3, -1.84, 11.50, -1.59, 11.44, -1.27, 11.46, 0, 1, 5.38, 11.46, 3, 5.34, 12.26, 5.74, 12.24, 5.55, 12.87, 
	3, 5.18, 12.78, 5.11, 13.24, 4.88, 13.04, 3, 5.23, 12.58, 4.88, 12.24, 4.88, 11.55, 3, 4.98, 11.45, 
	5.17, 11.45, 5.38, 11.46, 0, 1, -16.39, 11.79, 3, -16.59, 11.81, -16.79, 11.81, -16.89, 11.71, 3, -16.77, 
	11.57, -16.35, 11.42, -16.39, 11.79, 0, 1, -5.67, 11.71, 3, -5.50, 12.03, -5.79, 12.58, -6.17, 12.63, 
	3, -6.17, 12.43, -6.17, 12.24, -6.17, 12.04, 3, -5.89, 12.30, -5.72, 11.94, -5.67, 11.71, 0, 1, -21.46, 
	11.96, 3, -21.64, 12.19, -21.74, 12.26, -21.62, 12.63, 3, -22.11, 12.52, -21.94, 11.66, -21.46, 11.96, 
	0, 1, -10.49, 11.96, 3, -10.13, 13.13, -11.64, 13.36, -12.57, 12.79, 3, -12.34, 12.68, -12.03, 12.66, 
	-11.98, 12.38, 3, -11.87, 12.42, -11.78, 12.51, -11.74, 12.63, 3, -11.56, 12.44, -11.17, 12.47, -11.24, 
	12.04, 3, -10.93, 12.34, -10.81, 12.07, -10.49, 11.96, 0, 1, -16.89, 12.21, 3, -16.81, 12.28, -16.84, 
	12.44, -16.72, 12.46, 3, -16.85, 12.88, -17.22, 13.06, -17.80, 13.04, 3, -17.74, 12.97, -17.71, 12.85, 
	-17.72, 12.71, 3, -18.28, 13.55, -19.18, 12.44, -19.88, 12.71, 3, -19.89, 11.43, -17.91, 12.50, -16.89, 
	12.21, 0, 1, -6.34, 12.54, 3, -6.67, 12.62, -6.59, 12.29, -6.92, 12.38, 3, -6.84, 12.06, -6.39, 12.34, 
	-6.34, 12.54, 0, 1, 1.64, 13.79, 3, 1.81, 13.57, 2.05, 13.99, 2.06, 14.20, 3, 1.65, 14.33, 1.81, 13.90, 
	1.64, 13.79, 0, 1, -4.92, 14.04, 3, -4.84, 14.04, -4.76, 14.04, -4.67, 14.04, 3, -4.60, 14.13, -4.56, 
	14.26, -4.59, 14.45, 3, -4.85, 14.47, -4.88, 14.24, -4.92, 14.04, 0, 1, 18.34, 14.12, 3, 18.55, 14.39, 
	18.55, 14.63, 18.92, 14.37, 3, 18.93, 14.80, 18.40, 15.03, 18.09, 14.87, 3, 18.12, 14.56, 18.29, 14.41, 
	18.34, 14.12, 0, 1, 2.06, 14.29, 3, 2.10, 14.84, 2.16, 15.11, 1.89, 15.45, 3, 1.78, 15.36, 1.58, 15.37, 
	1.47, 15.28, 3, 1.48, 15.02, 1.66, 14.92, 1.97, 14.95, 3, 1.83, 14.81, 1.64, 14.73, 1.64, 14.45, 3, 
	1.90, 14.52, 1.80, 14.22, 2.06, 14.29, 0, 1, -11.32, 14.70, 3, -10.83, 14.68, -10.91, 15.11, -11.07, 
	15.37, 3, -11.28, 15.28, -11.52, 14.94, -11.32, 14.70, 0, 1, 12.94, 14.87, 3, 12.92, 15.24, 12.69, 15.39, 
	12.27, 15.37, 3, 12.28, 14.88, 12.66, 15.16, 12.94, 14.87, 0, 1, 12.11, 15.20, 3, 12.09, 15.27, 12.02, 
	15.28, 12.02, 15.37, 3, 12.04, 15.46, 12.11, 15.41, 12.11, 15.37, 3, 12.04, 15.97, 11.17, 15.40, 10.86, 
	15.95, 3, 10.78, 15.21, 11.75, 15.51, 12.11, 15.20, 0, 1, -7.17, 15.45, 3, -7.20, 15.85, -7.74, 16.38, 
	-8.08, 15.95, 3, -7.96, 16.24, -9.03, 16.32, -9.08, 15.86, 3, -8.97, 15.88, -8.62, 15.73, -8.83, 15.70, 
	3, -8.16, 15.45, -7.67, 15.37, -7.17, 15.45, 0, 1, -18.05, 15.45, 3, -18.04, 15.88, -18.26, 16.07, -18.63, 
	16.11, 3, -18.52, 15.81, -18.52, 15.39, -18.05, 15.45, 0, 1, -13.90, 15.61, 3, -14.25, 16.20, -15.13, 
	16.33, -16.14, 16.20, 3, -16.10, 16.04, -15.90, 16.05, -15.97, 15.78, 3, -15.40, 15.85, -14.62, 15.52, 
	-13.90, 15.61, 0, 1, -0.27, 15.61, 3, -0.53, 15.86, -0.96, 16.01, -1.27, 15.78, 3, -1.16, 15.47, -0.60, 
	15.55, -0.27, 15.61, 0, 1, -2.35, 15.61, 3, -2.03, 15.69, -1.37, 15.58, -1.60, 16.11, 3, -1.91, 16.01, 
	-2.24, 15.92, -2.35, 15.61, 0, 1, 8.53, 15.61, 3, 8.82, 15.61, 8.58, 16.12, 8.87, 16.11, 3, 8.85, 16.23, 
	8.62, 16.14, 8.62, 16.28, 3, 8.42, 16.06, 8.67, 15.90, 8.53, 15.61, 0, 1, -25.36, 15.95, 3, -25.02, 
	15.92, -24.93, 16.46, -25.03, 16.61, 3, -25.38, 16.60, -25.53, 16.39, -25.61, 16.11, 3, -25.54, 16.04, 
	-25.38, 16.06, -25.36, 15.95, 0, 1, -11.24, 16.03, 3, -10.89, 16.14, -11.25, 16.37, -11.24, 16.61, 3, 
	-11.42, 16.55, -11.34, 16.22, -11.57, 16.20, 3, -11.63, 15.97, -11.18, 16.26, -11.24, 16.03, 0, 1, -26.94, 
	16.20, 3, -26.99, 16.27, -27.17, 16.32, -27.02, 16.36, 3, -27.13, 16.51, -27.79, 16.53, -27.69, 16.20, 
	3, -27.51, 16.03, -27.14, 16.13, -26.94, 16.20, 0, 1, -20.54, 16.94, 3, -21.18, 17.09, -21.58, 17.07, 
	-22.29, 16.94, 3, -22.25, 16.78, -21.91, 16.94, -22.04, 16.61, 3, -21.26, 16.81, -20.29, 15.81, -20.54, 
	16.94, 0, 1, -8.58, 18.36, 3, -8.17, 18.42, -8.26, 18.55, -7.91, 18.36, 3, -8.11, 19.01, -7.93, 19.53, 
	-8.50, 19.77, 3, -8.57, 19.45, -8.29, 19.47, -8.25, 19.27, 3, -8.32, 19.03, -8.37, 19.46, -8.58, 19.35, 
	3, -8.59, 18.81, -8.33, 18.76, -8.58, 18.36, 0, 1, 1.89, 19.02, 3, 2.65, 18.81, 2.57, 19.83, 2.22, 20.02, 
	3, 2.13, 19.75, 1.61, 19.91, 1.39, 19.77, 3, 1.45, 19.35, 1.94, 19.35, 1.89, 19.02, 0, 1, 9.20, 19.02, 
	3, 9.22, 19.26, 9.21, 19.47, 8.95, 19.44, 3, 8.96, 19.29, 8.85, 19.26, 8.87, 19.10, 3, 8.94, 19.04, 
	9.06, 19.02, 9.20, 19.02, 0, 1, 8.45, 19.10, 3, 8.67, 19.13, 8.73, 19.32, 8.78, 19.52, 3, 8.38, 19.71, 
	8.18, 19.61, 7.70, 19.69, 3, 7.67, 19.21, 8.25, 19.35, 8.45, 19.10, 0, 1, -24.61, 19.19, 3, -24.53, 
	19.67, -25.31, 19.57, -25.44, 19.36, 3, -25.22, 19.09, -25.02, 19.30, -24.61, 19.19, 0, 1, -3.68, 19.44, 
	3, -3.81, 19.92, -4.15, 19.80, -4.67, 19.77, 3, -4.58, 19.75, -4.17, 19.33, -3.68, 19.44, 0, 1, -11.24, 
	19.52, 3, -10.97, 19.50, -10.84, 19.62, -10.82, 19.85, 3, -10.98, 20.09, -11.17, 20.13, -11.40, 19.94, 
	3, -11.37, 19.78, -11.17, 19.78, -11.24, 19.52, 0, 1, -4.92, 19.52, 3, -4.96, 19.78, -4.77, 19.81, -4.84, 
	20.10, 3, -5.45, 20.12, -5.44, 20.41, -6.00, 20.35, 3, -6.48, 19.75, -5.43, 19.64, -4.92, 19.52, 0, 
	1, -11.82, 19.60, 3, -11.51, 19.68, -11.63, 20.35, -12.07, 20.19, 3, -12.17, 19.80, -11.92, 19.78, -11.82, 
	19.60, 0, 1, -17.80, 19.85, 3, -17.95, 20.18, -18.75, 20.20, -18.80, 19.77, 3, -18.52, 19.58, -18.02, 
	19.73, -17.80, 19.85, 0, 1, -14.98, 19.94, 3, -14.67, 20.21, -14.94, 20.63, -15.23, 20.77, 3, -15.06, 
	20.61, -15.20, 20.46, -15.23, 20.27, 3, -15.10, 20.19, -14.96, 20.14, -14.98, 19.94, 0, 1, 4.88, 23.18, 
	3, 4.99, 23.39, 5.38, 23.11, 5.38, 23.26, 3, 5.45, 23.57, 4.98, 23.36, 4.80, 23.42, 3, 4.78, 23.36, 
	4.83, 23.35, 4.88, 23.34, 3, 4.88, 23.29, 4.88, 23.23, 4.88, 23.18, 0, 1, -7.75, 23.67, 3, -8.06, 23.61, 
	-8.14, 23.78, -8.41, 23.76, 3, -8.48, 23.69, -8.46, 23.53, -8.58, 23.51, 3, -8.47, 23.28, -7.76, 23.33, 
	-7.75, 23.67, 0, 1, -8.16, 25.25, 3, -8.03, 25.23, -8.02, 25.33, -7.91, 25.34, 3, -7.88, 25.54, -8.07, 
	25.52, -8.00, 25.75, 3, -8.21, 25.74, -8.16, 25.47, -8.16, 25.25, 0, 1, -25.36, 25.58, 3, -25.24, 25.85, 
	-25.84, 25.98, -25.78, 25.67, 3, -25.68, 25.60, -25.55, 25.56, -25.36, 25.58, 0, 1, -18.05, 26.50, 3, 
	-18.05, 26.73, -18.44, 26.70, -18.55, 26.58, 3, -18.47, 26.31, -18.21, 26.30, -18.05, 26.50, 0, 1, -14.56, 
	26.67, 3, -14.49, 26.71, -14.43, 26.75, -14.31, 26.75, 3, -14.39, 27.00, -14.53, 27.19, -14.56, 27.50, 
	3, -14.67, 27.50, -14.78, 27.50, -14.89, 27.50, 3, -14.83, 27.17, -14.75, 26.86, -14.56, 26.67, 0, 1, 
	-14.73, 27.75, 3, -14.64, 27.75, -14.56, 27.75, -14.48, 27.75, 3, -14.52, 27.87, -14.38, 28.18, -14.56, 
	28.16, 3, -14.84, 28.25, -14.69, 27.90, -14.73, 27.75, 0, 1, -4.84, 28.33, 3, -4.48, 28.44, -4.85, 28.67, 
	-4.92, 28.82, 3, -5.19, 28.68, -5.01, 28.45, -4.84, 28.33, 0, 1, 21.58, -22.35, 3, 21.67, -22.34, 21.63, 
	-22.27, 21.58, -22.27, 3, 21.52, -22.01, 21.81, -22.11, 21.74, -21.85, 3, 21.32, -21.86, 21.12, -21.89, 
	20.91, -21.94, 3, 21.00, -22.34, 21.38, -22.00, 21.58, -22.35, 0, 1, 7.12, -11.72, 3, 7.26, -11.66, 
	7.17, -11.53, 7.04, -11.55, 3, 7.05, -11.13, 7.16, -11.04, 7.04, -10.80, 3, 6.95, -10.82, 6.99, -10.89, 
	7.04, -10.89, 3, 6.98, -10.96, 6.89, -11.01, 6.79, -11.05, 3, 6.86, -11.23, 7.01, -11.34, 6.96, -11.63, 
	3, 7.05, -11.62, 7.10, -11.65, 7.12, -11.72, 0, 1, 9.95, -7.06, 3, 10.45, -7.18, 9.85, -7.84, 10.36, 
	-7.81, 3, 10.27, -7.96, 10.14, -8.09, 10.03, -8.23, 3, 10.34, -8.72, 10.59, -7.98, 10.61, -7.65, 3, 
	10.61, -7.40, 10.42, -7.34, 10.28, -7.23, 3, 10.44, -6.93, 10.23, -6.77, 10.36, -6.48, 3, 10.19, -6.20, 
	10.05, -6.52, 9.95, -6.40, 3, 9.72, -6.58, 10.33, -6.93, 9.95, -7.06, 0, 1, 13.69, -8.31, 3, 13.96, 
	-8.06, 14.61, -8.18, 14.77, -7.81, 3, 13.84, -7.63, 13.08, -7.52, 12.36, -7.65, 3, 12.41, -7.13, 11.84, 
	-7.81, 11.53, -7.40, 3, 12.12, -8.02, 12.83, -7.93, 13.69, -8.31, 0, 1, 20.83, -8.06, 3, 20.42, -7.37, 
	19.15, -7.95, 18.67, -7.48, 3, 18.71, -7.64, 18.61, -7.78, 18.59, -7.65, 3, 18.85, -7.98, 20.35, -8.39, 
	20.83, -8.06, 0, 1, -0.69, -0.75, 3, -0.68, -1.29, -0.76, -1.64, -0.27, -2.00, 3, -0.33, -2.14, -0.65, 
	-2.44, -0.77, -2.25, 3, -0.94, -2.53, -0.37, -2.44, -0.36, -2.91, 3, -0.22, -2.91, -0.08, -2.91, 0.06, 
	-2.91, 3, 0.24, -1.90, -0.09, -1.25, -0.11, -0.42, 3, -0.15, -0.29, -0.19, -0.41, -0.19, -0.50, 3, -0.30, 
	-0.52, -0.53, -0.57, -0.69, -0.75, 0, 1, -27.44, -1.25, 3, -27.06, -1.12, -26.90, -1.27, -26.44, -1.25, 
	3, -26.48, -0.93, -26.06, -1.08, -26.19, -0.67, 3, -26.55, -0.55, -26.49, -0.87, -26.69, -0.92, 3, -26.88, 
	-0.83, -27.06, -0.73, -27.19, -0.59, 3, -27.38, -0.73, -27.46, -0.92, -27.60, -0.75, 3, -27.76, -0.81, 
	-27.50, -1.14, -27.44, -1.25, 0, 1, -19.05, 1.41, 3, -18.88, 1.22, -19.30, 1.11, -19.38, 0.91, 3, -19.55, 
	0.93, -19.55, 1.13, -19.63, 1.24, 3, -20.42, 1.12, -21.26, 1.05, -21.37, 0.25, 3, -20.45, 0.49, -19.76, 
	-0.05, -19.38, 0.74, 3, -18.96, 0.72, -18.83, 0.86, -18.30, 0.66, 3, -18.27, 0.88, -18.05, 0.91, -18.05, 
	1.16, 3, -17.69, 1.08, -17.42, 0.55, -17.05, 0.75, 3, -17.02, 1.14, -17.37, 1.67, -16.72, 1.58, 3, -16.73, 
	1.79, -17.03, 1.71, -17.14, 1.83, 3, -16.97, 2.37, -17.43, 2.49, -17.55, 3.07, 3, -18.13, 2.83, -17.67, 
	2.00, -18.13, 1.74, 3, -18.13, 1.50, -17.74, 1.64, -17.64, 1.49, 3, -17.55, 1.01, -18.40, 1.34, -18.13, 
	1.49, 3, -18.26, 1.61, -18.65, 1.30, -19.05, 1.41, 0, 1, 12.69, 4.81, 3, 12.69, 4.73, 12.69, 4.65, 12.69, 
	4.57, 3, 12.67, 4.39, 12.32, 4.54, 12.27, 4.40, 3, 12.29, 4.17, 12.42, 4.05, 12.69, 4.07, 3, 12.85, 
	4.71, 12.83, 5.26, 12.19, 5.48, 3, 12.08, 5.22, 12.44, 5.02, 12.19, 4.90, 3, 12.20, 4.72, 12.54, 4.86, 
	12.69, 4.81, 0, 1, 8.53, 8.30, 3, 8.69, 8.18, 9.09, 8.31, 8.95, 7.89, 3, 9.07, 7.90, 9.19, 7.90, 9.20, 
	7.81, 3, 9.51, 8.18, 8.78, 8.65, 8.95, 8.89, 3, 8.80, 9.04, 8.55, 8.57, 8.53, 8.30, 0, 1, 6.79, 8.30, 
	3, 6.79, 8.47, 6.79, 8.64, 6.79, 8.80, 3, 6.30, 9.08, 5.43, 8.98, 4.71, 9.05, 3, 4.59, 8.75, 4.59, 8.56, 
	4.30, 8.80, 3, 4.94, 8.09, 6.15, 8.42, 6.79, 8.30, 0, 1, 2.89, 11.13, 3, 2.88, 11.25, 2.87, 11.36, 2.97, 
	11.38, 3, 2.61, 11.73, 2.08, 11.40, 1.89, 11.88, 3, 1.28, 11.57, 0.91, 11.81, 0.39, 11.79, 3, 0.56, 
	11.35, 0.88, 11.06, 1.23, 10.80, 3, 1.32, 11.06, 1.20, 11.02, 1.31, 11.21, 3, 1.46, 10.95, 2.31, 11.23, 
	2.06, 10.80, 3, 2.18, 10.87, 2.32, 10.92, 2.31, 11.13, 3, 2.69, 10.78, 2.32, 11.35, 2.89, 11.13, 0, 
	1, -4.42, 11.55, 3, -4.48, 11.08, -4.25, 12.11, -3.84, 11.96, 3, -4.08, 12.45, -5.12, 12.55, -5.59, 
	12.54, 3, -5.41, 12.14, -5.57, 11.74, -5.17, 11.46, 3, -4.99, 11.69, -4.82, 11.95, -4.34, 11.88, 3, 
	-4.35, 11.74, -4.30, 11.56, -4.42, 11.55, 0, 1, 11.53, 11.96, 3, 11.52, 11.71, 11.70, 11.64, 11.78, 
	11.46, 3, 12.12, 11.72, 12.26, 12.77, 11.86, 13.04, 3, 11.90, 12.85, 11.83, 12.24, 11.53, 11.96, 0, 
	1, 4.80, 15.03, 3, 5.13, 15.47, 6.02, 14.86, 6.13, 15.53, 3, 5.76, 15.24, 4.96, 16.00, 4.88, 15.28, 
	3, 4.71, 15.21, 4.71, 15.71, 4.63, 15.45, 3, 4.40, 15.15, 4.90, 15.53, 4.80, 15.03, 0, 1, -5.01, 17.11, 
	3, -4.92, 17.18, -5.13, 17.65, -5.51, 17.53, 3, -5.44, 17.28, -5.21, 17.21, -5.01, 17.11, 0, 1, -1.43, 
	-11.80, 3, -1.09, -11.72, -1.42, -11.48, -1.27, -11.22, 3, -2.49, -10.93, -3.45, -10.47, -4.51, -10.30, 
	3, -4.63, -10.78, -4.05, -10.57, -4.18, -11.05, 3, -3.35, -11.02, -2.07, -11.92, -1.68, -11.55, 3, -1.46, 
	-11.49, -1.52, -11.72, -1.43, -11.80, 0 }

shape[4] = { 1, -2.36, -30.34, 3, -2.14, -30.15, -2.17, -29.81, -2.54, -29.81, 3, -2.73, -30.00, -2.44, -30.16, -2.36, 
	-30.34, 0, 1, 1.64, -28.03, 3, 2.02, -27.30, 2.12, -25.60, 1.11, -25.18, 3, 1.46, -26.25, 1.37, -27.22, 
	1.64, -28.03, 0, 1, -6.37, -27.23, 3, -6.14, -27.24, -6.09, -27.09, -5.92, -27.05, 3, -6.17, -26.53, 
	-5.74, -26.05, -5.92, -25.45, 3, -6.27, -25.82, -6.23, -26.07, -6.72, -26.34, 3, -6.50, -26.67, -6.38, 
	-26.87, -6.37, -27.23, 0, 1, -0.94, -26.43, 3, -1.10, -25.87, -1.70, -26.06, -2.27, -26.07, 3, -2.10, 
	-26.57, -1.63, -26.36, -0.94, -26.43, 0, 1, -11.53, -23.85, 3, -11.19, -23.86, -11.11, -23.62, -11.08, 
	-23.32, 3, -11.26, -23.31, -11.19, -23.07, -11.44, -23.14, 3, -11.48, -23.45, -11.70, -23.54, -11.53, 
	-23.85, 0, 1, -19.53, -23.76, 3, -19.38, -23.65, -19.18, -23.58, -19.18, -23.32, 3, -19.69, -23.22, 
	-19.49, -22.75, -19.62, -22.43, 3, -19.69, -22.47, -19.77, -22.52, -19.89, -22.51, 3, -19.76, -23.00, 
	-19.95, -23.45, -19.53, -23.76, 0, 1, 12.50, -23.67, 3, 13.13, -23.65, 12.70, -22.83, 13.03, -22.69, 
	3, 12.82, -22.52, 12.74, -22.21, 12.32, -22.25, 3, 11.83, -22.78, 12.46, -23.14, 12.50, -23.67, 0, 1, 
	-3.07, -23.23, 3, -3.41, -22.81, -3.06, -22.69, -2.98, -22.25, 3, -3.34, -22.34, -3.25, -21.98, -3.61, 
	-22.07, 3, -4.33, -22.47, -3.69, -24.01, -3.07, -23.23, 0, 1, 5.91, -23.40, 3, 6.14, -23.06, 6.21, -21.95, 
	5.47, -22.16, 3, 5.79, -22.55, 5.53, -23.03, 5.91, -23.40, 0, 1, -0.14, -23.14, 3, 0.13, -22.98, 1.15, 
	-23.23, 1.29, -22.78, 3, 0.70, -22.62, 0.32, -22.62, -0.31, -22.87, 3, -0.33, -22.99, 0.14, -23.05, 
	-0.14, -23.14, 0, 1, 16.06, -23.05, 3, 16.28, -23.06, 16.48, -23.06, 16.59, -22.96, 3, 16.45, -22.80, 
	16.06, -22.70, 16.06, -23.05, 0, 1, 2.09, -22.96, 3, 2.16, -22.91, 2.23, -22.87, 2.35, -22.87, 3, 2.37, 
	-22.62, 2.37, -22.38, 2.09, -22.43, 3, 1.97, -22.54, 1.97, -22.84, 2.09, -22.96, 0, 1, 9.29, -22.96, 
	3, 9.53, -22.96, 9.80, -22.99, 9.92, -22.87, 3, 9.76, -22.76, 9.68, -22.57, 9.38, -22.60, 3, 9.40, -22.76, 
	9.27, -22.79, 9.29, -22.96, 0, 1, 5.65, -21.98, 3, 5.72, -21.93, 5.79, -21.89, 5.91, -21.89, 3, 5.87, 
	-21.69, 5.76, -21.57, 5.56, -21.54, 3, 5.53, -21.74, 5.57, -21.88, 5.65, -21.98, 0, 1, 0.04, -21.45, 
	3, 0.13, -21.45, 0.22, -21.45, 0.31, -21.45, 3, 0.23, -19.77, 0.84, -17.27, -0.58, -16.73, 3, -0.33, 
	-17.43, -0.75, -18.12, -0.14, -18.69, 3, -0.52, -18.96, -0.44, -19.69, -0.67, -20.11, 3, -0.41, -20.53, 
	-0.17, -20.98, 0.04, -21.45, 0, 1, -16.33, -18.87, 3, -16.55, -19.36, -16.05, -19.84, -16.33, -20.47, 
	3, -14.82, -20.83, -15.33, -19.11, -16.33, -18.87, 0, 1, 16.77, -20.02, 3, 17.05, -20.06, 17.17, -19.95, 
	17.12, -19.67, 3, 16.85, -19.63, 16.73, -19.74, 16.77, -20.02, 0, 1, -8.06, -19.93, 3, -7.76, -19.82, 
	-7.32, -19.84, -7.17, -19.58, 3, -7.96, -18.75, -7.54, -17.50, -8.14, -16.47, 3, -9.03, -16.78, -8.16, 
	-18.02, -8.59, -18.42, 3, -8.54, -19.09, -8.10, -19.12, -8.06, -19.93, 0, 1, 7.60, -19.67, 3, 7.59, 
	-19.86, 7.92, -19.71, 8.05, -19.76, 3, 8.23, -19.49, 8.24, -19.06, 8.40, -18.78, 3, 8.20, -18.78, 7.99, 
	-18.78, 7.78, -18.78, 3, 7.83, -19.23, 7.63, -19.54, 7.60, -19.67, 0, 1, 3.60, -19.22, 3, 3.60, -19.05, 
	3.36, -19.11, 3.42, -18.87, 3, 3.27, -18.95, 2.94, -18.86, 2.98, -19.13, 3, 3.09, -19.26, 3.36, -19.22, 
	3.60, -19.22, 0, 1, 4.93, -18.95, 3, 4.68, -18.84, 4.46, -18.96, 4.04, -18.95, 3, 4.26, -19.21, 4.68, 
	-19.11, 4.93, -18.95, 0, 1, 12.76, -19.04, 3, 12.49, -18.63, 11.61, -18.78, 11.16, -18.78, 3, 11.48, 
	-19.03, 12.26, -19.28, 12.76, -19.04, 0, 1, 6.27, -18.95, 3, 6.08, -18.76, 5.78, -18.67, 5.38, -18.69, 
	3, 5.28, -19.16, 6.03, -19.10, 6.27, -18.95, 0, 1, 10.72, -19.04, 3, 11.01, -18.80, 10.53, -18.59, 10.45, 
	-18.42, 3, 9.84, -18.47, 9.66, -18.50, 9.12, -18.69, 3, 9.47, -19.21, 10.17, -18.56, 10.72, -19.04, 
	0, 1, 7.96, -18.60, 3, 8.44, -18.11, 7.96, -17.51, 8.05, -17.00, 3, 7.90, -17.00, 7.75, -17.00, 7.60, 
	-17.00, 3, 7.64, -17.66, 7.59, -18.09, 7.96, -18.60, 0, 1, 16.41, -18.24, 3, 16.53, -18.24, 16.65, -18.24, 
	16.77, -18.24, 3, 16.80, -17.91, 16.70, -17.72, 16.41, -17.71, 3, 16.29, -17.82, 16.29, -18.13, 16.41, 
	-18.24, 0, 1, 2.53, -17.71, 3, 2.54, -17.57, 2.49, -17.37, 2.62, -17.35, 3, 2.50, -17.09, 2.18, -17.38, 
	2.09, -17.44, 3, 2.15, -17.62, 2.32, -17.68, 2.53, -17.71, 0, 1, -4.67, -17.62, 3, -3.97, -16.77, -4.58, 
	-15.61, -3.87, -14.69, 3, -4.00, -14.28, -4.44, -14.18, -4.76, -13.97, 3, -4.91, -14.33, -5.36, -15.23, 
	-5.39, -15.75, 3, -5.01, -16.08, -4.91, -16.89, -5.03, -17.44, 3, -4.98, -17.57, -4.69, -17.46, -4.67, 
	-17.62, 0, 1, 12.41, -16.91, 3, 12.61, -15.71, 12.47, -15.25, 12.68, -14.42, 3, 12.54, -14.00, 12.00, 
	-14.30, 11.87, -14.24, 3, 11.56, -15.14, 12.55, -16.24, 11.96, -16.91, 3, 12.13, -17.08, 12.19, -16.92, 
	12.41, -16.91, 0, 1, -20.33, -16.73, 3, -20.16, -15.98, -20.77, -15.52, -20.33, -15.04, 3, -20.87, -15.13, 
	-20.56, -14.64, -20.69, -14.51, 3, -20.86, -14.58, -21.02, -14.66, -21.22, -14.68, 3, -21.20, -15.22, 
	-21.07, -15.68, -21.31, -16.02, 3, -21.14, -16.41, -20.90, -16.73, -20.33, -16.73, 0, 1, -16.15, -16.20, 
	3, -15.71, -16.20, -15.75, -15.71, -15.44, -15.57, 3, -15.53, -15.23, -16.06, -14.95, -16.33, -15.31, 
	3, -16.08, -15.60, -16.30, -15.89, -16.15, -16.20, 0, 1, -13.13, -16.20, 3, -12.88, -16.26, -12.95, 
	-16.02, -12.77, -16.02, 3, -12.78, -15.30, -13.01, -14.90, -13.04, -14.42, 3, -13.65, -14.43, -13.35, 
	-15.35, -13.57, -15.75, 3, -13.52, -15.99, -13.12, -15.89, -13.13, -16.20, 0, 1, -8.32, -16.20, 3, -8.24, 
	-15.84, -7.90, -15.73, -7.43, -15.75, 3, -7.87, -15.20, -9.41, -15.08, -10.10, -15.75, 3, -10.06, -15.82, 
	-10.01, -15.90, -10.01, -16.02, 3, -9.65, -16.11, -8.88, -16.06, -8.32, -16.20, 0, 1, 16.06, -15.75, 
	3, 15.34, -15.62, 15.08, -15.37, 14.10, -15.57, 3, 14.47, -15.97, 15.74, -16.15, 16.06, -15.75, 0, 1, 
	-17.75, -15.84, 3, -17.41, -15.91, -17.26, -15.55, -17.40, -15.40, 3, -17.61, -15.36, -17.59, -15.56, 
	-17.84, -15.48, 3, -17.88, -15.67, -17.78, -15.72, -17.75, -15.84, 0, 1, 1.20, -15.40, 3, 0.66, -14.49, 
	-0.51, -15.55, -1.12, -15.31, 3, -0.82, -16.23, 0.66, -15.70, 1.20, -15.40, 0, 1, 9.47, -15.31, 3, 8.68, 
	-15.36, 7.98, -15.25, 7.25, -15.31, 3, 7.72, -15.50, 9.17, -16.13, 9.47, -15.31, 0, 1, -1.20, -15.40, 
	3, -1.30, -15.19, -1.76, -15.36, -2.01, -15.31, 3, -2.00, -15.91, -1.43, -15.56, -1.20, -15.40, 0, 1, 
	10.09, -15.40, 3, 9.94, -15.23, 9.84, -15.44, 9.65, -15.48, 3, 9.67, -15.76, 10.13, -15.67, 10.09, -15.40, 
	0, 1, -17.13, -14.42, 3, -16.91, -14.30, -16.63, -13.91, -16.77, -13.70, 3, -16.98, -13.73, -17.11, 
	-13.85, -17.40, -13.79, 3, -17.36, -14.02, -17.36, -14.21, -17.13, -14.42, 0, 1, -9.03, -14.24, 3, -8.86, 
	-14.24, -8.68, -14.24, -8.50, -14.24, 3, -8.38, -13.77, -8.52, -13.03, -8.14, -12.82, 3, -8.40, -12.22, 
	-8.34, -11.59, -8.23, -11.13, 3, -8.32, -10.85, -8.77, -10.95, -8.68, -10.50, 3, -9.12, -10.59, -9.19, 
	-11.06, -9.66, -11.13, 3, -9.53, -12.32, -9.47, -13.04, -9.03, -14.24, 0, 1, -1.47, -13.97, 3, -1.26, 
	-13.66, -1.40, -13.41, -1.20, -12.99, 3, -1.36, -13.01, -1.39, -12.88, -1.56, -12.91, 3, -1.75, -13.18, 
	-1.65, -13.78, -1.47, -13.97, 0, 1, -0.14, -13.97, 3, 0.15, -13.75, 0.41, -13.09, 0.22, -12.91, 3, 0.85, 
	-12.64, 0.47, -11.90, 0.84, -11.39, 3, 0.70, -11.19, 0.32, -10.98, 0.66, -10.77, 3, 0.58, -10.61, 0.50, 
	-10.46, 0.22, -10.50, 3, 0.29, -9.95, -0.04, -9.81, -0.05, -9.34, 3, -0.78, -9.80, -0.43, -11.55, -0.94, 
	-12.46, 3, -0.82, -12.55, -0.61, -12.55, -0.49, -12.64, 3, -0.66, -12.95, -0.43, -12.93, -0.32, -13.17, 
	3, -0.25, -13.54, -0.74, -13.34, -0.67, -13.70, 3, -0.37, -13.67, -0.29, -13.86, -0.14, -13.97, 0, 1, 
	11.78, -13.97, 3, 11.95, -13.81, 12.01, -13.96, 12.23, -13.97, 3, 12.06, -13.81, 12.20, -13.65, 12.23, 
	-13.44, 3, 12.13, -13.51, 11.99, -13.56, 11.78, -13.53, 3, 11.78, -13.68, 11.78, -13.82, 11.78, -13.97, 
	0, 1, -4.32, -13.79, 3, -4.30, -13.45, -4.46, -13.28, -4.76, -13.26, 3, -4.97, -13.51, -4.69, -13.85, 
	-4.32, -13.79, 0, 1, 7.43, -13.62, 3, 7.54, -13.62, 7.66, -13.62, 7.78, -13.62, 3, 7.62, -12.61, 8.62, 
	-11.80, 7.60, -11.13, 3, 7.67, -10.85, 8.01, -10.53, 7.87, -10.32, 3, 7.65, -10.46, 7.34, -10.51, 7.16, 
	-10.68, 3, 7.40, -11.97, 7.08, -12.62, 7.43, -13.62, 0, 1, 15.79, -13.53, 3, 16.25, -13.28, 16.75, -12.06, 
	15.97, -11.84, 3, 15.96, -11.39, 16.38, -10.98, 16.15, -10.59, 3, 15.85, -10.63, 15.75, -10.85, 15.52, 
	-10.95, 3, 15.69, -11.41, 15.63, -11.95, 15.25, -12.11, 3, 15.45, -12.56, 15.73, -12.94, 15.79, -13.53, 
	0, 1, -17.40, -13.26, 3, -16.91, -13.12, -16.90, -12.51, -16.51, -12.28, 3, -16.55, -11.97, -16.83, 
	-11.89, -16.95, -11.66, 3, -16.83, -11.55, -16.91, -11.22, -16.69, -11.21, 3, -16.95, -11.01, -16.85, 
	-10.43, -17.40, -10.50, 3, -17.39, -10.84, -17.33, -11.22, -17.75, -11.13, 3, -17.66, -11.57, -17.57, 
	-12.40, -17.84, -12.55, 3, -17.82, -12.91, -17.41, -12.89, -17.40, -13.26, 0, 1, -12.51, -12.55, 3, 
	-12.81, -11.68, -14.16, -11.45, -14.46, -12.37, 3, -13.92, -12.59, -13.09, -12.88, -12.51, -12.55, 0, 
	1, -3.07, -12.02, 3, -3.11, -11.68, -4.09, -11.32, -4.14, -11.84, 3, -4.72, -11.18, -6.22, -11.62, -6.63, 
	-12.19, 3, -6.45, -12.38, -6.34, -12.18, -6.19, -12.10, 3, -5.96, -12.06, -6.40, -12.51, -6.10, -12.55, 
	3, -5.37, -12.31, -4.03, -11.84, -3.07, -12.02, 0, 1, 11.61, -12.46, 3, 12.14, -12.49, 12.13, -11.97, 
	12.50, -11.84, 3, 11.78, -11.72, 10.82, -11.06, 10.54, -11.93, 3, 10.90, -12.10, 11.62, -11.92, 11.61, 
	-12.46, 0, 1, 4.93, -12.19, 3, 5.15, -12.05, 5.27, -11.81, 5.29, -11.48, 3, 4.23, -11.27, 2.71, -11.81, 
	1.55, -11.66, 3, 2.25, -12.42, 4.13, -12.04, 4.93, -12.19, 0, 1, -1.29, -12.10, 3, -1.38, -11.75, -1.75, 
	-11.67, -1.83, -11.30, 3, -2.19, -11.44, -2.79, -11.34, -3.07, -11.57, 3, -2.70, -12.16, -1.88, -11.78, 
	-1.29, -12.10, 0, 1, 13.12, -12.02, 3, 13.23, -11.98, 13.30, -11.90, 13.30, -11.75, 3, 13.18, -11.63, 
	12.97, -11.63, 12.85, -11.75, 3, 12.83, -11.95, 13.11, -11.85, 13.12, -12.02, 0, 1, -24.43, -11.84, 
	3, -24.08, -11.84, -23.84, -11.42, -23.98, -11.21, 3, -24.20, -11.18, -24.18, -11.38, -24.43, -11.30, 
	3, -24.43, -11.48, -24.43, -11.66, -24.43, -11.84, 0, 1, 4.05, -10.15, 3, 4.39, -9.93, 4.56, -9.54, 
	4.93, -9.34, 3, 4.72, -8.99, 4.82, -8.94, 5.11, -8.72, 3, 5.07, -8.18, 4.84, -7.37, 5.11, -7.03, 3, 
	5.09, -6.56, 4.42, -6.34, 3.96, -6.59, 3, 3.62, -7.86, 4.06, -9.03, 4.05, -10.15, 0, 1, -5.21, -9.79, 
	3, -4.74, -9.45, -4.29, -8.43, -3.70, -7.92, 3, -4.07, -7.36, -3.11, -6.02, -4.41, -5.70, 3, -4.26, 
	-7.21, -5.55, -8.44, -5.21, -9.79, 0, 1, -13.75, -9.17, 3, -13.34, -9.22, -13.43, -8.77, -13.13, -8.72, 
	3, -13.53, -7.99, -12.71, -7.88, -12.59, -7.39, 3, -12.68, -7.18, -13.00, -7.20, -13.04, -6.94, 3, -13.51, 
	-7.07, -13.62, -7.55, -14.02, -7.74, 3, -14.03, -8.38, -13.79, -8.46, -13.75, -9.17, 0, 1, -1.03, -8.90, 
	3, -0.56, -8.56, 0.28, -8.38, 0.66, -8.90, 3, 1.12, -8.73, 1.58, -8.87, 1.55, -8.10, 3, 1.15, -8.29, 
	0.46, -7.39, -0.05, -8.01, 3, -0.46, -8.01, -0.37, -7.50, -0.85, -7.57, 3, -1.16, -7.64, -1.18, -8.01, 
	-1.47, -8.10, 3, -2.30, -7.52, -2.89, -7.95, -3.88, -8.19, 3, -3.87, -8.31, -3.86, -8.44, -3.96, -8.46, 
	3, -3.12, -8.87, -1.37, -8.26, -1.03, -8.90, 0, 1, 12.32, -8.81, 3, 12.05, -7.97, 12.58, -7.55, 12.41, 
	-6.85, 3, 11.97, -6.97, 12.03, -6.58, 11.70, -6.59, 3, 11.66, -6.91, 11.43, -7.50, 11.43, -7.57, 3, 
	11.61, -7.85, 11.84, -7.96, 11.96, -8.10, 3, 11.95, -8.38, 11.76, -8.49, 11.78, -8.81, 3, 11.95, -8.99, 
	12.11, -8.84, 12.32, -8.81, 0, 1, 20.59, -8.90, 3, 20.65, -8.30, 19.82, -7.78, 20.33, -7.30, 3, 20.18, 
	-7.12, 20.03, -6.94, 19.70, -6.94, 3, 19.64, -7.67, 19.56, -8.67, 20.59, -8.90, 0, 1, 23.80, -8.90, 
	3, 23.93, -8.86, 24.02, -8.77, 24.15, -8.72, 3, 24.10, -8.48, 24.06, -8.22, 23.71, -8.28, 3, 23.48, 
	-8.50, 23.81, -8.63, 23.80, -8.90, 0, 1, 23.44, -8.81, 3, 23.48, -8.53, 23.31, -8.46, 23.26, -8.28, 
	3, 23.03, -8.31, 22.77, -8.32, 22.64, -8.46, 3, 22.73, -8.83, 22.98, -8.70, 23.44, -8.81, 0, 1, -16.06, 
	-8.63, 3, -15.83, -8.91, -15.64, -8.41, -15.26, -8.55, 3, -15.35, -7.43, -16.61, -8.31, -17.22, -7.83, 
	3, -17.48, -7.93, -17.56, -8.21, -17.93, -8.19, 3, -17.61, -8.47, -16.68, -8.45, -16.42, -8.28, 3, -16.29, 
	-8.34, -15.85, -8.53, -16.06, -8.63, 0, 1, -7.52, -8.72, 3, -7.27, -8.74, -7.30, -8.47, -7.17, -8.37, 
	3, -7.21, -7.99, -7.50, -7.88, -7.70, -7.65, 3, -8.07, -7.76, -8.22, -7.94, -8.50, -7.92, 3, -8.42, 
	-8.20, -8.26, -8.39, -8.14, -8.63, 3, -7.92, -8.46, -7.62, -8.39, -7.52, -8.72, 0, 1, 7.43, -8.19, 3, 
	8.25, -8.82, 9.11, -8.28, 9.83, -8.28, 3, 9.80, -8.00, 9.64, -7.88, 9.56, -7.66, 3, 8.53, -7.91, 6.87, 
	-7.76, 6.00, -8.19, 3, 6.13, -9.08, 7.05, -8.52, 7.43, -8.19, 0, 1, 16.41, -8.46, 3, 16.39, -8.21, 16.13, 
	-8.21, 16.06, -8.01, 3, 15.84, -8.00, 15.78, -8.15, 15.61, -8.19, 3, 15.52, -8.80, 16.15, -8.64, 16.41, 
	-8.46, 0, 1, -20.51, -8.28, 3, -20.18, -7.91, -20.58, -7.35, -20.16, -7.12, 3, -20.72, -6.62, -21.76, 
	-8.24, -20.51, -8.28, 0, 1, 8.76, -7.39, 3, 8.67, -7.18, 8.45, -7.10, 8.14, -7.12, 3, 8.17, -7.53, 8.42, 
	-7.46, 8.76, -7.39, 0, 1, -1.38, -6.32, 3, 0.10, -6.29, -0.48, -4.58, 0.13, -3.83, 3, -0.17, -3.71, 
	-0.33, -3.46, -0.76, -3.47, 3, -1.13, -4.33, -1.58, -5.12, -1.38, -6.32, 0, 1, 23.26, -6.23, 3, 23.35, 
	-6.23, 23.44, -6.23, 23.53, -6.23, 3, 23.91, -5.49, 23.47, -4.92, 23.80, -4.27, 3, 23.47, -4.22, 23.61, 
	-3.77, 23.17, -4.01, 3, 23.17, -4.28, 23.49, -4.22, 23.44, -4.54, 3, 22.91, -4.67, 23.47, -5.35, 23.00, 
	-5.52, 3, 23.12, -5.73, 23.35, -5.81, 23.26, -6.23, 0, 1, -8.06, -5.79, 3, -8.17, -5.03, -7.81, -4.20, 
	-8.32, -3.74, 3, -8.33, -3.59, -8.26, -3.51, -8.15, -3.47, 3, -8.17, -3.29, -8.39, -3.30, -8.41, -3.12, 
	3, -8.86, -3.00, -8.79, -3.39, -9.12, -3.38, 3, -9.05, -3.94, -9.35, -4.11, -9.48, -4.45, 3, -9.35, 
	-4.62, -9.35, -4.91, -9.12, -4.99, 3, -9.60, -5.42, -8.49, -6.24, -8.06, -5.79, 0, 1, 15.43, -5.97, 
	3, 15.70, -5.82, 15.82, -5.52, 16.15, -5.43, 3, 16.26, -4.76, 16.40, -3.85, 15.34, -3.74, 3, 15.34, 
	-4.23, 15.01, -5.07, 15.08, -5.70, 3, 15.30, -5.68, 15.36, -5.83, 15.43, -5.97, 0, 1, -13.22, -5.88, 
	3, -13.11, -5.77, -12.90, -5.77, -12.68, -5.79, 3, -12.67, -5.54, -12.90, -5.53, -13.13, -5.52, 3, -13.20, 
	-5.60, -13.22, -5.72, -13.22, -5.88, 0, 1, -3.52, -5.70, 3, -2.92, -5.58, -2.81, -4.98, -2.45, -4.63, 
	3, -3.71, -4.54, -6.22, -3.68, -6.99, -4.81, 3, -6.39, -4.84, -5.88, -4.71, -5.74, -5.34, 3, -5.20, 
	-5.23, -4.31, -5.33, -3.61, -5.16, 3, -3.39, -5.29, -3.45, -5.47, -3.52, -5.70, 0, 1, -6.72, -5.43, 
	3, -6.63, -5.61, -5.98, -5.58, -6.10, -5.25, 3, -6.38, -5.24, -6.52, -5.36, -6.72, -5.43, 0, 1, -17.04, 
	-5.34, 3, -17.01, -4.74, -16.63, -3.71, -17.49, -3.74, 3, -17.79, -4.36, -17.59, -4.67, -17.66, -5.25, 
	3, -17.44, -5.38, -17.32, -5.47, -17.04, -5.34, 0, 1, 1.20, -5.34, 3, 1.68, -5.26, 1.73, -4.74, 1.73, 
	-4.19, 3, 1.53, -4.31, 1.23, -4.34, 1.29, -4.72, 3, 1.02, -4.59, 0.95, -4.28, 0.58, -4.27, 3, 0.54, 
	-4.44, 0.32, -4.44, 0.40, -4.72, 3, 0.76, -4.84, 0.75, -4.87, 1.20, -4.81, 3, 1.31, -5.10, 0.91, -4.88, 
	1.02, -5.16, 3, 1.17, -5.13, 1.19, -5.23, 1.20, -5.34, 0, 1, 19.70, -4.81, 3, 19.40, -4.35, 18.75, -4.86, 
	18.28, -4.81, 3, 18.70, -5.27, 19.34, -5.35, 19.70, -4.81, 0, 1, -13.04, -4.63, 3, -12.75, -4.87, -12.23, 
	-4.40, -12.33, -5.08, 3, -11.79, -4.72, -10.62, -5.00, -10.46, -4.27, 3, -12.06, -4.38, -13.57, -3.71, 
	-15.53, -4.27, 3, -15.53, -4.83, -14.58, -4.45, -14.55, -4.99, 3, -13.98, -4.70, -13.15, -5.65, -13.04, 
	-4.63, 0, 1, 3.07, -5.16, 3, 3.74, -5.05, 4.34, -5.39, 4.58, -4.81, 3, 4.88, -4.86, 4.88, -5.07, 5.20, 
	-4.90, 3, 5.57, -4.10, 3.44, -4.01, 3.42, -4.81, 3, 2.94, -4.57, 2.38, -4.12, 1.91, -4.36, 3, 1.82, 
	-4.75, 2.09, -4.77, 2.18, -4.99, 3, 2.45, -4.94, 2.76, -4.91, 2.98, -4.81, 3, 3.10, -4.84, 3.05, -5.03, 
	3.07, -5.16, 0, 1, 7.34, -5.08, 3, 7.47, -5.20, 7.90, -4.87, 8.14, -4.81, 3, 8.15, -4.53, 7.90, -4.51, 
	7.96, -4.19, 3, 7.50, -4.23, 7.56, -4.79, 7.34, -5.08, 0, 1, 11.78, -5.16, 3, 12.37, -5.10, 12.32, -4.50, 
	12.76, -4.72, 3, 12.57, -4.18, 11.68, -4.53, 11.34, -4.81, 3, 11.03, -4.65, 10.91, -4.29, 10.36, -4.36, 
	3, 10.30, -4.84, 10.68, -4.87, 10.90, -5.08, 3, 11.14, -4.74, 11.50, -5.05, 11.78, -5.16, 0, 1, 20.33, 
	-4.54, 3, 20.22, -4.56, 20.17, -4.52, 20.15, -4.45, 3, 19.51, -4.61, 20.23, -5.06, 20.33, -4.54, 0, 
	1, -20.25, -4.72, 3, -20.05, -4.52, -19.88, -4.81, -19.53, -4.72, 3, -19.51, -4.48, -19.88, -4.65, -19.80, 
	-4.36, 3, -19.90, -4.53, -20.38, -4.32, -20.25, -4.72, 0, 1, -24.16, -4.63, 3, -24.02, -4.66, -24.01, 
	-4.55, -23.89, -4.54, 3, -23.98, -4.08, -24.05, -3.72, -24.07, -3.30, 3, -24.23, -3.28, -24.26, -3.40, 
	-24.43, -3.38, 3, -24.26, -3.95, -24.53, -3.99, -24.43, -4.45, 3, -24.25, -4.42, -24.15, -4.47, -24.16, 
	-4.63, 0, 1, -4.85, -2.85, 3, -4.60, -2.69, -4.73, -2.56, -4.32, -2.67, 3, -4.50, -2.35, -4.31, -2.32, 
	-4.05, -2.23, 3, -4.03, -2.02, -4.07, -1.89, -4.23, -1.87, 3, -4.00, -1.69, -3.85, -1.42, -3.61, -1.25, 
	3, -3.68, -0.97, -3.87, -0.80, -4.05, -0.63, 3, -3.73, -0.44, -3.78, 0.11, -3.78, 0.62, 3, -3.99, 0.62, 
	-4.05, 0.47, -4.32, 0.53, 3, -4.14, 0.18, -4.40, -0.34, -4.14, -0.45, 3, -4.66, -0.77, -4.59, -1.71, 
	-5.30, -2.05, 3, -5.13, -2.30, -5.01, -2.59, -4.85, -2.85, 0, 1, -20.42, -1.87, 3, -20.58, -1.95, -20.73, 
	-2.04, -20.69, -2.32, 3, -20.31, -2.60, -20.16, -2.09, -20.42, -1.87, 0, 1, 4.58, -1.96, 3, 5.69, -1.77, 
	6.03, 0.56, 5.02, 0.71, 3, 4.87, -0.12, 4.56, -1.25, 4.58, -1.96, 0, 1, 11.61, -1.87, 3, 11.73, -1.87, 
	11.84, -1.87, 11.96, -1.87, 3, 12.20, -1.42, 12.04, -0.86, 11.87, -0.54, 3, 11.51, -0.85, 11.39, -1.41, 
	11.61, -1.87, 0, 1, -19.89, -1.78, 3, -19.99, -1.19, -20.61, -0.82, -20.16, -0.18, 3, -20.85, -0.09, 
	-20.96, -2.06, -19.89, -1.78, 0, 1, -12.86, -1.43, 3, -13.01, -0.98, -12.98, -0.85, -13.13, -0.36, 3, 
	-14.18, -0.52, -13.81, -2.49, -12.86, -1.43, 0, 1, 19.88, -1.69, 3, 20.53, -1.21, 20.76, -0.54, 20.24, 
	-0.00, 3, 19.63, -0.16, 20.20, -0.93, 19.53, -0.98, 3, 19.59, -1.28, 19.77, -1.45, 19.88, -1.69, 0, 
	1, 1.73, -1.25, 3, 1.14, -0.94, -0.41, -0.81, -1.38, -0.98, 3, -0.73, -1.98, 0.80, -1.31, 1.73, -1.25, 
	0, 1, -7.79, -1.25, 3, -7.81, -0.53, -8.87, -0.85, -9.30, -0.54, 3, -9.33, -0.72, -9.48, -0.78, -9.57, 
	-0.89, 3, -9.71, -0.79, -9.76, -0.60, -10.01, -0.63, 3, -9.77, -1.92, -8.37, -1.15, -7.79, -1.25, 0, 
	1, -17.40, -1.25, 3, -17.27, -1.20, -16.94, -1.35, -16.95, -1.16, 3, -16.85, -0.85, -17.60, -0.90, -17.40, 
	-1.25, 0, 1, 10.01, -1.07, 3, 9.81, -0.48, 9.17, -1.09, 8.85, -0.89, 3, 8.94, -1.23, 9.72, -1.22, 10.01, 
	-1.07, 0, 1, -26.12, -0.89, 3, -25.79, -0.93, -25.59, -0.55, -25.76, -0.36, 3, -26.13, -0.29, -26.28, 
	-0.70, -26.12, -0.89, 0, 1, 19.94, -14.73, 3, 20.08, -14.75, 20.09, -14.64, 20.20, -14.64, 3, 20.19, 
	-14.41, 20.07, -14.29, 19.85, -14.28, 3, 20.04, -14.47, 19.77, -14.57, 19.94, -14.73, 0, 1, 11.78, -0.27, 
	3, 11.96, -0.27, 12.14, -0.27, 12.32, -0.27, 3, 12.26, 0.06, 12.55, 0.29, 12.32, 0.53, 3, 11.94, 0.47, 
	11.88, 0.08, 11.78, -0.27, 0, 1, 12.59, 1.69, 3, 12.47, 1.81, 12.20, 1.78, 11.96, 1.78, 3, 11.85, 1.56, 
	11.74, 1.34, 11.70, 1.07, 3, 12.17, 0.62, 12.49, 1.23, 12.59, 1.69, 0, 1, 0.75, 2.40, 3, 0.59, 2.79, 
	0.52, 3.04, 0.48, 3.38, 3, 0.31, 3.38, 0.13, 3.38, -0.05, 3.38, 3, -0.35, 2.62, -0.48, 1.76, -0.41, 
	1.06, 3, 0.57, 0.64, 0.30, 2.03, 0.75, 2.40, 0, 1, 8.49, 1.15, 3, 9.09, 1.47, 9.37, 2.12, 9.56, 2.84, 
	3, 9.33, 3.10, 9.29, 3.45, 9.29, 3.73, 3, 9.14, 3.73, 9.00, 3.73, 8.85, 3.73, 3, 8.52, 3.14, 8.75, 2.20, 
	8.31, 1.69, 3, 8.30, 1.44, 8.62, 1.51, 8.49, 1.15, 0, 1, -9.12, 1.24, 3, -8.84, 1.49, -8.57, 1.75, -8.32, 
	2.04, 3, -8.70, 2.67, -8.44, 3.23, -8.41, 3.91, 3, -8.76, 3.42, -8.68, 3.04, -9.12, 2.67, 3, -9.17, 
	2.33, -9.09, 2.11, -8.86, 2.04, 3, -9.00, 1.83, -9.19, 1.66, -9.12, 1.24, 0, 1, 5.02, 1.33, 3, 5.16, 
	1.75, 5.58, 1.90, 6.00, 2.04, 3, 6.08, 3.49, 4.29, 2.28, 3.78, 2.49, 3, 4.02, 1.71, 5.11, 2.26, 5.02, 
	1.33, 0, 1, 15.79, 1.33, 3, 16.39, 1.35, 16.46, 1.90, 16.77, 2.22, 3, 16.27, 2.74, 16.83, 3.57, 16.50, 
	4.18, 3, 15.63, 4.28, 16.18, 2.96, 15.61, 2.75, 3, 15.96, 2.18, 15.90, 2.05, 15.79, 1.33, 0, 1, 23.97, 
	1.42, 3, 24.01, 1.22, 24.41, 1.38, 24.60, 1.33, 3, 24.63, 1.54, 24.58, 1.67, 24.51, 1.78, 3, 24.21, 
	1.78, 24.12, 1.57, 23.97, 1.42, 0, 1, -16.86, 1.69, 3, -16.41, 2.06, -16.44, 2.74, -16.42, 3.29, 3, 
	-17.29, 3.45, -17.10, 2.11, -16.86, 1.69, 0, 1, -3.87, 2.31, 3, -3.71, 2.30, -3.82, 2.01, -3.70, 1.95, 
	3, -3.09, 1.86, -2.60, 2.12, -2.36, 2.13, 3, -2.40, 2.57, -2.98, 2.46, -3.16, 2.76, 3, -3.95, 2.15, 
	-4.88, 2.82, -6.01, 2.49, 3, -5.84, 2.32, -6.00, 2.26, -6.01, 2.04, 3, -4.91, 2.21, -4.58, 1.79, -3.87, 
	2.31, 0, 1, 12.94, 2.31, 3, 13.06, 2.57, 13.05, 2.86, 12.85, 3.02, 3, 12.31, 2.79, 11.91, 2.90, 11.16, 
	2.93, 3, 11.02, 2.80, 11.08, 2.48, 11.07, 2.22, 3, 11.95, 2.15, 11.92, 2.01, 12.94, 2.31, 0, 1, 24.51, 
	1.95, 3, 24.08, 2.32, 24.86, 2.85, 24.24, 3.02, 3, 24.37, 2.54, 24.01, 2.54, 23.89, 2.31, 3, 23.88, 
	1.98, 24.23, 2.01, 24.51, 1.95, 0, 1, -12.59, 2.49, 3, -13.29, 2.47, -13.43, 2.64, -14.11, 2.93, 3, 
	-14.45, 2.13, -12.87, 1.83, -12.59, 2.49, 0, 1, -10.73, 2.13, 3, -10.66, 2.46, -10.87, 2.53, -11.17, 
	2.49, 3, -11.23, 2.16, -10.99, 2.14, -10.73, 2.13, 0, 1, 3.42, 2.13, 3, 3.53, 2.77, 2.38, 2.97, 2.18, 
	2.49, 3, 2.40, 2.09, 2.87, 2.31, 3.42, 2.13, 0, 1, -24.16, 2.40, 3, -24.23, 2.50, -24.28, 2.64, -24.25, 
	2.84, 3, -24.48, 2.78, -24.44, 2.44, -24.69, 2.40, 3, -24.58, 2.02, -24.40, 2.40, -24.16, 2.40, 0, 1, 
	-5.12, 3.82, 3, -4.07, 3.75, -4.50, 5.16, -4.05, 5.69, 3, -4.01, 5.97, -4.29, 5.93, -4.32, 6.14, 3, 
	-4.12, 6.47, -3.87, 6.75, -3.61, 7.03, 3, -3.94, 7.13, -4.20, 7.32, -4.41, 7.56, 3, -5.07, 6.57, -5.19, 
	5.18, -5.12, 3.82, 0, 1, 0.22, 3.91, 3, 0.63, 3.91, 0.32, 4.64, 0.84, 4.53, 3, 0.78, 4.74, 0.55, 4.77, 
	0.49, 4.98, 3, 0.06, 4.69, -0.03, 4.34, 0.22, 3.91, 0, 1, 3.15, 4.35, 3, 2.97, 4.86, 2.54, 4.56, 2.00, 
	4.71, 3, 1.84, 3.96, 2.84, 4.15, 3.15, 4.35, 0, 1, 3.33, 4.18, 3, 3.54, 4.21, 3.75, 4.24, 3.69, 4.53, 
	3, 3.41, 4.58, 3.29, 4.46, 3.33, 4.18, 0, 1, 5.65, 4.62, 3, 5.85, 4.59, 5.99, 4.64, 6.09, 4.71, 3, 6.21, 
	4.88, 6.03, 5.07, 6.18, 5.33, 3, 6.39, 5.33, 6.59, 5.33, 6.80, 5.33, 3, 6.51, 5.54, 6.61, 6.17, 6.98, 
	6.22, 3, 6.70, 6.48, 6.25, 7.04, 6.27, 7.29, 3, 6.21, 7.56, 5.67, 7.35, 5.65, 7.65, 3, 5.48, 7.45, 5.30, 
	7.28, 5.20, 7.02, 3, 5.53, 6.23, 5.55, 5.33, 5.65, 4.62, 0, 1, -5.48, 5.16, 3, -5.49, 5.52, -5.95, 5.46, 
	-6.01, 5.78, 3, -6.26, 5.76, -6.25, 5.49, -6.45, 5.42, 3, -6.34, 4.87, -5.88, 4.85, -5.48, 5.16, 0, 
	1, 14.01, 5.07, 3, 13.98, 5.18, 13.85, 5.21, 13.83, 5.34, 3, 14.11, 5.27, 14.00, 5.27, 14.28, 5.34, 
	3, 14.09, 5.85, 14.24, 6.41, 13.74, 6.76, 3, 13.70, 7.04, 14.02, 6.96, 13.92, 7.29, 3, 13.80, 7.51, 
	13.65, 7.13, 13.57, 7.38, 3, 13.00, 6.89, 13.77, 5.54, 13.30, 4.98, 3, 13.57, 4.85, 13.76, 4.95, 14.01, 
	5.07, 0, 1, -10.37, 5.60, 3, -10.02, 5.53, -9.79, 5.14, -9.30, 4.98, 3, -9.04, 5.05, -8.86, 5.19, -8.68, 
	5.34, 3, -8.35, 5.25, -8.20, 4.98, -7.70, 5.07, 3, -7.44, 5.33, -7.74, 5.50, -7.34, 5.51, 3, -7.41, 
	5.59, -7.44, 5.71, -7.43, 5.87, 3, -7.88, 5.93, -8.23, 6.07, -8.59, 6.22, 3, -9.03, 5.63, -9.95, 6.27, 
	-10.37, 5.60, 0, 1, -12.95, 5.07, 3, -12.81, 5.17, -12.73, 5.32, -12.59, 5.42, 3, -12.84, 5.62, -12.60, 
	5.77, -12.86, 5.96, 3, -12.82, 6.07, -12.75, 6.14, -12.59, 6.13, 3, -12.74, 6.42, -12.64, 6.62, -12.59, 
	6.94, 3, -12.71, 6.94, -12.83, 6.94, -12.95, 6.94, 3, -12.93, 6.41, -13.33, 6.30, -13.66, 6.13, 3, -13.24, 
	5.96, -13.32, 5.29, -12.95, 5.07, 0, 1, 3.42, 5.96, 3, 3.25, 6.37, 3.47, 6.64, 3.15, 6.94, 3, 2.85, 
	6.86, 3.14, 6.74, 2.98, 6.58, 3, 2.87, 6.62, 2.79, 6.69, 2.80, 6.85, 3, 2.39, 6.54, 1.55, 6.20, 0.93, 
	6.40, 3, 0.83, 6.39, 0.85, 6.24, 0.84, 6.14, 3, -0.18, 5.84, -1.53, 6.23, -2.45, 5.87, 3, -1.14, 4.36, 
	1.53, 5.81, 3.42, 5.96, 0, 1, 20.86, 5.34, 3, 20.75, 5.65, 20.57, 5.97, 21.04, 6.05, 3, 20.85, 6.38, 
	21.08, 6.36, 21.22, 6.58, 3, 21.32, 6.98, 20.72, 6.68, 20.86, 7.11, 3, 20.40, 6.93, 20.02, 5.02, 20.86, 
	5.34, 0, 1, -19.71, 5.42, 3, -19.38, 5.50, -19.90, 6.13, -19.62, 6.49, 3, -20.27, 6.49, -20.10, 5.57, 
	-19.71, 5.42, 0, 1, 7.43, 5.60, 3, 7.75, 5.94, 8.23, 5.67, 8.41, 6.22, 3, 8.05, 6.19, 7.55, 6.31, 7.34, 
	6.14, 3, 7.34, 5.93, 7.49, 5.87, 7.43, 5.60, 0, 1, -16.60, 5.78, 3, -16.80, 6.18, -17.35, 6.03, -17.66, 
	5.87, 3, -17.40, 5.56, -17.04, 5.80, -16.60, 5.78, 0, 1, 10.81, 6.31, 3, 10.05, 6.42, 9.53, 6.22, 9.03, 
	6.58, 3, 8.92, 6.37, 8.58, 6.38, 8.58, 6.05, 3, 9.17, 5.68, 10.52, 5.61, 10.81, 6.31, 0, 1, 24.86, 5.78, 
	3, 25.35, 5.74, 25.76, 5.77, 25.67, 6.31, 3, 25.28, 6.25, 24.94, 6.15, 24.86, 5.78, 0, 1, -23.63, 6.23, 
	3, -23.43, 6.24, -23.44, 6.45, -23.45, 6.67, 3, -23.54, 6.67, -23.63, 6.67, -23.72, 6.67, 3, -23.88, 
	6.51, -23.68, 6.41, -23.63, 6.23, 0, 1, -19.71, 6.76, 3, -19.50, 6.89, -18.91, 7.65, -19.62, 7.65, 3, 
	-19.36, 7.13, -19.93, 7.36, -19.89, 6.85, 3, -19.79, 6.86, -19.73, 6.83, -19.71, 6.76, 0, 1, 0.48, 7.56, 
	3, 0.42, 7.92, 0.57, 8.07, 0.57, 8.36, 3, 0.42, 8.44, 0.31, 8.58, 0.13, 8.63, 3, 0.28, 8.95, 0.69, 9.02, 
	0.66, 9.52, 3, 0.39, 9.45, 0.40, 9.67, 0.13, 9.61, 3, 0.25, 9.91, 0.08, 10.08, 0.22, 10.23, 3, 0.14, 
	10.42, -0.05, 10.50, -0.32, 10.50, 3, -0.30, 10.39, -0.34, 10.34, -0.41, 10.32, 3, -0.15, 9.74, -0.32, 
	8.90, -0.58, 8.09, 3, -0.51, 7.84, -0.45, 7.99, -0.23, 8.01, 3, -0.15, 7.66, -0.62, 7.86, -0.49, 7.47, 
	3, -0.21, 7.25, 0.17, 7.53, 0.48, 7.56, 0, 1, -8.50, 7.83, 3, -8.07, 8.53, -8.20, 9.19, -8.14, 9.96, 
	3, -8.45, 10.17, -8.57, 10.42, -8.32, 10.76, 3, -8.66, 10.87, -9.02, 11.19, -9.21, 10.76, 3, -9.23, 
	10.51, -8.96, 10.54, -8.86, 10.41, 3, -9.28, 10.26, -9.26, 9.69, -9.66, 9.52, 3, -9.27, 9.20, -9.30, 
	9.01, -9.30, 8.36, 3, -8.93, 8.28, -8.85, 7.92, -8.50, 7.83, 0, 1, 8.58, 8.18, 3, 8.96, 8.16, 9.03, 
	8.44, 9.29, 8.54, 3, 9.30, 9.37, 8.94, 9.81, 9.47, 10.14, 3, 9.51, 10.54, 8.95, 10.33, 8.85, 10.58, 
	3, 8.81, 11.08, 8.91, 11.34, 8.49, 11.56, 3, 7.34, 10.91, 9.20, 9.37, 8.58, 8.18, 0, 1, 24.86, 8.36, 
	3, 25.30, 8.49, 25.05, 9.21, 25.13, 9.87, 3, 24.88, 10.01, 24.78, 10.29, 24.33, 10.23, 3, 24.70, 9.63, 
	24.58, 9.07, 24.86, 8.36, 0, 1, 16.32, 8.89, 3, 16.65, 8.84, 16.66, 9.09, 16.95, 9.07, 3, 16.74, 9.44, 
	17.04, 9.64, 17.39, 9.70, 3, 17.22, 9.95, 16.93, 10.07, 16.59, 10.14, 3, 16.51, 10.48, 16.73, 10.71, 
	16.59, 10.85, 3, 15.43, 10.52, 15.88, 9.63, 16.32, 8.89, 0, 1, -4.94, 9.07, 3, -4.74, 9.17, -4.50, 9.22, 
	-4.32, 9.34, 3, -4.44, 9.69, -5.16, 9.44, -5.57, 9.52, 3, -5.41, 8.95, -4.93, 9.74, -4.94, 9.07, 0, 
	1, 6.27, 9.43, 3, 5.78, 9.68, 4.56, 9.91, 4.22, 9.34, 3, 4.87, 9.33, 6.03, 8.77, 6.27, 9.43, 0, 1, -11.88, 
	9.60, 3, -12.52, 9.59, -13.52, 10.41, -13.93, 9.34, 3, -13.19, 9.22, -12.41, 9.17, -11.88, 9.60, 0, 
	1, -6.99, 9.43, 3, -6.98, 9.23, -6.61, 9.39, -6.45, 9.34, 3, -6.45, 9.52, -6.45, 9.69, -6.45, 9.87, 
	3, -6.86, 9.96, -6.82, 9.59, -6.99, 9.43, 0, 1, 21.39, 9.43, 3, 21.44, 9.83, 21.08, 9.82, 21.04, 10.14, 
	3, 20.64, 9.88, 20.81, 9.08, 21.39, 9.43, 0, 1, -19.71, 9.52, 3, -19.67, 10.15, -20.61, 9.80, -20.78, 
	10.23, 3, -21.06, 10.14, -21.46, 9.84, -21.31, 9.61, 3, -20.73, 9.97, -20.16, 9.42, -19.71, 9.52, 0, 
	1, -8.86, 11.30, 3, -8.46, 11.26, -8.64, 11.79, -8.14, 11.65, 3, -8.31, 11.85, -8.29, 12.22, -8.68, 
	12.19, 3, -8.57, 11.72, -8.86, 11.66, -8.86, 11.30, 0, 1, -7.43, 11.30, 3, -7.28, 11.30, -7.14, 11.30, 
	-6.99, 11.30, 3, -7.00, 11.70, -6.91, 11.98, -7.17, 12.27, 3, -7.61, 12.13, -7.45, 11.77, -7.43, 11.30, 
	0, 1, 20.77, 11.47, 3, 21.07, 11.75, 21.13, 12.53, 21.57, 12.90, 3, 21.26, 12.97, 21.30, 13.40, 20.77, 
	13.25, 3, 20.82, 12.62, 20.53, 12.02, 20.77, 11.47, 0, 1, 12.59, 11.74, 3, 12.96, 11.75, 13.21, 11.95, 
	13.83, 11.92, 3, 13.75, 12.08, 13.62, 12.18, 13.56, 12.36, 3, 13.79, 12.47, 14.07, 12.51, 14.19, 12.72, 
	3, 14.14, 13.00, 13.67, 12.86, 13.47, 12.99, 3, 13.40, 13.27, 13.71, 13.17, 13.74, 13.34, 3, 14.09, 
	13.42, 13.89, 12.95, 14.28, 13.07, 3, 14.24, 13.46, 13.49, 14.03, 14.01, 14.23, 3, 13.78, 14.49, 13.31, 
	14.73, 12.94, 14.59, 3, 13.02, 14.01, 12.81, 13.14, 13.39, 13.07, 3, 13.16, 12.63, 12.78, 13.34, 12.50, 
	13.07, 3, 12.41, 12.81, 12.69, 12.92, 12.85, 12.90, 3, 12.85, 12.42, 12.48, 12.33, 12.59, 11.74, 0, 
	1, 6.00, 13.97, 3, 5.93, 13.98, 5.91, 14.06, 5.82, 14.06, 3, 6.13, 14.05, 5.97, 14.43, 5.56, 14.41, 
	3, 5.41, 13.76, 5.48, 12.73, 5.65, 11.83, 3, 6.06, 11.87, 5.94, 11.88, 6.36, 11.92, 3, 6.18, 12.41, 
	6.82, 12.95, 6.54, 13.25, 3, 6.55, 13.45, 6.76, 13.44, 6.98, 13.43, 3, 6.67, 13.57, 6.47, 14.28, 6.00, 
	13.97, 0, 1, -12.59, 12.19, 3, -12.08, 12.55, -12.10, 12.94, -12.42, 13.43, 3, -13.15, 13.25, -12.57, 
	12.81, -12.59, 12.19, 0, 1, -6.37, 12.63, 3, -6.09, 12.74, -6.01, 13.05, -5.65, 13.08, 3, -5.74, 13.45, 
	-6.58, 12.87, -6.54, 13.52, 3, -6.62, 13.47, -6.69, 13.43, -6.81, 13.43, 3, -6.87, 12.96, -6.44, 12.97, 
	-6.37, 12.63, 0, 1, 2.00, 13.34, 3, 1.64, 14.00, 0.97, 13.29, 0.48, 13.25, 3, 0.92, 12.81, 1.75, 12.69, 
	2.00, 13.34, 0, 1, 25.75, 12.81, 3, 25.78, 13.02, 25.74, 13.15, 25.67, 13.25, 3, 25.55, 13.13, 25.28, 
	13.16, 25.04, 13.16, 3, 25.17, 12.74, 25.42, 12.93, 25.75, 12.81, 0, 1, 8.76, 13.34, 3, 8.53, 13.33, 
	8.30, 13.33, 8.32, 13.08, 3, 8.49, 12.90, 8.86, 12.98, 8.76, 13.34, 0, 1, 10.72, 12.99, 3, 10.32, 13.36, 
	9.70, 13.36, 9.03, 13.34, 3, 9.03, 13.25, 9.03, 13.16, 9.03, 13.07, 3, 9.48, 12.99, 10.17, 13.03, 10.72, 
	12.99, 0, 1, -7.17, 13.08, 3, -7.12, 13.39, -7.48, 13.29, -7.43, 13.61, 3, -7.67, 13.55, -7.77, 13.35, 
	-7.97, 13.25, 3, -7.72, 12.99, -7.59, 13.17, -7.17, 13.08, 0, 1, -19.18, 13.52, 3, -19.14, 13.80, -19.26, 
	13.92, -19.53, 13.88, 3, -19.62, 13.44, -19.62, 13.44, -19.18, 13.52, 0, 1, 21.75, 13.88, 3, 21.54, 
	14.14, 21.35, 14.42, 21.04, 14.59, 3, 20.82, 14.60, 20.76, 14.45, 20.59, 14.41, 3, 20.24, 13.30, 21.25, 
	13.36, 21.75, 13.88, 0, 1, -12.59, 13.88, 3, -12.52, 13.72, -12.16, 14.03, -11.97, 14.05, 3, -12.07, 
	14.52, -12.53, 14.02, -12.59, 13.88, 0, 1, 1.02, 14.50, 3, 1.28, 14.59, 1.49, 14.74, 1.47, 15.12, 3, 
	1.22, 15.01, 1.07, 14.80, 1.02, 14.50, 0, 1, 25.58, 15.12, 3, 25.66, 15.29, 25.31, 15.42, 25.58, 15.48, 
	3, 25.30, 15.89, 25.14, 14.98, 25.58, 15.12, 0, 1, 1.29, 15.21, 3, 1.61, 15.28, 1.91, 15.42, 1.73, 15.75, 
	3, 1.53, 15.62, 1.23, 15.59, 1.29, 15.21, 0, 1, -7.79, 15.30, 3, -7.51, 15.46, -7.45, 15.85, -7.08, 
	15.92, 3, -7.16, 16.11, -7.08, 16.45, -7.43, 16.37, 3, -7.28, 16.52, -7.07, 16.60, -7.08, 16.90, 3, 
	-7.55, 16.96, -7.84, 16.84, -8.23, 16.81, 3, -8.04, 16.53, -8.04, 16.06, -8.06, 15.57, 3, -7.86, 15.58, 
	-7.77, 15.49, -7.79, 15.30, 0, 1, 8.40, 15.48, 3, 8.94, 15.38, 9.22, 15.92, 9.03, 16.28, 3, 9.19, 16.44, 
	9.46, 16.50, 9.56, 16.72, 3, 9.54, 17.06, 9.18, 17.06, 9.12, 17.35, 3, 8.45, 16.96, 8.91, 16.00, 8.40, 
	15.48, 0, 1, 22.11, 16.55, 3, 21.58, 16.73, 20.81, 16.90, 20.33, 16.64, 3, 20.14, 16.75, 19.99, 16.89, 
	19.88, 17.08, 3, 19.49, 16.90, 19.45, 16.81, 18.90, 16.90, 3, 18.92, 16.80, 18.88, 16.74, 18.81, 16.72, 
	3, 19.38, 15.92, 21.27, 15.78, 22.11, 16.55, 0, 1, 7.16, 16.19, 3, 7.09, 16.55, 7.45, 16.50, 7.34, 16.90, 
	3, 6.52, 17.04, 5.73, 16.89, 4.76, 16.99, 3, 4.71, 16.71, 4.97, 16.63, 4.67, 16.55, 3, 5.26, 16.21, 
	6.16, 15.98, 7.16, 16.19, 0, 1, 13.83, 16.46, 3, 13.56, 17.08, 12.30, 16.71, 11.96, 17.26, 3, 11.58, 
	16.88, 11.16, 16.95, 10.54, 16.72, 3, 10.62, 16.44, 11.06, 16.53, 11.16, 16.28, 3, 12.12, 16.56, 13.16, 
	15.96, 13.83, 16.46, 0, 1, -2.54, 16.46, 3, -2.80, 16.67, -3.05, 16.90, -3.52, 16.90, 3, -3.51, 16.74, 
	-3.63, 16.71, -3.61, 16.55, 3, -3.35, 16.38, -2.87, 16.30, -2.54, 16.46, 0, 1, -1.92, 16.37, 3, -1.59, 
	16.27, -1.66, 16.59, -1.38, 16.55, 3, -1.53, 16.86, -1.84, 16.55, -2.01, 16.90, 3, -2.14, 16.82, -2.29, 
	16.77, -2.27, 16.55, 3, -2.11, 16.53, -1.98, 16.49, -1.92, 16.37, 0, 1, -16.06, 16.46, 3, -15.71, 16.50, 
	-15.49, 17.02, -15.71, 17.35, 3, -16.02, 17.21, -16.21, 16.79, -16.06, 16.46, 0, 1, 2.27, 16.90, 3, 
	2.20, 17.08, 2.03, 17.14, 1.82, 17.17, 3, 1.84, 17.36, 2.05, 17.36, 2.27, 17.35, 3, 2.19, 17.54, 2.05, 
	17.66, 1.73, 17.61, 3, 1.66, 17.23, 1.74, 17.25, 1.64, 16.90, 3, 1.84, 16.86, 2.10, 16.72, 2.27, 16.90, 
	0, 1, 14.99, 19.84, 3, 14.93, 20.05, 14.44, 19.82, 14.36, 20.02, 3, 14.50, 20.64, 14.41, 21.25, 14.63, 
	21.62, 3, 13.06, 22.24, 13.73, 19.84, 13.21, 18.86, 3, 14.27, 18.27, 13.71, 20.30, 14.99, 19.84, 0, 
	1, 6.09, 18.77, 3, 6.33, 18.99, 6.14, 19.38, 6.36, 19.75, 3, 5.91, 19.65, 5.97, 19.39, 5.74, 18.86, 
	3, 5.88, 18.85, 6.07, 18.90, 6.09, 18.77, 0, 1, 20.50, 18.95, 3, 20.81, 18.97, 21.02, 19.09, 21.39, 
	19.04, 3, 21.43, 19.52, 21.10, 19.63, 21.04, 20.02, 3, 20.52, 20.00, 20.75, 19.24, 20.50, 18.95, 0, 
	1, -11.88, 19.48, 3, -11.74, 19.26, -11.45, 19.64, -11.26, 19.66, 3, -11.26, 20.26, -11.15, 20.42, -11.26, 
	20.82, 3, -11.52, 20.73, -11.54, 20.39, -11.79, 20.28, 3, -11.48, 20.06, -11.77, 19.77, -11.88, 19.48, 
	0, 1, -18.82, 19.66, 3, -18.56, 19.92, -18.38, 20.68, -18.38, 21.26, 3, -18.86, 21.06, -18.85, 20.37, 
	-19.00, 19.84, 3, -18.85, 19.87, -18.83, 19.77, -18.82, 19.66, 0, 1, 2.18, 19.75, 3, 1.94, 19.94, 1.31, 
	20.24, 1.11, 19.93, 3, 1.42, 19.56, 1.80, 19.73, 2.18, 19.75, 0, 1, -4.67, 20.02, 3, -4.65, 20.56, -5.29, 
	19.92, -5.30, 20.46, 3, -5.56, 20.14, -5.91, 20.24, -6.28, 20.28, 3, -6.09, 19.52, -5.23, 20.29, -4.67, 
	20.02, 0, 1, 10.36, 19.93, 3, 10.49, 20.12, 10.78, 20.16, 11.07, 20.19, 3, 10.86, 20.48, 10.66, 20.79, 
	10.09, 20.73, 3, 10.07, 20.35, 10.22, 20.14, 10.36, 19.93, 0, 1, 6.18, 20.02, 3, 6.44, 20.03, 6.76, 
	19.97, 6.89, 20.11, 3, 6.44, 20.16, 6.47, 20.95, 6.63, 21.35, 3, 5.84, 21.39, 6.57, 20.19, 6.18, 20.02, 
	0, 1, 21.66, 20.02, 3, 21.72, 20.47, 21.56, 21.06, 20.95, 20.73, 3, 21.06, 20.49, 21.29, 20.51, 21.13, 
	20.19, 3, 21.31, 20.14, 21.38, 19.97, 21.66, 20.02, 0, 1, -8.32, 20.28, 3, -8.43, 20.59, -8.88, 20.55, 
	-9.30, 20.55, 3, -9.21, 20.22, -8.62, 20.40, -8.32, 20.28, 0, 1, 18.55, 20.46, 3, 18.49, 20.64, 18.10, 
	20.48, 18.19, 20.82, 3, 17.88, 20.83, 17.90, 20.52, 17.66, 20.46, 3, 17.53, 20.50, 17.69, 20.57, 17.66, 
	20.73, 3, 17.20, 20.61, 16.94, 20.81, 16.50, 20.64, 3, 16.62, 20.07, 18.00, 20.25, 18.55, 20.46, 0, 
	1, 16.68, 21.88, 3, 16.96, 21.58, 17.21, 22.06, 17.48, 22.06, 3, 17.41, 22.69, 16.67, 22.33, 16.68, 
	21.88, 0, 1, 2.44, 22.77, 3, 2.15, 22.76, 2.01, 22.98, 2.00, 22.59, 3, 2.08, 22.50, 2.46, 22.52, 2.44, 
	22.77, 0, 1, 10.54, 24.46, 3, 10.21, 24.28, 10.31, 24.59, 9.92, 24.55, 3, 8.53, 22.54, 10.22, 22.13, 
	10.54, 24.46, 0, 1, -6.54, 22.86, 3, -6.22, 23.20, -6.23, 23.84, -6.63, 24.11, 3, -7.08, 23.83, -6.68, 
	23.12, -6.54, 22.86, 0, 1, 2.44, 23.31, 3, 2.88, 23.05, 2.67, 23.92, 2.44, 24.02, 3, 2.31, 23.86, 2.12, 
	23.75, 2.17, 23.40, 3, 2.33, 23.48, 2.70, 23.51, 2.44, 23.31, 0, 1, -2.27, 23.48, 3, -2.27, 23.62, -2.93, 
	23.68, -2.81, 23.40, 3, -2.57, 23.15, -2.49, 23.46, -2.27, 23.48, 0, 1, 18.19, 24.02, 3, 17.54, 23.96, 
	18.06, 25.07, 17.30, 24.91, 3, 17.30, 24.82, 17.19, 24.84, 17.12, 24.82, 3, 17.14, 24.12, 17.07, 24.05, 
	16.95, 23.49, 3, 17.34, 23.36, 18.08, 23.58, 18.19, 24.02, 0, 1, 5.38, 23.57, 3, 5.59, 23.55, 5.72, 
	23.59, 5.82, 23.66, 3, 5.74, 23.82, 5.55, 23.86, 5.29, 23.84, 3, 5.34, 23.77, 5.38, 23.70, 5.38, 23.57, 
	0, 1, 6.63, 23.57, 3, 6.90, 23.53, 6.97, 23.70, 7.16, 23.75, 3, 7.04, 24.12, 6.83, 23.94, 6.45, 23.93, 
	3, 6.38, 23.69, 6.62, 23.75, 6.63, 23.57, 0, 1, 14.72, 23.84, 3, 14.46, 24.22, 13.18, 24.25, 12.94, 
	23.84, 3, 13.55, 23.91, 14.22, 23.69, 14.72, 23.84, 0, 1, 2.71, 24.91, 3, 2.64, 25.11, 2.16, 25.00, 
	2.27, 24.73, 3, 2.44, 24.55, 2.58, 24.80, 2.71, 24.91, 0, 1, 8.05, 26.16, 3, 8.17, 26.58, 7.80, 26.50, 
	7.69, 26.69, 3, 7.51, 26.66, 7.67, 26.29, 7.43, 26.33, 3, 7.54, 26.08, 7.79, 26.04, 8.05, 26.16, 0, 
	1, -2.36, 26.16, 3, -2.00, 26.10, -2.04, 26.50, -1.56, 26.33, 3, -1.81, 26.44, -1.65, 26.64, -1.56, 
	26.87, 3, -1.43, 26.76, -1.34, 26.76, -1.20, 26.87, 3, -1.19, 27.12, -1.23, 27.32, -1.38, 27.40, 3, 
	-1.36, 27.56, -1.23, 27.60, -1.03, 27.58, 3, -1.16, 27.86, -1.06, 27.97, -1.03, 28.29, 3, -1.24, 28.29, 
	-1.29, 28.44, -1.56, 28.38, 3, -1.63, 27.85, -2.07, 27.70, -2.18, 27.22, 3, -1.81, 27.40, -2.67, 26.50, 
	-2.36, 26.16, 0, 1, 14.54, 26.24, 3, 14.82, 26.20, 14.86, 26.40, 15.17, 26.33, 3, 15.22, 26.68, 14.97, 
	26.73, 14.72, 26.78, 3, 14.64, 26.62, 14.47, 26.55, 14.54, 26.24, 0, 1, 2.18, 26.78, 3, 2.40, 26.79, 
	2.52, 26.91, 2.53, 27.13, 3, 2.28, 27.18, 2.07, 27.26, 1.82, 27.31, 3, 1.78, 26.98, 2.38, 27.28, 2.18, 
	26.78, 0, 1, -9.84, 26.87, 3, -9.37, 26.85, -9.61, 27.26, -9.48, 27.40, 3, -9.67, 27.73, -9.68, 27.13, 
	-9.92, 27.22, 3, -9.94, 27.06, -9.81, 27.03, -9.84, 26.87, 0, 1, 3.60, 26.96, 3, 3.59, 27.06, 3.62, 
	27.11, 3.69, 27.13, 3, 3.62, 27.46, 2.99, 27.31, 2.89, 27.13, 3, 2.98, 26.93, 3.30, 26.95, 3.60, 26.96, 
	0, 1, 7.87, 27.05, 3, 8.06, 27.01, 8.11, 27.11, 8.23, 27.13, 3, 8.21, 27.39, 8.12, 27.56, 7.78, 27.49, 
	3, 7.74, 27.28, 7.94, 27.30, 7.87, 27.05, 0, 1, 14.72, 27.13, 3, 14.78, 27.13, 14.84, 27.13, 14.90, 
	27.13, 3, 15.36, 27.28, 15.79, 27.73, 15.43, 28.20, 3, 14.85, 28.19, 14.72, 27.73, 14.72, 27.13, 0, 
	1, 12.32, 27.31, 3, 12.11, 27.69, 11.32, 27.89, 10.81, 27.67, 3, 10.90, 27.11, 11.79, 27.17, 12.32, 
	27.31, 0, 1, 19.35, 27.49, 3, 19.22, 27.88, 18.47, 27.88, 18.10, 27.76, 3, 18.34, 26.94, 18.79, 27.76, 
	19.35, 27.49, 0, 1, 3.95, 29.36, 3, 4.07, 29.36, 4.19, 29.36, 4.31, 29.36, 3, 4.57, 29.50, 3.90, 29.84, 
	4.49, 29.80, 3, 4.49, 29.92, 4.49, 30.04, 4.49, 30.16, 3, 4.37, 30.16, 4.25, 30.16, 4.13, 30.16, 3, 
	4.43, 29.82, 3.83, 29.80, 3.95, 29.36, 0, 1, 11.34, 29.89, 3, 11.48, 29.87, 11.49, 29.98, 11.61, 29.98, 
	3, 11.60, 30.21, 11.48, 30.33, 11.25, 30.34, 3, 11.22, 30.13, 11.27, 30.00, 11.34, 29.89, 0, 1, -4.94, 
	30.16, 3, -4.65, 30.22, -4.51, 30.44, -4.23, 30.51, 3, -4.47, 30.78, -4.92, 30.49, -5.12, 30.42, 3, 
	-5.06, 30.33, -4.91, 30.33, -4.94, 30.16, 0, 1, 7.43, 30.16, 3, 7.38, 30.63, 7.08, 30.86, 6.63, 30.69, 
	3, 6.64, 30.59, 6.60, 30.53, 6.54, 30.51, 3, 6.66, 30.23, 6.97, 30.11, 7.43, 30.16, 0, 1, -1.29, 30.69, 
	3, -1.48, 30.79, -2.09, 30.70, -2.36, 30.60, 3, -2.36, 30.51, -2.36, 30.42, -2.36, 30.34, 3, -2.05, 
	30.19, -1.16, 30.12, -1.29, 30.69, 0, 1, 4.85, 30.34, 3, 4.99, 30.78, 4.54, 30.89, 4.31, 30.69, 3, 4.31, 
	30.60, 4.31, 30.51, 4.31, 30.43, 3, 4.42, 30.32, 4.63, 30.33, 4.85, 30.34, 0, 1, 11.52, 30.43, 3, 11.73, 
	30.42, 11.78, 30.58, 12.05, 30.52, 3, 11.89, 30.65, 11.92, 30.97, 11.61, 30.96, 3, 11.71, 30.61, 11.29, 
	30.64, 11.52, 30.43, 0, 1, -15.09, -27.23, 3, -14.90, -27.20, -14.91, -26.99, -14.82, -26.87, 3, -14.83, 
	-26.47, -15.29, -26.52, -15.35, -26.16, 3, -15.57, -26.47, -15.03, -26.79, -15.09, -27.23, 0, 1, 5.91, 
	-24.65, 3, 5.91, -24.55, 5.73, -24.01, 6.00, -23.76, 3, 5.88, -23.76, 5.76, -23.76, 5.65, -23.76, 3, 
	5.61, -24.04, 5.46, -24.14, 5.56, -24.56, 3, 5.70, -24.57, 5.90, -24.52, 5.91, -24.65, 0, 1, 16.23, 
	-18.42, 3, 16.24, -19.07, 16.63, -19.33, 17.03, -19.58, 3, 17.17, -19.27, 16.77, -18.81, 17.03, -18.51, 
	3, 16.92, -18.48, 16.59, -18.44, 16.23, -18.42, 0, 1, 4.67, -17.53, 3, 5.13, -17.47, 5.26, -16.31, 5.38, 
	-15.84, 3, 5.21, -15.80, 5.22, -15.59, 4.93, -15.66, 3, 5.20, -15.38, 5.79, -14.82, 5.29, -14.33, 3, 
	4.91, -14.30, 4.70, -14.45, 4.49, -14.60, 3, 4.82, -14.91, 4.40, -15.43, 4.84, -15.57, 3, 4.84, -15.80, 
	4.68, -15.89, 4.58, -16.02, 3, 5.05, -16.27, 4.53, -17.14, 4.67, -17.53, 0, 1, -20.96, -4.90, 3, -20.68, 
	-4.92, -21.18, -4.64, -20.87, -4.63, 3, -20.96, -4.38, -21.50, -4.26, -21.67, -4.36, 3, -21.72, -4.83, 
	-21.04, -4.57, -20.96, -4.90, 0, 1, 17.39, 6.14, 3, 16.87, 6.41, 16.66, 6.45, 16.06, 6.58, 3, 16.16, 
	6.21, 15.87, 6.23, 15.88, 5.96, 3, 16.27, 5.72, 16.36, 5.74, 16.86, 5.60, 3, 17.30, 5.72, 17.36, 6.23, 
	17.93, 6.23, 3, 17.93, 6.34, 17.93, 6.46, 17.93, 6.58, 3, 17.68, 6.49, 17.31, 6.54, 17.39, 6.14, 0, 
	1, 11.52, 9.25, 3, 11.84, 9.22, 12.01, 9.35, 12.23, 9.43, 3, 12.01, 9.90, 11.51, 9.30, 11.25, 9.52, 
	3, 10.97, 9.39, 11.62, 9.48, 11.52, 9.25, 0, 1, 16.32, 15.12, 3, 16.42, 15.14, 16.37, 15.21, 16.32, 
	15.21, 3, 16.55, 15.40, 16.94, 15.42, 17.12, 15.66, 3, 16.62, 16.20, 17.26, 16.45, 17.84, 16.63, 3, 
	17.23, 16.90, 17.55, 17.63, 16.59, 17.61, 3, 15.91, 17.03, 16.57, 16.11, 16.06, 15.39, 3, 16.03, 15.18, 
	16.31, 15.29, 16.32, 15.12, 0, 1, 1.73, 16.19, 3, 1.79, 16.03, 2.10, 16.34, 2.09, 16.54, 3, 1.92, 16.56, 
	1.79, 16.60, 1.73, 16.72, 3, 1.38, 16.59, 1.96, 16.20, 1.73, 16.19, 0, 1, -10.81, 16.46, 3, -10.73, 
	16.90, -11.08, 16.90, -11.35, 16.99, 3, -11.41, 16.72, -11.41, 16.82, -11.35, 16.55, 3, -11.78, 16.46, 
	-11.33, 17.13, -11.53, 17.08, 3, -11.61, 16.80, -11.94, 16.92, -12.42, 16.72, 3, -11.99, 16.65, -11.41, 
	16.45, -10.81, 16.46, 0, 1, 7.25, 25.62, 3, 7.40, 25.34, 7.90, 26.11, 7.34, 26.06, 3, 7.20, 25.86, 7.37, 
	25.68, 7.25, 25.62, 0, 1, -9.84, -8.46, 3, -9.35, -8.51, -9.16, -8.48, -8.68, -8.63, 3, -8.45, -8.40, 
	-8.67, -8.11, -8.77, -7.92, 3, -9.58, -7.94, -11.32, -7.30, -11.79, -8.54, 3, -11.09, -8.15, -10.06, 
	-9.42, -9.84, -8.46, 0, 1, -16.77, 9.25, 3, -16.61, 9.42, -16.55, 9.26, -16.33, 9.25, 3, -16.22, 9.65, 
	-16.17, 10.10, -16.77, 10.14, 3, -16.58, 9.80, -16.58, 9.58, -16.77, 9.25, 0, 1, -4.05, 11.83, 3, -3.74, 
	11.96, -3.57, 12.24, -3.34, 12.45, 3, -3.51, 12.66, -3.49, 13.07, -3.70, 13.25, 3, -3.60, 13.48, -3.42, 
	13.63, -3.16, 13.70, 3, -3.12, 13.87, -3.44, 14.08, -3.07, 14.05, 3, -3.15, 14.76, -4.14, 14.46, -4.23, 
	13.97, 3, -3.92, 13.98, -4.09, 13.51, -3.79, 13.52, 3, -4.24, 13.14, -4.37, 12.39, -4.05, 11.83, 0, 
	1, -3.34, 19.30, 3, -3.00, 19.52, -2.53, 19.62, -2.45, 20.11, 3, -2.54, 20.11, -2.63, 20.11, -2.72, 
	20.11, 3, -2.45, 20.30, -2.51, 20.31, -2.45, 20.64, 3, -2.70, 20.53, -2.70, 20.93, -2.45, 20.82, 3, 
	-2.47, 20.91, -2.63, 20.88, -2.63, 21.00, 3, -2.97, 20.67, -3.25, 20.11, -3.34, 19.30, 0 }